#!/usr/bin/env python
# coding: utf-8
import time
import wx
import subprocess
import sys
import os
import math

fileout = open("rot.mes", 'w')

imac = 0

insys, outsys = 0, 0
north1, north2 = 0, 0
inrot, outrot = 0, 0
inaxes, outaxes = 0, 0
incon, outcon = 0, 0
indir, outdir = 0, 0
cgroup = 0

inpol, outpol = 0, 0
indirp, outdirp = 0, 0

indirc, outdirc = 0, 0

roty, rotx, rotz = 0, -30, 45

eps1, eps2 = 0.01, 0.0001

ifile1, ifile2, ifile3 = 0, 0, 0
file1, file2, file3 = "", "", ""
icinp, icout, ierr = 0, 0, 0

ld1, ld2, ld3, ld4, ld5, ld6, ld7 = False, False, False, False, False, False, False
ldx, ldxt, ldyt = False, False, False

Sgroup = 0
nsym = 1

itrans, itransr = 0, 0
imove = 0
bgt = 0.
pert = 0.05
scx = 1.
prot3, prot4, prot5 = 1,1,1
protr3, protr4, protr5 = 1,1,1
cang1, cang2, cang3, kappa = 0., 0., 0., 0.
alpout, betout, gamout, kapout = 0., 0., 0., 0.
rot = rot1 = rot2 = rots = [0 for x in range(9)]
pro = [0 for x in range(9)]
m2 = [0 for x in range(9)]

lecp = ' '

Cell = ''

tsys = ['Euler ', 'polar ', 'cos   ', 'matrix', 'quaternion      ']
typerot = ['object rotation          ', 'system rotation          ']
typeaxes = ['fixed axes                  ', 'moving axes'] 

lax12 = ['xyx  ', 'yzy  ', 'zxz  ', 'xzx  ', 'yxy  ', 'zyz  ', 'xyz  ', 'yzx  ', 'zxy  ', 'xzy  ', 'yxz  ', 'zyx  ']
lrot8 = ['ttt ', 'ttc ', 'tct ', 'tcc ', 'ctt ', 'ctc ', 'cct ', 'ccc ']
laxp6 = ['zx   ', 'zy   ', 'xy   ', 'xz   ', 'yz   ', 'yx   ']
lrotp4 = ['tt   ', 'tc   ', 'ct   ', 'cc   ']
lrotc2 = ['counter-clockwise                ', 'clockwise']

teuler1 = "consecutive rotation axes 1, 2, 3:"
teuler2 = "rotation direction around axes 1, 2, 3:"
teuler3 = "(c - clockwise; t - trigonometric, counter-clockwise)"
teuler4 = "Euler angles in degrees around axes 1, 2, 3"
teuler5 = "Euler angles in degrees:"
tpolar1 = "zenith and azimuth axes:"
tpolar2 = "rotation direction around polar and rotation axes:"
tpolar3 = "polar angles in degrees: zenith, azimuth, rotation"
tpolar4 = "polar angles in degrees:"
tcos1 = "cosine values to x, y, z; rotation angle in degrees"
tcos2 = "rotation around the rotation axis:"
tmatrix = "rotation matrix:"
tmatrix1 = "matrix to be multiplied by atomic coordinates"
tquat1 = "qx, qy, qz, q0"

Filename1, Filename2, Filename3 = "", "", ""
dfile1 = dfile2 = dfile3 = dname1 = dname2 = dname3 =""
grrad = float(math.pi/180.)

anglist, angoutlist = [], []

vect = "0.0      0.0      0.0"
lmatr = ['1.0      0.0      0.0', '0.0      1.0      0.0', '0.0      0.0      1.0']

tbeuler = ['N/A', 'ALMN', 'AMoRe', 'CNS', 'DM', 'LSQKAB', 'MOLREP', 'PHASER', 'phenix.refine ZYX', 'phenix.refine ZYZ',
          'REFMAC', 'TNT Crowther', 'TNT Huber', 'TNT Rossmann']
tbpolar = ['N/A', 'AMoRe', 'CNS', 'DM', 'LSQKAB', 'MOLREP', 'PHASER', 'TNT Kabsch', 'TNT Rossmann']
tbcos = ['N/A', 'CNS', 'DM', 'LSQKAB', 'TNT']
tbmat = tbquat = ['N/A']

trot = ['N/A', ' a        c* x a           c*', ' b        a* x b           a*', 
        ' c        b* x c           b*', ' a+b    c* x (a+b)      c*',
        ' a*       c  x a*          c', ' a        b*                 a x b* ',
        ' a*       b                  b x c ']

coorwin, helpwin, demowin, demowinr = "", "", "", ""

ccolor = "#E5E5E5"
col1,col2,col3,col4,col5,col6,col7,col8,col9,col10 = 'red','black','#9400D3','#DCDCDC','#008B00','#FF00FF','blue','white','#E0FFFF','#8B008B'

grouplist = grouplist = ['N/A','1     P1','2     P-1','3     P2','1003  P2-A (P 2 1 1)','2003  P2-C (P 1 1 2)',
             '4     P2(1)','1004  P2(1)-A (P 21 1 1)','2004  P2(1)-C (P 1 1 21)','5     C2',
             '2005  B2 (B 1 1 2)','4005  I2 (I 1 2 1)','6     Pm','7     Pc','8     Cm',
             '9     Cc','10    P2/m','11    P2(1)/m','12    C2/m','13    P2/c','14    P2(1)/c',
             '15    C2/c','16    P222','17    P222(1)','18    P2(1)2(1)2','1018  P22(1)2(1)',
             '2018  P2(1)22(1)','19    P2(1)2(1)2(1)','20    C222(1)','1020  A2(1)22',
             '2020  B22(1)2','21    C222','22    F222','23    I222','24    I2(1)2(1)2(1)','25    Pmm2',
             '26    Pmc2(1)','27    Pcc2','28    Pma2','29    Pca2(1)','30    Pnc2','31    Pmn2(1)',
             '32    Pba2','33    Pna2(1)','34    Pnn2','35    Cmm2','36    Cmc2(1)','37    Ccc2',
             '38    Amm2','39    Abm2','40    Ama2','41    Aba2','42    Fmm2','43    Fdd2','44    Imm2',
             '45    Iba2','46    Ima2','47    Pmmm','48    Pnnn','49    Pccm','50    Pban','51    Pmma',
             '52    Pnna','53    Pmna','54    Pcca','55    Pbam','56    Pccn','57    Pbcm','58    Pnnm',
             '59    Pmmn','60    Pbcn','61    Pbca','62    Pnma','63    Cmcm','64    Cmca','65    Cmmm',
             '13065 Ammm','66    Cccm','67    Cmma','68    Ccca','69    Fmmm','70    Fddd',
             '71    Immm','72    Ibam','73    Ibca','74    Imma','75    P4','76    P4(1)','77    P4(2)',
             '78    P4(3)','79    I4','80    I4(1)','81    P-4','82    I-4','83    P4/m','84    P4(2)/m',
             '85    P4/n','86    P4(2)/n','87    I4/m','88    I4(1)/a','89    P422','90    P42(1)2',
             '91    P4(1)22','92    P4(1)2(1)2','93    P4(2)22','94    P4(2)2(1)2','95    P4(3)22',
             '96    P4(3)2(1)2','97    I422','98    I4(1)22','99    P4mm','100   P4bm','101   P4(2)cm',
             '102   P4(2)nm','103   P4cc','104   P4nc','105   P4(2)mc','106   P4(2)bc','107   I4mm',
             '108   I4cm','109   I4(1)md','110   I4(1)cd','111   P-42m','112   P-42c',
             '113   P-42(1)m','114   P-42(1)c','115   P-4m2','116   P-4c2','117   P-4b2',
             '118   P-4n2','119   I-4m2','120   I-4c2','121   I-42m','122   I-42d','123   P4/mmm',
             '124   P4/mcc','125   P4/nbm','126   P4/nnc','127   P4/mbm','128   P4/mnc',
             '129   P4/nmm','130   P4/ncc','131   P4(2)/mmc','132   P4(2)/mcm','133   P4(2)/nbc',
             '134   P4(2)/nnm','135   P4(2)/mbc','136   P4(2)/mnm','137   P4(2)/nmc','138   P4(2)/ncm',
             '139   I4/mmm','140   I4/mcm','141   I4(1)/amd','142   I4(1)/acd','143   P3',
             '144   P3(1)','145   P3(2)','146   R3','20146 R3r','147   P-3','148   R-3',
             '20148 R-3r','149   P312','150   P321','151   P3(1)12','152   P3(1)21','153   P3(2)12',
             '154   P3(2)21','155   R32','20155 R32r','156   P3m1','157   P31m','158   P3c1',
             '159   P31c','160   R3m','20160 R3mr','161   R3c','20161 R3cr','162   P-31m',
             '163   P-31c','164   P-3m1','165   P-3c1','166   R-3m','20166 R-3mr','167   R-3c',
             '20167 R-3cr','168   P6','169   P6(1)','170   P6(5)','171   P6(2)','172   P6(4)',
             '173   P6(3)','174   P-6','175   P6/m','176   P6(3)/m','177   P622','178   P6(1)22',
             '179   P6(5)22','180   P6(2)22','181   P6(4)22','182   P6(3)22','183   P6mm',
             '184   P6cc','185   P6(3)cm','186   P6(3)mc','187   P-6m2','188   P-6c2','189   P-62m',
             '190   P-62c','191   P6/mmm','192   P6/mcc','193   P6(3)/mcm','194   P6(3)/mmc',
             '195   P23','196   F23','197   I23','198   P2(1)3','199   I2(1)3','200   Pm-3',
             '201   Pn-3','202   Fm-3','203   Fd-3','204   Im-3','205   Pa-3','206   Ia-3',
             '207   P432','208   P4(2)32','209   F432','210   F4(1)32','211   I432','212   P4(3)32',
             '213   P4(1)32','214   I4(1)32','215   P-43m','216   F-43m','217   I-43m',
             '218   P-43n','219   F-43c','220   I-43d','221   Pm-3m','222   Pn-3n','223   Pm-3n',
             '224   Pn-3m','225   Fm-3m','226   Fm-3c','227   Fd-3m','228   Fd-3c','229   Im-3m',
             '230   Ia-3d'] 

filesym = [
'NEWGROUP  P1',
'     1    (code of the group)',
'     1    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P-1',
'     2    (code of the group)',
'     2    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P2',
'     3    (code of the group)',
'     2    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'NEWGROUP     P2-A    (P 2 1 1 unique axis a)',
'  1003    (code of the group)',
'     2    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'NEWGROUP     P2-C    (P 1 1 2  unique axis c)',
'  2003    (code of the group)',
'     2    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P2(1)',
'     4    (code of the group)',
'     2    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.0000000',
'NEWGROUP     P2(1)-A    (P 21 1 1 unique axis a)',
'  1004    (code of the group)',
'     2    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.0000000',
'NEWGROUP     P2(1)-C    (P 1 1 21  unique axis c)',
'  2004    (code of the group)',
'     2    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  C2',
'     5    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'NEWGROUP     B2    (B 1 1 2  unique axis c)',
'  2005    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'NEWGROUP     I2    (I 1 2 1  unique axis b)',
'  4005    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  PM',
'     6    (code of the group)',
'     2    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  PC',
'     7    (code of the group)',
'     2    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  CM',
'     8    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  CC',
'     9    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  P2/M',
'    10    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P2(1)/M',
'    11    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.0000000',
'NEWGROUP  C2/M',
'    12    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  P2/C',
'    13    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  P2(1)/C',
'    14    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'NEWGROUP  C2/C',
'    15    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  P222',
'    16    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P222(1)',
'    17    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  P2(1)2(1)2',
'    18    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'NEWGROUP     P22(1)2(1)    (P 2 21 21  2-fold axis a)',
'  1018    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'NEWGROUP     P2(1)22(1)    (P 21 2 21  2-fold axis b)',
'  2018    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'NEWGROUP  P2(1)2(1)2(1)',
'    19    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'NEWGROUP  C222(1)',
'    20    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'NEWGROUP     A2(1)22    (A 21 2 2  screw a)',
'  1020    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP     B22(1)2    (B 2 21 2  screw b)',
'  2020    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  C222',
'    21    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  F222',
'    22    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  I222',
'    23    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  I2(1)2(1)2(1)',
'    24    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'NEWGROUP  PMM2',
'    25    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  PMC2(1)',
'    26    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  PCC2',
'    27    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  PMA2',
'    28    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.0000000',
'NEWGROUP  PCA2(1)',
'    29    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.0000000',
'NEWGROUP  PNC2',
'    30    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'NEWGROUP  PMN2(1)',
'    31    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'NEWGROUP  PBA2',
'    32    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  PNA2(1)',
'    33    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  PNN2',
'    34    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  CMM2',
'    35    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  CMC2(1)',
'    36    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  CCC2',
'    37    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  AMM2',
'    38    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'NEWGROUP  ABM2',
'    39    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.0000000',
'NEWGROUP  AMA2',
'    40    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  ABA2',
'    41    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  FMM2',
'    42    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  FDD2',
'    43    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.2500000 0.2500000 0.2500000',
'   1   0   0   0  -1   0   0   0   1 0.2500000 0.2500000 0.2500000',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.2500000 0.7500000 0.7500000',
'   1   0   0   0  -1   0   0   0   1 0.2500000 0.7500000 0.7500000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.7500000 0.2500000 0.7500000',
'   1   0   0   0  -1   0   0   0   1 0.7500000 0.2500000 0.7500000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.7500000 0.7500000 0.2500000',
'   1   0   0   0  -1   0   0   0   1 0.7500000 0.7500000 0.2500000',
'NEWGROUP  IMM2',
'    44    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  IBA2',
'    45    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  IMA2',
'    46    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'NEWGROUP  PMMM',
'    47    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  PNNN',
'    48    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  PCCM',
'    49    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  PBAN',
'    50    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  PMMA',
'    51    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  PNNA',
'    52    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  PMNA',
'    53    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'NEWGROUP  PCCA',
'    54    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  PBAM',
'    55    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  PCCN',
'    56    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'NEWGROUP  PBCM',
'    57    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'NEWGROUP  PNNM',
'    58    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  PMMN',
'    59    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  PBCN',
'    60    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  PBCA',
'    61    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'NEWGROUP  PNMA',
'    62    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.0000000',
'NEWGROUP  CMCM',
'    63    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  CMCA',
'    64    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'NEWGROUP  CMMM',
'    65    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  AMMM',
' 13065    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'NEWGROUP  CCCM',
'    66    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  CMMA',
'    67    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.0000000',
'NEWGROUP  CCCA',
'    68    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'NEWGROUP  FMMM',
'    69    (code of the group)',
'    32    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  FDDD',
'    70    (code of the group)',
'    32    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.2500000 0.2500000 0.2500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.2500000 0.2500000 0.2500000',
'  -1   0   0   0   1   0   0   0   1 0.2500000 0.2500000 0.2500000',
'   1   0   0   0  -1   0   0   0   1 0.2500000 0.2500000 0.2500000',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.2500000 0.7500000 0.7500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.2500000 0.7500000 0.7500000',
'  -1   0   0   0   1   0   0   0   1 0.2500000 0.7500000 0.7500000',
'   1   0   0   0  -1   0   0   0   1 0.2500000 0.7500000 0.7500000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.7500000 0.2500000 0.7500000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.7500000 0.2500000 0.7500000',
'  -1   0   0   0   1   0   0   0   1 0.7500000 0.2500000 0.7500000',
'   1   0   0   0  -1   0   0   0   1 0.7500000 0.2500000 0.7500000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.7500000 0.7500000 0.2500000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.7500000 0.7500000 0.2500000',
'  -1   0   0   0   1   0   0   0   1 0.7500000 0.7500000 0.2500000',
'   1   0   0   0  -1   0   0   0   1 0.7500000 0.7500000 0.2500000',
'NEWGROUP  IMMM',
'    71    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  IBAM',
'    72    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  IBCA',
'    73    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'NEWGROUP  IMMA',
'    74    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'NEWGROUP  P4',
'    75    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P4(1)',
'    76    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.2500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.7500000',
'NEWGROUP  P4(2)',
'    77    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  P4(3)',
'    78    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.7500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.2500000',
'NEWGROUP  I4',
'    79    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  I4(1)',
'    80    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.5000000 0.2500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.5000000 0.2500000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.0000000 0.7500000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.0000000 0.7500000',
'NEWGROUP  P-4',
'    81    (code of the group)',
'     4    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  I-4',
'    82    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  P4/M',
'    83    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P4(2)/M',
'    84    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  P4/N',
'    85    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  P4(2)/N',
'    86    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  I4/M',
'    87    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  I4(1)/A',
'    88    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.2500000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.5000000 0.2500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.5000000 0.2500000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.2500000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.7500000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.0000000 0.7500000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.0000000 0.7500000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.7500000',
'NEWGROUP  P422',
'    89    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P42(1)2',
'    90    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P4(1)22',
'    91    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.2500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.7500000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.7500000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.2500000',
'NEWGROUP  P4(1)2(1)2',
'    92    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.2500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.7500000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.7500000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.2500000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  P4(2)22',
'    93    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  P4(2)2(1)2',
'    94    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P4(3)22',
'    95    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.7500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.2500000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.2500000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.7500000',
'NEWGROUP  P4(3)2(1)2',
'    96    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.7500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.2500000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.2500000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.7500000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  I422',
'    97    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  I4(1)22',
'    98    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.5000000 0.2500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.5000000 0.2500000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.2500000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.2500000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.0000000 0.7500000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.0000000 0.7500000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.7500000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.7500000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  P4MM',
'    99    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P4BM',
'   100    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  P4(2)CM',
'   101    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P4(2)NM',
'   102    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P4CC',
'   103    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  P4NC',
'   104    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  P4(2)MC',
'   105    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  P4(2)BC',
'   106    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  I4MM',
'   107    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  I4CM',
'   108    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  I4(1)MD',
'   109    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.5000000 0.2500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.5000000 0.2500000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.5000000 0.2500000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.5000000 0.2500000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.0000000 0.7500000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.0000000 0.7500000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.0000000 0.7500000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.0000000 0.7500000',
'NEWGROUP  I4(1)CD',
'   110    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.5000000 0.2500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.5000000 0.2500000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.0000000 0.2500000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.0000000 0.2500000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.0000000 0.7500000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.0000000 0.7500000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.5000000 0.7500000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.5000000 0.7500000',
'NEWGROUP  P-42M',
'   111    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P-42C',
'   112    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  P-42(1)M',
'   113    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  P-42(1)C',
'   114    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  P-4M2',
'   115    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P-4C2',
'   116    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  P-4B2',
'   117    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  P-4N2',
'   118    (code of the group)',
'     8    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  I-4M2',
'   119    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  I-4C2',
'   120    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  I-42M',
'   121    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  I-42D',
'   122    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.2500000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.2500000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.5000000 0.2500000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.5000000 0.2500000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.7500000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.7500000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.0000000 0.7500000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.0000000 0.7500000',
'NEWGROUP  P4/MMM',
'   123    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P4/MCC',
'   124    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  P4/NBM',
'   125    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  P4/NNC',
'   126    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  P4/MBM',
'   127    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  P4/MNC',
'   128    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  P4/NMM',
'   129    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  P4/NCC',
'   130    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  P4(2)/MMC',
'   131    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  P4(2)/MCM',
'   132    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P4(2)/NBC',
'   133    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  P4(2)/NNM',
'   134    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P4(2)/MBC',
'   135    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  P4(2)/MNM',
'   136    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P4(2)/NMC',
'   137    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  P4(2)/NCM',
'   138    (code of the group)',
'    16    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  I4/MMM',
'   139    (code of the group)',
'    32    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  I4/MCM',
'   140    (code of the group)',
'    32    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  I4(1)/AMD',
'   141    (code of the group)',
'    32    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.2500000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.5000000 0.2500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.5000000 0.2500000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.2500000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.2500000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.2500000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.5000000 0.2500000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.5000000 0.2500000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.7500000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.0000000 0.7500000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.0000000 0.7500000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.7500000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.7500000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.7500000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.0000000 0.7500000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.0000000 0.7500000',
'NEWGROUP  I4(1)/ACD',
'   142    (code of the group)',
'    32    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.2500000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.5000000 0.2500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.5000000 0.2500000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.2500000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.2500000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.2500000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.0000000 0.2500000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.0000000 0.2500000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.7500000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.0000000 0.7500000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.0000000 0.7500000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.7500000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.7500000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.7500000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.5000000 0.7500000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.5000000 0.7500000',
'NEWGROUP  P3',
'   143    (code of the group)',
'     3    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P3(1)',
'   144    (code of the group)',
'     3    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.3333333',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.6666667',
'NEWGROUP  P3(2)',
'   145    (code of the group)',
'     3    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.6666667',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.3333333',
'NEWGROUP  R3',
'   146    (code of the group)',
'     9    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.6666667 0.3333333 0.3333333',
'   0   1   0  -1  -1   0   0   0   1 0.6666667 0.3333333 0.3333333',
'  -1  -1   0   1   0   0   0   0   1 0.6666667 0.3333333 0.3333333',
'   1   0   0   0   1   0   0   0   1 0.3333333 0.6666667 0.6666667',
'   0   1   0  -1  -1   0   0   0   1 0.3333333 0.6666667 0.6666667',
'  -1  -1   0   1   0   0   0   0   1 0.3333333 0.6666667 0.6666667',
'NEWGROUP  R3R',
' 20146    (code of the group)',
'     3    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P-3',
'   147    (code of the group)',
'     6    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  R-3',
'   148    (code of the group)',
'    18    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.6666667 0.3333333 0.3333333',
'   0   1   0  -1  -1   0   0   0   1 0.6666667 0.3333333 0.3333333',
'  -1  -1   0   1   0   0   0   0   1 0.6666667 0.3333333 0.3333333',
'  -1   0   0   0  -1   0   0   0  -1 0.6666667 0.3333333 0.3333333',
'   0  -1   0   1   1   0   0   0  -1 0.6666667 0.3333333 0.3333333',
'   1   1   0  -1   0   0   0   0  -1 0.6666667 0.3333333 0.3333333',
'   1   0   0   0   1   0   0   0   1 0.3333333 0.6666667 0.6666667',
'   0   1   0  -1  -1   0   0   0   1 0.3333333 0.6666667 0.6666667',
'  -1  -1   0   1   0   0   0   0   1 0.3333333 0.6666667 0.6666667',
'  -1   0   0   0  -1   0   0   0  -1 0.3333333 0.6666667 0.6666667',
'   0  -1   0   1   1   0   0   0  -1 0.3333333 0.6666667 0.6666667',
'   1   1   0  -1   0   0   0   0  -1 0.3333333 0.6666667 0.6666667',
'NEWGROUP  R-3R',
' 20148    (code of the group)',
'     6    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P312',
'   149    (code of the group)',
'     6    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   1   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P321',
'   150    (code of the group)',
'     6    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P3(1)12',
'   151    (code of the group)',
'     6    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.3333333',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.6666667',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.6666667',
'  -1   0   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.3333333',
'   1   1   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P3(1)21',
'   152    (code of the group)',
'     6    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.3333333',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.6666667',
'   1   0   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.6666667',
'  -1  -1   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.3333333',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P3(2)12',
'   153    (code of the group)',
'     6    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.6666667',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.3333333',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.3333333',
'  -1   0   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.6666667',
'   1   1   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P3(2)21',
'   154    (code of the group)',
'     6    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.6666667',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.3333333',
'   1   0   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.3333333',
'  -1  -1   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.6666667',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  R32',
'   155    (code of the group)',
'    18    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.6666667 0.3333333 0.3333333',
'   0   1   0  -1  -1   0   0   0   1 0.6666667 0.3333333 0.3333333',
'  -1  -1   0   1   0   0   0   0   1 0.6666667 0.3333333 0.3333333',
'   1   0   0  -1  -1   0   0   0  -1 0.6666667 0.3333333 0.3333333',
'  -1  -1   0   0   1   0   0   0  -1 0.6666667 0.3333333 0.3333333',
'   0   1   0   1   0   0   0   0  -1 0.6666667 0.3333333 0.3333333',
'   1   0   0   0   1   0   0   0   1 0.3333333 0.6666667 0.6666667',
'   0   1   0  -1  -1   0   0   0   1 0.3333333 0.6666667 0.6666667',
'  -1  -1   0   1   0   0   0   0   1 0.3333333 0.6666667 0.6666667',
'   1   0   0  -1  -1   0   0   0  -1 0.3333333 0.6666667 0.6666667',
'  -1  -1   0   0   1   0   0   0  -1 0.3333333 0.6666667 0.6666667',
'   0   1   0   1   0   0   0   0  -1 0.3333333 0.6666667 0.6666667',
'NEWGROUP  R32R',
' 20155    (code of the group)',
'     6    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0  -1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0  -1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P3M1',
'   156    (code of the group)',
'     6    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   1   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P31M',
'   157    (code of the group)',
'     6    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P3C1',
'   158    (code of the group)',
'     6    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   1   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   1   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  P31C',
'   159    (code of the group)',
'     6    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1  -1   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  R3M',
'   160    (code of the group)',
'    18    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   1   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.6666667 0.3333333 0.3333333',
'   0   1   0  -1  -1   0   0   0   1 0.6666667 0.3333333 0.3333333',
'  -1  -1   0   1   0   0   0   0   1 0.6666667 0.3333333 0.3333333',
'  -1   0   0   1   1   0   0   0   1 0.6666667 0.3333333 0.3333333',
'   1   1   0   0  -1   0   0   0   1 0.6666667 0.3333333 0.3333333',
'   0  -1   0  -1   0   0   0   0   1 0.6666667 0.3333333 0.3333333',
'   1   0   0   0   1   0   0   0   1 0.3333333 0.6666667 0.6666667',
'   0   1   0  -1  -1   0   0   0   1 0.3333333 0.6666667 0.6666667',
'  -1  -1   0   1   0   0   0   0   1 0.3333333 0.6666667 0.6666667',
'  -1   0   0   1   1   0   0   0   1 0.3333333 0.6666667 0.6666667',
'   1   1   0   0  -1   0   0   0   1 0.3333333 0.6666667 0.6666667',
'   0  -1   0  -1   0   0   0   0   1 0.3333333 0.6666667 0.6666667',
'NEWGROUP  R3MR',
' 20160    (code of the group)',
'     6    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0   1   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   0   1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'NEWGROUP  R3C',
'   161    (code of the group)',
'    18    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   1   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   1   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.6666667 0.3333333 0.3333333',
'   0   1   0  -1  -1   0   0   0   1 0.6666667 0.3333333 0.3333333',
'  -1  -1   0   1   0   0   0   0   1 0.6666667 0.3333333 0.3333333',
'  -1   0   0   1   1   0   0   0   1 0.6666667 0.3333333 0.8333333',
'   1   1   0   0  -1   0   0   0   1 0.6666667 0.3333333 0.8333333',
'   0  -1   0  -1   0   0   0   0   1 0.6666667 0.3333333 0.8333333',
'   1   0   0   0   1   0   0   0   1 0.3333333 0.6666667 0.6666667',
'   0   1   0  -1  -1   0   0   0   1 0.3333333 0.6666667 0.6666667',
'  -1  -1   0   1   0   0   0   0   1 0.3333333 0.6666667 0.6666667',
'  -1   0   0   1   1   0   0   0   1 0.3333333 0.6666667 0.1666667',
'   1   1   0   0  -1   0   0   0   1 0.3333333 0.6666667 0.1666667',
'   0  -1   0  -1   0   0   0   0   1 0.3333333 0.6666667 0.1666667',
'NEWGROUP  R3CR',
' 20161    (code of the group)',
'     6    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0   1   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   0   1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'NEWGROUP  P-31M',
'   162    (code of the group)',
'    12    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   1   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P-31C',
'   163    (code of the group)',
'    12    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   1   1   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1  -1   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  P-3M1',
'   164    (code of the group)',
'    12    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   1   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P-3C1',
'   165    (code of the group)',
'    12    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1  -1   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   1   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   1   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  R-3M',
'   166    (code of the group)',
'    36    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   1   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.6666667 0.3333333 0.3333333',
'   0   1   0  -1  -1   0   0   0   1 0.6666667 0.3333333 0.3333333',
'  -1  -1   0   1   0   0   0   0   1 0.6666667 0.3333333 0.3333333',
'   1   0   0  -1  -1   0   0   0  -1 0.6666667 0.3333333 0.3333333',
'  -1  -1   0   0   1   0   0   0  -1 0.6666667 0.3333333 0.3333333',
'   0   1   0   1   0   0   0   0  -1 0.6666667 0.3333333 0.3333333',
'  -1   0   0   0  -1   0   0   0  -1 0.6666667 0.3333333 0.3333333',
'   0  -1   0   1   1   0   0   0  -1 0.6666667 0.3333333 0.3333333',
'   1   1   0  -1   0   0   0   0  -1 0.6666667 0.3333333 0.3333333',
'  -1   0   0   1   1   0   0   0   1 0.6666667 0.3333333 0.3333333',
'   1   1   0   0  -1   0   0   0   1 0.6666667 0.3333333 0.3333333',
'   0  -1   0  -1   0   0   0   0   1 0.6666667 0.3333333 0.3333333',
'   1   0   0   0   1   0   0   0   1 0.3333333 0.6666667 0.6666667',
'   0   1   0  -1  -1   0   0   0   1 0.3333333 0.6666667 0.6666667',
'  -1  -1   0   1   0   0   0   0   1 0.3333333 0.6666667 0.6666667',
'   1   0   0  -1  -1   0   0   0  -1 0.3333333 0.6666667 0.6666667',
'  -1  -1   0   0   1   0   0   0  -1 0.3333333 0.6666667 0.6666667',
'   0   1   0   1   0   0   0   0  -1 0.3333333 0.6666667 0.6666667',
'  -1   0   0   0  -1   0   0   0  -1 0.3333333 0.6666667 0.6666667',
'   0  -1   0   1   1   0   0   0  -1 0.3333333 0.6666667 0.6666667',
'   1   1   0  -1   0   0   0   0  -1 0.3333333 0.6666667 0.6666667',
'  -1   0   0   1   1   0   0   0   1 0.3333333 0.6666667 0.6666667',
'   1   1   0   0  -1   0   0   0   1 0.3333333 0.6666667 0.6666667',
'   0  -1   0  -1   0   0   0   0   1 0.3333333 0.6666667 0.6666667',
'NEWGROUP  R-3MR',
' 20166    (code of the group)',
'    12    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0  -1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0  -1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0   1   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   0   1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'NEWGROUP  R-3C',
'   167    (code of the group)',
'    36    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1  -1   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   1   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   1   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.6666667 0.3333333 0.3333333',
'   0   1   0  -1  -1   0   0   0   1 0.6666667 0.3333333 0.3333333',
'  -1  -1   0   1   0   0   0   0   1 0.6666667 0.3333333 0.3333333',
'   1   0   0  -1  -1   0   0   0  -1 0.6666667 0.3333333 0.8333333',
'  -1  -1   0   0   1   0   0   0  -1 0.6666667 0.3333333 0.8333333',
'   0   1   0   1   0   0   0   0  -1 0.6666667 0.3333333 0.8333333',
'  -1   0   0   0  -1   0   0   0  -1 0.6666667 0.3333333 0.3333333',
'   0  -1   0   1   1   0   0   0  -1 0.6666667 0.3333333 0.3333333',
'   1   1   0  -1   0   0   0   0  -1 0.6666667 0.3333333 0.3333333',
'  -1   0   0   1   1   0   0   0   1 0.6666667 0.3333333 0.8333333',
'   1   1   0   0  -1   0   0   0   1 0.6666667 0.3333333 0.8333333',
'   0  -1   0  -1   0   0   0   0   1 0.6666667 0.3333333 0.8333333',
'   1   0   0   0   1   0   0   0   1 0.3333333 0.6666667 0.6666667',
'   0   1   0  -1  -1   0   0   0   1 0.3333333 0.6666667 0.6666667',
'  -1  -1   0   1   0   0   0   0   1 0.3333333 0.6666667 0.6666667',
'   1   0   0  -1  -1   0   0   0  -1 0.3333333 0.6666667 0.1666667',
'  -1  -1   0   0   1   0   0   0  -1 0.3333333 0.6666667 0.1666667',
'   0   1   0   1   0   0   0   0  -1 0.3333333 0.6666667 0.1666667',
'  -1   0   0   0  -1   0   0   0  -1 0.3333333 0.6666667 0.6666667',
'   0  -1   0   1   1   0   0   0  -1 0.3333333 0.6666667 0.6666667',
'   1   1   0  -1   0   0   0   0  -1 0.3333333 0.6666667 0.6666667',
'  -1   0   0   1   1   0   0   0   1 0.3333333 0.6666667 0.1666667',
'   1   1   0   0  -1   0   0   0   1 0.3333333 0.6666667 0.1666667',
'   0  -1   0  -1   0   0   0   0   1 0.3333333 0.6666667 0.1666667',
'NEWGROUP  R-3CR',
' 20167    (code of the group)',
'    12    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   0  -1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   0  -1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0   1   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   0   1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'NEWGROUP  P6',
'   168    (code of the group)',
'     6    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P6(1)',
'   169    (code of the group)',
'     6    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.1666667',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.3333333',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.6666667',
'   0  -1   0   1   1   0   0   0   1 0.0000000 0.0000000 0.8333333',
'NEWGROUP  P6(5)',
'   170    (code of the group)',
'     6    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.8333333',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.6666667',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.3333333',
'   0  -1   0   1   1   0   0   0   1 0.0000000 0.0000000 0.1666667',
'NEWGROUP  P6(2)',
'   171    (code of the group)',
'     6    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.3333333',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.6666667',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.3333333',
'   0  -1   0   1   1   0   0   0   1 0.0000000 0.0000000 0.6666667',
'NEWGROUP  P6(4)',
'   172    (code of the group)',
'     6    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.6666667',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.3333333',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.6666667',
'   0  -1   0   1   1   0   0   0   1 0.0000000 0.0000000 0.3333333',
'NEWGROUP  P6(3)',
'   173    (code of the group)',
'     6    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  P-6',
'   174    (code of the group)',
'     6    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P6/M',
'   175    (code of the group)',
'    12    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P6(3)/M',
'   176    (code of the group)',
'    12    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0  -1   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   1   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  P622',
'   177    (code of the group)',
'    12    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   1   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P6(1)22',
'   178    (code of the group)',
'    12    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.1666667',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.3333333',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.6666667',
'   0  -1   0   1   1   0   0   0   1 0.0000000 0.0000000 0.8333333',
'   1   0   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.6666667',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.3333333',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.8333333',
'  -1   0   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   1   1   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.1666667',
'NEWGROUP  P6(5)22',
'   179    (code of the group)',
'    12    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.8333333',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.6666667',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.3333333',
'   0  -1   0   1   1   0   0   0   1 0.0000000 0.0000000 0.1666667',
'   1   0   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.3333333',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.6666667',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.1666667',
'  -1   0   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   1   1   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.8333333',
'NEWGROUP  P6(2)22',
'   180    (code of the group)',
'    12    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.3333333',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.6666667',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.3333333',
'   0  -1   0   1   1   0   0   0   1 0.0000000 0.0000000 0.6666667',
'   1   0   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.3333333',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.6666667',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.6666667',
'  -1   0   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   1   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.3333333',
'NEWGROUP  P6(4)22',
'   181    (code of the group)',
'    12    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.6666667',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.3333333',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.6666667',
'   0  -1   0   1   1   0   0   0   1 0.0000000 0.0000000 0.3333333',
'   1   0   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.6666667',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.3333333',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.3333333',
'  -1   0   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   1   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.6666667',
'NEWGROUP  P6(3)22',
'   182    (code of the group)',
'    12    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   1   1   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  P6MM',
'   183    (code of the group)',
'    12    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   1   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P6CC',
'   184    (code of the group)',
'    12    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   1   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   1   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1  -1   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  P6(3)CM',
'   185    (code of the group)',
'    12    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   1   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   1   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P6(3)MC',
'   186    (code of the group)',
'    12    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   1   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1  -1   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  P-6M2',
'   187    (code of the group)',
'    12    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   1   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   1   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P-6C2',
'   188    (code of the group)',
'    12    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   1   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   1   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   1   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  P-62M',
'   189    (code of the group)',
'    12    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P-62C',
'   190    (code of the group)',
'    12    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   1   0   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1  -1   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  P6/MMM',
'   191    (code of the group)',
'    24    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   1   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   1   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P6/MCC',
'   192    (code of the group)',
'    24    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1  -1   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   1   1   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   1   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   1   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1  -1   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  P6(3)/MCM',
'   193    (code of the group)',
'    24    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1  -1   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   1   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0  -1   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   1   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   1   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   1   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P6(3)/MMC',
'   194    (code of the group)',
'    24    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0   1   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   1   1   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0  -1   0   1   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   1   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   1   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   1   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0  -1  -1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1  -1   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'NEWGROUP  P23',
'   195    (code of the group)',
'    12    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  F23',
'   196    (code of the group)',
'    48    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  I23',
'   197    (code of the group)',
'    24    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  P2(1)3',
'   198    (code of the group)',
'    12    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'NEWGROUP  I2(1)3',
'   199    (code of the group)',
'    24    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.5000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.5000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'NEWGROUP  PM-3',
'   200    (code of the group)',
'    24    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'NEWGROUP  PN-3',
'   201    (code of the group)',
'    24    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0   1   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  FM-3',
'   202    (code of the group)',
'    96    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0   1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1  -1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1   1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0   1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0   1   1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0  -1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0   1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0   1  -1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1   1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0   1   1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0   1  -1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'NEWGROUP  FD-3',
'   203    (code of the group)',
'    96    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.2500000 0.2500000 0.2500000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1  -1   0   0 0.2500000 0.2500000 0.2500000',
'   0   0  -1  -1   0   0   0  -1   0 0.2500000 0.2500000 0.2500000',
'   0   0  -1   1   0   0   0   1   0 0.2500000 0.2500000 0.2500000',
'   0   1   0   0   0   1  -1   0   0 0.2500000 0.2500000 0.2500000',
'   0   0   1   1   0   0   0  -1   0 0.2500000 0.2500000 0.2500000',
'   0   1   0   0   0  -1   1   0   0 0.2500000 0.2500000 0.2500000',
'   0  -1   0   0   0   1   1   0   0 0.2500000 0.2500000 0.2500000',
'   0   0   1  -1   0   0   0   1   0 0.2500000 0.2500000 0.2500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.2500000 0.2500000 0.2500000',
'  -1   0   0   0   1   0   0   0   1 0.2500000 0.2500000 0.2500000',
'   1   0   0   0  -1   0   0   0   1 0.2500000 0.2500000 0.2500000',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.2500000 0.7500000 0.7500000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1  -1   0   0 0.2500000 0.7500000 0.7500000',
'   0   0  -1  -1   0   0   0  -1   0 0.2500000 0.7500000 0.7500000',
'   0   0  -1   1   0   0   0   1   0 0.2500000 0.7500000 0.7500000',
'   0   1   0   0   0   1  -1   0   0 0.2500000 0.7500000 0.7500000',
'   0   0   1   1   0   0   0  -1   0 0.2500000 0.7500000 0.7500000',
'   0   1   0   0   0  -1   1   0   0 0.2500000 0.7500000 0.7500000',
'   0  -1   0   0   0   1   1   0   0 0.2500000 0.7500000 0.7500000',
'   0   0   1  -1   0   0   0   1   0 0.2500000 0.7500000 0.7500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.2500000 0.7500000 0.7500000',
'  -1   0   0   0   1   0   0   0   1 0.2500000 0.7500000 0.7500000',
'   1   0   0   0  -1   0   0   0   1 0.2500000 0.7500000 0.7500000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.7500000 0.2500000 0.7500000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1  -1   0   0 0.7500000 0.2500000 0.7500000',
'   0   0  -1  -1   0   0   0  -1   0 0.7500000 0.2500000 0.7500000',
'   0   0  -1   1   0   0   0   1   0 0.7500000 0.2500000 0.7500000',
'   0   1   0   0   0   1  -1   0   0 0.7500000 0.2500000 0.7500000',
'   0   0   1   1   0   0   0  -1   0 0.7500000 0.2500000 0.7500000',
'   0   1   0   0   0  -1   1   0   0 0.7500000 0.2500000 0.7500000',
'   0  -1   0   0   0   1   1   0   0 0.7500000 0.2500000 0.7500000',
'   0   0   1  -1   0   0   0   1   0 0.7500000 0.2500000 0.7500000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.7500000 0.2500000 0.7500000',
'  -1   0   0   0   1   0   0   0   1 0.7500000 0.2500000 0.7500000',
'   1   0   0   0  -1   0   0   0   1 0.7500000 0.2500000 0.7500000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.7500000 0.7500000 0.2500000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0  -1  -1   0   0 0.7500000 0.7500000 0.2500000',
'   0   0  -1  -1   0   0   0  -1   0 0.7500000 0.7500000 0.2500000',
'   0   0  -1   1   0   0   0   1   0 0.7500000 0.7500000 0.2500000',
'   0   1   0   0   0   1  -1   0   0 0.7500000 0.7500000 0.2500000',
'   0   0   1   1   0   0   0  -1   0 0.7500000 0.7500000 0.2500000',
'   0   1   0   0   0  -1   1   0   0 0.7500000 0.7500000 0.2500000',
'   0  -1   0   0   0   1   1   0   0 0.7500000 0.7500000 0.2500000',
'   0   0   1  -1   0   0   0   1   0 0.7500000 0.7500000 0.2500000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.7500000 0.7500000 0.2500000',
'  -1   0   0   0   1   0   0   0   1 0.7500000 0.7500000 0.2500000',
'   1   0   0   0  -1   0   0   0   1 0.7500000 0.7500000 0.2500000',
'NEWGROUP  IM-3',
'   204    (code of the group)',
'    48    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0   1   0 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'NEWGROUP  PA-3',
'   205    (code of the group)',
'    24    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0   1   1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0   1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'NEWGROUP  IA-3',
'   206    (code of the group)',
'    48    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.5000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.5000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0   1   0 0.0000000 0.5000000 0.0000000',
'   0   1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.5000000',
'   0   0   1   1   0   0   0  -1   0 0.5000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1   1   0   0 0.0000000 0.5000000 0.0000000',
'   0  -1   0   0   0   1   1   0   0 0.5000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0   1   0 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0   1   1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0   1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'NEWGROUP  P432',
'   207    (code of the group)',
'    24    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0   1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0  -1   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0   1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   0   1   0   1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0   1   0   1   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0  -1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   0  -1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0  -1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'NEWGROUP  P4(2)32',
'   208    (code of the group)',
'    24    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0   1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0  -1   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   0   1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   0   1   0   1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   0   1   0   1   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   0  -1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   0  -1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   0  -1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'NEWGROUP  F432',
'   209    (code of the group)',
'    96    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0   1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0  -1   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0   1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   0   1   0   1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0   1   0   1   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0  -1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   0  -1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0  -1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   0   1   0  -1   0 0.0000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   0  -1   0   1   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   0   1   0   1   0   0 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   0   0   1   0   1   0  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   0   1   0   1   0 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   0  -1   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0   0   1   0  -1   0   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   0  -1   0  -1   0   0 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   0   1   0  -1   0 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   0  -1   0   1   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1   0   1   0   1   0   0 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   0   0   1   0   1   0  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   0   1   0   1   0 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   0  -1   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0   0   1   0  -1   0   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1   0  -1   0  -1   0   0 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   0   1   0  -1   0 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   0  -1   0   1   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1   0   1   0   1   0   0 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0   0   1   0   1   0  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   0   1   0   1   0 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   0  -1   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0   0   1   0  -1   0   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1   0  -1   0  -1   0   0 0.5000000 0.5000000 0.0000000',
'NEWGROUP  F4(1)32',
'   210    (code of the group)',
'    96    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.2500000 0.2500000 0.2500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.2500000 0.2500000 0.2500000',
'   1   0   0   0   0   1   0  -1   0 0.2500000 0.2500000 0.2500000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0  -1   0   1   0 0.2500000 0.2500000 0.2500000',
'   0   0  -1   0   1   0   1   0   0 0.2500000 0.2500000 0.2500000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   0   1   0   1   0  -1   0   0 0.2500000 0.2500000 0.2500000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.2500000 0.2500000 0.2500000',
'   0  -1   0  -1   0   0   0   0  -1 0.2500000 0.2500000 0.2500000',
'  -1   0   0   0   0   1   0   1   0 0.2500000 0.2500000 0.2500000',
'  -1   0   0   0   0  -1   0  -1   0 0.2500000 0.2500000 0.2500000',
'   0   0   1   0  -1   0   1   0   0 0.2500000 0.2500000 0.2500000',
'   0   0  -1   0  -1   0  -1   0   0 0.2500000 0.2500000 0.2500000',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.2500000 0.7500000 0.7500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.2500000 0.7500000 0.7500000',
'   1   0   0   0   0   1   0  -1   0 0.2500000 0.7500000 0.7500000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   0  -1   0   1   0 0.2500000 0.7500000 0.7500000',
'   0   0  -1   0   1   0   1   0   0 0.2500000 0.7500000 0.7500000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   0   0   1   0   1   0  -1   0   0 0.2500000 0.7500000 0.7500000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.2500000 0.7500000 0.7500000',
'   0  -1   0  -1   0   0   0   0  -1 0.2500000 0.7500000 0.7500000',
'  -1   0   0   0   0   1   0   1   0 0.2500000 0.7500000 0.7500000',
'  -1   0   0   0   0  -1   0  -1   0 0.2500000 0.7500000 0.7500000',
'   0   0   1   0  -1   0   1   0   0 0.2500000 0.7500000 0.7500000',
'   0   0  -1   0  -1   0  -1   0   0 0.2500000 0.7500000 0.7500000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.7500000 0.2500000 0.7500000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.7500000 0.2500000 0.7500000',
'   1   0   0   0   0   1   0  -1   0 0.7500000 0.2500000 0.7500000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   0  -1   0   1   0 0.7500000 0.2500000 0.7500000',
'   0   0  -1   0   1   0   1   0   0 0.7500000 0.2500000 0.7500000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   0   0   1   0   1   0  -1   0   0 0.7500000 0.2500000 0.7500000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.7500000 0.2500000 0.7500000',
'   0  -1   0  -1   0   0   0   0  -1 0.7500000 0.2500000 0.7500000',
'  -1   0   0   0   0   1   0   1   0 0.7500000 0.2500000 0.7500000',
'  -1   0   0   0   0  -1   0  -1   0 0.7500000 0.2500000 0.7500000',
'   0   0   1   0  -1   0   1   0   0 0.7500000 0.2500000 0.7500000',
'   0   0  -1   0  -1   0  -1   0   0 0.7500000 0.2500000 0.7500000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.7500000 0.7500000 0.2500000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.7500000 0.7500000 0.2500000',
'   1   0   0   0   0   1   0  -1   0 0.7500000 0.7500000 0.2500000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   0  -1   0   1   0 0.7500000 0.7500000 0.2500000',
'   0   0  -1   0   1   0   1   0   0 0.7500000 0.7500000 0.2500000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0   0   1   0   1   0  -1   0   0 0.7500000 0.7500000 0.2500000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.7500000 0.7500000 0.2500000',
'   0  -1   0  -1   0   0   0   0  -1 0.7500000 0.7500000 0.2500000',
'  -1   0   0   0   0   1   0   1   0 0.7500000 0.7500000 0.2500000',
'  -1   0   0   0   0  -1   0  -1   0 0.7500000 0.7500000 0.2500000',
'   0   0   1   0  -1   0   1   0   0 0.7500000 0.7500000 0.2500000',
'   0   0  -1   0  -1   0  -1   0   0 0.7500000 0.7500000 0.2500000',
'NEWGROUP  I432',
'   211    (code of the group)',
'    48    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0   1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0  -1   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0   1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   0   1   0   1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0   1   0   1   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0  -1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   0  -1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0  -1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0   1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0  -1   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   0   1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   0   1   0   1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   0   1   0   1   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   0  -1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   0  -1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   0  -1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'NEWGROUP  P4(3)32',
'   212    (code of the group)',
'    24    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.7500000 0.2500000 0.7500000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.7500000 0.7500000 0.2500000',
'   1   0   0   0   0   1   0  -1   0 0.7500000 0.7500000 0.2500000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   0  -1   0   1   0 0.2500000 0.7500000 0.7500000',
'   0   0  -1   0   1   0   1   0   0 0.2500000 0.7500000 0.7500000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   0   0   1   0   1   0  -1   0   0 0.7500000 0.2500000 0.7500000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.2500000 0.7500000 0.7500000',
'   0  -1   0  -1   0   0   0   0  -1 0.2500000 0.2500000 0.2500000',
'  -1   0   0   0   0   1   0   1   0 0.7500000 0.2500000 0.7500000',
'  -1   0   0   0   0  -1   0  -1   0 0.2500000 0.2500000 0.2500000',
'   0   0   1   0  -1   0   1   0   0 0.7500000 0.7500000 0.2500000',
'   0   0  -1   0  -1   0  -1   0   0 0.2500000 0.2500000 0.2500000',
'NEWGROUP  P4(1)32',
'   213    (code of the group)',
'    24    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.2500000 0.7500000 0.2500000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.2500000 0.2500000 0.7500000',
'   1   0   0   0   0   1   0  -1   0 0.2500000 0.2500000 0.7500000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   0  -1   0   1   0 0.7500000 0.2500000 0.2500000',
'   0   0  -1   0   1   0   1   0   0 0.7500000 0.2500000 0.2500000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   0   0   1   0   1   0  -1   0   0 0.2500000 0.7500000 0.2500000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.7500000 0.2500000 0.2500000',
'   0  -1   0  -1   0   0   0   0  -1 0.7500000 0.7500000 0.7500000',
'  -1   0   0   0   0   1   0   1   0 0.2500000 0.7500000 0.2500000',
'  -1   0   0   0   0  -1   0  -1   0 0.7500000 0.7500000 0.7500000',
'   0   0   1   0  -1   0   1   0   0 0.2500000 0.2500000 0.7500000',
'   0   0  -1   0  -1   0  -1   0   0 0.7500000 0.7500000 0.7500000',
'NEWGROUP  I4(1)32',
'   214    (code of the group)',
'    48    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.2500000 0.7500000 0.2500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.2500000 0.2500000 0.7500000',
'   1   0   0   0   0   1   0  -1   0 0.2500000 0.2500000 0.7500000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   0  -1   0   1   0 0.7500000 0.2500000 0.2500000',
'   0   0  -1   0   1   0   1   0   0 0.7500000 0.2500000 0.2500000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.0000000',
'   0   0   1   0   1   0  -1   0   0 0.2500000 0.7500000 0.2500000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.5000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.5000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.7500000 0.2500000 0.2500000',
'   0  -1   0  -1   0   0   0   0  -1 0.2500000 0.2500000 0.2500000',
'  -1   0   0   0   0   1   0   1   0 0.2500000 0.7500000 0.2500000',
'  -1   0   0   0   0  -1   0  -1   0 0.2500000 0.2500000 0.2500000',
'   0   0   1   0  -1   0   1   0   0 0.2500000 0.2500000 0.7500000',
'   0   0  -1   0  -1   0  -1   0   0 0.2500000 0.2500000 0.2500000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.7500000 0.2500000 0.7500000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.7500000 0.7500000 0.2500000',
'   1   0   0   0   0   1   0  -1   0 0.7500000 0.7500000 0.2500000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   0  -1   0   1   0 0.2500000 0.7500000 0.7500000',
'   0   0  -1   0   1   0   1   0   0 0.2500000 0.7500000 0.7500000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   0   0   1   0   1   0  -1   0   0 0.7500000 0.2500000 0.7500000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.2500000 0.7500000 0.7500000',
'   0  -1   0  -1   0   0   0   0  -1 0.7500000 0.7500000 0.7500000',
'  -1   0   0   0   0   1   0   1   0 0.7500000 0.2500000 0.7500000',
'  -1   0   0   0   0  -1   0  -1   0 0.7500000 0.7500000 0.7500000',
'   0   0   1   0  -1   0   1   0   0 0.7500000 0.7500000 0.2500000',
'   0   0  -1   0  -1   0  -1   0   0 0.7500000 0.7500000 0.7500000',
'NEWGROUP  P-43M',
'   215    (code of the group)',
'    24    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0  -1   0   1   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0   1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   0  -1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0  -1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0  -1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0   1   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0   1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   0   1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'NEWGROUP  F-43M',
'   216    (code of the group)',
'    96    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0  -1   0   1   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0   1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   0  -1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0  -1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0  -1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0   1   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0   1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   0   1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   0  -1   0   1   0 0.0000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   0   1   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0   0   1   0  -1   0  -1   0   0 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   0   0  -1   0  -1   0   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   0  -1   0  -1   0 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   0   1   0   1   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   0   1   0  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0   1   0   1   0   1   0   0 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   0  -1   0   1   0 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   0   1   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0   0   1   0  -1   0  -1   0   0 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   0   0  -1   0  -1   0   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   0  -1   0  -1   0 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   0   1   0   1   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1   0   1   0  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0   1   0   1   0   1   0   0 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   0  -1   0   1   0 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   0   1   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0   0   1   0  -1   0  -1   0   0 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0   0  -1   0  -1   0   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   0  -1   0  -1   0 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   0   1   0   1   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1   0   1   0  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0   1   0   1   0   1   0   0 0.5000000 0.5000000 0.0000000',
'NEWGROUP  I-43M',
'   217    (code of the group)',
'    48    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0  -1   0   1   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0   1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   0  -1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0  -1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0  -1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0   1   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0   1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   0   1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   0  -1   0   1   0 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   0   1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   0  -1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   0  -1   0  -1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0  -1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0   1   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   0   1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   0   1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'NEWGROUP  P-43N',
'   218    (code of the group)',
'    24    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   0  -1   0   1   0 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0   1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   0  -1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0  -1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0  -1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0   1   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   0   1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   0   1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'NEWGROUP  F-43C',
'   219    (code of the group)',
'    96    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   0  -1   0   1   0 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0   1   0  -1   0 0.0000000 0.0000000 0.5000000',
'   0   0   1   0  -1   0  -1   0   0 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0  -1   0   1   0   0 0.0000000 0.0000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   0  -1   0  -1   0 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   0   1   0   1   0 0.0000000 0.0000000 0.5000000',
'   0   0  -1   0   1   0  -1   0   0 0.0000000 0.0000000 0.5000000',
'   0   0   1   0   1   0   1   0   0 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.5000000 0.0000000',
'  -1   0   0   0   0  -1   0   1   0 0.0000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   0   1   0  -1   0 0.0000000 0.5000000 0.0000000',
'   0   0   1   0  -1   0  -1   0   0 0.0000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   0   0  -1   0  -1   0   1   0   0 0.0000000 0.5000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.5000000 0.0000000',
'   1   0   0   0   0  -1   0  -1   0 0.0000000 0.5000000 0.0000000',
'   1   0   0   0   0   1   0   1   0 0.0000000 0.5000000 0.0000000',
'   0   0  -1   0   1   0  -1   0   0 0.0000000 0.5000000 0.0000000',
'   0   0   1   0   1   0   1   0   0 0.0000000 0.5000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.0000000 0.0000000',
'  -1   0   0   0   0  -1   0   1   0 0.5000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   0   1   0  -1   0 0.5000000 0.0000000 0.0000000',
'   0   0   1   0  -1   0  -1   0   0 0.5000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   0   0  -1   0  -1   0   1   0   0 0.5000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.0000000 0.0000000',
'   1   0   0   0   0  -1   0  -1   0 0.5000000 0.0000000 0.0000000',
'   1   0   0   0   0   1   0   1   0 0.5000000 0.0000000 0.0000000',
'   0   0  -1   0   1   0  -1   0   0 0.5000000 0.0000000 0.0000000',
'   0   0   1   0   1   0   1   0   0 0.5000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   0  -1   0   1   0 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   0   1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   0  -1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0   0  -1   0  -1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0  -1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0   1   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   0   1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   0   1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'NEWGROUP  I-43D',
'   220    (code of the group)',
'    48    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.2500000 0.7500000 0.2500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.2500000 0.2500000 0.7500000',
'  -1   0   0   0   0  -1   0   1   0 0.2500000 0.2500000 0.7500000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   0   1   0  -1   0 0.7500000 0.2500000 0.2500000',
'   0   0   1   0  -1   0  -1   0   0 0.7500000 0.2500000 0.2500000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.0000000',
'   0   0  -1   0  -1   0   1   0   0 0.2500000 0.7500000 0.2500000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.5000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.5000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.7500000 0.2500000 0.2500000',
'   0   1   0   1   0   0   0   0   1 0.2500000 0.2500000 0.2500000',
'   1   0   0   0   0  -1   0  -1   0 0.2500000 0.7500000 0.2500000',
'   1   0   0   0   0   1   0   1   0 0.2500000 0.2500000 0.2500000',
'   0   0  -1   0   1   0  -1   0   0 0.2500000 0.2500000 0.7500000',
'   0   0   1   0   1   0   1   0   0 0.2500000 0.2500000 0.2500000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.7500000 0.2500000 0.7500000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.7500000 0.7500000 0.2500000',
'  -1   0   0   0   0  -1   0   1   0 0.7500000 0.7500000 0.2500000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   0   1   0  -1   0 0.2500000 0.7500000 0.7500000',
'   0   0   1   0  -1   0  -1   0   0 0.2500000 0.7500000 0.7500000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   0   0  -1   0  -1   0   1   0   0 0.7500000 0.2500000 0.7500000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.2500000 0.7500000 0.7500000',
'   0   1   0   1   0   0   0   0   1 0.7500000 0.7500000 0.7500000',
'   1   0   0   0   0  -1   0  -1   0 0.7500000 0.2500000 0.7500000',
'   1   0   0   0   0   1   0   1   0 0.7500000 0.7500000 0.7500000',
'   0   0  -1   0   1   0  -1   0   0 0.7500000 0.7500000 0.2500000',
'   0   0   1   0   1   0   1   0   0 0.7500000 0.7500000 0.7500000',
'NEWGROUP  PM-3M',
'   221    (code of the group)',
'    48    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0   1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0  -1   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0   1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   0   1   0   1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0   1   0   1   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0  -1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   0  -1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0  -1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0  -1   0   1   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0   1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   0  -1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0  -1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0  -1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0   1   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0   1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   0   1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'NEWGROUP  PN-3N',
'   222    (code of the group)',
'    48    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0   1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0  -1   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0   1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   0   1   0   1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   0  -1   0   1   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   0   1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   0  -1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   0  -1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0   1   0   1   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0  -1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   0  -1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0  -1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0  -1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0   1   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   0   1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   0   1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'NEWGROUP  PM-3N',
'   223    (code of the group)',
'    48    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0   1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0  -1   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   0   1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   0   1   0   1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   0   1   0   1   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   0  -1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   0  -1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   0  -1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   0  -1   0   1   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0   1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   0  -1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0  -1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0  -1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0   1   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   0   1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   0   1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'NEWGROUP  PN-3M',
'   224    (code of the group)',
'    48    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0   1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0  -1   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   0   1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   0   1   0   1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0  -1   0   1   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0   1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   0  -1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0  -1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   0   1   0   1   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   0  -1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   0  -1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   0  -1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0  -1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0   1   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0   1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   0   1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'NEWGROUP  FM-3M',
'   225    (code of the group)',
'   192    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0   1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0  -1   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0   1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   0   1   0   1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0   1   0   1   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0  -1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   0  -1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0  -1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0  -1   0   1   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0   1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   0  -1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0  -1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0  -1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0   1   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0   1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   0   1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   0   1   0  -1   0 0.0000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   0  -1   0   1   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   0   1   0   1   0   0 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   0   0   1   0   1   0  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   0   1   0   1   0 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   0  -1   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0   0   1   0  -1   0   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   0  -1   0  -1   0   0 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   0  -1   0   1   0 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   0   1   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0   0   1   0  -1   0  -1   0   0 0.0000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   0   0  -1   0  -1   0   1   0   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0   1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   0  -1   0  -1   0 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   0   1   0   1   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   0   1   0  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0   1   0   1   0   1   0   0 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   0   1   0  -1   0 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   0  -1   0   1   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1   0   1   0   1   0   0 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   0   0   1   0   1   0  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   0   1   0   1   0 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   0  -1   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0   0   1   0  -1   0   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1   0  -1   0  -1   0   0 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   0  -1   0   1   0 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   0   1   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0   0   1   0  -1   0  -1   0   0 0.5000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0   0  -1   0  -1   0   1   0   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1  -1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1   1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0   1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0   1   1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0  -1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0   1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0   1  -1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   0  -1   0  -1   0 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   0   1   0   1   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1   0   1   0  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0   1   0   1   0   1   0   0 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   0   1   0  -1   0 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   0  -1   0   1   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1   0   1   0   1   0   0 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0   0   1   0   1   0  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   0   1   0   1   0 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   0  -1   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0   0   1   0  -1   0   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1   0  -1   0  -1   0   0 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   0  -1   0   1   0 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   0   1   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0   0   1   0  -1   0  -1   0   0 0.5000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0   0  -1   0  -1   0   1   0   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1   1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0   1   1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0   1  -1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   0  -1   0  -1   0 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   0   1   0   1   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1   0   1   0  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0   1   0   1   0   1   0   0 0.5000000 0.5000000 0.0000000',
'NEWGROUP  FM-3C',
'   226    (code of the group)',
'   192    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   0   1   0  -1   0 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0  -1   0   1   0 0.0000000 0.0000000 0.5000000',
'   0   0  -1   0   1   0   1   0   0 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   0   1   0   1   0  -1   0   0 0.0000000 0.0000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   0   1   0   1   0 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   0  -1   0  -1   0 0.0000000 0.0000000 0.5000000',
'   0   0   1   0  -1   0   1   0   0 0.0000000 0.0000000 0.5000000',
'   0   0  -1   0  -1   0  -1   0   0 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   0  -1   0   1   0 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0   1   0  -1   0 0.0000000 0.0000000 0.5000000',
'   0   0   1   0  -1   0  -1   0   0 0.0000000 0.0000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0  -1   0   1   0   0 0.0000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   0  -1   0  -1   0 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   0   1   0   1   0 0.0000000 0.0000000 0.5000000',
'   0   0  -1   0   1   0  -1   0   0 0.0000000 0.0000000 0.5000000',
'   0   0   1   0   1   0   1   0   0 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.5000000 0.0000000',
'   1   0   0   0   0   1   0  -1   0 0.0000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   0  -1   0   1   0 0.0000000 0.5000000 0.0000000',
'   0   0  -1   0   1   0   1   0   0 0.0000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   0   0   1   0   1   0  -1   0   0 0.0000000 0.5000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.5000000 0.0000000',
'  -1   0   0   0   0   1   0   1   0 0.0000000 0.5000000 0.0000000',
'  -1   0   0   0   0  -1   0  -1   0 0.0000000 0.5000000 0.0000000',
'   0   0   1   0  -1   0   1   0   0 0.0000000 0.5000000 0.0000000',
'   0   0  -1   0  -1   0  -1   0   0 0.0000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.5000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.5000000 0.0000000',
'  -1   0   0   0   0  -1   0   1   0 0.0000000 0.5000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   0   1   0  -1   0 0.0000000 0.5000000 0.0000000',
'   0   0   1   0  -1   0  -1   0   0 0.0000000 0.5000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   0   0  -1   0  -1   0   1   0   0 0.0000000 0.5000000 0.0000000',
'   0  -1   0   0   0  -1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0   1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.5000000 0.0000000',
'   1   0   0   0   0  -1   0  -1   0 0.0000000 0.5000000 0.0000000',
'   1   0   0   0   0   1   0   1   0 0.0000000 0.5000000 0.0000000',
'   0   0  -1   0   1   0  -1   0   0 0.0000000 0.5000000 0.0000000',
'   0   0   1   0   1   0   1   0   0 0.0000000 0.5000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.0000000 0.0000000',
'   1   0   0   0   0   1   0  -1   0 0.5000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   0  -1   0   1   0 0.5000000 0.0000000 0.0000000',
'   0   0  -1   0   1   0   1   0   0 0.5000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   0   0   1   0   1   0  -1   0   0 0.5000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.0000000 0.0000000',
'  -1   0   0   0   0   1   0   1   0 0.5000000 0.0000000 0.0000000',
'  -1   0   0   0   0  -1   0  -1   0 0.5000000 0.0000000 0.0000000',
'   0   0   1   0  -1   0   1   0   0 0.5000000 0.0000000 0.0000000',
'   0   0  -1   0  -1   0  -1   0   0 0.5000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.0000000 0.0000000',
'  -1   0   0   0   0  -1   0   1   0 0.5000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   0   1   0  -1   0 0.5000000 0.0000000 0.0000000',
'   0   0   1   0  -1   0  -1   0   0 0.5000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0   0  -1   0  -1   0   1   0   0 0.5000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1  -1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1   1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0   1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0   1   1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0  -1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0   1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0   1  -1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.0000000 0.0000000',
'   1   0   0   0   0  -1   0  -1   0 0.5000000 0.0000000 0.0000000',
'   1   0   0   0   0   1   0   1   0 0.5000000 0.0000000 0.0000000',
'   0   0  -1   0   1   0  -1   0   0 0.5000000 0.0000000 0.0000000',
'   0   0   1   0   1   0   1   0   0 0.5000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0   1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   0  -1   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   0   1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0   0   1   0   1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   0   1   0   1   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   0  -1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   0  -1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   0  -1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   0  -1   0   1   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   0   1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   0  -1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0   0  -1   0  -1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1   1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0   1   1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0   1  -1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0  -1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0   1   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   0   1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   0   1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'NEWGROUP  FD-3M',
'   227    (code of the group)',
'   192    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.2500000 0.2500000 0.2500000',
'   0   1   0  -1   0   0   0   0   1 0.2500000 0.2500000 0.2500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.2500000 0.2500000 0.2500000',
'   1   0   0   0   0   1   0  -1   0 0.2500000 0.2500000 0.2500000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0  -1   0   1   0 0.2500000 0.2500000 0.2500000',
'   0   0  -1   0   1   0   1   0   0 0.2500000 0.2500000 0.2500000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   0   1   0   1   0  -1   0   0 0.2500000 0.2500000 0.2500000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0  -1   0   1   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0   1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   0  -1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0  -1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1  -1   0   0 0.2500000 0.2500000 0.2500000',
'   0   0  -1  -1   0   0   0  -1   0 0.2500000 0.2500000 0.2500000',
'   0   0  -1   1   0   0   0   1   0 0.2500000 0.2500000 0.2500000',
'   0   1   0   0   0   1  -1   0   0 0.2500000 0.2500000 0.2500000',
'   0   0   1   1   0   0   0  -1   0 0.2500000 0.2500000 0.2500000',
'   0   1   0   0   0  -1   1   0   0 0.2500000 0.2500000 0.2500000',
'   0  -1   0   0   0   1   1   0   0 0.2500000 0.2500000 0.2500000',
'   0   0   1  -1   0   0   0   1   0 0.2500000 0.2500000 0.2500000',
'   0   1   0   1   0   0   0   0  -1 0.2500000 0.2500000 0.2500000',
'   0  -1   0  -1   0   0   0   0  -1 0.2500000 0.2500000 0.2500000',
'  -1   0   0   0   0   1   0   1   0 0.2500000 0.2500000 0.2500000',
'  -1   0   0   0   0  -1   0  -1   0 0.2500000 0.2500000 0.2500000',
'   0   0   1   0  -1   0   1   0   0 0.2500000 0.2500000 0.2500000',
'   0   0  -1   0  -1   0  -1   0   0 0.2500000 0.2500000 0.2500000',
'   1   0   0   0   1   0   0   0  -1 0.2500000 0.2500000 0.2500000',
'  -1   0   0   0   1   0   0   0   1 0.2500000 0.2500000 0.2500000',
'   1   0   0   0  -1   0   0   0   1 0.2500000 0.2500000 0.2500000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0  -1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0   1   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0   1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   0   1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.2500000 0.7500000 0.7500000',
'   0   1   0  -1   0   0   0   0   1 0.2500000 0.7500000 0.7500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.2500000 0.7500000 0.7500000',
'   1   0   0   0   0   1   0  -1   0 0.2500000 0.7500000 0.7500000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   0  -1   0   1   0 0.2500000 0.7500000 0.7500000',
'   0   0  -1   0   1   0   1   0   0 0.2500000 0.7500000 0.7500000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   0   0   1   0   1   0  -1   0   0 0.2500000 0.7500000 0.7500000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   0  -1   0   1   0 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0   0   1   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0   0   1   0  -1   0  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   0  -1   0   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1  -1   0   0 0.2500000 0.7500000 0.7500000',
'   0   0  -1  -1   0   0   0  -1   0 0.2500000 0.7500000 0.7500000',
'   0   0  -1   1   0   0   0   1   0 0.2500000 0.7500000 0.7500000',
'   0   1   0   0   0   1  -1   0   0 0.2500000 0.7500000 0.7500000',
'   0   0   1   1   0   0   0  -1   0 0.2500000 0.7500000 0.7500000',
'   0   1   0   0   0  -1   1   0   0 0.2500000 0.7500000 0.7500000',
'   0  -1   0   0   0   1   1   0   0 0.2500000 0.7500000 0.7500000',
'   0   0   1  -1   0   0   0   1   0 0.2500000 0.7500000 0.7500000',
'   0   1   0   1   0   0   0   0  -1 0.2500000 0.7500000 0.7500000',
'   0  -1   0  -1   0   0   0   0  -1 0.2500000 0.7500000 0.7500000',
'  -1   0   0   0   0   1   0   1   0 0.2500000 0.7500000 0.7500000',
'  -1   0   0   0   0  -1   0  -1   0 0.2500000 0.7500000 0.7500000',
'   0   0   1   0  -1   0   1   0   0 0.2500000 0.7500000 0.7500000',
'   0   0  -1   0  -1   0  -1   0   0 0.2500000 0.7500000 0.7500000',
'   1   0   0   0   1   0   0   0  -1 0.2500000 0.7500000 0.7500000',
'  -1   0   0   0   1   0   0   0   1 0.2500000 0.7500000 0.7500000',
'   1   0   0   0  -1   0   0   0   1 0.2500000 0.7500000 0.7500000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   0  -1   0  -1   0 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   0   1   0   1   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   0   1   0  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0   1   0   1   0   1   0   0 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.7500000 0.2500000 0.7500000',
'   0   1   0  -1   0   0   0   0   1 0.7500000 0.2500000 0.7500000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.7500000 0.2500000 0.7500000',
'   1   0   0   0   0   1   0  -1   0 0.7500000 0.2500000 0.7500000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   0  -1   0   1   0 0.7500000 0.2500000 0.7500000',
'   0   0  -1   0   1   0   1   0   0 0.7500000 0.2500000 0.7500000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   0   0   1   0   1   0  -1   0   0 0.7500000 0.2500000 0.7500000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   0  -1   0   1   0 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0   0   1   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0   0   1   0  -1   0  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1   0  -1   0   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1  -1   0   0 0.7500000 0.2500000 0.7500000',
'   0   0  -1  -1   0   0   0  -1   0 0.7500000 0.2500000 0.7500000',
'   0   0  -1   1   0   0   0   1   0 0.7500000 0.2500000 0.7500000',
'   0   1   0   0   0   1  -1   0   0 0.7500000 0.2500000 0.7500000',
'   0   0   1   1   0   0   0  -1   0 0.7500000 0.2500000 0.7500000',
'   0   1   0   0   0  -1   1   0   0 0.7500000 0.2500000 0.7500000',
'   0  -1   0   0   0   1   1   0   0 0.7500000 0.2500000 0.7500000',
'   0   0   1  -1   0   0   0   1   0 0.7500000 0.2500000 0.7500000',
'   0   1   0   1   0   0   0   0  -1 0.7500000 0.2500000 0.7500000',
'   0  -1   0  -1   0   0   0   0  -1 0.7500000 0.2500000 0.7500000',
'  -1   0   0   0   0   1   0   1   0 0.7500000 0.2500000 0.7500000',
'  -1   0   0   0   0  -1   0  -1   0 0.7500000 0.2500000 0.7500000',
'   0   0   1   0  -1   0   1   0   0 0.7500000 0.2500000 0.7500000',
'   0   0  -1   0  -1   0  -1   0   0 0.7500000 0.2500000 0.7500000',
'   1   0   0   0   1   0   0   0  -1 0.7500000 0.2500000 0.7500000',
'  -1   0   0   0   1   0   0   0   1 0.7500000 0.2500000 0.7500000',
'   1   0   0   0  -1   0   0   0   1 0.7500000 0.2500000 0.7500000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   0  -1   0  -1   0 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   0   1   0   1   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1   0   1   0  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0   1   0   1   0   1   0   0 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.7500000 0.7500000 0.2500000',
'   0   1   0  -1   0   0   0   0   1 0.7500000 0.7500000 0.2500000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.7500000 0.7500000 0.2500000',
'   1   0   0   0   0   1   0  -1   0 0.7500000 0.7500000 0.2500000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   0  -1   0   1   0 0.7500000 0.7500000 0.2500000',
'   0   0  -1   0   1   0   1   0   0 0.7500000 0.7500000 0.2500000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0   0   1   0   1   0  -1   0   0 0.7500000 0.7500000 0.2500000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   0  -1   0   1   0 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   0   1   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0   0   1   0  -1   0  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1   0  -1   0   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0  -1  -1   0   0 0.7500000 0.7500000 0.2500000',
'   0   0  -1  -1   0   0   0  -1   0 0.7500000 0.7500000 0.2500000',
'   0   0  -1   1   0   0   0   1   0 0.7500000 0.7500000 0.2500000',
'   0   1   0   0   0   1  -1   0   0 0.7500000 0.7500000 0.2500000',
'   0   0   1   1   0   0   0  -1   0 0.7500000 0.7500000 0.2500000',
'   0   1   0   0   0  -1   1   0   0 0.7500000 0.7500000 0.2500000',
'   0  -1   0   0   0   1   1   0   0 0.7500000 0.7500000 0.2500000',
'   0   0   1  -1   0   0   0   1   0 0.7500000 0.7500000 0.2500000',
'   0   1   0   1   0   0   0   0  -1 0.7500000 0.7500000 0.2500000',
'   0  -1   0  -1   0   0   0   0  -1 0.7500000 0.7500000 0.2500000',
'  -1   0   0   0   0   1   0   1   0 0.7500000 0.7500000 0.2500000',
'  -1   0   0   0   0  -1   0  -1   0 0.7500000 0.7500000 0.2500000',
'   0   0   1   0  -1   0   1   0   0 0.7500000 0.7500000 0.2500000',
'   0   0  -1   0  -1   0  -1   0   0 0.7500000 0.7500000 0.2500000',
'   1   0   0   0   1   0   0   0  -1 0.7500000 0.7500000 0.2500000',
'  -1   0   0   0   1   0   0   0   1 0.7500000 0.7500000 0.2500000',
'   1   0   0   0  -1   0   0   0   1 0.7500000 0.7500000 0.2500000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   0  -1   0  -1   0 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   0   1   0   1   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1   0   1   0  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0   1   0   1   0   1   0   0 0.5000000 0.5000000 0.0000000',
'NEWGROUP  FD-3C',
'   228    (code of the group)',
'   192    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.2500000 0.2500000 0.7500000',
'   0   1   0  -1   0   0   0   0   1 0.2500000 0.2500000 0.2500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.2500000 0.2500000 0.2500000',
'   1   0   0   0   0   1   0  -1   0 0.2500000 0.2500000 0.2500000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0  -1   0   1   0 0.2500000 0.2500000 0.2500000',
'   0   0  -1   0   1   0   1   0   0 0.2500000 0.2500000 0.2500000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   0   1   0   1   0  -1   0   0 0.2500000 0.2500000 0.2500000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   0  -1   0   1   0 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   0   1   0  -1   0 0.0000000 0.0000000 0.5000000',
'   0   0   1   0  -1   0  -1   0   0 0.0000000 0.0000000 0.5000000',
'   0   0  -1   0  -1   0   1   0   0 0.0000000 0.0000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1  -1   0   0 0.2500000 0.2500000 0.7500000',
'   0   0  -1  -1   0   0   0  -1   0 0.2500000 0.2500000 0.7500000',
'   0   0  -1   1   0   0   0   1   0 0.2500000 0.2500000 0.7500000',
'   0   1   0   0   0   1  -1   0   0 0.2500000 0.2500000 0.7500000',
'   0   0   1   1   0   0   0  -1   0 0.2500000 0.2500000 0.7500000',
'   0   1   0   0   0  -1   1   0   0 0.2500000 0.2500000 0.7500000',
'   0  -1   0   0   0   1   1   0   0 0.2500000 0.2500000 0.7500000',
'   0   0   1  -1   0   0   0   1   0 0.2500000 0.2500000 0.7500000',
'   0   1   0   1   0   0   0   0  -1 0.2500000 0.2500000 0.2500000',
'   0  -1   0  -1   0   0   0   0  -1 0.2500000 0.2500000 0.2500000',
'  -1   0   0   0   0   1   0   1   0 0.2500000 0.2500000 0.2500000',
'  -1   0   0   0   0  -1   0  -1   0 0.2500000 0.2500000 0.2500000',
'   0   0   1   0  -1   0   1   0   0 0.2500000 0.2500000 0.2500000',
'   0   0  -1   0  -1   0  -1   0   0 0.2500000 0.2500000 0.2500000',
'   1   0   0   0   1   0   0   0  -1 0.2500000 0.2500000 0.7500000',
'  -1   0   0   0   1   0   0   0   1 0.2500000 0.2500000 0.7500000',
'   1   0   0   0  -1   0   0   0   1 0.2500000 0.2500000 0.7500000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   0  -1   0  -1   0 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   0   1   0   1   0 0.0000000 0.0000000 0.5000000',
'   0   0  -1   0   1   0  -1   0   0 0.0000000 0.0000000 0.5000000',
'   0   0   1   0   1   0   1   0   0 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.2500000 0.7500000 0.2500000',
'   0   1   0  -1   0   0   0   0   1 0.2500000 0.7500000 0.7500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.2500000 0.7500000 0.7500000',
'   1   0   0   0   0   1   0  -1   0 0.2500000 0.7500000 0.7500000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   1   0   0   0   0  -1   0   1   0 0.2500000 0.7500000 0.7500000',
'   0   0  -1   0   1   0   1   0   0 0.2500000 0.7500000 0.7500000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   0   0   1   0   1   0  -1   0   0 0.2500000 0.7500000 0.7500000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.5000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.5000000 0.0000000',
'  -1   0   0   0   0  -1   0   1   0 0.0000000 0.5000000 0.0000000',
'  -1   0   0   0   0   1   0  -1   0 0.0000000 0.5000000 0.0000000',
'   0   0   1   0  -1   0  -1   0   0 0.0000000 0.5000000 0.0000000',
'   0   0  -1   0  -1   0   1   0   0 0.0000000 0.5000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1  -1   0   0 0.2500000 0.7500000 0.2500000',
'   0   0  -1  -1   0   0   0  -1   0 0.2500000 0.7500000 0.2500000',
'   0   0  -1   1   0   0   0   1   0 0.2500000 0.7500000 0.2500000',
'   0   1   0   0   0   1  -1   0   0 0.2500000 0.7500000 0.2500000',
'   0   0   1   1   0   0   0  -1   0 0.2500000 0.7500000 0.2500000',
'   0   1   0   0   0  -1   1   0   0 0.2500000 0.7500000 0.2500000',
'   0  -1   0   0   0   1   1   0   0 0.2500000 0.7500000 0.2500000',
'   0   0   1  -1   0   0   0   1   0 0.2500000 0.7500000 0.2500000',
'   0   1   0   1   0   0   0   0  -1 0.2500000 0.7500000 0.7500000',
'   0  -1   0  -1   0   0   0   0  -1 0.2500000 0.7500000 0.7500000',
'  -1   0   0   0   0   1   0   1   0 0.2500000 0.7500000 0.7500000',
'  -1   0   0   0   0  -1   0  -1   0 0.2500000 0.7500000 0.7500000',
'   0   0   1   0  -1   0   1   0   0 0.2500000 0.7500000 0.7500000',
'   0   0  -1   0  -1   0  -1   0   0 0.2500000 0.7500000 0.7500000',
'   1   0   0   0   1   0   0   0  -1 0.2500000 0.7500000 0.2500000',
'  -1   0   0   0   1   0   0   0   1 0.2500000 0.7500000 0.2500000',
'   1   0   0   0  -1   0   0   0   1 0.2500000 0.7500000 0.2500000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.5000000 0.0000000',
'   1   0   0   0   0  -1   0  -1   0 0.0000000 0.5000000 0.0000000',
'   1   0   0   0   0   1   0   1   0 0.0000000 0.5000000 0.0000000',
'   0   0  -1   0   1   0  -1   0   0 0.0000000 0.5000000 0.0000000',
'   0   0   1   0   1   0   1   0   0 0.0000000 0.5000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.7500000 0.2500000 0.2500000',
'   0   1   0  -1   0   0   0   0   1 0.7500000 0.2500000 0.7500000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.7500000 0.2500000 0.7500000',
'   1   0   0   0   0   1   0  -1   0 0.7500000 0.2500000 0.7500000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   1   0   0   0   0  -1   0   1   0 0.7500000 0.2500000 0.7500000',
'   0   0  -1   0   1   0   1   0   0 0.7500000 0.2500000 0.7500000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   0   0   1   0   1   0  -1   0   0 0.7500000 0.2500000 0.7500000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.0000000 0.0000000',
'  -1   0   0   0   0  -1   0   1   0 0.5000000 0.0000000 0.0000000',
'  -1   0   0   0   0   1   0  -1   0 0.5000000 0.0000000 0.0000000',
'   0   0   1   0  -1   0  -1   0   0 0.5000000 0.0000000 0.0000000',
'   0   0  -1   0  -1   0   1   0   0 0.5000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1  -1   0   0 0.7500000 0.2500000 0.2500000',
'   0   0  -1  -1   0   0   0  -1   0 0.7500000 0.2500000 0.2500000',
'   0   0  -1   1   0   0   0   1   0 0.7500000 0.2500000 0.2500000',
'   0   1   0   0   0   1  -1   0   0 0.7500000 0.2500000 0.2500000',
'   0   0   1   1   0   0   0  -1   0 0.7500000 0.2500000 0.2500000',
'   0   1   0   0   0  -1   1   0   0 0.7500000 0.2500000 0.2500000',
'   0  -1   0   0   0   1   1   0   0 0.7500000 0.2500000 0.2500000',
'   0   0   1  -1   0   0   0   1   0 0.7500000 0.2500000 0.2500000',
'   0   1   0   1   0   0   0   0  -1 0.7500000 0.2500000 0.7500000',
'   0  -1   0  -1   0   0   0   0  -1 0.7500000 0.2500000 0.7500000',
'  -1   0   0   0   0   1   0   1   0 0.7500000 0.2500000 0.7500000',
'  -1   0   0   0   0  -1   0  -1   0 0.7500000 0.2500000 0.7500000',
'   0   0   1   0  -1   0   1   0   0 0.7500000 0.2500000 0.7500000',
'   0   0  -1   0  -1   0  -1   0   0 0.7500000 0.2500000 0.7500000',
'   1   0   0   0   1   0   0   0  -1 0.7500000 0.2500000 0.2500000',
'  -1   0   0   0   1   0   0   0   1 0.7500000 0.2500000 0.2500000',
'   1   0   0   0  -1   0   0   0   1 0.7500000 0.2500000 0.2500000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.0000000 0.0000000',
'   1   0   0   0   0  -1   0  -1   0 0.5000000 0.0000000 0.0000000',
'   1   0   0   0   0   1   0   1   0 0.5000000 0.0000000 0.0000000',
'   0   0  -1   0   1   0  -1   0   0 0.5000000 0.0000000 0.0000000',
'   0   0   1   0   1   0   1   0   0 0.5000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.7500000 0.7500000 0.7500000',
'   0   1   0  -1   0   0   0   0   1 0.7500000 0.7500000 0.2500000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.7500000 0.7500000 0.2500000',
'   1   0   0   0   0   1   0  -1   0 0.7500000 0.7500000 0.2500000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   0  -1   0   1   0 0.7500000 0.7500000 0.2500000',
'   0   0  -1   0   1   0   1   0   0 0.7500000 0.7500000 0.2500000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   0   0   1   0   1   0  -1   0   0 0.7500000 0.7500000 0.2500000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   0  -1   0   1   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   0   1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   0  -1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   0  -1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0   0   0  -1  -1   0   0 0.7500000 0.7500000 0.7500000',
'   0   0  -1  -1   0   0   0  -1   0 0.7500000 0.7500000 0.7500000',
'   0   0  -1   1   0   0   0   1   0 0.7500000 0.7500000 0.7500000',
'   0   1   0   0   0   1  -1   0   0 0.7500000 0.7500000 0.7500000',
'   0   0   1   1   0   0   0  -1   0 0.7500000 0.7500000 0.7500000',
'   0   1   0   0   0  -1   1   0   0 0.7500000 0.7500000 0.7500000',
'   0  -1   0   0   0   1   1   0   0 0.7500000 0.7500000 0.7500000',
'   0   0   1  -1   0   0   0   1   0 0.7500000 0.7500000 0.7500000',
'   0   1   0   1   0   0   0   0  -1 0.7500000 0.7500000 0.2500000',
'   0  -1   0  -1   0   0   0   0  -1 0.7500000 0.7500000 0.2500000',
'  -1   0   0   0   0   1   0   1   0 0.7500000 0.7500000 0.2500000',
'  -1   0   0   0   0  -1   0  -1   0 0.7500000 0.7500000 0.2500000',
'   0   0   1   0  -1   0   1   0   0 0.7500000 0.7500000 0.2500000',
'   0   0  -1   0  -1   0  -1   0   0 0.7500000 0.7500000 0.2500000',
'   1   0   0   0   1   0   0   0  -1 0.7500000 0.7500000 0.7500000',
'  -1   0   0   0   1   0   0   0   1 0.7500000 0.7500000 0.7500000',
'   1   0   0   0  -1   0   0   0   1 0.7500000 0.7500000 0.7500000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0  -1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0   1   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   0   1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   0   1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'NEWGROUP  IM-3M',
'   229    (code of the group)',
'    96    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0   1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0  -1   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0   1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   0   1   0   1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0   1   0   1   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0  -1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   0  -1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0  -1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0  -1   0   1   0 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'  -1   0   0   0   0   1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   0  -1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0  -1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0   1   0   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0  -1   0  -1   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   0   1   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   0   1   0  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   0   1   0   1   0   0 0.0000000 0.0000000 0.0000000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0   1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0  -1   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   0   1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   0   1   0   1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   0   1   0   1   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   0  -1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   0  -1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   0  -1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   0  -1   0   1   0 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'  -1   0   0   0   0   1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   0  -1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   0  -1   0  -1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'   0  -1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0   1   0 0.5000000 0.5000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0   1   0   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0  -1   0  -1   0 0.5000000 0.5000000 0.5000000',
'   1   0   0   0   0   1   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   0   1   0  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   0   1   0   1   0   0 0.5000000 0.5000000 0.5000000',
'NEWGROUP  IA-3D',
'   230    (code of the group)',
'    96    (number of symmetries)',
'   1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.0000000',
'   0   1   0  -1   0   0   0   0   1 0.2500000 0.7500000 0.2500000',
'  -1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.0000000',
'   0  -1   0   1   0   0   0   0   1 0.2500000 0.2500000 0.7500000',
'   1   0   0   0   0   1   0  -1   0 0.2500000 0.2500000 0.7500000',
'   1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.5000000',
'   1   0   0   0   0  -1   0   1   0 0.7500000 0.2500000 0.2500000',
'   0   0  -1   0   1   0   1   0   0 0.7500000 0.2500000 0.2500000',
'  -1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.0000000',
'   0   0   1   0   1   0  -1   0   0 0.2500000 0.7500000 0.2500000',
'   0   1   0   0   0   1   1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0   1   1   0   0   0   1   0 0.0000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0  -1   0 0.0000000 0.5000000 0.0000000',
'   0  -1   0   0   0  -1   1   0   0 0.0000000 0.0000000 0.5000000',
'   0   0  -1  -1   0   0   0   1   0 0.5000000 0.0000000 0.0000000',
'   0  -1   0   0   0   1  -1   0   0 0.0000000 0.5000000 0.0000000',
'   0   1   0   0   0  -1  -1   0   0 0.5000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0  -1   0 0.0000000 0.0000000 0.5000000',
'   0   1   0   1   0   0   0   0  -1 0.7500000 0.2500000 0.2500000',
'   0  -1   0  -1   0   0   0   0  -1 0.2500000 0.2500000 0.2500000',
'  -1   0   0   0   0   1   0   1   0 0.2500000 0.7500000 0.2500000',
'  -1   0   0   0   0  -1   0  -1   0 0.2500000 0.2500000 0.2500000',
'   0   0   1   0  -1   0   1   0   0 0.2500000 0.2500000 0.7500000',
'   0   0  -1   0  -1   0  -1   0   0 0.2500000 0.2500000 0.2500000',
'  -1   0   0   0  -1   0   0   0  -1 0.0000000 0.0000000 0.0000000',
'   0  -1   0   1   0   0   0   0  -1 0.7500000 0.2500000 0.7500000',
'   1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.0000000',
'   0   1   0  -1   0   0   0   0  -1 0.7500000 0.7500000 0.2500000',
'  -1   0   0   0   0  -1   0   1   0 0.7500000 0.7500000 0.2500000',
'  -1   0   0   0   1   0   0   0   1 0.0000000 0.0000000 0.5000000',
'  -1   0   0   0   0   1   0  -1   0 0.2500000 0.7500000 0.7500000',
'   0   0   1   0  -1   0  -1   0   0 0.2500000 0.7500000 0.7500000',
'   1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.0000000',
'   0   0  -1   0  -1   0   1   0   0 0.7500000 0.2500000 0.7500000',
'   0  -1   0   0   0  -1  -1   0   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1  -1   0   0   0  -1   0 0.0000000 0.0000000 0.0000000',
'   0   0  -1   1   0   0   0   1   0 0.0000000 0.5000000 0.0000000',
'   0   1   0   0   0   1  -1   0   0 0.0000000 0.0000000 0.5000000',
'   0   0   1   1   0   0   0  -1   0 0.5000000 0.0000000 0.0000000',
'   0   1   0   0   0  -1   1   0   0 0.0000000 0.5000000 0.0000000',
'   0  -1   0   0   0   1   1   0   0 0.5000000 0.0000000 0.0000000',
'   0   0   1  -1   0   0   0   1   0 0.0000000 0.0000000 0.5000000',
'   0  -1   0  -1   0   0   0   0   1 0.2500000 0.7500000 0.7500000',
'   0   1   0   1   0   0   0   0   1 0.7500000 0.7500000 0.7500000',
'   1   0   0   0   0  -1   0  -1   0 0.7500000 0.2500000 0.7500000',
'   1   0   0   0   0   1   0   1   0 0.7500000 0.7500000 0.7500000',
'   0   0  -1   0   1   0  -1   0   0 0.7500000 0.7500000 0.2500000',
'   0   0   1   0   1   0   1   0   0 0.7500000 0.7500000 0.7500000',
'   1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.5000000',
'   0   1   0  -1   0   0   0   0   1 0.7500000 0.2500000 0.7500000',
'  -1   0   0   0  -1   0   0   0   1 0.5000000 0.0000000 0.5000000',
'   0  -1   0   1   0   0   0   0   1 0.7500000 0.7500000 0.2500000',
'   1   0   0   0   0   1   0  -1   0 0.7500000 0.7500000 0.2500000',
'   1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.0000000',
'   1   0   0   0   0  -1   0   1   0 0.2500000 0.7500000 0.7500000',
'   0   0  -1   0   1   0   1   0   0 0.2500000 0.7500000 0.7500000',
'  -1   0   0   0   1   0   0   0  -1 0.0000000 0.5000000 0.5000000',
'   0   0   1   0   1   0  -1   0   0 0.7500000 0.2500000 0.7500000',
'   0   1   0   0   0   1   1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0   1   1   0   0   0   1   0 0.5000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0  -1   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0  -1   1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0  -1  -1   0   0   0   1   0 0.0000000 0.5000000 0.5000000',
'   0  -1   0   0   0   1  -1   0   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0  -1  -1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0  -1   0 0.5000000 0.5000000 0.0000000',
'   0   1   0   1   0   0   0   0  -1 0.2500000 0.7500000 0.7500000',
'   0  -1   0  -1   0   0   0   0  -1 0.7500000 0.7500000 0.7500000',
'  -1   0   0   0   0   1   0   1   0 0.7500000 0.2500000 0.7500000',
'  -1   0   0   0   0  -1   0  -1   0 0.7500000 0.7500000 0.7500000',
'   0   0   1   0  -1   0   1   0   0 0.7500000 0.7500000 0.2500000',
'   0   0  -1   0  -1   0  -1   0   0 0.7500000 0.7500000 0.7500000',
'  -1   0   0   0  -1   0   0   0  -1 0.5000000 0.5000000 0.5000000',
'   0  -1   0   1   0   0   0   0  -1 0.2500000 0.7500000 0.2500000',
'   1   0   0   0   1   0   0   0  -1 0.5000000 0.0000000 0.5000000',
'   0   1   0  -1   0   0   0   0  -1 0.2500000 0.2500000 0.7500000',
'  -1   0   0   0   0  -1   0   1   0 0.2500000 0.2500000 0.7500000',
'  -1   0   0   0   1   0   0   0   1 0.5000000 0.5000000 0.0000000',
'  -1   0   0   0   0   1   0  -1   0 0.7500000 0.2500000 0.2500000',
'   0   0   1   0  -1   0  -1   0   0 0.7500000 0.2500000 0.2500000',
'   1   0   0   0  -1   0   0   0   1 0.0000000 0.5000000 0.5000000',
'   0   0  -1   0  -1   0   1   0   0 0.2500000 0.7500000 0.2500000',
'   0  -1   0   0   0  -1  -1   0   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1  -1   0   0   0  -1   0 0.5000000 0.5000000 0.5000000',
'   0   0  -1   1   0   0   0   1   0 0.5000000 0.0000000 0.5000000',
'   0   1   0   0   0   1  -1   0   0 0.5000000 0.5000000 0.0000000',
'   0   0   1   1   0   0   0  -1   0 0.0000000 0.5000000 0.5000000',
'   0   1   0   0   0  -1   1   0   0 0.5000000 0.0000000 0.5000000',
'   0  -1   0   0   0   1   1   0   0 0.0000000 0.5000000 0.5000000',
'   0   0   1  -1   0   0   0   1   0 0.5000000 0.5000000 0.0000000',
'   0  -1   0  -1   0   0   0   0   1 0.7500000 0.2500000 0.2500000',
'   0   1   0   1   0   0   0   0   1 0.2500000 0.2500000 0.2500000',
'   1   0   0   0   0  -1   0  -1   0 0.2500000 0.7500000 0.2500000',
'   1   0   0   0   0   1   0   1   0 0.2500000 0.2500000 0.2500000',
'   0   0  -1   0   1   0  -1   0   0 0.2500000 0.2500000 0.7500000',
'   0   0   1   0   1   0   1   0   0 0.2500000 0.2500000 0.2500000'
]

#-------------------------------------                           
class APanel(wx.Panel):
    def __init__(self, parent, size, pos):
       wx.Panel.__init__(self, parent, -1, size = size, pos = pos)

#-------------------------------------
# mainframe

class InsertFrame(wx.Frame):
  
    def __init__(self, parent, id):
        global wd, hd, wppanel, hppanel, wpar, hpar
        global tmes, font1, font2, font3, font4, font5, font6, font7
        global lw, wsl, hsl, hver, wout
        global inputang
        global wfi9, wfi12, wfi13, wfi14, wfi24, wfi25, wfi29, wfi31, wfi33, wfi34, wwe, wwp, wpp2
        global wh2, wh3, wiort, wtit5, wax, wtit9, wtit91, wrdir, wt
        global wrbsys, wtitp5, waxp, wtitp9, waxcp, wtitc9
        global axd1, axd11, axd2, axd22, axd3, axd33, axdr1, axdr11, axdr2, axdr22, axdr3, axdr33
        global hint, btnDemo, btnDemor, imac, lrot8
   
        (wd, hd) = wx.DisplaySize()   
        wdbase = 1440
        hdbase = 900

        wpar, hpar = 1, 1

        if wd != wdbase : wpar= float(wd)/float(wdbase) 
        if hd != hdbase : hpar = float(hd)/float(hdbase)
	
        font1 = wx.Font(10, wx.ROMAN, wx.NORMAL, wx.BOLD)
        font2 = wx.Font(11, wx.ROMAN, wx.NORMAL, wx.BOLD)
        font3 = wx.Font(11, wx.ROMAN, wx.NORMAL, wx.NORMAL)
        font4 = wx.Font(10, wx.MODERN, wx.NORMAL, wx.BOLD)
        font5 = wx.Font(11, wx.ROMAN, wx.NORMAL, wx.BOLD)
        font6 = wx.Font(10, wx.SWISS, wx.NORMAL, wx.NORMAL)
        font7 = wx.Font(9, wx.SWISS, wx.NORMAL, wx.NORMAL)
		 
        if 'wxGTK' in wx.PlatformInfo:
              font1 = wx.Font(10, wx.ROMAN, wx.NORMAL, wx.NORMAL)
              font2 = wx.Font(11, wx.ROMAN, wx.NORMAL, wx.NORMAL)
              font4 = wx.Font(10, wx.MODERN, wx.NORMAL, wx.NORMAL)
              font5 = wx.Font(11, wx.ROMAN, wx.NORMAL, wx.NORMAL)
	      
        if 'wxMac' in wx.PlatformInfo:
              font2 = wx.Font(12, wx.ROMAN, wx.NORMAL, wx.BOLD)
              imac = 1

        dc = wx.ScreenDC()
        dc.SetFont(font2)

        wrb2, hrb2 = dc.GetTextExtent('xyx  yzy  zxz  xzx  yxy  zyz  ')
        wrb3, hrb3 = dc.GetTextExtent('ttt ttc tct tcc ctt ctc cct ccc ')
        wrb4, hrb4 = dc.GetTextExtent('zx   zy   xy   xz   yz   yx   ')
        wrb5, hrb5 = dc.GetTextExtent('tt   tc   ct   cc   ')

        wch = 100
        if imac == 1: 
          wrb2 = int(1.5*wrb2)
          wrb3 = int(2*wrb3)
          wrb4 = int(1.5*wrb4)
          wrb5 = int(1.5*wrb5)
          wch = 0

        wfi1, hfi1 = dc.GetTextExtent("INPUT ROTATION")
        wfi3, hfi3 = dc.GetTextExtent("program")
        wfi4, hfi4 = dc.GetTextExtent("orthogonalisation")
        wfi9, hfi9 = dc.GetTextExtent(teuler1)
        wfi10, hfi10 = dc.GetTextExtent(teuler2)
        wfi11, hfi11 = dc.GetTextExtent(teuler3)
        wfi12, hfi12 = dc.GetTextExtent("demo")
        wfi13, hfi13 = dc.GetTextExtent(teuler4)
        wfi14, hfi14 = dc.GetTextExtent("choose from file")
        wfi15, hfi15 = dc.GetTextExtent("enter values")
        wfi16, hfi16 = dc.GetTextExtent("unit cell parameters")
        wfi17, hfi17 = dc.GetTextExtent("space group")
        wfi20, hfi20 = dc.GetTextExtent("output values")
        wfi21, hfi21 = dc.GetTextExtent("transform coordinates")
        wfi24, hfi24 = dc.GetTextExtent(tpolar3)
        wfi25, hfi25 = dc.GetTextExtent(tcos1)
        wfi28, hfi28 = dc.GetTextExtent(tpolar2)
        wfi29, hfi29 = dc.GetTextExtent("close")
        wfi30, hfi30 = dc.GetTextExtent("xyz  ")
        wfi31, hfi31 = dc.GetTextExtent(tpolar1)
        wfi32, hfi32 = dc.GetTextExtent(tcos2)
        wfi33, hfi33 = dc.GetTextExtent(tpolar4)
        wfi34, hfi34 = dc.GetTextExtent(tquat1)
        wwe, hhe = dc.GetTextExtent("around axis 1 =   ")
        wwp, hhp = dc.GetTextExtent("azimuth =   ")

        dc.SetFont(font1)
        wf1, hf1 = dc.GetTextExtent('phenix.refine ZYX')
        wf2, hf2 = dc.GetTextExtent(' i||(a+b), j||c*x(a+b), k||c*')

        dc.SetFont(font3)
        wt, ht = dc.GetTextExtent('-0.9999')

        dc.SetFont(font4)
        wf4, hf4 = dc.GetTextExtent("1004  P2(1)-A (P 21 1 1)")

        dc.SetFont(font5)
        wh2, hh2 = dc.GetTextExtent("Close") 
        wh3, hh3 = dc.GetTextExtent("transparent") 
 
        hsl = int(10*hpar)
        hint = int(5*hpar)
        wsl = 20

        hver = hfi1*hpar

        if imac == 1 : 
          hver = hfi1*hpar+5
          lrot8 = ['ttt', 'ttc', 'tct', 'tcc', 'ctt', 'ctc', 'cct', 'ccc']

        wppanel = int(2*(wsl+wfi3+wfi4+2*wf1+100*wpar)+160*wpar)
        hppanel = int(hsl+44*hver)

        titl = 'PYM_CONVROT Python3 version 2.1 from 27.08.2020 Authors : L.Urzhumtseva & A.Urzhumtsev' 

        print("*** program PYM_CONVROT: conversion of rotation parameters ***", file = fileout)

        print("                   (Euler and polar angles, etc)", file = fileout) 
        print("                Python3 + wxPython, version 2.1, Aug 22, 2020", file = fileout)
        print("             Authors :  L.Urzhumtseva & A.Urzhumtsev", file = fileout)
        print(70*"-"+"\n", file = fileout) 

        xfmain = 10
        yfmain = int(20*hpar) 
        posmainframe = (xfmain, yfmain)
 
        wx.Frame.__init__(self, None, -1, title = titl, pos = posmainframe, size = (wppanel, hppanel),
          style = wx.DEFAULT_FRAME_STYLE & ~(wx.RESIZE_BORDER | wx.MAXIMIZE_BOX))
        self.CreatePpanel(self)  

        lw = int(wppanel/2-20)
        lh = int(hppanel-45*hpar)

        wrbsys = 40
        if imac == 1: wrbsys = 60
        wax = int((lw-(wrb2+120))/2)
        wrdir = int((lw-(wrb3+160))/2)
        waxp = int((lw-(wrb4+120))/2)
        waxcp =  int((lw-(wrb5+80))/2)

        wtit1 = int((lw-wfi1)/2)
        wtit3 = int(wsl+wfi3+wf1+50)
        wtit5 = int((lw-wfi9)/2)
        wtit9 = int((lw-wfi10)/2+10)
        wtit91 = int((lw-wfi11)/2+10)
        wtitp5 = int((lw-wfi31)/2)
        wtitp9 = int((lw-wfi28)/2)
        wtitc9 = int((lw-wfi32)/2+10)

        wiprog = int(wsl+wfi3+5)
        wiort = int(wsl+wfi3+wf1+wfi4+60)
        hp5 = int(5*hpar)
        hp40 = int(40*hpar)
        wpp2 = int(wppanel/2)
              
        wx.StaticLine(self.ppanel, -1, pos =(5,hp5), size = (lw,4), style =wx.LI_HORIZONTAL)
        wx.StaticLine(self.ppanel, -1, pos =(5,hppanel-hp40), size = (lw,4), style =wx.LI_HORIZONTAL)
        wx.StaticLine(self.ppanel, -1, pos =(5,hp5), size = (4,lh), style =wx.LI_VERTICAL)
        wx.StaticLine(self.ppanel, -1, pos =(wpp2-15,hp5), size = (4,lh), style =wx.LI_VERTICAL)

        wx.StaticLine(self.ppanel, -1, pos =(wpp2+5,hp5), size = (lw,4), style =wx.LI_HORIZONTAL)
        wx.StaticLine(self.ppanel, -1, pos =(wpp2+5,hppanel-hp40), size = (lw,4), style =wx.LI_HORIZONTAL)
        wx.StaticLine(self.ppanel, -1, pos =(wpp2+5,hp5), size = (4,lh), style =wx.LI_VERTICAL)
        wx.StaticLine(self.ppanel, -1, pos =(wpp2+lw+5,hp5), size = (4,lh), style =wx.LI_VERTICAL)

# INPUT

        self.imax, self.ax, self.rdiri = "", "", ""
        self.axp, self.axcp = "", ""
        self.axcc = ""
        self.tit5, self.tit9, self.tit91, self.tit10 = "", "", "", ""
        
        tit1 = wx.StaticText(self.ppanel, -1, "INPUT", pos =(10, 10))
        tit1.SetFont(font2)

        rbsys = self.rbsys = wx.RadioBox(self.ppanel, pos = (int(wsl-5), int(hsl+hver)),  size = (0, 0), choices = tsys,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)

        rbsys.SetFont(font2)
        self.rbsys.SetSelection(0)
        self.rbsys.Bind(wx.EVT_RADIOBOX, self.SystemInputSelect)

        tit2 = wx.StaticText(self.ppanel, -1, "program", pos =(wsl-5, int(hsl+4*hver)))
        tit2.SetFont(font2)
        self.iprog = wx.ListBox(self.ppanel, -1, choices= tbeuler, pos =(wiprog, int(hsl+4.5*hver)), size=(wf1+40, int(3*hver)))
        self.iprog.SetFont(font7)
        self.iprog.SetSelection(icinp)
        self.Bind(wx.EVT_LISTBOX, self.OnProgramInput, self.iprog)

        tit3 = wx.StaticText(self.ppanel, -1, "orthogonalisation", pos =(wtit3, int(hsl+4*hver)))
        tit3.SetFont(font2)
        tit3a = wx.StaticText(self.ppanel, -1, "         x, y, z along", pos =(wtit3, int(hsl+5*hver)))
        tit3a.SetFont(font2)
        self.iorth = wx.ListBox(self.ppanel, -1, choices=trot, pos=(wiort,  int(hsl+4.5*hver)), size=(wf2+40,  int(3*hver)))
        self.iorth.SetFont(font6)
        self.iorth.SetSelection(north1)
        self.Bind(wx.EVT_LISTBOX, self.OnNorthInput, self.iorth)

        self.irot = wx.RadioBox(self.ppanel, pos = (wax+20, int(hsl+7*hver)), size = (0, 0), choices = typerot,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        self.irot.SetFont(font2)
        self.irot.SetSelection(inrot)
        self.irot.Bind(wx.EVT_RADIOBOX, self.InputRot)

        self.imax = wx.RadioBox(self.ppanel, pos = (wax+20, int(hsl+9*hver)), size = (0, 0), choices = typeaxes,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        self.imax.SetFont(font2)
        self.imax.SetSelection(inaxes)
        self.imax.Bind(wx.EVT_RADIOBOX, self.InputAxes)

        tit5 = self.tit5 = wx.StaticText(self.ppanel, -1, teuler1, pos =(wtit5, int(hsl+12*hver)))
        tit5.SetFont(font2)

        ax = self.ax = wx.RadioBox(self.ppanel, pos = (wax, int(hsl+12.5*hver)), size = (0, 0), choices = lax12,
              majorDimension = 6, style = wx.RA_SPECIFY_COLS | wx.NO_BORDER)
        ax.SetFont(font2)
        self.ax.SetSelection(0)
        self.ax.Bind(wx.EVT_RADIOBOX, self.OnAxisInput)

        tit9 = self.tit9 = wx.StaticText(self.ppanel, -1, teuler2, pos =(wtit9, int(hsl+17.2*hver)))
        tit9.SetFont(font2)
        tit91 = self.tit91 = wx.StaticText(self.ppanel, -1, teuler3, pos =(wtit91, int(hsl+18.5*hver)))
        tit91.SetFont(font2)

        rdiri = self.rdiri = wx.RadioBox(self.ppanel, pos = (wrdir, int(hsl+19*hver)), size = (0, 0), choices = lrot8,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        rdiri.SetFont(font2)
        self.rdiri.SetSelection(0)
        self.rdiri.Bind(wx.EVT_RADIOBOX, self.InputRotDir)

        btnDemo = self.btnDemo = wx.Button(self.ppanel, -1, 'demo', (int((lw-wfi12)/2), int(hsl+22*hver)), (wfi12+20, int(2*hver)))
        btnDemo.SetBackgroundColour(col4) 
        btnDemo.SetFont(font2)
        btnDemo.Bind(wx.EVT_BUTTON, self.OnDemo)

        wx.StaticLine(self.ppanel, -1, pos =(5,int(hsl+24*hver)), size = (lw,3), style =wx.LI_HORIZONTAL)

        tit10 = self.tit10 = wx.StaticText(self.ppanel, -1, teuler4, pos =(int((lw-wfi13)/2), int(hsl+24.5*hver)))
        tit10.SetFont(font2)

        rbbrow = self.rbbrow = wx.RadioButton(self.ppanel, -1, "choose from file", (wsl, int(hsl+26*hver)), (wfi14+20, int(1.5*hver)))
        rbbrow.SetFont(font2)
        self.Bind(wx.EVT_RADIOBUTTON, self.FilenameBrowse, self.rbbrow)   

        inpfile1 = self.inpfile1 = wx.TextCtrl(self.ppanel, -1, Filename1, pos=(wsl+wfi14+30, int(hsl+26*hver)), 
                    size=(lw-wsl-wfi14-40, int(1.5*hver)), style = wx.TE_PROCESS_ENTER)
        inpfile1.SetFont(font2) 
        zz = os.getcwd()
        self.inpfile1.SetValue(zz)
        inpfile1.Bind(wx.EVT_TEXT_ENTER, self.FilenameEnter)

        rbtype = self.rbtype = wx.RadioButton(self.ppanel, -1, "enter values", (wsl, int(hsl+28.5*hver)), (wfi15+20, int(1.5*hver)))
        rbtype.SetFont(font2) 
        self.Bind(wx.EVT_RADIOBUTTON, self.AngDef, self.rbtype)  
        rbtype.SetValue(1)

        inputang = self.inputang = wx.TextCtrl(self.ppanel, -1, '0. 0. 0.', pos=(wsl+wfi14+30, int(hsl+28.2*hver)), 
                   size=(lw-wsl-wfi14-40, int(4.5*hver)), style = wx.TE_PROCESS_ENTER | wx.TE_MULTILINE)
        inputang.SetFont(font3) 
        inputang.Bind(wx.EVT_TEXT_ENTER, self.SwType)

        wx.StaticLine(self.ppanel, -1, pos =(5,int(hsl+33*hver)), size = (lw,3), style =wx.LI_HORIZONTAL)

        tit11 = wx.StaticText(self.ppanel, -1, "unit cell parameters", pos =(wsl, int(hsl+33.5*hver)))
        tit11.SetFont(font2)  
        inputcell = self.inputcell = wx.TextCtrl(self.ppanel, -1, Cell, pos=(wsl+wfi16+10, int(hsl+33.5*hver)), 
                    size=(lw-wfi16-40, int(1.5*hver)), style = wx.TE_PROCESS_ENTER)
        inputcell.SetFont(font2) 
        inputcell.Bind(wx.EVT_TEXT_ENTER, self.CleanMes)

        tit12 = wx.StaticText(self.ppanel, -1, "space group", pos =(wsl, int(hsl+36*hver)))
        tit12.SetFont(font2) 
        self.group = wx.ListBox(self.ppanel, -1, choices= grouplist, pos =(wsl+wfi16+10, int(hsl+35.6*hver)), 
                     size=(wf4+30, int(3.5*hver)))
        self.group.SetFont(font3)
        self.group.SetSelection(cgroup)
        self.Bind(wx.EVT_LISTBOX, self.Evtgroup, self.group) 

# OUTPUT

        self.imaxr, self.axr, self.rdirr = "", "", ""
        self.axpr, self.axcpr = "", ""
        self.axccr = ""
        self.titr5, self.titr9, self.titr91 = "", "", ""

        wout = lw + 20

        tt1 = wx.StaticText(self.ppanel, -1, "OUTPUT", pos =(lw+30,10))
        tt1.SetFont(font2)

        rbsysr = self.rbsysr= wx.RadioBox(self.ppanel, pos = (wout+wsl-5, int(hsl+hver)), size = (0, 0), choices = tsys,
              majorDimension = 1, style =  wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        rbsysr.SetFont(font2)
        self.rbsysr.SetSelection(0)
        self.rbsysr.Bind(wx.EVT_RADIOBOX, self.SystemOutputSelect)

        tit2 = wx.StaticText(self.ppanel, -1, "program", pos =(wsl+wout-5, int(hsl+4*hver)))
        tit2.SetFont(font2)
        self.iprogr = wx.ListBox(self.ppanel, -1, choices= tbeuler, pos =(wout+wiprog, int(hsl+4.5*hver)), size=(wf1+40, int(3*hver)))
        self.iprogr.SetFont(font7)
        self.iprogr.SetSelection(icout)
        self.Bind(wx.EVT_LISTBOX, self.OnProgramOutput, self.iprogr)

        tit3 = wx.StaticText(self.ppanel, -1, "orthogonalisation", pos =(wout+wtit3, int(hsl+4*hver)))
        tit3.SetFont(font2)
        tit3b = wx.StaticText(self.ppanel, -1, "         x, y, z along", pos =(wout+wtit3, int(hsl+5*hver)))
        tit3b.SetFont(font2)
        self.iorthr = wx.ListBox(self.ppanel, -1, choices= trot, pos =(wout+wiort, int(hsl+4.5*hver)), size=(wf2+40, int(3*hver)))
        self.iorthr.SetFont(font6)
        self.iorthr.SetSelection(north2)
        self.Bind(wx.EVT_LISTBOX, self.OnNorthOutput, self.iorthr)

        self.irotr = wx.RadioBox(self.ppanel, pos = (wout+wax+20, int(hsl+7*hver)), size = (0, 0), choices = typerot,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        self.irotr.SetFont(font2)
        self.irotr.SetSelection(outrot)
        self.irotr.Bind(wx.EVT_RADIOBOX, self.OutputRot)

        self.imaxr = wx.RadioBox(self.ppanel, pos = (wout+wax+20, int(hsl+9*hver)), size = (0, 0), choices = typeaxes,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        self.imaxr.SetFont(font2)
        self.imaxr.SetSelection(outaxes)
        self.imaxr.Bind(wx.EVT_RADIOBOX, self.OutputAxes)

        titr5 = self.titr5 = wx.StaticText(self.ppanel, -1, teuler1, pos =(wout+wtit5, int(hsl+12*hver)))
        titr5.SetFont(font2)

        axr = self.axr = wx.RadioBox(self.ppanel, pos = (wout+wax, int(hsl+12.5*hver)), size = (0, 0), choices = lax12,
              majorDimension = 6, style = wx.RA_SPECIFY_COLS | wx.NO_BORDER)
        axr.SetFont(font2)
        self.axr.SetSelection(0)
        self.axr.Bind(wx.EVT_RADIOBOX, self.OnAxisOutput)

        titr9 = self.titr9 = wx.StaticText(self.ppanel, -1, teuler2, pos =(wout+wtit9, int(hsl+17.2*hver)))
        titr9.SetFont(font2)
        titr91 = self.titr91 = wx.StaticText(self.ppanel, -1, teuler3, pos =(wout+wtit91, int(hsl+18.5*hver)))
        titr91.SetFont(font2)

        rdirr = self.rdirr = wx.RadioBox(self.ppanel, pos = (wout+wrdir, int(hsl+19*hver)), size = (0, 0), choices = lrot8,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        rdirr.SetFont(font2)
        self.rdirr.SetSelection(0)
        self.rdirr.Bind(wx.EVT_RADIOBOX, self.OutputRotDir)

        btnDemor = self.btnDemor = wx.Button(self.ppanel, -1, 'demo', (int(wout+(lw-wfi12)/2), int(hsl+22*hver)), (wfi12+20, int(2*hver)))
        btnDemor.SetBackgroundColour(col4) 
        btnDemor.SetFont(font2)
        btnDemor.Bind(wx.EVT_BUTTON, self.OnDemor)
        if len(angoutlist) == 0: btnDemor.Disable()

        wx.StaticLine(self.ppanel, -1, pos =(wout+5, int(hsl+24*hver)), size = (lw,3), style =wx.LI_HORIZONTAL)

        titr10 = wx.StaticText(self.ppanel, -1, "output values", pos =(int(wout+(lw-wfi20)/2), int(hsl+24.5*hver)))
        titr10.SetFont(font2)

        tmes = wx.TextCtrl(self.ppanel, -1, pos=(wout+7, int(hsl+26*hver)), size=(lw-2, int(8*hver)), style = wx.TE_MULTILINE|wx.CB_READONLY)
        tmes.SetForegroundColour(col2) 
        tmes.SetFont(font6)   

        btnParam = wx.Button(self.ppanel, -1, 'transform parameters', (wout+80, int(hsl+34.5*hver)), (wfi21+30, int(2*hver)))
        btnParam.SetBackgroundColour(col4) 
        btnParam.SetFont(font2)
        btnParam.Bind(wx.EVT_BUTTON, self.Param_Trans)

        btnCoor = wx.Button(self.ppanel, -1, 'transform coordinates', (wout+80, int(hsl+37*hver)), (wfi21+30, int(2*hver)))
        btnCoor.SetBackgroundColour(col4) 
        btnCoor.SetFont(font2)
        btnCoor.Bind(wx.EVT_BUTTON, self.Coor_Trans)

        btnHelp = self.btnHelp = wx.Button(self.ppanel, -1, 'help', (wppanel-wfi12-85, int(hsl+34.5*hver)), (wfi12+20, int(2*hver)))
        btnHelp.SetBackgroundColour(col4) 
        btnHelp.SetFont(font2)
        btnHelp.Bind(wx.EVT_BUTTON, self.OnSearchMenu)

        btnExit = wx.Button(self.ppanel, -1, 'exit', (wppanel-wfi12-85, int(hsl+37*hver)), (wfi12+20, int(2*hver)))
        btnExit.SetBackgroundColour(col4) 
        btnExit.SetFont(font2)
        btnExit.Bind(wx.EVT_BUTTON, self.OnCloseWindows)
        self.Bind(wx.EVT_CLOSE, self.OnCloseWindows)

#-------------------------------------
# input: choose the system

    def SystemInputSelect(self, evt):
        global insys, inaxes, inrot, north1, scx, cang1, cang2, cang3, kappa

        insys = self.rbsys.GetSelection()

        inrot = 0
        inaxes = 0
        icinp = 0
        north1 = 0
        scx = 1.
 
        if insys < 2: 
          cang1, cang2, cang3 = 0., 0., 0.
          self.inputang.SetValue('0. 0. 0.')
        if insys == 2:
          cang1, cang2, cang3, kappa = 0., 0., 1., 0.
          self.inputang.SetValue('0. 0. 1. 0.')
        if insys == 4:
          cang1, cang2, cang3, kappa = 1., 0., 0., 0.
          self.inputang.SetValue('1. 0. 0. 0.')

        self.CleanMes(evt)
        if demowin: demowin.Destroy()

        self.iorth.SetSelection(north1)
        if insys == 0: 
           self.EulerInputSelect(self)
           self.iprog.Clear()
           self.iprog.InsertItems(tbeuler,0)
           self.iprog.SetSelection(icinp)
           btnDemo.Enable()
        if insys == 1: 
           self.PolarInputSelect(self)
           self.iprog.Clear()
           self.iprog.InsertItems(tbpolar,0)
           self.iprog.SetSelection(icinp)
           btnDemo.Enable()
        if insys == 2: 
           self.CosInputSelect(self)
           self.iprog.Clear()
           self.iprog.InsertItems(tbcos,0)
           self.iprog.SetSelection(icinp)
           btnDemo.Enable()
        if insys == 3: 
           self.MatrixInputSelect(self)
           self.iprog.Clear()
           self.iprog.InsertItems(tbmat,0)
           self.iprog.SetSelection(icinp)
           btnDemo.Disable()
        if insys == 4: 
           self.QuatInputSelect(self)
           self.iprog.Clear()
           self.iprog.InsertItems(tbquat,0)
           self.iprog.SetSelection(icinp)
           btnDemo.Enable()
        
#-------------------------------------
# output: choose the system

    def SystemOutputSelect(self, evt):
        global outsys, outaxes, outrot, north2, scx

        outsys = self.rbsysr.GetSelection() 

        outrot = 0
        outaxes = 0
        icout = 0
        north2 = 0
        scx = 1.

        self.CleanMes(evt)
        if demowinr: demowinr.Destroy()
    
        self.iorthr.SetSelection(north2)

        if outsys == 0: 
           self.EulerOutputSelect(self)
           self.iprogr.Clear()
           self.iprogr.InsertItems(tbeuler,0)
           self.iprogr.SetSelection(icout)
           if len(anglist) != 0: btnDemor.Enable()
        if outsys == 1: 
           self.PolarOutputSelect(self)
           self.iprogr.Clear()
           self.iprogr.InsertItems(tbpolar,0)
           self.iprogr.SetSelection(icout)
           if len(anglist) != 0: btnDemor.Enable()
        if outsys == 2: 
           self.CosOutputSelect(self)
           self.iprogr.Clear()
           self.iprogr.InsertItems(tbcos,0)
           self.iprogr.SetSelection(icout)
           if len(anglist) != 0: btnDemor.Enable()
        if outsys == 3: 
           self.MatrixOutputSelect(self)
           self.iprogr.Clear()
           self.iprogr.InsertItems(tbmat,0)
           self.iprogr.SetSelection(icout)
           btnDemor.Disable()
        if outsys == 4: 
           self.QuatOutputSelect(self)
           self.iprogr.Clear()
           self.iprogr.InsertItems(tbquat,0)
           self.iprogr.SetSelection(icout)
           if len(anglist) != 0: btnDemor.Enable()

#-------------------------------------
# input: choose the Euler system

    def EulerInputSelect(self, evt):

        self.CleanInput(self)

        self.iprog.SetSelection(0)
        self.Bind(wx.EVT_LISTBOX, self.OnProgramInput, self.iprog)

        self.irot = wx.RadioBox(self.ppanel, pos = (wax+20, int(hsl+7*hver)), size = (0, 0), choices = typerot,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        self.irot.SetFont(font2)
        self.irot.SetSelection(inrot)
        self.irot.Bind(wx.EVT_RADIOBOX, self.InputRot)

        self.imax = wx.RadioBox(self.ppanel, pos = (wax+20, int(hsl+9*hver)), size = (0, 0), choices = typeaxes,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        self.imax.SetFont(font2)
        self.imax.SetSelection(inaxes)
        self.imax.Bind(wx.EVT_RADIOBOX, self.InputAxes)

        tit5 = self.tit5 = wx.StaticText(self.ppanel, -1, teuler1, pos =(wtit5, int(hsl+12*hver)))
        tit5.SetFont(font2)

        ax = self.ax = wx.RadioBox(self.ppanel, pos = (wax, int(hsl+12.5*hver)), size = (0, 0), choices = lax12,
              majorDimension = 6, style = wx.RA_SPECIFY_COLS | wx.NO_BORDER)
        ax.SetFont(font2)
        self.ax.SetSelection(0)
        self.ax.Bind(wx.EVT_RADIOBOX, self.OnAxisInput)

        tit9 = self.tit9 = wx.StaticText(self.ppanel, -1, teuler2, pos =(wtit9, int(hsl+17.2*hver)))
        tit9.SetFont(font2)
        tit91 = self.tit91 = wx.StaticText(self.ppanel, -1, teuler3, pos =(wtit91, int(hsl+18.5*hver)))
        tit91.SetFont(font2)

        rdiri = self.rdiri = wx.RadioBox(self.ppanel, pos = (wrdir, int(hsl+19*hver)), size = (0, 0), choices = lrot8,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        rdiri.SetFont(font2)
        self.rdiri.SetSelection(0)
        self.rdiri.Bind(wx.EVT_RADIOBOX, self.InputRotDir)

        wx.StaticLine(self.ppanel, -1, pos =(5,int(hsl+24*hver)), size = (lw,3), style =wx.LI_HORIZONTAL)

        tit10 = self.tit10 = wx.StaticText(self.ppanel, -1, teuler4, pos =(int((lw-wfi13)/2), int(hsl+24.5*hver)))
        tit10.SetFont(font2)

        self.Refresh()

#-------------------------------------
# output: choose the Euler system

    def EulerOutputSelect(self, evt):

        self.CleanOutput(self)

        self.iprogr.SetSelection(0)
        self.Bind(wx.EVT_LISTBOX, self.OnProgramOutput, self.iprogr)

        self.irotr = wx.RadioBox(self.ppanel, pos = (wout+wax+20, int(hsl+7*hver)), size = (0, 0), choices = typerot,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        self.irotr.SetFont(font2)
        self.irotr.SetSelection(outrot)
        self.irotr.Bind(wx.EVT_RADIOBOX, self.OutputRot)

        self.imaxr = wx.RadioBox(self.ppanel, pos = (wout+wax+20, int(hsl+9*hver)), size = (0, 0), choices = typeaxes,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        self.imaxr.SetFont(font2)
        self.imaxr.SetSelection(outaxes)
        self.imaxr.Bind(wx.EVT_RADIOBOX, self.OutputAxes)

        titr5 = self.titr5 = wx.StaticText(self.ppanel, -1, teuler1, pos =(wout+wtit5, int(hsl+12*hver)))
        titr5.SetFont(font2)

        axr = self.axr = wx.RadioBox(self.ppanel, pos = (wout+wax, int(hsl+12.5*hver)), size = (0, 0), choices = lax12,
              majorDimension = 6, style = wx.RA_SPECIFY_COLS | wx.NO_BORDER)
        axr.SetFont(font2)
        self.axr.SetSelection(0)
        self.axr.Bind(wx.EVT_RADIOBOX, self.OnAxisOutput)

        titr9 = self.titr9 = wx.StaticText(self.ppanel, -1, teuler2, pos =(wout+wtit9, int(hsl+17.2*hver)))
        titr9.SetFont(font2)
        titr91 = self.titr91 = wx.StaticText(self.ppanel, -1, teuler3, pos =(wout+wtit91, int(hsl+18.5*hver)))
        titr91.SetFont(font2)

        rdirr = self.rdirr = wx.RadioBox(self.ppanel, pos = (wout+wrdir, int(hsl+19*hver)), size = (0, 0), choices = lrot8,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        rdirr.SetFont(font2)
        self.rdirr.SetSelection(0)

        self.rdirr.Bind(wx.EVT_RADIOBOX, self.OutputRotDir)

        self.Refresh()

#-------------------------------------
# input: choose the polar system

    def PolarInputSelect(self, evt):

        self.CleanInput(self)

        self.iprog.SetSelection(0)
        self.Bind(wx.EVT_LISTBOX, self.OnProgramInput, self.iprog)

        self.irot = wx.RadioBox(self.ppanel, pos = (wax+20, int(hsl+7*hver)), size = (0, 0), choices = typerot,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        self.irot.SetFont(font2)
        self.irot.SetSelection(inrot)
        self.irot.Bind(wx.EVT_RADIOBOX, self.InputRot)

        titp5 = self.tit5 = wx.StaticText(self.ppanel, -1, tpolar1, pos =(wtitp5, int(hsl+10.5*hver)), size = (lw, int(hver)))
        titp5.SetFont(font2)

        axp = self.axp = wx.RadioBox(self.ppanel, pos = (waxp, int(hsl+12*hver)), size = (0, 0), choices = laxp6,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        axp.SetFont(font2)
        self.axp.SetSelection(0)

        self.axp.Bind(wx.EVT_RADIOBOX, self.OnAxisPolInput)

        titp9 = self.tit9 = wx.StaticText(self.ppanel, -1, tpolar2, pos =(wtitp9, int(hsl+16.5*hver)))
        titp9.SetFont(font2)
        tit91 = self.tit91 = wx.StaticText(self.ppanel, -1, teuler3, pos =(wtit91, int(hsl+18*hver)))
        tit91.SetFont(font2)

        axcp = self.axcp = wx.RadioBox(self.ppanel, pos = (waxcp, int(hsl+19*hver)), size = (0, 0), choices = lrotp4,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        axcp.SetFont(font2)
        self.axcp.SetSelection(0)

        self.axcp.Bind(wx.EVT_RADIOBOX, self.InputPolRotDir)

        tit10 = self.tit10 = wx.StaticText(self.ppanel, -1, tpolar3, pos =(int((lw-wfi24)/2), int(hsl+24.5*hver)))
        tit10.SetFont(font2)

        self.Refresh()

#-------------------------------------
# output: choose the polar system

    def PolarOutputSelect(self, evt):

        self.CleanOutput(self)

        self.iprogr.SetSelection(0)
        self.Bind(wx.EVT_LISTBOX, self.OnProgramOutput, self.iprogr)

        self.irotr = wx.RadioBox(self.ppanel, pos = (wout+wax+20, int(hsl+7*hver)), size = (0, 0), choices = typerot,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        self.irotr.SetFont(font2)
        self.irotr.SetSelection(outrot)
        self.irotr.Bind(wx.EVT_RADIOBOX, self.OutputRot)

        titpr5 = self.titr5 = wx.StaticText(self.ppanel, -1, tpolar1, pos =(wout+wtitp5, int(hsl+10.5*hver)), size = (lw, int(hver)))
        titpr5.SetFont(font2)

        axpr = self.axpr = wx.RadioBox(self.ppanel, pos = (wout+waxp, int(hsl+12*hver)), size = (0, 0), choices = laxp6,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        axpr.SetFont(font2)
        self.axpr.SetSelection(0)

        self.axpr.Bind(wx.EVT_RADIOBOX, self.OnAxisPolOutput)  

        titr9 = self.titr9 = wx.StaticText(self.ppanel, -1, tpolar2, pos =(wout+wtitp9, int(hsl+16.5*hver)))
        titr9.SetFont(font2)

        titr91 = self.titr91 = wx.StaticText(self.ppanel, -1, teuler3, pos =(wout+wtit91, int(hsl+18*hver)))
        titr91.SetFont(font2)

        axcpr = self.axcpr = wx.RadioBox(self.ppanel, pos = (wout+waxcp, int(hsl+19*hver)), size = (0, 0), choices = lrotp4,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        axcpr.SetFont(font2)
        self.axcpr.SetSelection(0)

        self.axcpr.Bind(wx.EVT_RADIOBOX, self.OutputPolRotDir)

        self.Refresh()

#-------------------------------------
# input: choose the cos system

    def CosInputSelect(self, evt):

        self.CleanInput(self)

        self.iprog.SetSelection(0)
        self.Bind(wx.EVT_LISTBOX, self.OnProgramInput, self.iprog)

        self.irot = wx.RadioBox(self.ppanel, pos = (wax+20, int(hsl+7*hver)), size = (0, 0), choices = typerot,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        self.irot.SetFont(font2)
        self.irot.SetSelection(inrot)
        self.irot.Bind(wx.EVT_RADIOBOX, self.InputRot)

        titc9 = self.tit9 = wx.StaticText(self.ppanel, -1, tcos2, pos =(wtitc9, int(hsl+15.5*hver)))
        titc9.SetFont(font2)

        self.axcc = wx.RadioBox(self.ppanel, pos = (wax, int(hsl+17*hver)), size = (0, 0), choices = lrotc2,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        self.axcc.SetFont(font2)
        self.axcc.SetSelection(indirc)
        self.axcc.Bind(wx.EVT_RADIOBOX, self.InputCosRotDir)

        tit10 = self.tit10 = wx.StaticText(self.ppanel, -1, tcos1, pos =(int((lw-wfi25)/2), int(hsl+24.5*hver)))
        tit10.SetFont(font2)

        self.Refresh()

#-------------------------------------
# output: choose the cos system

    def CosOutputSelect(self, evt):

        self.CleanOutput(self)

        self.iprogr.SetSelection(0)
        self.Bind(wx.EVT_LISTBOX, self.OnProgramOutput, self.iprogr)

        self.irotr = wx.RadioBox(self.ppanel, pos = (wout+wax+20, int(hsl+7*hver)), size = (0, 0), choices = typerot,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        self.irotr.SetFont(font2)
        self.irotr.SetSelection(outrot)
        self.irotr.Bind(wx.EVT_RADIOBOX, self.OutputRot)

        titr9 = self.titr9 = wx.StaticText(self.ppanel, -1, tcos2, pos =(wout+wtitc9, int(hsl+15.5*hver)))
        titr9.SetFont(font2)

        self.axccr = wx.RadioBox(self.ppanel, pos = (wout+wax, int(hsl+17*hver)), size = (0, 0), choices = lrotc2,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        self.axccr.SetFont(font2)
        self.axccr.SetSelection(outdirc)
        self.axccr.Bind(wx.EVT_RADIOBOX, self.OutputCosRotDir)

        self.Refresh()

#-------------------------------------
# input: choose the matrix system

    def MatrixInputSelect(self, evt):

        self.CleanInput(self)

        self.iprog.SetSelection(0)
        self.Bind(wx.EVT_LISTBOX, self.OnProgramInput, self.iprog)

        tit10 = self.tit10 = wx.StaticText(self.ppanel, -1, tmatrix1, pos =(int((lw-wfi25)/2), int(hsl+24.5*hver)))
        tit10.SetFont(font2)

        self.Refresh()

#-------------------------------------
# output: choose the matrix system

    def MatrixOutputSelect(self, evt):

        self.CleanOutput(self)

        self.iprogr.SetSelection(0)
        self.Bind(wx.EVT_LISTBOX, self.OnProgramOutput, self.iprogr)

        self.Refresh()

#-------------------------------------
# input: choose the quaternion system

    def QuatInputSelect(self, evt):

        self.CleanInput(self)

        self.iprog.SetSelection(0)
        self.Bind(wx.EVT_LISTBOX, self.OnProgramInput, self.iprog)

        self.irot = wx.RadioBox(self.ppanel, pos = (wax+20, int(hsl+7*hver)), size = (0, 0), choices = typerot,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        self.irot.SetFont(font2)
        self.irot.SetSelection(inrot)
        self.irot.Bind(wx.EVT_RADIOBOX, self.InputRot)

        tit9 = self.tit9 = wx.StaticText(self.ppanel, -1, tcos2, pos =(wtitc9, int(hsl+15.5*hver)))
        tit9.SetFont(font2)

        self.axcc = wx.RadioBox(self.ppanel, pos = (wax, int(hsl+17*hver)), size = (0, 0), choices = lrotc2,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        self.axcc.SetFont(font2)
        self.axcc.SetSelection(indirc)
        self.axcc.Bind(wx.EVT_RADIOBOX, self.InputQuatRotDir)

        tit10 = self.tit10 = wx.StaticText(self.ppanel, -1, tquat1, pos =(int((lw-wfi34)/2), int(hsl+24.5*hver)))
        tit10.SetFont(font2)

        self.Refresh()

#-------------------------------------
# output: choose the quaternion system

    def QuatOutputSelect(self, evt):

        self.CleanOutput(self)

        self.iprogr.SetSelection(0)
        self.Bind(wx.EVT_LISTBOX, self.OnProgramOutput, self.iprogr)

        self.irotr = wx.RadioBox(self.ppanel, pos = (wout+wax+20, int(hsl+7*hver)), size = (0, 0), choices = typerot,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        self.irotr.SetFont(font2)
        self.irotr.SetSelection(outrot)
        self.irotr.Bind(wx.EVT_RADIOBOX, self.OutputRot)

        titr9 = self.titr9 = wx.StaticText(self.ppanel, -1, tcos2, pos =(wout+wtitc9, int(hsl+15.5*hver)))
        titr9.SetFont(font2)

        self.axccr = wx.RadioBox(self.ppanel, pos = (wout+wax, int(hsl+17*hver)), size = (0, 0), choices = lrotc2,
              majorDimension = 1, style = wx.RA_SPECIFY_ROWS | wx.NO_BORDER)
        self.axccr.SetFont(font2)
        self.axccr.SetSelection(outdirc)
        self.axccr.Bind(wx.EVT_RADIOBOX, self.OutputQuatRotDir)

        self.Refresh()

#-------------------------------------
# input: clean

    def CleanInput(self, evt):
        global icinp

        icinp = 0

        if self.irot: self.irot.Destroy()

        if self.imax: self.imax.Destroy()
        if self.tit5: self.tit5.Destroy()
        if self.ax: self.ax.Destroy()
        if self.tit9: self.tit9.Destroy()
        if self.tit91: self.tit91.Destroy()
        if self.rdiri: self.rdiri.Destroy()
        if self.tit10: self.tit10.Destroy()

        if self.axp: self.axp.Destroy()
        if self.axcp: self.axcp.Destroy()
        if self.axcc: self.axcc.Destroy()

#-------------------------------------
# output: clean

    def CleanOutput(self, evt):
        global icout

        icout = 0

        if self.irotr: self.irotr.Destroy()

        if self.imaxr: self.imaxr.Destroy()
        if self.titr5: self.titr5.Destroy()
        if self.axr: self.axr.Destroy()
        if self.rdirr: self.rdirr.Destroy()
        if self.titr9: self.titr9.Destroy()
        if self.titr91: self.titr91.Destroy()

        if self.axpr: self.axpr.Destroy()
        if self.axcpr: self.axcpr.Destroy()     
        if self.axccr: self.axccr.Destroy()
 
#-------------------------------------
# Choice of input Euler axes

    def OnAxisInput(self, evt):
        global incon, cang1, cang2, cang3

        cang1, cang2, cang3 = 0., 0., 0.
        self.inputang.SetValue('0. 0. 0.')

        self.CleanMes(evt)
        if demowin: demowin.Destroy()
        if insys == 0:
          if icinp == 0: 
             incon = evt.GetSelection()
          else: 
             incon = 5
             if icinp == 3 or icinp == 13: incon = 2
             if icinp == 8 or icinp == 12: incon = 11
             self.ax.SetSelection(incon)
    
#-------------------------------------
# Choice of output Euler axes

    def OnAxisOutput(self, evt):
        global outcon

        self.CleanMes(evt)
        if demowinr: demowinr.Destroy()
        if outsys == 0:
          if icout == 0: 
             outcon = evt.GetSelection()
          else: 
             outcon = 5
             if icout == 3 or icout == 13: outcon = 2
             if icout == 8 or icout == 12: outcon = 11
             self.axr.SetSelection(outcon)

#-------------------------------------
# Choice of input polar axes

    def OnAxisPolInput(self, evt):
        global inpol, cang1, cang2, cang3

        cang1, cang2, cang3 = 0., 0., 0.
        self.inputang.SetValue('0. 0. 0.')

        self.CleanMes(evt)
        if demowin: demowin.Destroy()

        if insys == 1:
          if icinp == 0: 
             inpol = evt.GetSelection()
          else: 
             inpol = 0
             if icinp == 2 or icinp == 8: inpol = 5
             self.axp.SetSelection(inpol)
    
#-------------------------------------
# Choice of output polar axes

    def OnAxisPolOutput(self, evt):
        global outpol

        self.CleanMes(evt)
        if demowinr: demowinr.Destroy()
        if outsys == 1:
          if icout == 0: 
             outpol = evt.GetSelection()
          else: 
             outpol = 0
             if icout == 2 or icout == 8: outpol = 5
             self.axpr.SetSelection(outpol)
    
#-------------------------------------
# Create button panel 

    def CreatePpanel(self, parent):
        global ppanel
	 
        ppanel = self.ppanel = APanel(parent, (wppanel,hppanel), (0,0))
        return ppanel

#-------------------------------------
# Select input program

    def OnProgramInput(self, evt):
        global icinp, north1, inrot, inaxes, incon, indir

        self.CleanMes(evt) 
        if demowin: demowin.Destroy()
        icinp = evt.GetSelection()

# Euler

        if insys == 0: 
           north1 = 0

# ALMN, AMoRe, CNS, DM, LSQKAB, MOLREP, PHASER, phenix.refine, REFMAC

           if icinp == 2: north1 = 1
           self.iorth.SetSelection(north1)
           if icinp >=1 and icinp <= 10:
             inrot = 0
             self.irot.SetSelection(inrot)
             inaxes = 1
             if icinp == 8: inaxes = 0
             self.imax.SetSelection(inaxes)
             incon = 5
             if icinp == 3: incon = 2
             if icinp == 8: incon = 11
             self.ax.SetSelection(incon)
             indir = 0
             self.rdiri.SetSelection(indir)

# TNT Crowther, TNT Huber, TNT Rossmann

           if icinp >=11 and icinp <= 13:
             north1 = 5
             self.iorth.SetSelection(north1)
             inrot = 0
             self.irot.SetSelection(inrot)
             inaxes = 1
             self.imax.SetSelection(inaxes)
             incon = 5
             if icinp == 12: incon = 11
             if icinp == 13: incon = 2
             self.ax.SetSelection(incon)
             indir = 7
             self.rdiri.SetSelection(indir)

# polar

        if insys == 1: 
           north1 = 0
           if icinp == 1 or icinp == 7: north1 = 1
           if icinp == 8: north1 = 5
           self.iorth.SetSelection(north1)

# AMoRe, CNS, DM, LSQKAB, MOLREP, PHASER, TNT Rossmann, TNT Kabsch

           if icinp >=1 and icinp <= 8:
             inrot = 0
             self.irot.SetSelection(inrot)
             inpol = 0
             if icinp == 2 or icinp == 8: inpol = 5
             self.axp.SetSelection(inpol)
             indirp = 0
             if icinp == 7 or icinp == 8: indirp = 3
             self.axcp.SetSelection(indirp)

# cos

        if insys == 2: 
           north1 = 0
           self.iorth.SetSelection(north1)
           inrot = 0
           self.irot.SetSelection(inrot)

# CNS, DM, LSQKAB, TNT

           if icinp >=1 and icinp <= 3:
             indirc = 0
             self.axcc.SetSelection(indirc)  
           if icinp ==4:
             indirc = 1
             self.axcc.SetSelection(indirc)    
# matrix

        if insys == 3: 
           north1 = 0
           self.iorth.SetSelection(north1) 
  
# quaternions

        if insys == 4: 
           north1 = 0
           self.iorth.SetSelection(north1)
           inrot = 0
           self.irot.SetSelection(inrot)   
            
#-------------------------------------
# Select output program

    def OnProgramOutput(self, evt):
        global icout, north2, outrot, outaxes, outcon, outdir

        self.CleanMes(evt) 
        if demowinr: demowinr.Destroy()
        icout = evt.GetSelection()

# Euler

        if outsys == 0: 
           north2 = 0

# ALMN, AMoRe, CNS, DM, LSQKAB, MOLREP, PHASER, phenix.refine, REFMAC

           if icout == 2: north2 = 1
           self.iorthr.SetSelection(north2)
           if icout >=1 and icout <= 10:
             outrot = 0
             self.irotr.SetSelection(outrot)
             outaxes = 1
             if icout == 8: outaxes = 0
             self.imaxr.SetSelection(outaxes)
             outcon = 5
             if icout == 3: outcon = 2
             if icout == 8: outcon = 11
             self.axr.SetSelection(outcon)
             outdir = 0
             self.rdirr.SetSelection(outdir)

# TNT Crowther, TNT Huber, TNT Rossmann

           if icout >=11 and icout <= 13:
             north2 = 5
             self.iorthr.SetSelection(north2)
             outrot = 0
             self.irotr.SetSelection(outrot)
             outaxes = 1
             self.imaxr.SetSelection(outaxes)
             outcon = 5
             if icout == 12: outcon = 11
             if icout == 13: outcon = 2
             self.axr.SetSelection(outcon)
             outdir = 7
             self.rdirr.SetSelection(outdir)

# polar

        if outsys == 1: 
           north2 = 0
           if icout == 1 or icout == 7: north2 = 1
           if icout == 8: north2 = 5
           self.iorthr.SetSelection(north2)

# AMoRe, CNS, DM, LSQKAB, MOLREP, PHASER, TNT Rossmann, TNT Kabsch

           if icout >=1 and icout <= 8:
             outrot = 0
             self.irotr.SetSelection(outrot)
             outpol = 0
             if icout == 2 or icout == 8: outpol = 5
             self.axpr.SetSelection(outpol)
             outdirp = 0
             if icout == 7 or icout == 8: outdirp = 3
             self.axcpr.SetSelection(outdirp)

# cos

        if outsys == 2: 
           north2 = 0
           self.iorthr.SetSelection(north2)
           outrot = 0
           self.irotr.SetSelection(outrot)

# CNS, DM, LSQKAB, TNT

           if icout >=1 and icout <= 3:             
             outdirc = 0
             self.axccr.SetSelection(outdirc)  
           if icout ==4:
             outdirc = 1
             self.axccr.SetSelection(outdirc)  

# matrix

        if outsys == 3: 
           north2 = 0
           self.iorthr.SetSelection(north2)

# quaternions

        if outsys == 4: 
           north2 = 0
           self.iorthr.SetSelection(north2)
           outrot = 0
           self.irotr.SetSelection(outrot)

#-------------------------------------
# Select input orthogonalisation code

    def OnNorthInput(self, evt):
        global north1

        self.CleanMes(evt) 
        if demowin: demowin.Destroy()

        if insys == 0:
          if icinp == 2: 
             north1 = 1
             self.iorth.SetSelection(north1)
          elif icinp >=11 and icinp <= 13:
             north1 = 5
             self.iorth.SetSelection(north1)
          else: 
           north1 = evt.GetSelection()
        if insys == 1:
          if icinp == 1 or icinp == 7:
             north1 = 1
             self.iorth.SetSelection(north1)
          elif icinp == 8:
             north1 = 5
             self.iorth.SetSelection(north1)
          else: 
           north1 = evt.GetSelection()

#-------------------------------------
# Select output orthogonalisation code

    def OnNorthOutput(self, evt):
        global north2

        self.CleanMes(evt) 
        if demowinr: demowinr.Destroy()

        if outsys == 0:
          if icout == 2: 
             north2 = 1
             self.iorthr.SetSelection(north2)
          elif icout >=11 and icout <= 13:
             north2 = 5
             self.iorthr.SetSelection(north2)
          else: 
           north2 = evt.GetSelection()
        if outsys == 1:
          if icout == 1 or icout == 7: 
             north2 = 1
             self.iorthr.SetSelection(north2)
          elif icout == 8:
             north2 = 5
             self.iorthr.SetSelection(north2)
          else: 
           north2 = evt.GetSelection()

#-------------------------------------
# Select input rotation

    def InputRot(self, evt):
        global inrot, inaxes, imove, cang1, cang2, cang3, kappa, prot3, prot4, prot5

        imove = 0
        if insys < 2: 
          cang1, cang2, cang3 = 0., 0., 0.
          self.inputang.SetValue('0. 0. 0.')
        if insys == 2:
          cang1, cang2, cang3, kappa = 0., 0., 1., 0.
          self.inputang.SetValue('0. 0. 1. 0.')
        if insys == 4:
          cang1, cang2, cang3, kappa = 1., 0., 0., 0.
          self.inputang.SetValue('1. 0. 0. 0.')
 
        prot3, prot4, prot5 = 1,1,1

        self.CleanMes(evt)       
        if demowin: demowin.Destroy()
        if insys != 3:
          if icinp == 0: 
             inrot = evt.GetSelection()
          else: 
             inrot = 0
             self.irot.SetSelection(inrot)

        if insys == 0:
         inaxes = 0
         if insys == 0 and inrot == 1: inaxes = 1
         self.imax.SetSelection(inaxes)

#-------------------------------------
# Select output rotation

    def OutputRot(self, evt):
        global outrot, outaxes, protr3, protr4, protr5

        protr3, protr4, protr5 = 1,1,1

        self.CleanMes(evt)
        if demowinr: demowinr.Destroy()
        if outsys != 3:
          if icout == 0: 
             outrot = evt.GetSelection()
          else: 
             outrot = 0
             self.irotr.SetSelection(outrot)

        if outsys == 0:
         outaxes = 0
         if outsys == 0 and outrot == 1: outaxes = 1
         self.imaxr.SetSelection(outaxes)

#-------------------------------------
# Select input axes

    def InputAxes(self, evt):
        global inaxes, cang1, cang2, cang3    

        cang1, cang2, cang3 = 0., 0., 0.
        self.inputang.SetValue('0. 0. 0.')

        self.CleanMes(evt)
        if demowin: demowin.Destroy()
        if insys == 0:
          if icinp == 0: 
             inaxes = evt.GetSelection()
          else: 
             if (icinp >= 1 and icinp <= 7) or icinp >= 10: inaxes = 1
             if icinp == 8: inaxes = 0
             self.imax.SetSelection(inaxes)
        if inrot == 1: inaxes = 1
        self.imax.SetSelection(inaxes)

#-------------------------------------
# Select output axes

    def OutputAxes(self, evt):
        global outaxes

        self.CleanMes(evt)
        if demowinr: demowinr.Destroy()
        if outsys == 0:
          if icout == 0: 
             outaxes = evt.GetSelection()
          else: 
             if (icout >= 1 and icout <= 7) or icout >= 10: outaxes = 1
             if icout == 8: outaxes = 0
             self.imaxr.SetSelection(outaxes)
        if outrot == 1: outaxes = 1
        self.imaxr.SetSelection(outaxes)

#-------------------------------------
# Select Euler input rotation direction

    def InputRotDir(self, evt):
        global indir, cang1, cang2, cang3


        cang1, cang2, cang3 = 0., 0., 0.
        self.inputang.SetValue('0. 0. 0.')

        self.CleanMes(evt)
        if demowin: demowin.Destroy()
        if insys == 0:
          if icinp == 0: 
             indir = evt.GetSelection()
          else: 
             indir = 0
             if icinp >= 11 and icinp <= 13: indir = 7
             self.rdiri.SetSelection(indir)

#-------------------------------------
# Select Euler output rotation direction

    def OutputRotDir(self, evt):
        global outdir

        self.CleanMes(evt)
        if demowinr: demowinr.Destroy()
        if outsys == 0:
          if icout == 0: 
             outdir = evt.GetSelection()
          else: 
             outdir = 0
             if icout >= 11 and icout <= 13: outdir = 7
             self.rdirr.SetSelection(outdir)

#-------------------------------------
# Select polar input rotation direction

    def InputPolRotDir(self, evt):
        global indirp, cang1, cang2, cang3

        cang1, cang2, cang3 = 0., 0., 0.
        self.inputang.SetValue('0. 0. 0.')

        self.CleanMes(evt)
        if demowin: demowin.Destroy()
        if insys == 1:
          if icinp == 0: 
             indirp = evt.GetSelection()
          elif icinp == 7 or icinp == 8: 
             indirp = 3
             self.axcp.SetSelection(indirp)
          else: 
             indirp = 0
             self.axcp.SetSelection(indirp)

#-------------------------------------
# Select polar output rotation direction

    def OutputPolRotDir(self, evt):
        global outdirp

        self.CleanMes(evt)
        if demowinr: demowinr.Destroy()
        if outsys == 1:
          if icout == 0: 
             outdirp = evt.GetSelection()
          elif icout == 7 or icout == 8: 
             outdirp = 3
             self.axcpr.SetSelection(outdirp)
          else: 
             outdirp = 0
             self.axcpr.SetSelection(outdirp)

#-------------------------------------
# Select cos input rotation direction

    def InputCosRotDir(self, evt):
        global indirc, cang1, cang2, cang3, kappa

        cang1, cang2, cang3, kappa = 0., 0., 1., 0
        self.inputang.SetValue('0. 0. 1. 0.')

        self.CleanMes(evt)
        if insys == 2:
          if icinp == 0: 
             indirc = evt.GetSelection()
          else: 
             indirc = 0
             self.axcc.SetSelection(indirc) 
             if icinp == 4:
               indirc = 1
               self.axcc.SetSelection(indirc)  

#-------------------------------------
# Select cos output rotation direction

    def OutputCosRotDir(self, evt):
        global outdirc

        self.CleanMes(evt)
        if outsys == 2:
          if icout == 0: 
             outdirc = evt.GetSelection()
          else: 
             outdirc = 0
             self.axccr.SetSelection(outdirc)
             if icout == 4:
               outdirc = 1
               self.axccr.SetSelection(outdirc)  

#-------------------------------------
# Select quaternion input rotation direction

    def InputQuatRotDir(self, evt):
        global indirc, cang1, cang2, cang3, kappa

        cang1, cang2, cang3, kappa = 1., 0., 0., 0
        self.inputang.SetValue('1. 0. 0. 0.')

        self.CleanMes(evt)
        if insys == 4: indirc = evt.GetSelection()

#-------------------------------------
# Select quaternion output rotation direction

    def OutputQuatRotDir(self, evt):
        global outdirc

        self.CleanMes(evt)
        if outsys == 4: outdirc = evt.GetSelection()

#------------------------------
# Clean up the message list 

    def CleanMes(self, evt):
     global ierr, anglist, angoutlist    

     tmes.SetValue("") 
     ierr = 0
     anglist, angoutlist = [], []
     btnDemor.Disable()

#------------------------------
# type values

    def SwType(self, evt): 
     global ifile1, Filename1

     if demowin : demowin.Destroy()
     if demowinr : demowinr.Destroy()

     ifile1 = 0 
     Filename1 =  ""
     self.rbtype.SetValue(True)

#------------------------------
# Enter input file name
 
    def FilenameEnter(self, evt):
        global ifile1, Filename1

        self.CleanMes(evt)        
        ifile1 = 1
        Filename1 =  ""
        self.rbbrow.SetValue(True)

        self.OnBrowse(self)

#------------------------------
# Enter angle value
 
    def AngEnter(self, evt):
        global ifile1, anglist, angoutlist

        anglist, angoutlist = [], []

        line = self.inputang.GetValue() 
        line = line.rstrip('\n')
        
        linen = line.split('\n')
        llin = len(linen)

        for i in range(llin):
            aaa = linen[i].rstrip('\n') 
            anglist.append(aaa)

        self.rbtype.SetValue(True)      
        ifile1 = 0
        return

#------------------------------
# Set the angle
 
    def AngDef(self, evt):

        self.CleanMes(evt) 

        self.rbtype.SetValue(1)

#------------------------------
# Browse input file name
 
    def FilenameBrowse(self, evt):
        global ifile1

        self.CleanMes(evt) 
        self.inputang.SetValue("")

        ifile1 = 0
        self.OnBrowse(self)

#-----------------------------------------------------
# OnBrowse - create open file dialog

    def OnBrowse(self, evt):
       global ierr, anglist, dfile1, dname1, Filename1, file1

       self.CleanMes(evt) 

       if  ifile1 == 0:    
        wildcard = "All files (*.*)|*.*"    

        if dfile1 == "": dDir=os.getcwd()
        else: dDir=dfile1
        dlg = wx.FileDialog(
            self, message="Choose a file",
            defaultDir=dDir, 
            defaultFile="",
            wildcard=wildcard,
            style=wx.FD_OPEN
            )                
        if dlg.ShowModal() == wx.ID_OK:
            pth = dlg.GetPath()
            dfile1 = dlg.GetDirectory()
            if dname1 == "": dname1 = dfile1
            self.inpfile1.SetValue(dname1)
            self.inpfile1.ChangeValue(pth)
            dlg.Destroy()
            Filename1 = self.inpfile1.GetValue()
            Filename1 = Filename1.strip() 

       if  ifile1 == 1:

        fn = self.inpfile1.GetValue()
        fn = fn.strip() 
        if os.path.isfile(fn):Filename1 = fn 
        else: 
          tmes.SetValue("No such file or directory : " + fn)
          self.rbbrow.SetValue(False)
          self.rbtype.SetValue(True)
          tmes.SetForegroundColour(col1) 
          ierr = 1
          return

       try:
           file1 = open(Filename1, 'r')
       except IOError:
           tmes.SetValue("No such file or directory : " + Filename1)
           self.rbbrow.SetValue(False)
           self.rbtype.SetValue(True)
           tmes.SetForegroundColour(col1) 
           ierr = 1
           return

       lines = file1.readlines()
       for line in lines:  
        line = line.rstrip('\n')
        anglist.append(line)
        self.inputang.AppendText(str(line) + "\n")

#-----------------------------------------------------
# Read input file

    def Ver_inp(self,line):
       global ierr

       linen = line.split()
       
       if len(linen) == 0:
          if insys <= 2: 
           tmes.SetValue(" Input rotation angles are not defined")
           tmes.SetForegroundColour(col1) 
           ierr = 1
           return
          if insys == 3: 
           tmes.SetValue(" Row of the matrix is not defined")
           tmes.SetForegroundColour(col1)
           ierr = 1
           return 
          if insys == 4: 
           tmes.SetValue(" Input quaternions are not defined")
           tmes.SetForegroundColour(col1)
           ierr = 1
           return 
       if len(linen) < 3:
          if insys <= 1: 
           tmes.SetValue(" Wrong number of the rotation angles")
           tmes.SetForegroundColour(col1) 
           ierr = 1
           return
          if insys == 3: 
           tmes.SetValue(" Wrong number of the matrix elements")
           tmes.SetForegroundColour(col1) 
           ierr = 1
           return
       if insys == 2 and len(linen) < 4:
          tmes.SetValue(" Wrong number of the rotation parameters")
          tmes.SetForegroundColour(col1) 
          ierr = 1
          return
       if insys == 4 and len(linen) < 4:
          tmes.SetValue(" Wrong number of the quaternions")
          tmes.SetForegroundColour(col1) 
          ierr = 1
          return
       if len(linen) != 0 :
          for i in range(len(linen)):
            try:
              flinen = float(linen[i])
            except ValueError:       
              if insys <= 1: 
               tmes.SetValue(" Wrong symbol in the rotation angles")
               tmes.SetForegroundColour(col1) 
               ierr = 1
               return
              if insys == 2: 
               tmes.SetValue(" Wrong symbol in the rotation parameters")
               tmes.SetForegroundColour(col1) 
               ierr = 1
               return
              if insys == 3: 
               tmes.SetValue(" Wrong symbol in the matrix element")
               tmes.SetForegroundColour(col1) 
               ierr = 1
               return 
              if insys == 4: 
               tmes.SetValue(" Wrong symbol in the quaternions")
               tmes.SetForegroundColour(col1) 
               ierr = 1
               return     
        
#-------------------------------------
# Choose menu

    def OnSearchMenu(self, evt):
   
      if not hasattr(self, "helpID1"):
            self.helpID1 = wx.NewIdRef(count=1)
            self.helpID2 = wx.NewIdRef(count=1)
            self.helpID3 = wx.NewIdRef(count=1)
            self.helpID4 = wx.NewIdRef(count=1)
            self.helpID5 = wx.NewIdRef(count=1)
            self.helpID6 = wx.NewIdRef(count=1)

            self.Bind(wx.EVT_MENU, self.OnHelp, id=self.helpID1)
            self.Bind(wx.EVT_MENU, self.OnHelp, id=self.helpID2)
            self.Bind(wx.EVT_MENU, self.OnHelp, id=self.helpID3)
            self.Bind(wx.EVT_MENU, self.OnHelp, id=self.helpID4)
            self.Bind(wx.EVT_MENU, self.OnHelp, id=self.helpID5)
            self.Bind(wx.EVT_MENU, self.OnHelp, id=self.helpID6)

      menu = wx.Menu()
      menu.Append(self.helpID1, "Running the program")
      menu.Append(self.helpID2, "Euler rotation")
      menu.Append(self.helpID3, "Polar rotation")
      menu.Append(self.helpID4, "Direction cosines")
      menu.Append(self.helpID5, "Quaternions")
      menu.Append(self.helpID6, "Orthogonalisation")

      self.PopupMenu(menu)
      menu.Destroy()

#-------------------------------------
# Demo input

    def OnDemo(self, evt):
        global demowin

        if demowin : demowin.Destroy()
        if demowinr : demowinr.Destroy()
        demowin = Demo_Rot(self)
        return

#-------------------------------------
# Demo output

    def OnDemor(self, evt):
        global demowinr

        if demowinr: demowinr.Destroy()
        demowinr = Demor_Rot(self)
        return

#-------------------------------------
# Menu

    def OnHelp(self, evt):
        global id, helpwin

        if helpwin : helpwin.Destroy()

        id = evt.GetId()

        if id == self.helpID1: 
          helpwin = Help_Trans(self)
          helpwin.Show()

        if id == self.helpID2: RunPdfFile('help_Euler.pdf')
        if id == self.helpID3: RunPdfFile('help_polar.pdf') 
        if id == self.helpID4: RunPdfFile('help_dircos.pdf')
        if id == self.helpID5: RunPdfFile('help_quaternions.pdf')
        if id == self.helpID6: RunPdfFile('help_orthogonalization.pdf')

#-----------------------------------------------------
# Exit

    def OnCloseWindows(self, evt):

        self.Destroy()
        if demowin: demowin.Destroy()
        if demowinr: demowinr.Destroy()
        if helpwin: helpwin.Destroy()
        if coorwin : coorwin.Destroy()
 
#------------------------------
# Choice of space group
 
    def Evtgroup(self, evt):
        global cgroup

        self.CleanMes(evt)

        cgroup = evt.GetSelection()
        if cgroup > 0:
          Sgrp = int(grouplist[cgroup].split()[0])
          self.SpaceGr(Sgrp)
        self.group.SetSelection(cgroup)

#-----------------------------------------------------
# Indicate space group

    def SpaceGr (self, Sgrp):
       global ierr, Sgroup, cgroup 

       ic = 0 
       for i in range(1, len(grouplist)):
        ng = int(grouplist[i].split()[0])
        if Sgrp == ng: 
          Sgroup = ng
          cgroup = i  
          ic = 1
       if ic == 0:  
          tmes.SetValue(" Problem with the space group")
          tmes.SetForegroundColour(col1) 
          ierr = 1
          return

#-------------------------------------
# Parameters transformation

    def Param_Trans(self, evt):
       global ierr, acell, bcell, ccell, alp, bet, gam, Cell, Sgroup, anglist, angl
       global Filename1, file1, lmatr

       if demowinr: demowinr.Destroy()

       lmatr = ['1.0      0.0      0.0', '0.0      1.0      0.0', '0.0      0.0      1.0']
   
       ierr = 0
       tmes.SetForegroundColour(col2) 

# Read input parameters

       if north1 == 0 and north2 != 0:
          tmes.SetValue(" Define orthogonalisation mode for the input model")
          tmes.SetForegroundColour(col1) 
          ierr = 1
          return

       if north1 != 0 and north2 == 0:
          tmes.SetValue(" Define orthogonalisation mode for the output model")
          tmes.SetForegroundColour(col1) 
          ierr = 1
          return

       Cell = self.inputcell.GetValue()
       lcell = Cell.split()

       if Cell != '':
 
         if len(lcell) == 0:
          tmes.SetValue(" Unit cell parameters are not defined")
          tmes.SetForegroundColour(col1) 
          ierr = 1
          return 
         if len(lcell) < 6:
          tmes.SetValue(" Wrong number of the unit cell parameters")
          tmes.SetForegroundColour(col1) 
          ierr = 1
          return
         if len(lcell) != 0 :
           try:
            acell= float(lcell[0])
            bcell= float(lcell[1])
            ccell= float(lcell[2])
            alp = float(lcell[3])
            bet = float(lcell[4])
            gam = float(lcell[5])
           except ValueError:
            tmes.SetValue(" Wrong symbol in the unit cell parameters")
            tmes.SetForegroundColour(col1) 
            ierr = 1
            return       
         if acell <= 0 or bcell <= 0 or ccell <= 0 or alp <= 0 or bet <= 0 or gam <= 0:
          tmes.SetValue(" Wrong unit cell parameters: negative value")
          tmes.SetForegroundColour(col1) 
          ierr = 1
          return
         if alp >= 180 or bet >= 180 or gam >= 180:
          tmes.SetValue(" Wrong unit cell parameters: angle >= 180 degrees")
          tmes.SetForegroundColour(col1) 
          ierr = 1
          return
         if alp+bet <= gam or alp+gam <= bet or bet+gam <= alp:
          tmes.SetValue(" Wrong unit cell parameters: sum of two angles is less than or equal to the third")
          tmes.SetForegroundColour(col1) 
          ierr = 1
          return

       else:

         if north1 >= 1 and north2 >= 1:
          tmes.SetValue(" Enter unit cell parameters in angstroms and degrees")
          tmes.SetForegroundColour(col1) 
          ierr = 1
          return

         if cgroup != 0:
          tmes.SetValue(" Enter unit cell parameters in angstroms and degrees")
          tmes.SetForegroundColour(col1) 
          ierr = 1
          return

       if self.rbbrow.GetValue() == True and Filename1 == "":

         Filename1 = self.inpfile1.GetValue()
         Filename1 = Filename1.strip()

         fn = self.inpfile1.GetValue()
         fn = fn.strip() 

         if  ifile1 == 1:
           if os.path.isfile(fn): Filename1 = fn 
         else: 
          tmes.SetValue(" No such file or directory : " + fn)
          self.rbbrow.SetValue(False)
          self.rbtype.SetValue(True)
          tmes.SetForegroundColour(col1) 
          ierr = 1
          return

         try:
           file1 = open(Filename1, 'r')
         except IOError:
           tmes.SetValue(" No such file or directory : " + Filename1)
           self.rbbrow.SetValue(False)
           self.rbtype.SetValue(True)
           tmes.SetForegroundColour(col1) 
           ierr = 1
           return

         self.FilenameEnter(self)
         Filename1 = ""

       self.AngEnter(self)

       if insys == 3 and len(anglist) != 3:
          tmes.SetValue(" Wrong matrix")
          tmes.SetForegroundColour(col1) 
          ierr = 1
          return 

       for i in range(len(anglist)):
           self.Ver_inp(anglist[i])
           if ierr == 1: return

       if ierr == 0: self.Convrot(self)

#-----------------------------------------------------
# Symmatrix - matrix of symmetry operations


    def Reasym(self, evt):
       global nsym, rsym
      
       numlin, nsym, inum1, inum2 = 0, 0, 0, 0     

       txt_numgr = '(code of the group)'
       txt_numsm = '(number of symmetries)'

       ii = 0 

       for line in filesym:
           control = line.splitlines()[0]
           numlin = numlin+1            
           if control[10:29] == txt_numgr : sym_gr = int(control[0:6])
           if control[10:32] == txt_numsm and int(Sgroup) == sym_gr:
                nsym = int(control[0:6])
                rsym = [[0 for x in range(12)] for y in range(nsym)] 
                inum1 = numlin+1
                inum2 = numlin+nsym                       
           if numlin >=inum1 and numlin <= inum2 :

                   rsym[ii][0] = int(line.split()[0])
                   rsym[ii][1] = int(line.split()[1])
                   rsym[ii][2] = int(line.split()[2])
                   rsym[ii][3] = int(line.split()[3])
                   rsym[ii][4] = int(line.split()[4])
                   rsym[ii][5] = int(line.split()[5])
                   rsym[ii][6] = int(line.split()[6])
                   rsym[ii][7] = int(line.split()[7])
                   rsym[ii][8] = int(line.split()[8])
                   rsym[ii][9] = float(line.split()[9])
                   rsym[ii][10] = float(line.split()[10])
                   rsym[ii][11] = float(line.split()[11])
 
                   ii = ii +1

#-----------------------------------------------------
# Convert different rotation description to a single convention

    def Convrot(self, evt):
       global icode, grrad, orth1, orth2, deort1, deort2, rsym, nsym, lmatr
       global txinp, txout
       global coorwin

       rsym = [[0 for x in range(12)] for y in range(1)] 
       rsym[0][0] = rsym[0][4] = rsym[0][8] = 1.0

       orth1 = orth2 = deort1 = deort2 = [0 for x in range(9)]
       orth1[0] = orth1[4] = orth1[8] = 1.
       orth2[0] = orth2[4] = orth2[8] = 1.
       deort1[0] = deort1[4] = deort1[8] = 1.
       deort2[0] = deort2[4] = deort2[8] = 1.

       chort1 = chort2 = [0 for x in range(9)]
     
       nsym = 1

       if Cell != '':

        if north1 >= 1:
         self.Matort(north1)
         orth1 = orth
         deort1 = deorth

        if north2 >= 1:
         self.Matort(north2)
         orth2 = orth
         deort2 = deorth

        if cgroup != 0: self.Reasym(self)

        for i in range(nsym):
         rs = rsym[i]
         Mulrot(self,rs,deort1)
         Mulrot(self,orth2, rtemp)
         rsym[i] = rtemp

       Mulrot(self,orth1,deort2)
       chort1 = rtemp
       Mulrot(self,orth2,deort1)
       chort2 = rtemp

       if insys != 3: linp = len(anglist)
       if insys == 3: linp = 1
       if outsys != 3: lout = len(anglist)
       if outsys == 3: lout = 1

       tmes.SetValue("")

       if insys == 0:

           txinp = 'Euler  ' + lax12[incon]

           ltxtr1 = ' INPUT:     ' + tsys[insys].strip() + ', ' + typerot[inrot].strip() + ', ' + typeaxes[inaxes].strip()
           ltxtr2 = "%53s" %teuler1 + '   ' + lax12[incon]
           ltxtr3 = "%58s" %teuler2 + '   ' + lrot8[indir]
           ltxtr4 = "%62s" %teuler4
           tmes.WriteText(ltxtr1+"\n")
           tmes.WriteText(ltxtr2+"\n")
           tmes.WriteText(ltxtr3+"\n")
           tmes.WriteText(ltxtr4+"\n")
           print(ltxtr1, file = fileout)
           print(ltxtr2, file = fileout)
           print(ltxtr3, file = fileout)
           print(ltxtr4, file = fileout)

       if insys == 1:

           txinp = 'polar  ' + laxp6[inpol]

           ltxtr1 = ' INPUT:     ' + tsys[insys].strip() + ', ' + typerot[inrot].strip()
           ltxtr2 = "%43s" %tpolar1 + '   ' + laxp6[inpol]
           ltxtr3 = "%69s" %tpolar2 + '   ' + lrotp4[indirp]
           ltxtr4 = "%69s" %tpolar3
           tmes.WriteText(ltxtr1+"\n")
           tmes.WriteText(ltxtr2+"\n")
           tmes.WriteText(ltxtr3+"\n")
           tmes.WriteText(ltxtr4+"\n")
           print(ltxtr1, file = fileout)
           print(ltxtr2, file = fileout)
           print(ltxtr3, file = fileout)
           print(ltxtr4, file = fileout)

       if insys == 2:

           txinp = 'cos'

           ltxtr1 = ' INPUT:     ' + tsys[insys].strip() + ', ' + typerot[inrot].strip()
           ltxtr2 = "%51s" %tcos2 + '   ' + lrotc2[indirc]
           ltxtr3 = "%68s" %tcos1
    
           tmes.WriteText(ltxtr1+"\n")
           tmes.WriteText(ltxtr2+"\n")
           tmes.WriteText(ltxtr3+"\n")
           print(ltxtr1, file = fileout)
           print(ltxtr2, file = fileout)
           print(ltxtr3, file = fileout)

       if insys == 3:

           txinp = 'input rotation matrix is:'

           ltxtr1 = ' INPUT:     ' + tsys[insys].strip()
           ltxtr2 = "%64s" %tmatrix1
           tmes.WriteText(ltxtr1+"\n")
           tmes.WriteText(ltxtr2+"\n")
           print(ltxtr1, file = fileout)
           print(ltxtr2, file = fileout)

       if insys == 4:

           txinp = 'quaternions'

           ltxtr1 = ' INPUT:     ' + tsys[insys].strip() + ', ' + typerot[inrot].strip()
           ltxtr2 = "%51s" %tcos2 + '   ' + lrotc2[indirc]
           ltxtr3 = "%68s" %tquat1
    
           tmes.WriteText(ltxtr1+"\n")
           tmes.WriteText(ltxtr2+"\n")
           tmes.WriteText(ltxtr3+"\n")
           print(ltxtr1, file = fileout)
           print(ltxtr2, file = fileout)
           print(ltxtr3, file = fileout)

       if Cell != '':

            ltxt2 = '                   orthogonalisation code:   ' + trot[north1]
            ltxt3 = '                   unit cell: '+"%8.3f" %acell+"%8.3f" %bcell+"%8.3f" %ccell+"%8.2f" %alp+"%8.2f" %bet+"%8.2f" %gam
            ltxt4 = '                   space group:   '+str(grouplist[cgroup])

            tmes.WriteText(ltxt2+"\n")
            tmes.WriteText(ltxt3+"\n")
            tmes.WriteText(ltxt4+"\n")

            print(ltxt2, file = fileout)
            print(ltxt3, file = fileout)
            print(ltxt4, file = fileout)

       if outsys == 0:
 
           ltxtr4 = ' OUTPUT: ' + tsys[outsys].strip() + ', ' + typerot[outrot].strip() + ', ' + typeaxes[outaxes].strip()
           ltxtr5 = "%53s" %teuler1 + '   ' + lax12[outcon]
           ltxtr6 = "%58s" %teuler2 + '   '  + lrot8[outdir]

           tmes.WriteText(ltxtr4+"\n")
           tmes.WriteText(ltxtr5+"\n")
           tmes.WriteText(ltxtr6+"\n")

           print(" OUTPUT:    " + tsys[outsys].strip() + ", " + typerot[outrot].strip() + ", " + typeaxes[outaxes].strip(), file = fileout)
           print(ltxtr5, file = fileout)
           print(ltxtr6, file = fileout)

       if outsys == 1:
 
           ltxtr4 = ' OUTPUT: ' + tsys[outsys].strip() + ', ' + typerot[outrot].strip()
           ltxtr5 = "%43s" %tpolar1 + '   ' + laxp6[outpol]
           ltxtr6 = "%69s" %tpolar2 + '   ' + lrotp4[outdirp]

           tmes.WriteText(ltxtr4+"\n")
           tmes.WriteText(ltxtr5+"\n")
           tmes.WriteText(ltxtr6+"\n")

           print(" OUTPUT:    " + tsys[outsys].strip() + ", " + typerot[outrot].strip(), file = fileout)
           print(ltxtr5, file = fileout)
           print(ltxtr6, file = fileout)

       if outsys == 2 or outsys == 4:
 
           ltxtr4 = ' OUTPUT: ' + tsys[outsys].strip() + ', ' + typerot[outrot].strip()            
           ltxtr5 = "%53s" %tcos2 + '   ' + lrotc2[outdirc]

           tmes.WriteText(ltxtr4+"\n")
           tmes.WriteText(ltxtr5+"\n")
           print(" OUTPUT:      " + tsys[outsys].strip() + ", " + typerot[outrot].strip(), file = fileout)  
           print(ltxtr5, file = fileout)

       if outsys == 3:
 
           ltxtr4 = ' OUTPUT: ' + tsys[outsys].strip()         
           tmes.WriteText(ltxtr4+"\n")
           print(" OUTPUT:    " + tsys[outsys].strip(), file = fileout) 

       if Cell != '':

            ltxt2 = '                   orthogonalisation code:   ' +  trot[north2]

            tmes.WriteText(ltxt2+"\n")
            print(ltxt2, file = fileout)

       if outsys == 0:

           txout = 'Euler  '+ lax12[outcon]

           ltxtr7 = "%62s" %teuler4
           ltxtr8 = "%38s" %txinp + "%56s" %txout
           tmes.WriteText(ltxtr7+"\n")
           tmes.WriteText(ltxtr8+"\n")
           print(ltxtr7, file = fileout)
           print("%38s" %txinp + "%42s" %txout, file = fileout)

       elif outsys == 1:

           txout = 'polar  ' + laxp6[outpol]

           ltxtr7 = "%69s" %tpolar3
           ltxtr8 = "%38s" %txinp + "%56s" %txout
           tmes.WriteText(ltxtr7+"\n")
           tmes.WriteText(ltxtr8+"\n")
           print(ltxtr7, file = fileout)
           print("%38s" %txinp + "%42s" %txout, file = fileout)

       elif outsys == 2:

           txout = 'cos'

           ltxtr7 = "%70s" %tcos1
           ltxtr8 = "%38s" %txinp + "%55s" %txout
           tmes.WriteText(ltxtr7+"\n")
           tmes.WriteText(ltxtr8+"\n")
           print(ltxtr7, file = fileout)
           print("%38s" %txinp + "%38s" %txout, file = fileout)

       elif outsys == 3:
           
           txout = 'output rotation matrix is:'
           
           ltxtr7 = "%64s" %tmatrix1
           ltxtr8 = "%38s" %txinp + "%56s" %txout
           tmes.WriteText(ltxtr7+"\n")
           tmes.WriteText(ltxtr8+"\n")
           print(ltxtr7, file = fileout)
           print("%38s" %txinp + "%50s" %txout, file = fileout)

       else:

           txout = 'quaternions'

           ltxtr7 = "%70s" %tquat1
           ltxtr8 = "%38s" %txinp + "%55s" %txout
           tmes.WriteText(ltxtr7+"\n")
           tmes.WriteText(ltxtr8+"\n")
           print(ltxtr7, file = fileout)
           print("%38s" %txinp + "%38s" %txout, file = fileout)

# calculate the rotation matrix for the input angles

       for j in range(linp):

         icode = 0

         if insys == 0 and incon == 0: self.RotXYX(rot1,nsym,rsym,j)
         if insys == 0 and incon == 1: self.RotYZY(rot1,nsym,rsym,j)
         if insys == 0 and incon == 2: self.RotZXZ(rot1,nsym,rsym,j)
         if insys == 0 and incon == 3: self.RotXZX(rot1,nsym,rsym,j)
         if insys == 0 and incon == 4: self.RotYXY(rot1,nsym,rsym,j)
         if insys == 0 and incon == 5: self.RotZYZ(rot1,nsym,rsym,j)
         if insys == 0 and incon == 6: self.RotXYZ(rot1,nsym,rsym,j)
         if insys == 0 and incon == 7: self.RotYZX(rot1,nsym,rsym,j)
         if insys == 0 and incon == 8: self.RotZXY(rot1,nsym,rsym,j)
         if insys == 0 and incon == 9: self.RotXZY(rot1,nsym,rsym,j)
         if insys == 0 and incon == 10: self.RotYXZ(rot1,nsym,rsym,j)
         if insys == 0 and incon == 11: self.RotZYX(rot1,nsym,rsym,j)

         if insys == 1 and (inpol == 0 or inpol == 1): self.RotZX(rot1,nsym,rsym,j)
         if insys == 1 and (inpol == 2 or inpol == 3): self.RotXY(rot1,nsym,rsym,j)
         if insys == 1 and (inpol == 4 or inpol == 5): self.RotYZ(rot1,nsym,rsym,j)

         if insys == 2: self.RotCos(rot1,nsym,rsym,j)

         if insys == 3: self.RotMat(rot1,nsym,rsym)

         if insys == 4: self.RotQuat(rot1,nsym,rsym,j)

         if ierr == 1: return

         Mulrot(self,rot1,chort1)
         rot2 = rtemp
         Mulrot(self,chort2,rot2)

         lmatr[0] = "%12.7f" %rtemp[0]+"%12.7f" %rtemp[1]+"%12.7f" %rtemp[2]
         lmatr[1] = "%12.7f" %rtemp[3]+"%12.7f" %rtemp[4]+"%12.7f" %rtemp[5]
         lmatr[2] = "%12.7f" %rtemp[6]+"%12.7f" %rtemp[7]+"%12.7f" %rtemp[8]

         if coorwin : 
           coorwin.Destroy()
           coorwin = Coor_Win(self)

# calculate the output angles from the rotation matrix
# apply symmetry operation

         if icode != 0:

          if outsys == 0: 
            if outcon == 0: self.RotXYX(rot1,nsym,rsym,j)
            if outcon == 1: self.RotYZY(rot1,nsym,rsym,j)
            if outcon == 2: self.RotZXZ(rot1,nsym,rsym,j)
            if outcon == 3: self.RotXZX(rot1,nsym,rsym,j)
            if outcon == 4: self.RotYXY(rot1,nsym,rsym,j)
            if outcon == 5: self.RotZYZ(rot1,nsym,rsym,j)

            if outcon == 6: 
              if outaxes == 0 or outrot == 1: self.RotXYZ(rot1,nsym,rsym,j)
              else: self.RotZYX(rot1,nsym,rsym,j)
            if outcon == 7: 
              if outaxes == 0 or outrot == 1: self.RotYZX(rot1,nsym,rsym,j)
              else: self.RotXZY(rot1,nsym,rsym,j)
            if outcon == 8: 
              if outaxes == 0 or outrot == 1: self.RotZXY(rot1,nsym,rsym,j)
              else: self.RotYXZ(rot1,nsym,rsym,j)
            if outcon == 9: 
              if outaxes == 0 or outrot == 1: self.RotXZY(rot1,nsym,rsym,j)
              else: self.RotYZX(rot1,nsym,rsym,j)
            if outcon == 10: 
              if outaxes == 0 or outrot == 1: self.RotYXZ(rot1,nsym,rsym,j)
              else: self.RotZXY(rot1,nsym,rsym,j)
            if outcon == 11: 
              if outaxes == 0 or outrot == 1: self.RotZYX(rot1,nsym,rsym,j)
              else: self.RotXYZ(rot1,nsym,rsym,j)

          if outsys == 1 and (outpol == 0 or outpol == 1): self.RotZX(rot1,nsym,rsym,j)
          if outsys == 1 and (outpol == 2 or outpol == 3): self.RotXY(rot1,nsym,rsym,j)
          if outsys == 1 and (outpol == 4 or outpol == 5): self.RotYZ(rot1,nsym,rsym,j)

          if outsys == 2: self.RotCos(rot1,nsym,rsym,j)

          if outsys == 3: self.RotMat(rot1,nsym,rsym)

          if outsys == 4: self.RotQuat(rot1,nsym,rsym,j)

          print("\n", file = fileout)

       if len(angoutlist) != 0: btnDemor.Enable()
 
       return

#-------------------------------------
# Rotation Z(1) Y(2) Z(3)

    def RotZYZ(self,rot,nsym,rsym,nangl):
      global ang1, ang2, ang3, icode, ierr, ltxteul, ltcor

      if icode == 0:

         ang1 = float(anglist[nangl].split()[0])
         ang2 = float(anglist[nangl].split()[1])
         ang3 = float(anglist[nangl].split()[2])

         ltxteul = "%20.2f" %ang1 + "%12.2f" %ang2 + "%12.2f" %ang3

         Mrot(self,ang1,ang2,ang3)

         icode=1

# matrix solution

      else:

         for i in range(nsym):
           rs = rsym[i]
           self.CalDet(i,rot,nsym,rs)
           if ierr == 1: return
        
           cbet = rtemp[8]
           if abs(cbet) > 1.0+eps1:
             tmes.SetValue(' (3,3)-element of the matrix is larger than 1 :' + "%12.3g" %cbet)
             tmes.SetForegroundColour(col1) 
             icode = 0
             ierr = 1
             return
           elif cbet > 1.0: cbet = 1.0
           elif cbet < -1.0: cbet = -1.0

           bet = math.acos(cbet)
           sbet = math.sin(bet)
           
           if abs(sbet) <= eps2:
             ltcor = ' beta = 0 degrees, only alpha and gamma can be defined. Set up gamma = 0'
             tmes.WriteText(ltcor+ "\n")

             print(ltcor, file = fileout)

             gam = 0.0
             alp = math.atan2(rtemp[3],rtemp[4])
           else:
             alp = math.atan2(rtemp[7],-rtemp[6])
             gam = math.atan2(rtemp[5], rtemp[2])

           self.AngOut(alp,bet,gam)

      return

#-------------------------------------
# Rotation Z(1) X(2) Z(3)

    def RotZXZ(self,rot,nsym,rsym,nangl):
      global ang1, ang2, ang3, icode, ierr, ltxteul, ltcor

      if icode == 0:

         ang1 = float(anglist[nangl].split()[0])
         ang2 = float(anglist[nangl].split()[1])
         ang3 = float(anglist[nangl].split()[2])

         ltxteul = "%20.2f" %ang1 + "%12.2f" %ang2 + "%12.2f" %ang3

         Mrot(self,ang1,ang2,ang3)

         icode=1

# matrix solution

      else:

         for i in range(nsym):
           rs = rsym[i]
           self.CalDet(i,rot,nsym,rs)
           if ierr == 1: return
        
           cbet = rtemp[8]
           if abs(cbet) > 1.0+eps1:
             tmes.SetValue(' (3,3)-element of the matrix is larger than 1 :' + "%12.3g" %cbet)
             tmes.SetForegroundColour(col1) 
             icode = 0
             ierr = 1
             return
           elif cbet > 1.0: cbet = 1.0
           elif cbet < -1.0: cbet = -1.0

           bet = math.acos(cbet)
           sbet = math.sin(bet)

           if abs(sbet) <= eps2:
             ltcor = ' beta = 0 degrees, only alpha and gamma can be defined. Set up gamma = 0'
             tmes.WriteText(ltcor+ "\n")

             print(ltcor, file = fileout)

             gam = 0.0
             alp = math.atan2(-rtemp[1],rtemp[0])
           else:
             alp = math.atan2(rtemp[6], rtemp[7])
             gam = math.atan2(rtemp[2],-rtemp[5])

           self.AngOut(alp,bet,gam)

      return

#-------------------------------------
# Rotation X(1) Z(2) X(3)

    def RotXZX(self,rot,nsym,rsym,nangl):
      global ang1, ang2, ang3, icode, ierr, ltxteul, ltcor

      if icode == 0:

         ang1 = float(anglist[nangl].split()[0])
         ang2 = float(anglist[nangl].split()[1])
         ang3 = float(anglist[nangl].split()[2])

         ltxteul = "%20.2f" %ang1 + "%12.2f" %ang2 + "%12.2f" %ang3

         Mrot(self,ang1,ang2,ang3)

         icode=1

# matrix solution

      else:

         for i in range(nsym):
           rs = rsym[i]
           self.CalDet(i,rot,nsym,rs)
           if ierr == 1: return
        
           cbet = rtemp[0]
           if abs(cbet) > 1.0+eps1:
             tmes.SetValue(' (1,1)-element of the matrix is larger than 1 :' + "%12.3g" %cbet)
             tmes.SetForegroundColour(col1) 
             icode = 0
             ierr = 1
             return
           elif cbet > 1.0: cbet = 1.0
           elif cbet < -1.0: cbet = -1.0
           bet = math.acos(cbet)
           sbet = math.sin(bet)
           if abs(sbet) <= eps2:
             ltcor = ' beta = 0 degrees, only alpha and gamma can be defined. Set up gamma = 0'
             tmes.WriteText(ltcor+ "\n")

             print(ltcor, file = fileout)

             gam = 0.0
             alp = math.atan2(rtemp[7],rtemp[8])
           else:
             alp = math.atan2(rtemp[2],-rtemp[1])
             gam = math.atan2(rtemp[6], rtemp[3])

           self.AngOut(alp,bet,gam)

      return

#-------------------------------------
# Rotation X(1) Y(2) X(3)

    def RotXYX(self,rot,nsym,rsym,nangl):
      global ang1, ang2, ang3, icode, ierr, ltxteul, ltcor

      if icode == 0:

         ang1 = float(anglist[nangl].split()[0])
         ang2 = float(anglist[nangl].split()[1])
         ang3 = float(anglist[nangl].split()[2])

         ltxteul = "%20.2f" %ang1 + "%12.2f" %ang2 + "%12.2f" %ang3

         Mrot(self,ang1,ang2,ang3)

         icode=1

# matrix solution

      else:

         for i in range(nsym):
           rs = rsym[i]
           self.CalDet(i,rot,nsym,rs)
           if ierr == 1: return
        
           cbet = rtemp[0]
           if abs(cbet) > 1.0+eps1:
             tmes.SetValue(' (1,1)-element of the matrix is larger than 1 :' + "%12.3g" %cbet)
             tmes.SetForegroundColour(col1) 
             icode = 0
             ierr = 1
             return
           elif cbet > 1.0: cbet = 1.0
           elif cbet < -1.0: cbet = -1.0
           bet = math.acos(cbet)
           sbet = math.sin(bet)
           if abs(sbet) <= eps2:
             ltcor = ' beta = 0 degrees, only alpha and gamma can be defined. Set up gamma = 0'
             tmes.WriteText(ltcor+ "\n")

             print(ltcor, file = fileout)

             gam = 0.0
             alp = math.atan2(-rtemp[5],rtemp[4])
           else:
             alp = math.atan2(rtemp[1], rtemp[2])
             gam = math.atan2(rtemp[3],-rtemp[6])

           self.AngOut(alp,bet,gam)

      return

#-------------------------------------
# Rotation Y(1) X(2) Y(3)

    def RotYXY(self,rot,nsym,rsym,nangl):
      global ang1, ang2, ang3, icode, ierr, ltxteul, ltcor

      if icode == 0:

         ang1 = float(anglist[nangl].split()[0])
         ang2 = float(anglist[nangl].split()[1])
         ang3 = float(anglist[nangl].split()[2])

         ltxteul = "%20.2f" %ang1 + "%12.2f" %ang2 + "%12.2f" %ang3

         Mrot(self,ang1,ang2,ang3)

         icode=1

# matrix solution

      else:

         for i in range(nsym):
           rs = rsym[i]
           self.CalDet(i,rot,nsym,rs)
           if ierr == 1: return
        
           cbet = rtemp[4]
           if abs(cbet) > 1.0+eps1:
             tmes.SetValue(' (2,2)-element of the matrix is larger than 1 :' + "%12.3g" %cbet)
             tmes.SetForegroundColour(col1) 
             icode = 0
             ierr = 1
             return
           elif cbet > 1.0: cbet = 1.0
           elif cbet < -1.0: cbet = -1.0
           bet = math.acos(cbet)
           sbet = math.sin(bet)
           if abs(sbet) <= eps2:
             ltcor = ' beta = 0 degrees, only alpha and gamma can be defined. Set up gamma = 0'
             tmes.WriteText(ltcor+ "\n")

             print(ltcor, file = fileout)

             gam = 0.0
             alp = math.atan2(rtemp[2],rtemp[0])
           else:
             alp = math.atan2(rtemp[3],-rtemp[5])
             gam = math.atan2(rtemp[1], rtemp[7])

           self.AngOut(alp,bet,gam)

      return

#-------------------------------------
# Rotation Y(1) Z(2) Y(3)

    def RotYZY(self,rot,nsym,rsym,nangl):
      global ang1, ang2, ang3, icode, ierr, ltxteul, ltcor

      if icode == 0:

         ang1 = float(anglist[nangl].split()[0])
         ang2 = float(anglist[nangl].split()[1])
         ang3 = float(anglist[nangl].split()[2])

         ltxteul = "%20.2f" %ang1 + "%12.2f" %ang2 + "%12.2f" %ang3

         Mrot(self,ang1,ang2,ang3)

         icode=1

# matrix solution

      else:

         for i in range(nsym):
           rs = rsym[i]
           self.CalDet(i,rot,nsym,rs)
           if ierr == 1: return
        
           cbet = rtemp[4]
           if abs(cbet) > 1.0+eps1:
             tmes.SetValue(' (2,2)-element of the matrix is larger than 1 :' + "%12.3g" %cbet)
             tmes.SetForegroundColour(col1) 
             icode = 0
             ierr = 1
             return
           elif cbet > 1.0: cbet = 1.0
           elif cbet < -1.0: cbet = -1.0
           bet = math.acos(cbet)
           sbet = math.sin(bet)
           if abs(sbet) <= eps2:
             ltcor = ' beta = 0 degrees, only alpha and gamma can be defined. Set up gamma = 0'
             tmes.WriteText(ltcor+ "\n")

             print(ltcor, file = fileout)

             gam = 0.0
             alp = math.atan2(-rtemp[6],rtemp[8])
           else:
             alp = math.atan2(rtemp[5], rtemp[3])
             gam = math.atan2(rtemp[7],-rtemp[1])

           self.AngOut(alp,bet,gam)

      return

#-------------------------------------
# Rotation Z(1) Y(2) X(3)

    def RotZYX(self,rot,nsym,rsym,nangl):
      global ang1, ang2, ang3, icode, ierr, ltxteul, ltcor

      if icode == 0:

         ang1 = float(anglist[nangl].split()[0])
         ang2 = float(anglist[nangl].split()[1])
         ang3 = float(anglist[nangl].split()[2])

         ltxteul = "%20.2f" %ang1 + "%12.2f" %ang2 + "%12.2f" %ang3

         Mrot(self,ang1,ang2,ang3)

         icode=1

# matrix solution

      else:

         for i in range(nsym):
           rs = rsym[i]
           self.CalDet(i,rot,nsym,rs)
           if ierr == 1: return
        
           sbet = rtemp[2]
           if abs(sbet) > 1.0+eps1:
             tmes.SetValue(' (1,3)-element of the matrix is larger than 1 :' + "%12.3g" %sbet)
             tmes.SetForegroundColour(col1) 
             icode = 0
             ierr = 1
             return
           elif sbet > 1.0: sbet = 1.0
           elif sbet < -1.0: sbet = -1.0
           bet = math.asin(sbet)
           cbet = math.cos(bet)
           if abs(cbet) <= eps2:
             ltcor = ' beta = 90 degrees, only alpha and gamma can be defined. Set up gamma = 0'
             tmes.WriteText(ltcor+ "\n")

             print(ltcor, file = fileout)

             gam = 0.0
             alp = math.atan2(rtemp[3],rtemp[4])
           else:
             alp = math.atan2(-rtemp[1], rtemp[0])
             gam = math.atan2(-rtemp[5], rtemp[8])

           self.AngOut(alp,bet,gam)

      return

#-------------------------------------
# Rotation X(1) Y(2) Z(3)

    def RotXYZ(self,rot,nsym,rsym,nangl):
      global ang1, ang2, ang3, icode, ierr, ltxteul, ltcor

      if icode == 0:

         ang1 = float(anglist[nangl].split()[0])
         ang2 = float(anglist[nangl].split()[1])
         ang3 = float(anglist[nangl].split()[2])

         ltxteul = "%20.2f" %ang1 + "%12.2f" %ang2 + "%12.2f" %ang3

         Mrot(self,ang1,ang2,ang3)

         icode=1

# matrix solution

      else:

         for i in range(nsym):
           rs = rsym[i]
           self.CalDet(i,rot,nsym,rs)
           if ierr == 1: return
        
           sbet = rtemp[6]
           if abs(sbet) > 1.0+eps1:
             tmes.SetValue(' (3,1)-element of the matrix is larger than 1 :' + "%12.3g" %sbet)
             tmes.SetForegroundColour(col1) 
             icode = 0
             ierr = 1
             return
           elif sbet > 1.0: sbet = 1.0
           elif sbet < -1.0: sbet = -1.0
           bet = -math.asin(sbet)
           cbet = math.cos(bet)
           if abs(cbet) <= eps2:
             ltcor = ' beta = 90 degrees, only alpha and gamma can be defined. Set up gamma = 0'
             tmes.WriteText(ltcor+ "\n")

             print(ltcor, file = fileout)

             gam = 0.0
             alp = math.atan2(-rtemp[5],rtemp[4])
           else:
             alp = math.atan2(rtemp[7], rtemp[8])
             gam = math.atan2(rtemp[3], rtemp[0])

           self.AngOut(alp,bet,gam)

      return

#-------------------------------------
# Rotation Y(1) X(2) Z(3)

    def RotYXZ(self,rot,nsym,rsym,nangl):
      global ang1, ang2, ang3, icode, ierr, ltxteul, ltcor

      if icode == 0:

         ang1 = float(anglist[nangl].split()[0])
         ang2 = float(anglist[nangl].split()[1])
         ang3 = float(anglist[nangl].split()[2])

         ltxteul = "%20.2f" %ang1 + "%12.2f" %ang2 + "%12.2f" %ang3

         Mrot(self,ang1,ang2,ang3)

         icode=1

# matrix solution

      else:

         for i in range(nsym):
           rs = rsym[i]
           self.CalDet(i,rot,nsym,rs)
           if ierr == 1: return
        
           sbet = rtemp[7]
           if abs(sbet) > 1.0+eps1:
             tmes.SetValue(' (3,2)-element of the matrix is larger than 1 :' + "%12.3g" %sbet)
             tmes.SetForegroundColour(col1) 
             icode = 0
             ierr = 1
             return
           elif sbet > 1.0: sbet = 1.0
           elif sbet < -1.0: sbet = -1.0
           bet = math.asin(sbet)
           cbet = math.cos(bet)
           if abs(cbet) <= eps2:
             ltcor = ' beta = 90 degrees, only alpha and gamma can be defined. Set up gamma = 0'
             tmes.WriteText(ltcor+ "\n")

             print(ltcor, file = fileout)

             gam = 0.0
             alp = math.atan2(rtemp[2],rtemp[0])
           else:
             alp = math.atan2(-rtemp[6], rtemp[8])
             gam = math.atan2(-rtemp[1], rtemp[4])

           self.AngOut(alp,bet,gam)

      return

#-------------------------------------
# Rotation Z(1) X(2) Y(3)

    def RotZXY(self,rot,nsym,rsym,nangl):
      global ang1, ang2, ang3, icode, ierr, ltxteul, ltcor

      if icode == 0:

         ang1 = float(anglist[nangl].split()[0])
         ang2 = float(anglist[nangl].split()[1])
         ang3 = float(anglist[nangl].split()[2])

         ltxteul = "%20.2f" %ang1 + "%12.2f" %ang2 + "%12.2f" %ang3

         Mrot(self,ang1,ang2,ang3)

         icode=1

# matrix solution

      else:

         for i in range(nsym):
           rs = rsym[i]
           self.CalDet(i,rot,nsym,rs)
           if ierr == 1: return
        
           sbet = rtemp[5]
           if abs(sbet) > 1.0+eps1:
             tmes.SetValue(' (2,3)-element of the matrix is larger than 1 :' + "%12.3g" %sbet)
             tmes.SetForegroundColour(col1) 
             icode = 0
             ierr = 1
             return
           elif sbet > 1.0: sbet = 1.0
           elif sbet < -1.0: sbet = -1.0
           bet = -math.asin(sbet)
           cbet = math.cos(bet)
           if abs(cbet) <= eps2:
             ltcor = ' beta = 90 degrees, only alpha and gamma can be defined. Set up gamma = 0'
             tmes.WriteText(ltcor+ "\n")

             print(ltcor, file = fileout)

             gam = 0.0
             alp = math.atan2(-rtemp[1],rtemp[0])
           else:
             alp = math.atan2(rtemp[3], rtemp[4])
             gam = math.atan2(rtemp[2], rtemp[8])

           self.AngOut(alp,bet,gam)

      return

#-------------------------------------
# Rotation X(1) Z(2) Y(3)

    def RotXZY(self,rot,nsym,rsym,nangl):
      global ang1, ang2, ang3, icode, ierr, ltxteul, ltcor

      if icode == 0:

         ang1 = float(anglist[nangl].split()[0])
         ang2 = float(anglist[nangl].split()[1])
         ang3 = float(anglist[nangl].split()[2])

         ltxteul = "%20.2f" %ang1 + "%12.2f" %ang2 + "%12.2f" %ang3

         Mrot(self,ang1,ang2,ang3)

         icode=1

# matrix solution

      else:

         for i in range(nsym):
           rs = rsym[i]
           self.CalDet(i,rot,nsym,rs)
           if ierr == 1: return
        
           sbet = rtemp[3]
           if abs(sbet) > 1.0+eps1:
             tmes.SetValue(' (2,1)-element of the matrix is larger than 1 :' + "%12.3g" %sbet)
             tmes.SetForegroundColour(col1) 
             icode = 0
             ierr = 1
             return
           elif sbet > 1.0: sbet = 1.0
           elif sbet < -1.0: sbet = -1.0
           bet = math.asin(sbet)
           cbet = math.cos(bet)
           if abs(cbet) <= eps2:
             ltcor = ' beta = 90 degrees, only alpha and gamma can be defined. Set up gamma = 0'
             tmes.WriteText(ltcor+ "\n")

             print(ltcor, file = fileout)

             gam = 0.0
             alp = math.atan2(rtemp[7],rtemp[8])
           else:
             alp = math.atan2(-rtemp[5], rtemp[4])
             gam = math.atan2(-rtemp[6], rtemp[0])

           self.AngOut(alp,bet,gam)

      return

#-------------------------------------
# Rotation Y(1) Z(2) X(3)

    def RotYZX(self,rot,nsym,rsym,nangl):
      global ang1, ang2, ang3, icode, ierr, ltxteul, ltcor

      if icode == 0:

         ang1 = float(anglist[nangl].split()[0])
         ang2 = float(anglist[nangl].split()[1])
         ang3 = float(anglist[nangl].split()[2])

         ltxteul = "%20.2f" %ang1 + "%12.2f" %ang2 + "%12.2f" %ang3

         Mrot(self,ang1,ang2,ang3)

         icode=1

# matrix solution

      else:

         for i in range(nsym):
           rs = rsym[i]
           self.CalDet(i,rot,nsym,rs)
           if ierr == 1: return
        
           sbet = rtemp[1]
           if abs(sbet) > 1.0+eps1:
             tmes.SetValue(' (1,2)-element of the matrix is larger than 1 :' + "%12.3g" %sbet)
             tmes.SetForegroundColour(col1) 
             icode = 0
             ierr = 1
             return
           elif sbet > 1.0: sbet = 1.0
           elif sbet < -1.0: sbet = -1.0
           bet = -math.asin(sbet)
           cbet = math.cos(bet)
           if abs(cbet) <= eps2:
             ltcor = ' beta = 90 degrees, only alpha and gamma can be defined. Set up gamma = 0'
             tmes.WriteText(ltcor+ "\n")

             print(ltcor, file = fileout)

             gam = 0.0
             alp = math.atan2(-rtemp[6],rtemp[8])
           else:
             alp = math.atan2(rtemp[2], rtemp[0])
             gam = math.atan2(rtemp[7], rtemp[4])

           self.AngOut(alp,bet,gam)

      return

#-------------------------------------
# Output Euler angles

    def AngOut(self,alp,bet,gam):
        global outaxes, angoutlist

        alp = alp/grrad
        bet = bet/grrad
        gam = gam/grrad

        laboutdir = lrot8[outdir].strip()

        if outrot == 1: outaxes = 1
        self.imaxr.SetSelection(outaxes)

        if outrot == 0 and outaxes == 1:
          a1 = alp
          alp = gam
          bet = bet
          gam = a1

        if outrot == 1 and outaxes == 1:
          alp = -alp
          bet = -bet
          gam = -gam

        if laboutdir[0] == 'c': alp = -alp
        if laboutdir[1] == 'c': bet = -bet
        if laboutdir[2] == 'c': gam = -gam

# reduce the angles to the minimal interval

        if gam < 0.0: gam = gam+360.
        if gam >= 360.0: gam = gam-360.
        if gam >= 180.0:
             alp = alp+180.
             if outcon <= 5: bet = 360.-bet 
             else: bet = 180.-bet 
             gam = gam-180.
           
        if alp < 0.0: alp = alp+360.
        if alp >= 360.0: alp = alp-360.
        if bet < 0.0: bet = bet+360.
        if bet >= 360.0: bet = bet-360.

        alps = alp+180. 
        if outcon <= 5: bets = 360.-bet 
        else: bets = 180.-bet 
        if bets < 0.: bets = bets+360.
        gams = gam+180.

        if alps >= 360.0: alps=alps-360.
        if bets >= 360.0: bets=bets-360.
        if gams >= 360.0: gams=gams-360.

        ltxtr21 = "%20.2f" %alp + "%12.2f" %bet + "%12.2f" %gam 
        ltxtr22 = "%74.2f" %alps + "%12.2f" %bets + "%12.2f" %gams
        if insys == 3: ltxtr22 = "%20.2f" %alps + "%12.2f" %bets + "%12.2f" %gams
        ltxtr23 = 52*" "+"%12.2f" %alps + "%12.2f" %bets + "%12.2f" %gams

        if insys == 0:

            tmes.WriteText(ltxteul+ltxtr21+"\n")
            tmes.WriteText(ltxtr22+"\n\n")
            print(ltxteul+ltxtr21, file = fileout)
            print(ltxtr23, file = fileout)

        if insys == 1:

            tmes.WriteText(ltxtpol+ltxtr21+"\n")
            tmes.WriteText(ltxtr22+"\n\n")
            print(ltxtpol+ltxtr21, file = fileout)
            print(ltxtr23, file = fileout)

        if insys == 2:

            tmes.WriteText(ltxtcos+ltxtr21+"\n")
            tmes.WriteText(ltxtr22+"\n\n")
            print(ltxtcos+ltxtr21, file = fileout)
            print(ltxtr23, file = fileout)

        if insys == 3:

            tmes.WriteText(ltxtm1+ltxtr21+"\n")
            tmes.WriteText(ltxtm2+ltxtr22+"\n")
            tmes.WriteText(ltxtm3+"\n\n")
            print(ltxtm1+ltxtr21, file = fileout)
            print(ltxtm2+ltxtr22, file = fileout)
            print(ltxtm3, file = fileout)

        if insys == 4:

            tmes.WriteText(ltxtquat+ltxtr21+"\n")
            tmes.WriteText(ltxtr22+"\n\n")
            print(ltxtquat+ltxtr21, file = fileout)
            print(ltxtr23, file = fileout)

        ana = "%.0f" %alp + " %.0f" %bet + " %.0f" %gam
        anb = "%.0f" %alps + " %.0f" %bets + " %.0f" %gams
        angoutlist.append(ana)
        angoutlist.append(anb)

#-------------------------------------
# Polar rotation ZX

    def RotZX(self,rot,nsym,rsym,nangl):
      global ang1, ang2, ang3, icode, ierr, ltxtpol, ltcor

      if icode == 0:

         ang1 = float(anglist[nangl].split()[0])
         ang2 = float(anglist[nangl].split()[1])
         ang3 = float(anglist[nangl].split()[2]) 

         ltxtpol = "%20.2f" %ang1 + "%12.2f" %ang2 + "%12.2f" %ang3

         Mrot(self,ang1,ang2,ang3)

         icode=1

# matrix solution

      else:

         for i in range(nsym):
           rs = rsym[i]
           self.CalDet(i,rot,nsym,rs)
           if ierr == 1: return
        
           trace=rtemp[0]+rtemp[4]+rtemp[8]
           ck=(trace-1.)/2.
           if abs(ck) > 1.0+eps1:
             tmes.SetValue(' Matrix trace is beyond (-1,3) :' + "%12.3g" %trace)
             tmes.SetForegroundColour(col1) 
             icode = 0
             ierr = 1
             return
           elif ck > 1.0: ck = 1.0
           elif ck < -1.0: ck = -1.0

           kap = math.acos(ck)
           sk = math.sin(kap)

           if ck >= 1.-eps2:
             ltcor = ' kappa = 0 degrees. Set up theta = phi = 0'
             tmes.WriteText(ltcor+"\n")
             print(ltcor, file = fileout)

             the =0.0
             phi =0.0
           elif ck <= -1.+eps2:
             ar = rtemp[8]
             if ar > 1.0: ar = 1.0
             if ar < -1.0: ar = -1.0
             the = 0.5*math.acos(ar)
             if abs(the) <= eps2:
               ltcor = ' theta = 0 degrees and kappa = 180 degrees. Set up phi = 0'
               tmes.WriteText(ltcor+"\n")
               print(ltcor, file = fileout)

               phi =0.0
             elif abs(the-math.pi/2.) <= eps2:
               ltcor = ' theta = 90 degrees and kappa = 180 degrees'
               tmes.WriteText(ltcor+"\n")
               print(ltcor, file = fileout)

               phi =0.5*math.atan2(rtemp[1]+rtemp[3],2*rtemp[0])
             else:
               phi =math.atan2(rtemp[5]+rtemp[7],rtemp[2]+rtemp[6])
           else:
               ar = (rtemp[3]-rtemp[1])/(2*sk)
               if ar > 1.0: ar = 1.0
               if ar < -1.0: ar = -1.0
               the =math.acos(ar)
               st = math.sin(the)
               if abs(st) <= eps2:
                ltcor = ' theta = 0 degrees or theta = 180 degrees. Set up phi = 0'
                tmes.WriteText(ltcor+"\n")
                print(ltcor, file = fileout)

                phi = 0.0
               else:
                phi =math.atan2(rtemp[2]-rtemp[6], rtemp[7]-rtemp[5])

           self.AngPolOut(the,phi,kap)

      return   

#-------------------------------------
# Polar rotation XY

    def RotXY(self,rot,nsym,rsym,nangl):
      global ang1, ang2, ang3, icode, ierr, ltxtpol, ltcor

      if icode == 0:

         ang1 = float(anglist[nangl].split()[0])
         ang2 = float(anglist[nangl].split()[1])
         ang3 = float(anglist[nangl].split()[2])

         ltxtpol = "%20.2f" %ang1 + "%12.2f" %ang2 + "%12.2f" %ang3

         Mrot(self,ang1,ang2,ang3)

         icode=1

# matrix solution

      else:

         for i in range(nsym):
           rs = rsym[i]
           self.CalDet(i,rot,nsym,rs)
           if ierr == 1: return
        
           ck=(rtemp[0]+rtemp[4]+rtemp[8]-1.)/2.
           if abs(ck) > 1.0+eps1:
             tmes.SetValue(' Matrix trace is larger than 3 :' + "%12.3g" %ck)
             tmes.SetForegroundColour(col1) 
             icode = 0
             ierr = 1
             return
           elif ck > 1.0: ck = 1.0
           elif ck < -1.0: ck = -1.0

           kap = math.acos(ck)
           sk = math.sin(kap)

           if ck >= 1.-eps2:
             ltcor = ' kappa = 0 degrees. Set up theta = phi = 0'
             tmes.WriteText(ltcor+"\n")
             print(ltcor, file = fileout)

             the =0.0
             phi =0.0
           elif ck <= -1.+eps2:
             ar = rtemp[0]
             if ar > 1.0: ar = 1.0
             if ar < -1.0: ar = -1.0
             the = 0.5*math.acos(ar)
             if abs(the) <= eps2:
               ltcor = ' theta = 0 degrees and kappa = 180 degrees. Set up phi = 0'
               tmes.WriteText(ltcor+"\n")
               print(ltcor, file = fileout)

               phi =0.0
             elif abs(the-math.pi/2.) <= eps2:
               ltcor = ' theta = 90 degrees and kappa = 180 degrees.'
               tmes.WriteText(ltcor+"\n")
               print(ltcor, file = fileout)

               phi =0.5*math.atan2(rtemp[5]+rtemp[7],2*rtemp[4])
             else:
               phi =math.atan2(rtemp[2]+rtemp[6],rtemp[1]+rtemp[3])
           else:
               ar = (rtemp[7]-rtemp[5])/(2*sk)
               if ar > 1.0: ar = 1.0
               if ar < -1.0: ar = -1.0
               the =math.acos(ar)
               st = math.sin(the)
               if abs(st) <= eps2:
                ltcor = ' theta = 0 degrees or theta = 180 degrees. Set up phi = 0'
                tmes.WriteText(ltcor+"\n")
                print(ltcor, file = fileout)

                phi = 0.0
               else:
                phi =math.atan2((rtemp[3]-rtemp[1]),(rtemp[2]-rtemp[6]))

           self.AngPolOut(the,phi,kap)

      return

#-------------------------------------
# Polar rotation YZ

    def RotYZ(self,rot,nsym,rsym,nangl):
      global ang1, ang2, ang3, icode, ierr, ltxtpol, ltcor

      if icode == 0:

         ang1 = float(anglist[nangl].split()[0])
         ang2 = float(anglist[nangl].split()[1])
         ang3 = float(anglist[nangl].split()[2])

         ltxtpol = "%20.2f" %ang1 + "%12.2f" %ang2 + "%12.2f" %ang3

         Mrot(self,ang1,ang2,ang3)

         icode=1

# matrix solution

      else:

         for i in range(nsym):
           rs = rsym[i]
           self.CalDet(i,rot,nsym,rs)
           if ierr == 1: return
        
           trace=rtemp[0]+rtemp[4]+rtemp[8]
           ck=(trace-1.)/2.
           if abs(ck) > 1.0+eps1:
             tmes.SetValue(' Matrix trace is beyond (-1,3) :' + "%12.3g" %trace)
             tmes.SetForegroundColour(col1) 
             icode = 0
             ierr = 1
             return
           elif ck > 1.0: ck = 1.0
           elif ck < -1.0: ck = -1.0

           kap = math.acos(ck)
           sk = math.sin(kap)

           if ck >= 1.-eps2:
             ltcor = ' kappa = 0 degrees. Set up theta = phi = 0'
             tmes.WriteText(ltcor+"\n")
             print(ltcor, file = fileout)

             the =0.0
             phi =0.0
           elif ck <= -1.+eps2:
             ar = rtemp[4]
             if ar > 1.0: ar = 1.0
             if ar < -1.0: ar = -1.0
             the = 0.5*math.acos(ar)
             if abs(the) <= eps2:
               ltcor = ' theta = 0 degrees and kappa = 180 degrees. Set up phi = 0'
               tmes.WriteText(ltcor+"\n")
               print(ltcor, file = fileout)

               phi =0.0
             elif abs(the-math.pi/2.) <= eps2:
               ltcor = ' theta = 90 degrees and kappa = 180 degrees.'
               tmes.WriteText(ltcor+"\n")
               print(ltcor, file = fileout)

               phi =0.5*math.atan2(rtemp[2]+rtemp[6],2*rtemp[8])
             else:
               phi =math.atan2(rtemp[1]+rtemp[3],rtemp[5]+rtemp[7])
           else:
               ar = (rtemp[2]-rtemp[6])/(2*sk)
               if ar > 1.0: ar = 1.0
               if ar < -1.0: ar = -1.0
               the =math.acos(ar)
               st = math.sin(the)
               if abs(st) <= eps2:
                ltcor = ' theta = 0 degrees or theta = 180 degrees. Set up phi = 0'
                tmes.WriteText(ltcor+"\n")
                print(ltcor, file = fileout)

                phi = 0.0
               else:
                phi =math.atan2((rtemp[7]-rtemp[5]),(rtemp[3]-rtemp[1]))

           self.AngPolOut(the,phi,kap)

      return 

#-------------------------------------
# Output polar angles

    def AngPolOut(self,the,phi,kap):
           global angoutlist

           the =the/grrad
           phi =phi/grrad
           kap =kap/grrad

           if outrot == 1: kap = -kap

           laboutdirp = lrotp4[outdirp].strip()

           if laboutdirp[0] == 'c': phi = -phi
           if laboutdirp[1] == 'c': kap = -kap

           if outpol == 1 or outpol == 3 or outpol == 5: phi=phi-90.

# reduce the angles to the minimal interval

           if kap < 0.0: kap =kap+360.
           if kap >= 360.0: kap =kap-360.
           if kap >= 180.0:
             the = the+180.
             phi =-phi+180.
             kap = 360.-kap

           if the < 0.0: the =the+360.
           if the >= 360.0: the =the-360.
           if phi < 0.0: phi =phi+360.
           if phi >= 360.0: phi =phi-360.

           thes = -the+180.
           phis = phi+180.
           kaps = 360.-kap
           if thes >= 360.0: thes =thes-360.
           if phis >= 360.0: phis =phis-360.
           if kaps >= 360.0: kaps =kaps-360.

           ltxtr21 = "%20.2f" %the + "%12.2f" %phi + "%12.2f" %kap 
           ltxtr22 = "%75.2f" %thes + "%12.2f" %phis + "%12.2f" %kaps
           if insys == 3: ltxtr22 = "%20.2f" %thes + "%12.2f" %phis + "%12.2f" %kaps
           ltxtr23 = "%64.2f" %thes + "%12.2f" %phis + "%12.2f" %kaps

           if insys == 0:

            tmes.WriteText(ltxteul+ltxtr21+"\n")
            tmes.WriteText(ltxtr22+"\n")
            print(ltxteul+ltxtr21, file = fileout)
            print(ltxtr23, file = fileout)

           if insys == 1:

            tmes.WriteText(ltxtpol+ltxtr21+"\n")
            tmes.WriteText(ltxtr22+"\n")
            print(ltxtpol+ltxtr21, file = fileout)
            print(ltxtr23, file = fileout)

           if insys == 2:

            tmes.WriteText(ltxtcos+ltxtr21+"\n")
            tmes.WriteText(ltxtr22+"\n")
            print(ltxtcos+ltxtr21, file = fileout)
            print(ltxtr23, file = fileout)

           if insys == 3:

            tmes.WriteText(ltxtm1+ltxtr21+"\n")
            tmes.WriteText(ltxtm2+ltxtr22+"\n")
            tmes.WriteText(ltxtm3+"\n")
            print(ltxtm1+ltxtr21, file = fileout)
            print(ltxtm2+ltxtr22, file = fileout)
            print(ltxtm3, file = fileout)

           if insys == 4:

            tmes.WriteText(ltxtquat+ltxtr21+"\n")
            tmes.WriteText(ltxtr22+"\n")
            print(ltxtquat+ltxtr21, file = fileout)
            print(ltxtr23, file = fileout)

           ana = "%.0f" %the + " %.0f" %phi + " %.0f" %kap
           anb = "%.0f" %thes + " %.0f" %phis + " %.0f" %kaps

           angoutlist.append(ana)
           angoutlist.append(anb)

#-------------------------------------
# Cos rotation

    def RotCos(self,rot,nsym,rsym,nangl):
      global cx, cy, cz, kappa, cxs, cys, czs, kappas, icode, ierr
      global ltcor, ltxtcos, angoutlist

      if icode == 0:

         cx = float(anglist[nangl].split()[0])
         cy = float(anglist[nangl].split()[1])
         cz = float(anglist[nangl].split()[2])
         kappa = float(anglist[nangl].split()[3])

         ltxtcos = "%20.3f" %cx + "%8.3f" %cy + "%8.3f" %cz + "%8.2f" %kappa         

         det = math.sqrt(cx*cx+cy*cy+cz*cz)
         if det == 0.:
          tmes.SetValue(" A problem in the direction cosines, the sum of their squares is equal to 0. ")
          tmes.SetForegroundColour(col1) 
          ierr = 1
          return

         if det != 1.0:
           scal =1./det
           cx =cx*scal
           cy =cy*scal
           cz =cz*scal
           if abs(abs(det)-1.0) > 1.*eps1:
             tt1 = 'A problem in the direction cosines, the sum of their squares is not equal to 1.0 :' + "%10.3f" %det
             tt2 = '.   Direction cosines are rescaled to ' + "%9.5f" %cx + "%9.5f" %cy + "%9.5f" %cz + "\n"   
             ltcor = tt1+tt2
             tmes.WriteText(ltcor+"\n")
             print(ltcor, file = fileout)

         Mrot(self,cx,cy,cz)

         icode=1

# matrix solution

      else:

         for i in range(nsym):
           rs = rsym[i]
           self.CalDet(i,rot,nsym,rs)

           if ierr == 1: return
        
           trace=rtemp[0]+rtemp[4]+rtemp[8]
           ck=(trace-1.)/2.
           if abs(ck) > 1.0+eps1:
             tmes.SetValue(' Matrix trace is beyond (-1,3) :' + "%12.3g" %trace)
             tmes.SetForegroundColour(col1) 
             icode = 0
             ierr = 1
             return
           elif ck > 1.0: ck = 1.0
           elif ck < -1.0: ck = -1.0

           kappa = math.acos(ck)
           sk = math.sin(kappa)

           if ck >= 1.-eps2:
             ltcor = ' kappa = 0 degrees. Set up the direction cosines as cosx = cosy = 0, cosz = 1'
             tmes.WriteText(ltcor+"\n")
             print(ltcor, file = fileout)

             cx=0.0
             cy=0.0
             cz=1.0
           elif ck <= -1.+eps2:
             arm = max(abs(rtemp[0]), abs(rtemp[4]), abs(rtemp[8]))
             ar = arm
             if ar > 1.0: ar = 1.0
             cn = math.cos(0.5*math.acos(ar)) 	          
             if arm == abs(rtemp[0]):
              cx = cn
              cy = math.cos(0.5*math.acos(rtemp[4]))  
              cy = math.copysign(cy,rtemp[3])
              cz = math.cos(0.5*math.acos(rtemp[8]))  
              cz = math.copysign(cz,rtemp[6])
             if arm == abs(rtemp[4]):
              cx = math.cos(0.5*math.acos(rtemp[0]))
              cx = math.copysign(cx,rtemp[1])
              cy = cn
              cz = math.cos(0.5*math.acos(rtemp[8]))  
              cz = math.copysign(cz,rtemp[7])
             if arm == abs(rtemp[8]):
              cx = math.cos(0.5*math.acos(rtemp[0]))
              cx = math.copysign(cx,rtemp[2])
              cy = math.cos(0.5*math.acos(rtemp[4]))  
              cy = math.copysign(cy,rtemp[5])
              cz = cn
           else:
               cx =(rtemp[7]-rtemp[5])/(2*sk)
               cy =(rtemp[2]-rtemp[6])/(2*sk)
               cz =(rtemp[3]-rtemp[1])/(2*sk)

           kappa = kappa/grrad
           det =cx*cx+cy*cy+cz*cz
           scal =1./math.sqrt(det)
           cx =cx*scal
           cy =cy*scal
           cz =cz*scal

           if outrot == 1: kappa = -kappa
           if outdirc == 1: kappa = -kappa

           if kappa < 0.0: kappa =kappa+360.
           if kappa >= 360.0: kappa =kappa-360.
           if kappa >= 180.0:
             cx =-cx
             cy =-cy
             cz =-cz
             kappa =360.-kappa

           cxs =-cx
           cys =-cy
           czs =-cz
           kappas =360.-kappa
           if kappas >= 360.0: kappas =kappas-360.

           ltxtr21 = "%20.3f" %cx + "%8.3f" %cy + "%8.3f" %cz + "%8.2f" %kappa  
           ltxtr22 = "%75.3f" %cxs + "%8.3f" %cys + "%8.3f" %czs + "%8.2f" %kappas
           if insys == 3: ltxtr22 = "%20.3f" %cxs + "%8.3f" %cys + "%8.3f" %czs + "%8.2f" %kappas
           ltxtr23 = "%64.3f" %cxs + "%8.3f" %cys + "%8.3f" %czs + "%8.2f" %kappas

           if insys == 0:

            tmes.WriteText(ltxteul+ltxtr21+"\n")
            tmes.WriteText(ltxtr22+"\n")
            print(ltxteul+ltxtr21, file = fileout)
            print(ltxtr23, file = fileout)

           if insys == 1:

            tmes.WriteText(ltxtpol+ltxtr21+"\n")
            tmes.WriteText(ltxtr22+"\n")
            print(ltxtpol+ltxtr21, file = fileout)
            print(ltxtr23, file = fileout)

           if insys == 2:

            tmes.WriteText(ltxtcos+ltxtr21+"\n")
            tmes.WriteText(ltxtr22+"\n")
            print(ltxtcos+ltxtr21, file = fileout)
            print(ltxtr23, file = fileout)

           if insys == 3:

            tmes.WriteText(ltxtm1+ltxtr21+"\n")
            tmes.WriteText(ltxtm2+ltxtr22+"\n")
            tmes.WriteText(ltxtm3+"\n")
            print(ltxtm1+ltxtr21, file = fileout)
            print(ltxtm2+ltxtr22, file = fileout)
            print(ltxtm3, file = fileout)

           if insys == 4:

            tmes.WriteText(ltxtquat+ltxtr21+"\n")
            tmes.WriteText(ltxtr22+"\n")
            print(ltxtquat+ltxtr21, file = fileout)
            print(ltxtr23, file = fileout)

           ana = "%8.3f" %cx + "%8.3f" %cy + "%8.3f" %cz + "%8.3f" %kappa  
           anb = "%8.3f" %cxs + "%8.3f" %cys + "%8.3f" %czs + "%8.3f" %kappas  

           angoutlist.append(ana)
           angoutlist.append(anb)

      return   

#-------------------------------------
# Quaternions rotation

    def RotQuat(self,rot,nsym,rsym,nangl):
      global qx, qy, qz, q0, qxs, qys, qzs, q0s, icode, ierr
      global ltcor, ltxtquat, angoutlist

      if icode == 0:

         qx = float(anglist[nangl].split()[0])
         qy = float(anglist[nangl].split()[1])
         qz = float(anglist[nangl].split()[2])
         q0 = float(anglist[nangl].split()[3])

         ltxtquat = "%20.3f" %qx + "%8.3f" %qy + "%8.3f" %qz + "%8.3f" %q0         

         det = math.sqrt(qx*qx+qy*qy+qz*qz+q0*q0)
         if det == 0.:
          tmes.SetValue(" A problem in the direction quaternions, the sum of their squares is equal to 0. ")
          tmes.SetForegroundColour(col1) 
          ierr = 1
          return

         if det != 1.0:
           scal =1./det
           qx =qx*scal
           qy =qy*scal
           qz =qz*scal
           q0 =q0*scal
           if abs(abs(det)-1.0) > 1.*eps1:
             tt1 = 'A problem in the direction quaternions, the sum of their squares is not equal to 1.0 :' + "%10.3f" %det
             tt2 = '.   Direction quaternions are rescaled to ' + "%9.5f" %qx + "%9.5f" %qy + "%9.5f" %qz + "%9.5f" %q0 + "\n"   
             ltcor = tt1+tt2
             tmes.WriteText(ltcor+"\n")
             print(ltcor, file = fileout)

         MQrot(self,qx,qy,qz,q0)

         icode=1

# matrix solution

      else:

         for i in range(nsym):
           rs = rsym[i]
           self.CalDet(i,rot,nsym,rs)

           if ierr == 1: return
        
           trace=rtemp[0]+rtemp[4]+rtemp[8]
           ck=(trace-1.)/2.

           if abs(ck) > 1.0+eps1:
             tmes.SetValue(' Matrix trace is beyond (-1,3) :' + "%12.3g" %trace)
             tmes.SetForegroundColour(col1) 
             icode = 0
             ierr = 1
             return
           elif ck > 1.0: ck = 1.0
           elif ck < -1.0: ck = -1.0

           q0 = math.sqrt(1+trace)/2.
           sk2 = math.sqrt(1-q0*q0)

           if ck >= 1.-eps2:

             ltcor = ' q0 = 1 . Set up the direction quaternions as qx = qy = qz = 0'
             tmes.WriteText(ltcor+"\n")
             print(ltcor, file = fileout)

             qx = qy = qz = 0.
             q0 = 1.

           elif ck <= -1.+eps2:
             arm = max(abs(rtemp[0]), abs(rtemp[4]), abs(rtemp[8]))
             ar = arm
             if ar > 1.0: ar = 1.0
             cn = math.cos(0.5*math.acos(ar)) 
             if arm == abs(rtemp[0]):
              cx = cn
              cy = math.cos(0.5*math.acos(rtemp[4]))  
              cy = math.copysign(cy,rtemp[3])
              cz = math.cos(0.5*math.acos(rtemp[8]))  
              cz = math.copysign(cz,rtemp[6])
             if arm == abs(rtemp[4]):
              cx = math.cos(0.5*math.acos(rtemp[0]))
              cx = math.copysign(cx,rtemp[1])
              cy = cn
              cz = math.cos(0.5*math.acos(rtemp[8]))  
              cz = math.copysign(cz,rtemp[7])
             if arm == abs(rtemp[8]):
              cx = math.cos(0.5*math.acos(rtemp[0]))
              cx = math.copysign(cx,rtemp[2])
              cy = math.cos(0.5*math.acos(rtemp[4]))  
              cy = math.copysign(cy,rtemp[5])
              cz = cn

             qx = cx*sk2
             qy = cy*sk2
             qz = cz*sk2

           else:

             qx = (rtemp[7]-rtemp[5])/(4*q0)
             qy = (rtemp[2]-rtemp[6])/(4*q0)
             qz = (rtemp[3]-rtemp[1])/(4*q0)

           det =qx*qx+qy*qy+qz*qz+q0*q0
           scal =1./math.sqrt(det)
           qx =qx*scal
           qy =qy*scal
           qz =qz*scal
           q0 =q0*scal

           if outrot == 1:
             qx = -qx
             qy = -qy
             qz = -qz
           if outdirc == 1: 
             qx = -qx
             qy = -qy
             qz = -qz

           qxs = -qx
           qys = -qy
           qzs = -qz
           q0s = -q0

           ltxtr21 = "%20.3f" %qx + "%8.3f" %qy + "%8.3f" %qz + "%8.3f" %q0  
           ltxtr22 = "%75.3f" %qxs + "%8.3f" %qys + "%8.3f" %qzs + "%8.3f" %q0s
           if insys == 3: ltxtr22 = "%20.3f" %qxs + "%8.3f" %qys + "%8.3f" %qzs + "%8.3f" %q0s
           ltxtr23 = "%64.3f" %qxs + "%8.3f" %qys + "%8.3f" %qzs + "%8.3f" %q0s

           if insys == 0:

            tmes.WriteText(ltxteul+ltxtr21+"\n")
            tmes.WriteText(ltxtr22+"\n")
            print(ltxteul+ltxtr21, file = fileout)
            print(ltxtr23, file = fileout)

           if insys == 1:

            tmes.WriteText(ltxtpol+ltxtr21+"\n")
            tmes.WriteText(ltxtr22+"\n")
            print(ltxtpol+ltxtr21, file = fileout)
            print(ltxtr23, file = fileout)

           if insys == 2:

            tmes.WriteText(ltxtcos+ltxtr21+"\n")
            tmes.WriteText(ltxtr22+"\n")
            print(ltxtcos+ltxtr21, file = fileout)
            print(ltxtr23, file = fileout)

           if insys == 3:

            tmes.WriteText(ltxtm1+ltxtr21+"\n")
            tmes.WriteText(ltxtm2+ltxtr22+"\n")
            tmes.WriteText(ltxtm3+"\n")
            print(ltxtm1+ltxtr21, file = fileout)
            print(ltxtm2+ltxtr22, file = fileout)
            print(ltxtm3, file = fileout)

           if insys == 4:

            tmes.WriteText(ltxtquat+ltxtr21+"\n")
            tmes.WriteText(ltxtr22+"\n\n")
            print(ltxtquat+ltxtr21, file = fileout)
            print(ltxtr23, file = fileout)

           ana = "%8.3f" %qx + "%8.3f" %qy + "%8.3f" %qz + "%8.3f" %q0  
           anb = "%8.3f" %qxs + "%8.3f" %qys + "%8.3f" %qzs + "%8.3f" %q0s  

           angoutlist.append(ana)
           angoutlist.append(anb)

      return   

#-------------------------------------
# matrix rotation

    def RotMat(self,rot,nsym,rsym):
      global icode, ierr, ltxtm1, ltxtm2, ltxtm3, ltxtm11, ltxtm22, ltxtm33, ltcor
      
      if icode == 0:

         rot[0] = float(anglist[0].split()[0])
         rot[1] = float(anglist[0].split()[1])
         rot[2] = float(anglist[0].split()[2])
         rot[3] = float(anglist[1].split()[0])
         rot[4] = float(anglist[1].split()[1])
         rot[5] = float(anglist[1].split()[2])
         rot[6] = float(anglist[2].split()[0])
         rot[7] = float(anglist[2].split()[1])
         rot[8] = float(anglist[2].split()[2])

         ltxtm1 = "%20.5f" %rot[0] + "%15.5f" %rot[1] + "%15.5f" %rot[2] 
         ltxtm2 = "%20.5f" %rot[3] + "%15.5f" %rot[4] + "%15.5f" %rot[5]
         ltxtm3 = "%20.5f" %rot[6] + "%15.5f" %rot[7] + "%15.5f" %rot[8] 

         det1 =rot[4]*rot[8]-rot[7]*rot[5]
         det2 =rot[3]*rot[8]-rot[6]*rot[5]
         det3 =rot[3]*rot[7]-rot[6]*rot[4]
         det =rot[0]*det1-rot[1]*det2+rot[2]*det3

         icode = 1
    
         if abs(det-1.0) > eps1:
           tmes.SetValue(' matrix determinant is far from 1.0 :' + "%12.3g" %det + ', retype your matrix')
           tmes.SetForegroundColour(col1)
           icode=0
           ierr = 1
           return
         elif det != 1.0:
           scal=1./(det**(1./3.))
           for k in range(9):
              rot[k] = rot[k]*scal
           ltcor = 'Matrix is rescaled to have determinant=1,  all elements are multiplied by ' + "%10.5f" %scal
           tmes.WriteText(ltcor+"\n")
           print(ltcor, file = fileout)

# matrix solution

      else:

         for i in range(nsym):
           rs = rsym[i]
           self.CalDet(i,rot,nsym,rs)
           if ierr == 1: return

           ltxtm11 = "%20.5f" %rtemp[0] + "%15.5f" %rtemp[1] + "%15.5f" %rtemp[2]
           if insys == 2 or insys == 3 or insys == 4: ltxtm11 = "%15.5f" %rtemp[0] + "%15.5f" %rtemp[1] + "%15.5f" %rtemp[2]
           ltxtm22 = "%15.5f" %rtemp[3] + "%15.5f" %rtemp[4] + "%15.5f" %rtemp[5]
           ltxtm33 = "%15.5f" %rtemp[6] + "%15.5f" %rtemp[7] + "%15.5f" %rtemp[8]

           ltxtr22 = "%60s" %lecp
           if insys == 2 or insys == 4: ltxtr22 = "%62s" %lecp

           if insys == 0:

            tmes.WriteText(ltxteul+ltxtm11+"\n")
            tmes.WriteText(ltxtr22+ltxtm22+"\n")
            tmes.WriteText(ltxtr22+ltxtm33+"\n")
            print(ltxteul+ltxtm11, file = fileout)
            print("%44s" %lecp + "%20.5f" %rtemp[3] + "%15.5f" %rtemp[4] + "%15.5f" %rtemp[5], file = fileout)
            print("%44s" %lecp + "%20.5f" %rtemp[6] + "%15.5f" %rtemp[7] + "%15.5f" %rtemp[8], file = fileout)

           if insys == 1:

            tmes.WriteText(ltxtpol+ltxtm11+"\n")
            tmes.WriteText(ltxtr22+ltxtm22+"\n")
            tmes.WriteText(ltxtr22+ltxtm33+"\n")
            print(ltxtpol + "%15.5f" %rtemp[0] + "%15.5f" %rtemp[1] + "%15.5f" %rtemp[2], file = fileout)
            print("%44s" %lecp + ltxtm22, file = fileout)
            print("%44s" %lecp + ltxtm33, file = fileout)

           if insys == 2:

            tmes.WriteText(ltxtcos+ltxtm11+"\n")
            tmes.WriteText(ltxtr22+ltxtm22+"\n")
            tmes.WriteText(ltxtr22+ltxtm33+"\n")
            print(ltxtcos+ltxtm11, file = fileout)
            print("%49s" %lecp + ltxtm22, file = fileout)
            print("%49s" %lecp + ltxtm33, file = fileout)

           if insys == 3:

            tmes.WriteText(ltxtm1+ltxtm11+"\n")
            tmes.WriteText(ltxtm2+ltxtm22+"\n")
            tmes.WriteText(ltxtm3+ltxtm33+"\n")
            print(ltxtm1+ltxtm11, file = fileout)
            print(ltxtm2+ltxtm22, file = fileout)
            print(ltxtm3+ltxtm33, file = fileout)

           if insys == 4:

            tmes.WriteText(ltxtquat+ltxtm11+"\n")
            tmes.WriteText(ltxtr22+ltxtm22+"\n")
            tmes.WriteText(ltxtr22+ltxtm33+"\n")
            print(ltxtquat+ltxtm11, file = fileout)
            print("%49s" %lecp + ltxtm22, file = fileout)
            print("%49s" %lecp + ltxtm33, file = fileout)

      return         

#-------------------------------------
# Determinant

    def CalDet(self,i,rot,nsym,rs):
           global icode, ierr, rtemp

           Mulrot(self,rs,rot)

           if nsym > 1: 
            ii = i+1
            ltxts = '    symmetry N ' + "%5i" %ii
            tmes.WriteText(ltxts+"\n")
            print(ltxts, file = fileout)
           
           det1=rtemp[4]*rtemp[8]-rtemp[7]*rtemp[5]
           det2=rtemp[3]*rtemp[8]-rtemp[6]*rtemp[5]
           det3=rtemp[3]*rtemp[7]-rtemp[6]*rtemp[4]
           det=rtemp[0]*det1-rtemp[1]*det2+rtemp[2]*det3

           if abs(det-1.0) > eps1:
             tmes.SetValue(' the matrix determinant is far from 1.0 :' + "%12.3g" %det)
             tmes.SetForegroundColour(col1) 
             icode = 0
             ierr = 1
             return
           elif det != 1.0:
             scal = 1./(det**(1./3.))
             for j in range(9): 
                rtemp[i] = rtemp[i]*scal

#-------------------------------------
# Coordinates transformation (pdb format)

    def Coor_Trans( self, evt):
       global coorwin

       if coorwin : coorwin.Destroy()
       tmes.SetValue("")
       tmes.SetForegroundColour(col2) 

       coorwin = Coor_Win(self)

#-------------------------------------
# calculation of the orthogonalisation/deorthogonalisation matrices (kept by columns)

    def Matort(self,north): 
       global orth, deorth 

       orth = [0 for x in range(9)]
       deorth = [0 for x in range(9)]

# data preparation

       alpr=alp*grrad
       betr=bet*grrad
       gamr=gam*grrad

# deorthogonalization matrix (Angstroms -> fract.coord)

       calr=math.cos(alpr)
       salr=math.sin(alpr)
       cber=math.cos(betr)
       sber=math.sin(betr)
       cgar=math.cos(gamr)
       sgar=math.sin(gamr)

       cha=(calr-cber*cgar)/(sber*sgar)
       if cha > 1.0: cha = 1.0
       if cha < -1.0: cha = -1.0
       sha=math.sqrt(1.-cha*cha)

       chb=(cber-calr*cgar)/(salr*sgar)
       if chb > 1.0: chb = 1.0
       if chb < -1.0: chb = -1.0
       shb=math.sqrt(1.-chb*chb)

       chg=(cgar-calr*cber)/(salr*sber)
       if chg > 1.0: chg = 1.0
       if chg < -1.0: chg = -1.0
       shg=math.sqrt(1.-chg*chg)

# calcualtion of the matrices

       if north == 1:

         deorth[0]=1./acell
         deorth[1]=0.0
         deorth[2]=0.0
         deorth[3]=-deorth[0]*cgar/sgar
         deorth[4]=1./(bcell*sgar)
         deorth[5]=0.0
         deorth[6]=-deorth[0]*salr*chb/(sber*sgar*sha)
         deorth[7]=-deorth[4]*cha/sha
         deorth[8]=1./(ccell*sber*sha)

# orthogonalization matrix (fract.coord -> angstroms)

         orth[0]=acell
         orth[1]=0.0
         orth[2]=0.0
         orth[3]=bcell*cgar
         orth[4]=bcell*sgar
         orth[5]=0.0
         orth[6]=ccell*cber
         orth[7]=ccell*sber*cha
         orth[8]=ccell*sber*sha

       elif north == 2:
 
         deorth[0]=0.0
         deorth[1]=1./bcell
         deorth[2]=0.0
         deorth[3]=0.0
         deorth[4]=-deorth[1]*calr/salr
         deorth[5]=1./(ccell*salr)
         deorth[6]=1./(acell*sgar*shb)
         deorth[7]=-deorth[1]*sber*chg/(salr*sgar*shb)
         deorth[8]=-deorth[5]*chb/shb

# orthogonalization matrix (fract.coord -> angstroms)

         orth[0]=acell*cgar
         orth[1]=acell*sgar*chb
         orth[2]=acell*sgar*shb
         orth[3]=bcell
         orth[4]=0.0
         orth[5]=0.0
         orth[6]=ccell*calr
         orth[7]=ccell*salr
         orth[8]=0.0

       elif north == 3:

         deorth[0]=0.0
         deorth[1]=0.0
         deorth[2]=1./ccell
         deorth[3]=1./(acell*sber)
         deorth[4]=0.0
         deorth[5]=-deorth[2]*cber/sber
         deorth[6]=-deorth[3]*chg/shg
         deorth[7]=1./(bcell*salr*shg)
         deorth[8]=-deorth[2]*sgar*cha/(salr*sber*shg)

# orthogonalization matrix (fract.coord -> angstroms)

         orth[0]=acell*cber
         orth[1]=acell*sber
         orth[2]=0.0
         orth[3]=bcell*calr
         orth[4]=bcell*salr*chg
         orth[5]=bcell*salr*shg
         orth[6]=ccell
         orth[7]=0.0
         orth[8]=0.0

       elif north == 4:

         chi=math.atan2(bcell*sgar,acell+bcell*cgar)
         cchi=math.cos(chi)
         schi=math.sin(chi)
         cdg=math.cos(gamr-chi)
         sdg=math.sin(gamr-chi)
         cdb=math.cos(betr-chi)
         sdb=math.sin(betr-chi)

         deorth[0]=sdg/(acell*sgar)
         deorth[1]=schi/(bcell*sgar)
         deorth[2]=0.0
         deorth[3]=-cdg/(acell*sgar)
         deorth[4]=cchi/(bcell*sgar)
         deorth[5]=0.0
         deorth[6]=-salr*chb/(acell*sber*sgar*sha)
         deorth[7]=-1.*cha/(bcell*sgar*sha)
         deorth[8]=1./(ccell*sber*sha)

# orthogonalization matrix (fract.coord -> angstroms)

         orth[0]=acell*cchi
         orth[1]=-acell*schi
         orth[2]=0.0
         orth[3]=bcell*cdg
         orth[4]=bcell*sdg
         orth[5]=0.0
         orth[6]=ccell*(cdb-sber*schi*(1.-cha))
         orth[7]=ccell*(sdb*cha-cber*schi*(1.-cha))
         orth[8]=ccell*sber*sha

       elif north == 5:

         deorth[6]=0.0
         deorth[7]=0.0
         deorth[8]=1./ccell
         deorth[3]=0.0
         deorth[4]=1./(bcell*salr)
         deorth[5]=-deorth[8]*calr/salr
         deorth[0]=1./(acell*sber*shg)
         deorth[1]=-deorth[4]*chg/shg
         deorth[2]=-deorth[8]*sgar*chb/(salr*sber*shg)

# orthogonalization matrix (fract.coord -> angstroms)

         orth[6]=0.0
         orth[7]=0.0
         orth[8]=ccell
         orth[3]=0.0
         orth[4]=bcell*salr
         orth[5]=bcell*calr
         orth[0]=acell*sber*shg
         orth[1]=acell*sber*chg
         orth[2]=acell*cber

       elif north == 6:

         deorth[0]=1./acell
         deorth[1]=0.0
         deorth[2]=0.0
         deorth[6]=-deorth[0]*cber/sber
         deorth[7]=0.0
         deorth[8]=1./(ccell*sber)        
         deorth[3]=-deorth[0]*salr*chg/(sber*sgar*sha)
         deorth[4]=1./(bcell*sgar*sha)
         deorth[5]=-deorth[8]*cha/sha

# orthogonalization matrix (fract.coord -> angstroms)

         orth[0]=acell
         orth[1]=0.0
         orth[2]=0.0
         orth[3]=bcell*cgar
         orth[4]=bcell*sgar*sha
         orth[5]=bcell*sgar*cha
         orth[6]=ccell*cber
         orth[7]=0.0
         orth[8]=ccell*sber

       else:

         deorth[3]=0.0
         deorth[4]=1./bcell
         deorth[5]=0.0
         deorth[6]=0.0
         deorth[7]=-deorth[4]*calr/salr
         deorth[8]=1./(ccell*salr)
         deorth[0]=1./(acell*sgar*shb)
         deorth[1]=-deorth[4]*sber*chg/(salr*sgar*shb)
         deorth[2]=-deorth[8]*chb/shb

# orthogonalization matrix (fract.coord -> angstroms)

         orth[0]=acell*sgar*shb
         orth[1]=acell*cgar
         orth[2]=acell*sgar*chb
         orth[3]=0.0
         orth[4]=bcell
         orth[5]=0.0
         orth[6]=0.0
         orth[7]=ccell*calr
         orth[8]=ccell*salr

       return

#-------------------------------------
# New window: coordinates transformation

class Coor_Win(wx.Frame):
    def __init__(self, parent) :

       dc = wx.ScreenDC()
       dc.SetFont(font2)
       wf0, hf0 = dc.GetTextExtent("Define the input and output file names (PDB, PDBx/mmCIF formats):")
       wf1, hf1 = dc.GetTextExtent("Define the rotation matrix:")
       wf2, hf2 = dc.GetTextExtent("Define the vector of the translation in angstroms:")
       wf3, hf3 = dc.GetTextExtent("output")

       wcor = int(wf0+40)
       hcor = int(23*hver)
       wctr = int((wcor-wf1)/2)
       wctl = int((wcor-wf2)/2)

       wx.Frame.__init__(self, None, -1, title= 'Coordinates transformation', pos=(wpp2+100, int(50*hpar)), size=(wcor,hcor),
        style = wx.DEFAULT_FRAME_STYLE & ~(wx.RESIZE_BORDER | wx.MAXIMIZE_BOX)) 

       cpanel = self.cpanel = wx.Panel(self, pos=(0, 0), size=(wcor, hcor))
       cpanel.SetBackgroundColour(ccolor)

       titc1 = wx.StaticText(self.cpanel, -1, "Define the rotation matrix:", pos =(wctr, int(0.5*hver)))
       titc1.SetFont(font2) 

       nmatr = lmatr[0]+'\n'+lmatr[1]+'\n'+lmatr[2]

       mlines = self.mlines = wx.TextCtrl(self.cpanel, -1, nmatr, pos=(wctl, int(2*hver)), 
                    size=(wf2,4*hver), style = wx.TE_PROCESS_ENTER | wx.TE_MULTILINE)
       mlines.SetFont(font2) 

       titc2 = wx.StaticText(self.cpanel, -1, "Define the vector of the translation in angstroms:", pos =(wctl, int(6.5*hver)))
       titc2.SetFont(font2) 
       vline = self.vline = wx.TextCtrl(self.cpanel, 444, vect, pos=(wctl, int(8*hver)), 
                    size=(wf2, int(1.5*hver)), style = wx.TE_PROCESS_ENTER)
       vline.SetFont(font2) 
       vline.Bind(wx.EVT_TEXT_ENTER, self.LineVector)

       titc3 = wx.StaticText(self.cpanel, -1, "Define the input and output file names (PDB, PDBx/mmCIF formats):", pos =(int((wcor-wf0)/2), int(10*hver)))
       titc3.SetFont(font2) 
 
       finp = self.finp = wx.TextCtrl(self.cpanel, -1, Filename2, pos=(int((wcor-wf0)/2), int(11.5*hver)), 
                    size=(wcor-wctl-wf3, int(1.5*hver)), style = wx.TE_PROCESS_ENTER)
       finp.SetFont(font2) 
       finp.Bind(wx.EVT_TEXT_ENTER, self.FilenameCinp)

       ibrow = self.ibrow = wx.Button(self.cpanel, 600, "input", (wctr+wf1+70, int(11.5*hver)), (wf3+20, int(1.5*hver)))
       ibrow.SetFont(font2)
       ibrow.SetBackgroundColour(col4) 
       self.Bind(wx.EVT_BUTTON, self.FileCoorBrowse, ibrow)   
 
       fout = self.fout = wx.TextCtrl(self.cpanel, -1, Filename3, pos=(int((wcor-wf0)/2), int(13.5*hver)), 
                    size=(wcor-wctl-wf3, int(1.5*hver)), style = wx.TE_PROCESS_ENTER)
       fout.SetFont(font2)
       fout.Bind(wx.EVT_TEXT_ENTER, self.FilenameCout)

       obrow = self.obrow = wx.Button(self.cpanel, 700, "output", (wctr+wf1+70, int(13.5*hver)), (wf3+20, int(1.5*hver)))
       obrow.SetFont(font2)
       obrow.SetBackgroundColour(col4) 
       self.Bind(wx.EVT_BUTTON, self.FileCoorBrowse, obrow)   

       runw = self.runw = wx.Button(self.cpanel, -1, "run", (int((wcor-wfi29)/2), int(16*hver)), (wfi29+20, int(1.5*hver)))
       runw.SetFont(font2)
       runw.SetBackgroundColour(col4) 
       self.Bind(wx.EVT_BUTTON, self.Run_Coor_Trans, self.runw)   

       closw = self.closw = wx.Button(self.cpanel, -1, "close", (int((wcor-wfi29)/2), int(18*hver)), (wfi29+20, int(1.5*hver)))
       closw.SetFont(font2)
       closw.SetBackgroundColour(col4) 
       self.Bind(wx.EVT_BUTTON, self.OnCloseWindow, closw)   
       self.Bind(wx.EVT_CLOSE, self.OnCloseWindows)
 
       self.Show()

       #-----------------------------------------------------
# Exit

    def OnCloseWindows(self, evt):

        self.Destroy()
        if demowin: demowin.Destroy()
        if demowinr: demowinr.Destroy()
        if helpwin: helpwin.Destroy()
        if coorwin : coorwin.Destroy()

#------------------------------
# Set the translation vector
 
    def LineVector(self, evt):
       global vect, ierr

       ierr = 0

       id = evt.GetId()
       if id == 444: vect = self.vline.GetValue()
       return

#------------------------------
# Enter input .pdb file name 
 
    def FilenameCinp(self, evt):
        global ifile2, Filename2, ierr

        ierr = 0 
        tmes.SetValue("")  
        ifile2 = 1
        Filename2 =  ""
        self.OnBrowseCinp(self)

#------------------------------
# Enter output .pdb file name 
 
    def FilenameCout(self, evt):
        global ifile3, Filename3, ierr
       
        ierr = 0
        tmes.SetValue("") 
        ifile3 = 1
        Filename3 =  ""
        self.OnBrowseCout(self)

#------------------------------
# Browse input or output .pdb file name
 
    def FileCoorBrowse(self, evt):
        global id, ifile2, ifile3, ierr

        tmes.SetValue("") 

        id = evt.GetId()

        ierr = 0
        if id == 600: 
          ifile2 = 0
          self.OnBrowseCinp(self)

        if id == 700: 
          ifile3 = 0
          self.OnBrowseCout(self)

#-----------------------------------------------------
# OnBrowse - create open input PDB, PDBx/mmCIF files dialog

    def OnBrowseCinp(self, evt):
       global ierr, Filename2, dfile2, dname2, file2

       if ifile2 == 0:   
        wildcard = "All files (*.*)|*.*"    

        if dfile2 == "": dDir=os.getcwd()
        else: dDir=dfile2
        dlg = wx.FileDialog(
            self, message="Choose a input file",
            defaultDir=dDir, 
            defaultFile="",
            wildcard=wildcard,
            style=wx.FD_OPEN
            )                
        if dlg.ShowModal() == wx.ID_OK:
            pth = dlg.GetPath()
            dfile2 = dlg.GetDirectory()
            if dname2 == "": dname2 = dfile2
            self.finp.SetValue(dname2)
            self.finp.ChangeValue(pth)
            dlg.Destroy()
            Filename2 = self.finp.GetValue()
            Filename2 = Filename2.strip()
            
       if  ifile2 == 1:
        fn = self.finp.GetValue()
        fn = fn.strip() 
        if os.path.isfile(fn):
          Filename2 = fn 
        else: 
          tmes.SetValue(" No such file or directory : " + fn)
          tmes.SetForegroundColour(col1) 
          ierr = 1
          return

       try:
           file2 = open(Filename2, 'r')
       except IOError:
           tmes.SetValue(" No such file or directory : " + Filename2)
           tmes.SetForegroundColour(col1) 
           ierr = 1
           return

#-----------------------------------------------------
# OnBrowse - create open output .pdb file dialog

    def OnBrowseCout(self, evt):
       global ierr, Filename3, dfile3, dname3, file3

       if ifile3 == 0:  
        wildcard = "All files (*.*)|*.*"    

        if dfile3 == "": dDir=os.getcwd()
        else: dDir=dfile3
        dlg = wx.FileDialog(
            self, message="Save file as ...",
            defaultDir=dDir, 
            defaultFile="",
            wildcard=wildcard,
            style=wx.FD_SAVE
            )  
              
        if dlg.ShowModal() == wx.ID_OK:
            pth = dlg.GetPath()
            dfile3 = dlg.GetDirectory()
            if dname3 == "": dname3 = dfile3
            self.fout.SetValue(dname3)
            self.fout.ChangeValue(pth)
            dlg.Destroy()
            Filename3 = self.fout.GetValue()
            Filename3 = Filename3.strip() 

       if  ifile3 == 1:

        fn = self.fout.GetValue()
        fn = fn.strip() 
        if os.path.isfile(fn):
          Filename3 = fn 
        else: 
          tmes.SetValue(" No such file or directory : " + fn)
          tmes.SetForegroundColour(col1) 
          ierr = 1
          return

       try:
           file3 = open(Filename3, 'r')
       except IOError:
           tmes.SetValue(" No such file or directory : " + Filename3)
           tmes.SetForegroundColour(col1) 
           ierr = 1
           return

#------------------------------
# Coordinates transformation
 
    def Run_Coor_Trans(self, evt):
       global ierr, lmatr, vect, file2, file3, Filename2, Filename3

       tmes.SetValue("")

       ierr = 0
       if3 = 0

# Set the translation matrix

       linen = str(self.mlines.GetValue())

       lm = linen.split()

       try:
        lmatr[0] = lm[0]+3*' '+lm[1]+3*' '+lm[2]
        lmatr[1] = lm[3]+3*' '+lm[4]+3*' '+lm[5]
        lmatr[2] = lm[6]+3*' '+lm[7]+3*' '+lm[8]
       except:
        tmes.SetValue(" Incorrect matrix row")
        tmes.SetForegroundColour(col1)
        ierr = 1
        return 
    
       for i in range(len(lm)):
            try:
              flinen = float(lm[i])
            except ValueError:  
               tmes.SetValue(" Wrong symbol in the matrix element   " + "%s" %lm[i])
               tmes.SetForegroundColour(col1) 
               ierr = 1
               return

       vect = self.vline.GetValue()
       linen = vect.split()

       if len(linen) != 3: 
           tmes.SetValue(" Wrong number of the vector elements")
           tmes.SetForegroundColour(col1) 
           ierr = 1
           return
       else:
         for i in range(len(linen)):
            try:
              flinen = float(linen[i])
            except ValueError:  
              tmes.SetValue(" Wrong symbol in the vector element   " + "%s" %linen[i])
              tmes.SetForegroundColour(col1) 
              ierr = 1
              return

       fn = self.finp.GetValue()
       fn = fn.strip()
       if os.path.isfile(fn): Filename2 = fn 
       else: 
         tmes.SetValue(" No such file or directory : " + fn)
         tmes.SetForegroundColour(col1) 
         ierr = 1
         return       
       if Filename2 == "":
         tmes.SetValue(" Input file is not defined")
         tmes.SetForegroundColour(col1) 
         ierr = 1
         return 
       try:
           file2 = open(Filename2, 'r')
       except IOError:
           tmes.SetValue(" No such file or directory : " + Filename2)
           tmes.SetForegroundColour(col1) 
           ierr = 1
           return 

       fn = self.fout.GetValue()
       Filename3 = fn.strip()
       if Filename3 == "":
         tmes.SetValue(" Output file is not defined")
         tmes.SetForegroundColour(col1) 
         ierr = 1
         return 
       try:
           file3 = open(Filename3, 'w+')
       except IOError:
           tmes.SetValue(" No such file or directory : " + Filename3)
           tmes.SetForegroundColour(col1) 
           ierr = 1
           return
       if Filename2 == Filename3: 
         tmes.SetValue(" Input and utput file names are the same")
         tmes.SetForegroundColour(col1) 
         ierr = 1
         return 
           
       self.Convrpdb(self)       

#-----------------------------------------------------
# .pdb   --->  .pdb

    def Convrpdb(self, evt):

       ir, iwr, ias, icx = 0, 0, 0, 0
       atom, hetatm, atomsite = 'ATOM  ','HETATM', '_atom_site.' 
       nline = ''

       a11 = float(lmatr[0].split()[0])
       a12 = float(lmatr[0].split()[1])
       a13 = float(lmatr[0].split()[2])
       a21 = float(lmatr[1].split()[0])
       a22 = float(lmatr[1].split()[1])
       a23 = float(lmatr[1].split()[2])
       a31 = float(lmatr[2].split()[0])
       a32 = float(lmatr[2].split()[1])
       a33 = float(lmatr[2].split()[2])
       tx = float(vect.split()[0])
       ty = float(vect.split()[1])
       tz = float(vect.split()[2])

       ltxtc1 = ' The transformation applied is :'
       ltxtc2 = +17*(' ') + 'matrix' +20*(' ') + 'translation vector (A)'
       ltxtcm1 = " " + "%9.5f" %a11 + "%9.5f" %a12 + "%9.5f" %a13 +10*(' ') + "%10.5f" %tx
       ltxtcm2 = " " + "%9.5f" %a21 + "%9.5f" %a22 + "%9.5f" %a23 +10*(' ') + "%10.5f" %ty
       ltxtcm3 = " " + "%9.5f" %a31 + "%9.5f" %a32 + "%9.5f" %a33 +10*(' ') + "%10.5f" %tz

       tmes.WriteText(ltxtc1+"\n")
       tmes.WriteText(ltxtc2+"\n")
       tmes.WriteText(ltxtcm1+"\n")
       tmes.WriteText(ltxtcm2+"\n")
       tmes.WriteText(ltxtcm3+"\n")

       print(ltxtc1, file = fileout)
       print(ltxtc2, file = fileout)
       print(ltxtcm1, file = fileout)
       print(ltxtcm2, file = fileout)
       print(ltxtcm3, file = fileout)

       lines = file2.readlines()
       for line in lines:  

        ir = ir+1

        line = line.rstrip('\n')

        if line[0:11] == atomsite:
 
          if line[11:18] == 'Cartn_x': icx = ias
          ias  = ias+1

        if line[0:6] == atom or line[0:6] == hetatm:

          if icx != 0:
           lpdb = line.split() 
           lind = line.find(lpdb[icx])
           l1 = line.find(lpdb[icx+2])
           l2 = line[l1:].find(' ')
           hind = l1+l2+line[l1+l2:].find(lpdb[icx+3])
 
           lin1 = line[0:lind-1]
           lin2 = line[lind-1:hind]
           lin3 = line[hind:]
          else:
            lin1 = line[0:30]
            lin2 = line[30:54]
            lin3 = line[54:80]
       
# Atomic record. Extract coordinates.

          try:

           if icx != 0:
            lcr = int(len(lin2)/3)
            l2 = lin2.split()            
            xi = float(l2[0])
            yi = float(l2[1])
            zi = float(l2[2])
           else:
            xi = float(lin2[0:8])
            yi = float(lin2[8:16])
            zi = float(lin2[16:24])

           xw=a11*xi+a12*yi+a13*zi+tx
           yw=a21*xi+a22*yi+a23*zi+ty
           zw=a31*xi+a32*yi+a33*zi+tz

           iwr=iwr+1

           if icx == 0:
            nline = str(lin1) + "%8.3f" %xw + "%8.3f" %yw + "%8.3f" %zw + str(lin3)+"\n"
           else: 
            if lcr == 8: nline = str(lin1) + "%8.3f" %xw + "%8.3f" %yw + "%8.3f" %zw + " " +str(lin3)+"\n"
            if lcr == 9: nline = str(lin1) + "%9.3f" %xw + "%9.3f" %yw + "%9.3f" %zw + " " +str(lin3)+"\n"
            if lcr == 10: nline = str(lin1) + "%10.3f" %xw + "%10.3f" %yw + "%10.3f" %zw + " " +str(lin3)+"\n"

           file3.write(nline)
          except ValueError:
            tmes.SetValue(' record' + "%10i" %ir + ' has wrong coordinate values')
            tmes.SetForegroundColour(col1) 
            ierr = 1
            return 
 
        else:
         file3.write(line+"\n") 

       ltxtc3 = ' ' + "%10i" %ir + ' records are in the file'
       if icx == 0: ltxtc4 = ' ' + "%10i" %iwr + ' of them correspond to the PDB atomic records'
       else: ltxtc4 = ' ' + "%10i" %iwr + ' of them correspond to the PDBx/mmCIF atomic records'

       tmes.WriteText(ltxtc3+"\n")
       tmes.WriteText(ltxtc4+"\n")
       print(ltxtc3, file = fileout)
       print(ltxtc4, file = fileout)

       file2.close()
       file3.close()

#-----------------------------------------------------
# Close window

    def OnCloseWindow(self, evt):

        if coorwin : coorwin.Destroy()

#-------------------------------------
# Demo input rotation

class Demo_Rot(wx.Frame):
    def __init__(self, parent) :
       global dpanel, angl, cang1, cang2, cang3, cang4, kappa, colt1, colt2, colt3
       global qx, qy, qz, q0, qxt, qyt, qzt, q0t, sk2t, limlt, limpt, cx, cy, cz
       global lxax, lxay, lyax, lyay, lzax, lzay, lxbx, lxby, lybx, lyby, lzbx, lzby
       global lxrx, lxry, lyrx, lyry, lzrx, lzry, lzen, lzen1, lzen2
       global lxcx, lxcy, lycx, lycy, lzcx, lzcy
       global rotb, ierr, xm1, ym1, zm1, xm2, ym2, zm2, rotx, roty, rotz

       rotb = [1., 0., 0., 0., 1., 0., 0., 0., 1.]
       qxt = qyt = qzt = 0.
       q0t = sk2t = 0.
       limlt = limpt = 0

       OnPaintInit(self)

       lzen, lzen1, lzen2 = [], [], []

       xm1 = [0 for x in range(3)]
       ym1 = [0 for x in range(3)]
       zm1 = [0 for x in range(3)]

       xm2 = [0 for x in range(3)]
       ym2 = [0 for x in range(3)]
       zm2 = [0 for x in range(3)]

       lxbx = int(cx0-lb*pro[0])
       lxby = int(cy0-lb*pro[6])
       lybx = int(cx0-lb*pro[1])
       lyby = int(cy0-lb*pro[7])
       lzbx = int(cx0-lb*pro[2])
       lzby = int(cy0-lb*pro[8])

       lxax = int(cx0-la*pro[0])
       lxay = int(cy0-la*pro[6])
       lyax = int(cx0-la*pro[1])
       lyay = int(cy0-la*pro[7])
       lzax = int(cx0-la*pro[2])
       lzay = int(cy0-la*pro[8])

       lxcx = int(cx0-ld*pro[0])
       lxcy = int(cy0-ld*pro[6])
       lycx = int(cx0-ld*pro[1])
       lycy = int(cy0-ld*pro[7])
       lzcx = int(cx0-ld*pro[2])
       lzcy = int(cy0-ld*pro[8])

       lxrx = int(cx0-lr*pro[0])
       lxry = int(cy0-lr*pro[6])
       lyrx = int(cx0-lr*pro[1])
       lyry = int(cy0-lr*pro[7])
       lzrx = int(cx0-lr*pro[2])
       lzry = int(cy0-lr*pro[8])

       iwp = int(wsl+40)
       ihp = int(hd-hh-80)

       if insys == 0:  
         wx.Frame.__init__(self, None, -1, title= 'DEMO INPUT: Euler rotation', pos=(iwp, ihp), size=(wh, hh)) 
       if insys == 1: 
         wx.Frame.__init__(self, None, -1, title= 'DEMO INPUT: polar rotation', pos=(iwp, ihp), size=(wh, hh)) 
       if insys == 2: 
         wx.Frame.__init__(self, None, -1, title= 'DEMO INPUT: cos rotation', pos=(iwp, ihp), size=(wh+20, hh)) 
       if insys == 4: 
         wx.Frame.__init__(self, None, -1, title= 'DEMO INPUT: quaternions rotation', pos=(iwp, ihp), size=(wh, hh)) 

       dpanel = self.dpanel = wx.Panel(self, pos=(0, 0), size=(wh, hh))
       dpanel.SetBackgroundColour(col8)
       dpanel.SetFont(font5)

       if insys == 0: 

         rax1 = lax12[incon][0]
         rax2 = lax12[incon][1]
         rax3 = lax12[incon][2]

         if str(rax1) == 'x': colt1 = col5
         if str(rax1) == 'y': colt1 = col6
         if str(rax1) == 'z': colt1 = col7
         if str(rax2) == 'x': colt2 = col5
         if str(rax2) == 'y': colt2 = col6 
         if str(rax2) == 'z': colt2 = col7
         if str(rax3) == 'x': colt3 = col5
         if str(rax3) == 'y': colt3 = col6
         if str(rax3) == 'z': colt3 = col7
         
         tit1 = wx.StaticText(self.dpanel, -1, typerot[inrot].strip()+", "+typeaxes[inaxes], pos =(int(cx0/2), int(0.1*hver)))
         tit1.SetFont(font2) 
         tit2 = wx.StaticText(self.dpanel, -1, "consecutive rotation axes: "+lax12[incon], pos =(int(cx0/2), int(1.3*hver)))
         tit2.SetFont(font2) 
         tit3 = wx.StaticText(self.dpanel, -1, "rotation direction: "+lrot8[indir], pos =(int(cx0/2), int(2.5*hver)))
         tit3.SetFont(font2) 
         tit4 = wx.StaticText(self.dpanel, -1, teuler5, pos =(int(0.7*wh), int(7*hver)))
         tit4.SetFont(font2)

       angl = inputang.GetValue()

       langl = angl.split()

       if insys < 2 and len(langl) > 0 and len(langl) < 3:
         tmes.SetValue(" Wrong number of the rotation angles")
         tmes.SetForegroundColour(col1) 
         ierr = 1
         return
       if insys == 2 and len(langl) < 4:
          tmes.SetValue(" Wrong number of the rotation parameters")
          tmes.SetForegroundColour(col1) 
          ierr = 1
          return
       if insys == 4 and len(langl) < 4:
          tmes.SetValue(" Wrong number of the quaternions")
          tmes.SetForegroundColour(col1) 
          ierr = 1
          return
       if len(langl) != 0 :
         for i in range(len(langl)):
            try:
              flan = float(langl[i])
            except ValueError:       
              tmes.SetValue(" Wrong symbol in the rotation angles")
              tmes.SetForegroundColour(col1) 
              ierr = 1
              return

       if angl != "":

        if insys < 2:

         cang1 = float(angl.split()[0])
         if insys == 0 and cang1 > 360: cang1 = math.fmod(cang1, 360)
         if insys == 1 and cang1 > 180: cang1 = math.fmod(cang1, 180)
         cang2 = float(angl.split()[1])
         if cang2 > 360: cang2 = math.fmod(cang2, 360)
         cang3 = float(angl.split()[2])
         if cang3 > 360: cang3 = math.fmod(cang3, 360)

        if insys == 2:
         cang1 = float(angl.split()[0])
         cang2 = float(angl.split()[1])
         cang3 = float(angl.split()[2])
         kappa = float(angl.split()[3])

         det = math.sqrt(cang1*cang1+cang2*cang2+cang3*cang3)

         if det == 0.:
          tmes.SetValue(" A problem in the direction cosines, the sum of their squares is equal to 0. ")
          tmes.SetForegroundColour(col1) 
          ierr = 1
          return

         if det != 1.0:
           scal =1./det
           cang1 =cang1*scal
           cang2 =cang2*scal
           cang3 =cang3*scal
           if abs(abs(det)-1.0) > 1.*eps1:
             ex = "%9.3f" %cang1 + "%9.3f" %cang2 + "%9.3f" %cang3 + "%9.3f" %kappa
             tt1 = 'A problem in the direction cosines, the sum of their squares is not equal to 1.0 :' + "%10.3f" %det
             tt2 = '.   Direction cosines are rescaled to ' + ex + "\n"   
             ltcor = tt1+tt2
             tmes.WriteText(ltcor+"\n")
             inputang.SetValue(ex)

         if kappa > 360: kappa = math.fmod(kappa, 360)

        if insys == 4:

         cang1 = float(angl.split()[0])
         cang2 = float(angl.split()[1])
         cang3 = float(angl.split()[2])
         cang4 = float(angl.split()[3])

         det = math.sqrt(cang1*cang1+cang2*cang2+cang3*cang3+cang4*cang4)

         if det == 0.:
          tmes.SetValue(" A problem in the direction quaternions, the sum of their squares is equal to 0. ")
          tmes.SetForegroundColour(col1) 
          ierr = 1
          return

         if det != 1.0:
           scal =1./det
           cang1 =cang1*scal
           cang2 =cang2*scal
           cang3 =cang3*scal
           cang4 =cang4*scal
           if abs(abs(det)-1.0) > 1.*eps1:
             ex = "%9.3f" %cang1 + "%9.3f" %cang2 + "%9.3f" %cang3 + "%9.3f" %cang4
             tt1 = 'A problem in the direction quaternions, the sum of their squares is not equal to 1.0 :' + "%10.3f" %det
             tt2 = '.   Direction quaternions are rescaled to ' + ex + "\n"   
             ltcor = tt1+tt2
             tmes.WriteText(ltcor+"\n")
             inputang.SetValue(ex)

       if insys == 0:

         tel1= wx.StaticText(self.dpanel, -1, "around axis 1 = ", pos =(int(0.75*wh), int(9*hver)))
         tel1.SetFont(font2)
         tel1.SetForegroundColour(colt1)
         tel2= wx.StaticText(self.dpanel, -1, "around axis 2 = ", pos =(int(0.75*wh), int(11*hver)))
         tel2.SetFont(font2)
         tel2.SetForegroundColour(colt2)
         tel3= wx.StaticText(self.dpanel, -1, "around axis 3 = ", pos =(int(0.75*wh), int(13*hver)))
         tel3.SetFont(font2)
         tel3.SetForegroundColour(colt3)

       pgr = 360
       sls = 250

       if insys == 1: 

          raxp1 = laxp6[inpol][0]
          raxp2 = laxp6[inpol][1]

          if str(raxp1) == 'x' and str(raxp2) == 'y': 
            colt1 = col3
            colt2 = col5
            colt3 = col7
          if str(raxp1) == 'x' and str(raxp2) == 'z': 
            colt1 = col3
            colt2 = col7
            colt3 = col5

          if str(raxp1) == 'y' and str(raxp2) == 'x': 
            colt1 = col5
            colt2 = col3
            colt3 = col7
          if str(raxp1) == 'y' and str(raxp2) == 'z': 
            colt1 = col7
            colt2 = col3
            colt3 = col5

          if str(raxp1) == 'z' and str(raxp2) == 'x': 
            colt1 = col5
            colt2 = col7
            colt3 = col3
          if str(raxp1) == 'z' and str(raxp2) == 'y': 
            colt1 = col7
            colt2 = col5
            colt3 = col3
 
          pgr = 180
          sls = 125
   
          tit1 = wx.StaticText(self.dpanel, -1, typerot[inrot].strip(), pos =(int(cx0/2), int(0.1*hver)))
          tit1.SetFont(font2)
          tit2 = wx.StaticText(self.dpanel, -1, tpolar1+"  "+laxp6[inpol], pos =(int(cx0/2), int(1.3*hver)))
          tit2.SetFont(font2) 
          tit3 = wx.StaticText(self.dpanel, -1, "rotation direction: "+lrotp4[indirp], pos =(int(cx0/2), int(2.5*hver)))
          tit3.SetFont(font2) 
          tit4 = wx.StaticText(self.dpanel, -1, tpolar4, pos =(int(0.7*wh), int(7*hver)))
          tit4.SetFont(font2)

          tel1= wx.StaticText(self.dpanel, -1, "zenith = ", pos =(int(0.75*wh), int(9*hver)))
          tel1.SetFont(font2)
          tel1.SetForegroundColour(col3)
          tel2= wx.StaticText(self.dpanel, -1, "azimuth = ", pos =(int(0.75*wh), int(11*hver)))
          tel2.SetFont(font2)
          tel2.SetForegroundColour(col5)
          tel3= wx.StaticText(self.dpanel, -1, "rotation = ", pos =(int(0.75*wh), int(13*hver)))
          tel3.SetFont(font2)
          tel3.SetForegroundColour(col1)

       if insys == 2:

         tit1 = wx.StaticText(self.dpanel, -1, typerot[inrot].strip(), pos =(int(cx0/2), int(0.1*hver)))
         tit1.SetFont(font2)
         tit2 = wx.StaticText(self.dpanel, -1, "rotation direction: "+lrotc2[indirc], pos =(int(cx0/2), int(1.3*hver)))
         tit2.SetFont(font2) 

         tel= wx.StaticText(self.dpanel, -1, "cos(ax)     ax ", pos =(int(cirxc+rcminc+15), int(6.5*hver)))
         tel.SetFont(font2)
         tel.SetForegroundColour(col2)

         tel1= wx.StaticText(self.dpanel, -1, "cosine values to x ", pos =(int(cirx-3*rcmin), int(ciryc-hver)))
         tel1.SetFont(font2)
         tel1.SetForegroundColour(col5)
         tel2= wx.StaticText(self.dpanel, -1, "cosine values to y ", pos =(int(cirx-3*rcmin), int(ciryc+2.5*hver)))
         tel2.SetFont(font2)
         tel2.SetForegroundColour(col6)
         tel3= wx.StaticText(self.dpanel, -1, "cosine values to z ", pos =(int(cirx-3*rcmin), int(ciryc+6*hver)))
         tel3.SetFont(font2)
         tel3.SetForegroundColour(col7)
         tel4= wx.StaticText(self.dpanel, -1, "rotation angle ", pos =(int(cirx-3*rcmin), int(ciryc+9.5*hver)))
         tel4.SetFont(font2)
         tel4.SetForegroundColour(col1)

       if insys == 4:

         tit1 = wx.StaticText(self.dpanel, -1, typerot[inrot].strip(), pos =(int(cx0/2), int(0.1*hver)))
         tit1.SetFont(font2)
         tit2 = wx.StaticText(self.dpanel, -1, "rotation direction: "+lrotc2[indirc], pos =(int(cx0/2), int(1.3*hver)))
         tit2.SetFont(font2) 

         tel1= wx.StaticText(self.dpanel, -1, "qx ", pos =(int(cirx-3*rcmin), int(ciryc-hver)))
         tel1.SetFont(font2)
         tel1.SetForegroundColour(col5)
         tel2= wx.StaticText(self.dpanel, -1, "qy ", pos =(int(cirx-3*rcmin), int(ciryc+2.5*hver)))
         tel2.SetFont(font2)
         tel2.SetForegroundColour(col6)
         tel3= wx.StaticText(self.dpanel, -1, "qz ", pos =(int(cirx-3*rcmin), int(ciryc+6*hver)))
         tel3.SetFont(font2)
         tel3.SetForegroundColour(col7)
         tel4= wx.StaticText(self.dpanel, -1, "q0 ", pos =(int(cirx-3*rcmin), int(ciryc+9.5*hver)))
         tel4.SetFont(font2)
         tel4.SetForegroundColour(col1)

       if insys < 2: wx.StaticLine(dpanel, -1, pos =(int(cirx-3*rcmin), int(ciry-1)), size = (int(6*rcmin),2), style =wx.LI_HORIZONTAL)
       if insys == 2: wx.StaticLine(dpanel, -1, pos =(int(cirxc-rcminc), int(ciryc+10.5*hver-1)), size = (int(2*rcminc),2), style =wx.LI_HORIZONTAL)

       titm = wx.StaticText(self.dpanel, -1, tmatrix, pos =(int(0.7*wh), int(0.1*hver)))
       titm.SetFont(font2)

       if insys == 0 :

        btnop = self.btnop = wx.Button(dpanel, 1, "opaque", (int(0.05*wh),int(0.82*hh)), (int(wh3+5), int(2*hver)))
        btnop.SetFont(font5)
        btnop.SetBackgroundColour(col4) 
        btnop.Bind(wx.EVT_BUTTON, self.ChangeTrans, self.btnop)  
 
        btntr = self.btntr = wx.Button(dpanel, 2, "transparent", (int(0.3*wh), int(0.82*hh)), (int(wh3+15), int(2*hver)))
        btntr.SetFont(font5)
        btntr.SetBackgroundColour(col4) 
        btntr.Bind(wx.EVT_BUTTON, self.ChangeTrans, self.btntr)   

       closd = self.closd = wx.Button(dpanel, -1, "close", (int(0.85*wh), int(0.82*hh)), (int(wh2+15), int(2*hver)))
       closd.SetFont(font5)
       closd.SetBackgroundColour(col4) 
       closd.Bind(wx.EVT_BUTTON, self.OnCloseDemo)
       self.Bind(wx.EVT_CLOSE, self.OnCloseDemo) 

       dpanel.Bind(wx.EVT_PAINT, self.DcDemo)
 
       self.Show()

#-------------------------------------
# Put DC on the window input)

    def DcDemo(self, evt): 

       pdc = wx.PaintDC(self.dpanel)
       pdc.Clear()
       try:
            dcd = wx.GCDC(pdc)
       except:
            dcd = pdc

       self.OnPaintDemo(dcd)

#-----------------------------------------------------

    def OnPaintDemo(self, dcd): 
      global rots, lxbx, lxby, lybx, lyby, lzbx, lzby, lxrx, lxry, lyrx, lyry, lzrx, lzry
      global prot3, prot4, prot5, lxpol, lypol, lxpol1, lypol1, lzen, lzen1, lzen2
      global lxcos, lycos, lxcos1, lycos1
      global cang1, cang2, cang3, kappa, lxax, lxay, lyax, lyay, lzax, lzay
      global sk2, cx, cy, cz
      global tsk2, tliml, tlimp, tqx, tqy, tqz, tq0
      global lnl, lnc, liml, limp, limlt, limpt, cx1, cy1, cx2, cy2, cx3, cy3, cx4, cy4, cscx1, cscx2
      global xm, ym, zm, xxm, yym, zzm, ln1, ln2, ln3
      
      if insys <= 2: Mrot(self,cang1,cang2,cang3) 
      if insys == 4: 
       MQrot(self,cang1,cang2,cang3,cang4)
       if ld7 == True or q0t == -1. or q0t == 1.: MQrot(self,qxt,qyt,qzt,q0t)

       sk2 = math.sqrt(1.-cang4*cang4)

       if sk2 != 0:
         cx = cang1/sk2
         cy = cang2/sk2
         cz = cang3/sk2
       else:         
         cx = cy = cz = 0
         cang1 = cang2 = cang3 = 0

       lnl = int(cirxc+rcminc-cirx+rcmin)
       lnc = int(0.5*(cirx+cirxc+rcminc-rcmin))

       liml = int(lnc-0.5*sk2*lnl)
       limp = int(lnc+0.5*sk2*lnl)

       tsk2 = sk2
       tliml = liml
       tlimp = limp
       tqx = cang1
       tqy = cang2 
       tqz = cang3
       tq0 = cang4 
       cx1,cy1 = int(lnc+0.5*lnl*cang1), int(ciryc)
       cx2,cy2 = int(lnc+0.5*lnl*cang2), int(ciryc+3.5*hver)
       cx3,cy3 = int(lnc+0.5*lnl*cang3), int(ciryc+7*hver)
       cx4,cy4 = int(lnc+0.5*lnl*cang4), int(ciryc+10.5*hver)

       if ld7 == True or q0t == -1. or q0t == 1.:

         tsk2 = sk2t
         tliml = limlt
         tlimp = limpt 
         tqx = qxt
         tqy = qyt
         tqz = qzt
         tq0 = q0t
         cx1,cy1 = int(lnc+0.5*lnl*qxt), int(ciryc)
         cx2,cy2 = int(lnc+0.5*lnl*qyt), int(ciryc+3.5*hver)
         cx3,cy3 = int(lnc+0.5*lnl*qzt), int(ciryc+7*hver)
         cx4,cy4 = int(lnc+0.5*lnl*q0t), int(ciryc+10.5*hver)

      if inrot == 1:
       xm = (rotb[0], rotb[1], rotb[2])
       ym = (rotb[3], rotb[4], rotb[5])
       zm = (rotb[6], rotb[7], rotb[8]) 

       xxm = ([rot[0], rot[3], rot[6]])
       yym = ([rot[1], rot[4], rot[7]])
       zzm = ([rot[2], rot[5], rot[8]])  

       ln1 = str("%12.4f" %rot[0]+"%12.4f" %rot[3]+"%12.4f" %rot[6])
       ln2 = str("%12.4f" %rot[1]+"%12.4f" %rot[4]+"%12.4f" %rot[7])
       ln3 = str("%12.4f" %rot[2]+"%12.4f" %rot[5]+"%12.4f" %rot[8])

      if inrot == 0:
       xm = (rot[0], rot[1], rot[2])
       ym = (rot[3], rot[4], rot[5])
       zm = (rot[6], rot[7], rot[8]) 

       ln1 = str("%12.4f" %rot[0]+"%12.4f" %rot[1]+"%12.4f" %rot[2])
       ln2 = str("%12.4f" %rot[3]+"%12.4f" %rot[4]+"%12.4f" %rot[5])
       ln3 = str("%12.4f" %rot[6]+"%12.4f" %rot[7]+"%12.4f" %rot[8])

       xxm = ([rotb[0], rotb[3], rotb[6]])
       yym = ([rotb[1], rotb[4], rotb[7]])
       zzm = ([rotb[2], rotb[5], rotb[8]])   

      if inrot == 0 or imove == 1:
      
         for i in range(3):     
           xm1[i]=xm[i]*pro[0]+ym[i]*pro[1]+zm[i]*pro[2]
           ym1[i]=xm[i]*pro[3]+ym[i]*pro[4]+zm[i]*pro[5]
           zm1[i]=xm[i]*pro[6]+ym[i]*pro[7]+zm[i]*pro[8]

         lxrx = int(cx0-scx*lr*xm1[0])
         lxry = int(cy0-scx*lr*zm1[0])
         lyrx = int(cx0-scx*lr*xm1[1])
         lyry = int(cy0-scx*lr*zm1[1])
         lzrx = int(cx0-scx*lr*xm1[2])
         lzry = int(cy0-scx*lr*zm1[2])

         lxax = int(cx0-la*xm1[0])
         lxay = int(cy0-la*zm1[0])
         lyax = int(cx0-la*xm1[1])
         lyay = int(cy0-la*zm1[1])
         lzax = int(cx0-la*xm1[2])
         lzay = int(cy0-la*zm1[2])

         if insys == 0:

          if inrot == 1: Mulrot(self,pro,rotb)
          if inrot == 0: Mulrot(self,pro,rot)
          prot3 = rtemp[3]
          prot4 = rtemp[4]
          prot5 = rtemp[5]

      if inrot == 1 or imove == 1:  

         rots = rot
        
         for i in range(3):
          xm2[i]=xxm[i]*pro[0]+yym[i]*pro[1]+zzm[i]*pro[2]
          ym2[i]=xxm[i]*pro[3]+yym[i]*pro[4]+zzm[i]*pro[5]
          zm2[i]=xxm[i]*pro[6]+yym[i]*pro[7]+zzm[i]*pro[8]

         lxbx = int(cx0-lb*xm2[0])
         lxby = int(cy0-lb*zm2[0])
         lybx = int(cx0-lb*xm2[1])
         lyby = int(cy0-lb*zm2[1])
         lzbx = int(cx0-lb*xm2[2])
         lzby = int(cy0-lb*zm2[2])

      if insys == 1:

         OnPaintInPol(self,inpol,cang1,cang2,cang3)
         lxpol = lxp
         lypol = lyp
         lxpol1 = lxp1
         lypol1 = lyp1
         lzen = lzn
         lzen1 = lzn1

         dcd.SetPen(wx.Pen(col7, 1))
         dcd.DrawCircle(cx0,cy0,lb)
         dcd.DrawEllipse(cx0-lb,lyey,lb*2,(cy0-lyey)*2)

         dcd.SetPen(wx.Pen(col3, 1))
         dcd.DrawLines(((lxpol,lypol),(cx0,cy0)))
       
         dcd.SetPen(wx.Pen(col5, 1))
         dcd.DrawLines(((lxpol1,lypol1),(cx0,cy0)))

         dcd.SetPen(wx.Pen(colt1, 2))
         dcd.DrawLines(((lxbx,lxby),(cx0,cy0)))
         dcd.SetPen(wx.Pen(colt2, 2))
         dcd.DrawLines(((lybx,lyby),(cx0,cy0)))
         dcd.SetPen(wx.Pen(colt3, 2))
         dcd.DrawLines(((lzbx,lzby),(cx0,cy0)))

      if insys < 2:

       cr1 = math.radians(cang1)
       cr2 = math.radians(cang2)
       cr3 = math.radians(cang3)

       cx1, cy1 = int(cirx+rcmin*math.cos(cr1)), int(ciry-rcmin*math.sin(cr1))
       cx2, cy2 = int(cirx+2*rcmin*math.cos(cr2)), int(ciry-2*rcmin*math.sin(cr2))
       cx3, cy3 = int(cirx+3*rcmin*math.cos(cr3)), int(ciry-3*rcmin*math.sin(cr3))
 
       cang1 = int(round(cang1))
       cang2 = int(round(cang2))
       cang3 = int(round(cang3))

      if insys == 2:

       cr1 = math.acos(float(cang1))
       cr2 = math.acos(float(cang2))
       cr3 = math.acos(float(cang3))  
       cr4 = math.radians(float(kappa))
  
       cx1,cy1 = int(cirxc+rcminc*cang1), int(ciryc-rcminc*math.sin(cr1))
       cx2,cy2 = int(cirxc+rcminc*cang2), int(ciryc+3.5*hver-rcminc*math.sin(cr2))
       cx3,cy3 = int(cirxc+rcminc*cang3), int(ciryc+7*hver-rcminc*math.sin(cr3))
       cx4,cy4 = int(cirxc+rcminc*math.cos(cr4)), int(ciryc+10.5*hver-rcminc*math.sin(cr4))

       cr1 = math.degrees(cr1)
       cr2 = math.degrees(cr2)
       cr3 = math.degrees(cr3)
       cr4 = math.degrees(cr4)
       cr1 = int(round(cr1))
       cr2 = int(round(cr2))
       cr3 = int(round(cr3))
       cr4 = int(round(cr4))

      if insys == 0:

         dcd.SetPen(wx.Pen(colt3, 1))
         dcd.DrawCircle(cirx,ciry,3*rcmin)
         dcd.SetPen(wx.TRANSPARENT_PEN)
         dcd.SetBrush(wx.Brush(colt3))
         dcd.DrawCircle(cx3,cy3,5)

         dcd.SetBrush(wx.Brush(col8))
         dcd.SetPen(wx.Pen(colt2, 1))
         dcd.DrawCircle(cirx,ciry,2*rcmin)
         dcd.SetPen(wx.TRANSPARENT_PEN)
         dcd.SetBrush(wx.Brush(colt2))
         dcd.DrawCircle(cx2,cy2,5)

         dcd.SetBrush(wx.Brush(col8))
         dcd.SetPen(wx.Pen(colt1, 1))
         dcd.DrawCircle(cirx,ciry,rcmin) 
         dcd.SetPen(wx.TRANSPARENT_PEN)
         dcd.SetBrush(wx.Brush(colt1))
         dcd.DrawCircle(cx1,cy1,5)

         dcd.SetFont(font2)
         dcd.SetTextForeground(colt1) 
         dcd.DrawText(str(cang1), int(wwe+0.75*wh), int(9*hver))
         dcd.SetTextForeground(colt2) 
         dcd.DrawText(str(cang2), int(wwe+0.75*wh), int(11*hver))
         dcd.SetTextForeground(colt3) 
         dcd.DrawText(str(cang3), int(wwe+0.75*wh), int(13*hver))

         dcd.SetPen(wx.Pen(col10, 3))
         dcd.DrawLine(cscx1, int(hh-7*hver), cscx2, int(hh-7*hver))

         dcd.SetPen(wx.TRANSPARENT_PEN)
         dcd.SetBrush(wx.Brush(col10))
         dcd.DrawCircle(cscx2, int(hh-7*hver), 5)

         dcd.SetFont(font2)
         dcd.SetTextForeground(col10) 
         dcd.DrawText('scale', cscx2+20, int(hh-7.5*hver))

         dcd.SetPen(wx.Pen(col5, 2))
         dcd.DrawLines(((lxbx,lxby),(cx0,cy0)))
         dcd.SetPen(wx.Pen(col6, 2))
         dcd.DrawLines(((lybx,lyby),(cx0,cy0)))
         dcd.SetPen(wx.Pen(col7, 2))
         dcd.DrawLines(((lzbx,lzby),(cx0,cy0)))

         dcd.SetPen(wx.Pen(col1, 2))
         dcd.DrawLines(((lxax,lxay),(cx0,cy0)))
         dcd.SetPen(wx.Pen(col1, 2))
         dcd.DrawLines(((lyax,lyay),(cx0,cy0)))
         dcd.SetPen(wx.Pen(col1, 2))
         dcd.DrawLines(((lzax,lzay),(cx0,cy0)))

         dcd.SetFont(font2)
         dcd.SetTextForeground(col5) 
         dcd.DrawText('X',lxbx-15,lxby)
         dcd.SetTextForeground(col6) 
         dcd.DrawText('Y',lybx+8,lyby)
         dcd.SetTextForeground(col7) 
         dcd.DrawText('Z',lzbx-15,lzby-15)

         dcd.SetTextForeground(col1) 
         dcd.SetFont(font2)
         dcd.DrawText('x',lxax-12,lxay-17)
         dcd.DrawText('y',lyax+8,lyay-17)
         dcd.DrawText('z',lzax-12,lzay-10)

         xh1 = int(lxrx+lzrx-cx0)
         yh1 = int(lxry+lzry-cy0)
         xh2 = int(lyrx+lzrx-cx0)
         yh2 = int(lyry+lzry-cy0)
         xh3 = int(lxrx+lyrx-cx0)
         yh3 = int(lxry+lyry-cy0)
         xh4 = int(xh1+xh3-lxrx)
         yh4 = int(yh1+yh3-lxry)

         dcd.SetPen(wx.Pen(col1, 2))

         if prot3 >0 and prot4 >0: dcd.DrawLine(lzax,lzay,cx0,cy0)
         if prot3 >0 and prot5 >0: dcd.DrawLine(lyax,lyay,cx0,cy0)
         if prot4 >0 and prot5 >0: dcd.DrawLine(lxax,lxay,cx0,cy0)

         if itrans == 0: trcol = wx.ALPHA_OPAQUE
         if itrans == 1: trcol = 128     

         dcd.SetPen(wx.Pen(col2, 1))

         if prot3 >0:
           dcd.SetBrush(wx.Brush(wx.Colour(205, 129, 98, trcol)))  
           dcd.DrawPolygon([(xh1,yh1),(xh4,yh4),(xh3,yh3),(lxrx,lxry)])
         else:
           dcd.SetBrush(wx.Brush(wx.Colour(122, 103, 238, trcol)))  
           dcd.DrawPolygon([(lyrx,lyry),(xh2,yh2),(lzrx,lzry),(cx0,cy0)])

         if prot4 >0:
           dcd.SetBrush(wx.Brush(wx.Colour(127, 255, 0, trcol)))   
           dcd.DrawPolygon([(xh4,yh4),(xh3,yh3),(lyrx,lyry),(xh2,yh2)])
         else:
           dcd.SetBrush(wx.Brush(wx.Colour(255, 215, 0, trcol)))
           dcd.DrawPolygon([(lzrx,lzry),(cx0,cy0),(lxrx,lxry),(xh1,yh1)])

         if prot5 >0:
           dcd.SetBrush(wx.Brush(wx.Colour(0, 0, 255, trcol)))  
           dcd.DrawPolygon([(lzrx,lzry),(xh1,yh1),(xh4,yh4),(xh2,yh2)])
         else:
           dcd.SetBrush(wx.Brush(wx.Colour(0, 197, 205, trcol)))
           dcd.DrawPolygon([(cx0,cy0),(lxrx,lxry),(xh3,yh3),(lyrx,lyry)])

         dcd.SetPen(wx.Pen(col1, 2))

         if prot3 <=0 or prot4 <=0: dcd.DrawLine(lzax,lzay,cx0,cy0)
         if prot3 <=0 or prot5 <=0: dcd.DrawLine(lyax,lyay,cx0,cy0)
         if prot4 <=0 or prot5 <=0: dcd.DrawLine(lxax,lxay,cx0,cy0)

      if insys == 1:

         dcd.SetFont(font2)
         dcd.SetTextForeground(col3) 
         dcd.DrawText(str(cang1), int(wwp+0.75*wh), int(9*hver))
         dcd.SetTextForeground(col5) 
         dcd.DrawText(str(cang2), int(wwp+0.75*wh), int(11*hver))
         dcd.SetTextForeground(col1) 
         dcd.DrawText(str(cang3), int(wwp+0.75*wh), int(13*hver))

         dcd.SetPen(wx.Pen(col1, 1))
         dcd.DrawCircle(cirx,ciry,3*rcmin)
         dcd.SetPen(wx.TRANSPARENT_PEN)
         dcd.SetBrush(wx.Brush(col1))
         dcd.DrawCircle(cx3,cy3,5)

         dcd.SetBrush(wx.Brush(col8))
         dcd.SetPen(wx.Pen(col5, 1))
         dcd.DrawCircle(cirx,ciry,2*rcmin)
         dcd.SetPen(wx.TRANSPARENT_PEN)
         dcd.SetBrush(wx.Brush(col5))
         dcd.DrawCircle(cx2,cy2,5)

         dcd.SetBrush(wx.Brush(col8))
         dcd.SetPen(wx.Pen(col3, 1))
         dcd.DrawArc(cirx+rcmin,ciry,cirx-rcmin,ciry,cirx,ciry) 
         dcd.SetPen(wx.TRANSPARENT_PEN)
         dcd.SetBrush(wx.Brush(col3))
         dcd.DrawCircle(cx1,cy1,5)

         dcd.SetPen(wx.TRANSPARENT_PEN)

         dcd.SetBrush(wx.Brush(wx.Colour(148, 0, 211, 128)))   # 128 == half transparent
         dcd.DrawPolygon(lzen)

         dcd.SetBrush(wx.Brush(wx.Colour(0, 255, 0, 128)))   # 128 == half transparent
         dcd.DrawPolygon(lzen1)

         dcd.SetPen(wx.Pen(col1, 2))
         dcd.DrawLine(lxrx,lxry,cx0,cy0)
         dcd.DrawLine(lyrx,lyry,cx0,cy0)
         dcd.DrawLine(lzrx,lzry,cx0,cy0)

         len1= len(lzen)
         dcd.SetPen(wx.Pen(col3, 4))
         dcd.DrawLine(lzen[len1-1][0],lzen[len1-1][1],cx0,cy0)

         dcd.SetFont(font2)
         dcd.SetTextForeground(colt1) 
         dcd.DrawText('X',lxbx-15,lxby)
         dcd.SetTextForeground(colt2) 
         dcd.DrawText('Y',lybx+8,lyby)
         dcd.SetTextForeground(colt3) 
         dcd.DrawText('Z',lzbx-15,lzby-15)

         dcd.SetTextForeground(col1) 
         dcd.SetFont(font2)
         dcd.DrawText('x',lxrx-12,lxry-17)
         dcd.DrawText('y',lyrx+8,lyry-17)
         dcd.DrawText('z',lzrx-12,lzry-10)

      if insys == 2:

         dcd.SetPen(wx.Pen(col5, 2))
         dcd.DrawLines(((lxbx,lxby),(cx0,cy0)))
         dcd.SetPen(wx.Pen(col6, 2))
         dcd.DrawLines(((lybx,lyby),(cx0,cy0)))
         dcd.SetPen(wx.Pen(col7, 2))
         dcd.DrawLines(((lzbx,lzby),(cx0,cy0)))

         dcd.SetPen(wx.Pen(col1, 2))
         dcd.DrawLines(((lxax,lxay),(cx0,cy0)))
         dcd.SetPen(wx.Pen(col1, 2))
         dcd.DrawLines(((lyax,lyay),(cx0,cy0)))
         dcd.SetPen(wx.Pen(col1, 2))
         dcd.DrawLines(((lzax,lzay),(cx0,cy0)))

         dcd.SetFont(font2)
         dcd.SetTextForeground(col5) 
         dcd.DrawText('X',lxbx-15,lxby)
         dcd.SetTextForeground(col6) 
         dcd.DrawText('Y',lybx+8,lyby)
         dcd.SetTextForeground(col7) 
         dcd.DrawText('Z',lzbx-15,lzby-15)

         dcd.SetTextForeground(col1) 
         dcd.SetFont(font2)
         dcd.DrawText('x',lxax-12,lxay-17)
         dcd.DrawText('y',lyax+8,lyay-17)
         dcd.DrawText('z',lzax-12,lzay-10)

         dcd.SetFont(font3)

         dcd.SetPen(wx.Pen(col5, 1))
         dcd.DrawArc(cirxc+rcminc,ciryc,cirxc-rcminc,ciryc,cirxc,ciryc) 
         dcd.SetPen(wx.TRANSPARENT_PEN)
         dcd.SetBrush(wx.Brush(col5))
         dcd.DrawRectangle(cx1-4,ciryc-4,8,8)
         dcd.SetPen(wx.Pen(col5, 2))
         dcd.DrawLine(cx1,ciryc,cx1,cy1)
         dcd.SetBrush(wx.Brush(col8))
         dcd.SetPen(wx.Pen(col5, 1))
         dcd.DrawRectangle(cirxc+rcminc+10, int(ciryc-0.75*rcminc), int(1.5*rcminc), int(0.7*rcminc))
         dcd.DrawRectangle(int(cirxc+2.5*rcminc+10), int(ciryc-0.75*rcminc), int(1.8*rcminc), int(0.7*rcminc))
         dcd.SetTextForeground(col2) 
         dcd.DrawText(("%5.3f" %cang1), cirxc+rcminc+20, int(ciryc-0.6*rcminc))
         dcd.DrawText(str(cr1), int(cirxc+2.5*rcminc+15), int(ciryc-0.6*rcminc))

         dcd.SetBrush(wx.Brush(col8))
         dcd.SetPen(wx.Pen(col6, 1))
         dcd.DrawArc(cirxc+rcminc, int(ciryc+3.5*hver), cirxc-rcminc, int(ciryc+3.5*hver), cirxc, int(ciryc+3.5*hver)) 
         dcd.SetPen(wx.TRANSPARENT_PEN)
         dcd.SetBrush(wx.Brush(col6))
         dcd.DrawRectangle(cx2-4, int(ciryc+3.5*hver-4),8,8)
         dcd.SetPen(wx.Pen(col6, 2))
         dcd.DrawLine(cx2,int(ciryc+3.5*hver),cx2,cy2)
         dcd.SetBrush(wx.Brush(col8))
         dcd.SetPen(wx.Pen(col6, 1))
         dcd.DrawRectangle(cirxc+rcminc+10, int(ciryc+3.5*hver-0.75*rcminc), int(1.5*rcminc), int(0.7*rcminc))
         dcd.DrawRectangle(int(cirxc+2.5*rcminc+10), int(ciryc+3.5*hver-0.75*rcminc), int(1.8*rcminc), int(0.7*rcminc))
         dcd.SetTextForeground(col2) 
         dcd.DrawText(("%5.3f" %cang2),cirxc+rcminc+20, int(ciryc+3.5*hver-0.6*rcminc))
         dcd.DrawText(str(cr2), int(cirxc+2.5*rcminc+15), int(ciryc+3.5*hver-0.6*rcminc))

         dcd.SetBrush(wx.Brush(col8))
         dcd.SetPen(wx.Pen(col7, 1))
         dcd.DrawArc(cirxc+rcminc, int(ciryc+7*hver), cirxc-rcminc, int(ciryc+7*hver), cirxc, int(ciryc+7*hver)) 
         dcd.SetPen(wx.TRANSPARENT_PEN)
         dcd.SetBrush(wx.Brush(col7))
         dcd.DrawRectangle(cx3-4, int(ciryc+7*hver-4),8,8)
         dcd.SetPen(wx.Pen(col7, 2))
         dcd.DrawLine(cx3, int(ciryc+7*hver),cx3,cy3)
         dcd.SetBrush(wx.Brush(col8))
         dcd.SetPen(wx.Pen(col7, 1))
         dcd.DrawRectangle(cirxc+rcminc+10, int(ciryc+7*hver-0.75*rcminc), int(1.5*rcminc), int(0.7*rcminc))
         dcd.DrawRectangle(int(cirxc+2.5*rcminc+10), int(ciryc+7*hver-0.75*rcminc), int(1.8*rcminc), int(0.7*rcminc))
         dcd.SetTextForeground(col2) 
         dcd.DrawText(("%5.3f" %cang3), cirxc+rcminc+20, int(ciryc+7*hver-0.6*rcminc))
         dcd.DrawText(str(cr3), int(cirxc+2.5*rcminc+15), int(ciryc+7*hver-0.6*rcminc))

         dcd.SetBrush(wx.Brush(col8))
         dcd.SetPen(wx.Pen(col1, 1))
         dcd.DrawCircle(cirxc, int(ciryc+10.5*hver), rcminc)
         dcd.SetBrush(wx.Brush(col8))
         dcd.SetPen(wx.Pen(col1, 1))
         dcd.DrawRectangle(int(cirxc+2.5*rcminc+10), int(ciryc+10.5*hver-0.75*rcminc), int(1.8*rcminc), int(0.7*rcminc))
         dcd.SetTextForeground(col2) 
         dcd.DrawText(str(kappa), int(cirxc+2.5*rcminc+15), int(ciryc+10.5*hver-0.6*rcminc))
         dcd.SetBrush(wx.Brush(col1))
         dcd.SetPen(wx.Pen(col1, 1))
         dcd.DrawCircle(cx4,cy4,5)

         OnPaintInCos(self,cang1,cang2,cang3)

         dcd.SetPen(wx.TRANSPARENT_PEN)

         dcd.SetBrush(wx.Brush(wx.Colour(0, 128, 0, 128)))   # 128 == half transparent
         dcd.DrawPolygon(lzn)
         dcd.SetPen(wx.Pen(col5, 1))
         dcd.DrawLines(lzn)

         dcd.SetBrush(wx.Brush(wx.Colour(255, 0, 255, 128)))   # 128 == half transparent
         dcd.DrawPolygon(lzn1)
         dcd.SetPen(wx.Pen(col6, 1))
         dcd.DrawLines(lzn1)

         dcd.SetBrush(wx.Brush(wx.Colour(0, 0, 255, 128)))   # 128 == half transparent
         dcd.DrawPolygon(lzn2)
         dcd.SetPen(wx.Pen(col7, 1))
         dcd.DrawLines(lzn2)

         dcd.SetPen(wx.Pen(col3, 4))
         dcd.DrawLine(lxc,lyc,cx0,cy0)    

      if insys == 4:

         dcd.SetPen(wx.Pen(col5, 2))
         dcd.DrawLines(((lxbx,lxby),(cx0,cy0)))
         dcd.SetPen(wx.Pen(col6, 2))
         dcd.DrawLines(((lybx,lyby),(cx0,cy0)))
         dcd.SetPen(wx.Pen(col7, 2))
         dcd.DrawLines(((lzbx,lzby),(cx0,cy0)))

         dcd.SetPen(wx.Pen(col1, 2))
         dcd.DrawLines(((lxax,lxay),(cx0,cy0)))
         dcd.SetPen(wx.Pen(col1, 2))
         dcd.DrawLines(((lyax,lyay),(cx0,cy0)))
         dcd.SetPen(wx.Pen(col1, 2))
         dcd.DrawLines(((lzax,lzay),(cx0,cy0)))

         dcd.SetFont(font2)
         dcd.SetTextForeground(col5) 
         dcd.DrawText('X',lxbx-15,lxby)
         dcd.SetTextForeground(col6) 
         dcd.DrawText('Y',lybx+8,lyby)
         dcd.SetTextForeground(col7) 
         dcd.DrawText('Z',lzbx-15,lzby-15)

         dcd.SetTextForeground(col1) 
         dcd.SetFont(font2)
         dcd.DrawText('x',lxax-12,lxay-17)
         dcd.DrawText('y',lyax+8,lyay-17)
         dcd.DrawText('z',lzax-12,lzay-10)

         dcd.SetPen(wx.Pen(col5, 1))
         dcd.DrawLine(cirxc+rcminc, int(ciryc-0.5*hver), cirx-rcmin, int(ciryc-0.5*hver)) 
         dcd.SetPen(wx.Pen(col5, 3))
         dcd.DrawLine(tliml, int(ciryc-0.5*hver), tlimp, int(ciryc-0.5*hver)) 
         dcd.SetTextForeground(col5)
         dcd.DrawText(("%7.4f" %(-tsk2)), cirx-rcmin, int(ciryc-2*hver))
         dcd.DrawText(("%7.4f" %(tsk2)), cirxc+rcminc-wt, int(ciryc-2*hver))
         dcd.SetPen(wx.TRANSPARENT_PEN)
         dcd.SetBrush(wx.Brush(col5))
         dcd.SetPen(wx.Pen(col5, 1))
         dcd.DrawCircle(cx1, int(ciryc-0.5*hver), 5)
         dcd.SetBrush(wx.Brush(col8))
         dcd.SetPen(wx.Pen(col5, 1))
         dcd.DrawRectangle(cirxc+rcminc+30, int(ciryc-0.75*rcminc), int(1.8*rcminc), int(0.7*rcminc))
         dcd.SetTextForeground(col2) 
         dcd.DrawText(("%7.4f" %tqx),cirxc+rcminc+40, int(ciryc-0.6*rcminc))
         dcd.DrawLine(lnc, int(ciryc-0.1*hver), lnc, int(ciryc-0.9*hver)) 

         dcd.SetBrush(wx.Brush(col8))
         dcd.SetPen(wx.Pen(col6, 1))
         dcd.DrawLine(cirxc+rcminc, int(ciryc+3*hver), cirx-rcmin, int(ciryc+3*hver)) 
         dcd.SetPen(wx.Pen(col6, 3))
         dcd.DrawLine(tliml, int(ciryc+3*hver), tlimp, int(ciryc+3*hver))
         dcd.SetTextForeground(col6)
         dcd.DrawText(("%7.4f" %(-tsk2)), cirx-rcmin, int(ciryc+1.5*hver))
         dcd.DrawText(("%7.4f" %(tsk2)), cirxc+rcminc-wt, int(ciryc+1.5*hver)) 
         dcd.SetPen(wx.TRANSPARENT_PEN)
         dcd.SetBrush(wx.Brush(col6))
         dcd.DrawCircle(cx2, int(ciryc+3*hver), 5)
         dcd.SetBrush(wx.Brush(col8))
         dcd.SetPen(wx.Pen(col6, 1))
         dcd.DrawRectangle(cirxc+rcminc+30, int(ciryc+3.5*hver-0.75*rcminc), int(1.8*rcminc), int(0.7*rcminc))
         dcd.SetTextForeground(col2) 
         dcd.DrawText(("%7.4f" %tqy), cirxc+rcminc+40, int(ciryc+3.5*hver-0.6*rcminc))
         dcd.DrawLine(lnc, int(ciryc+2.6*hver), lnc, int(ciryc+3.4*hver))

         dcd.SetBrush(wx.Brush(col8))
         dcd.SetPen(wx.Pen(col7, 1))
         dcd.DrawLine(cirxc+rcminc, int(ciryc+6.5*hver), cirx-rcmin, int(ciryc+6.5*hver)) 
         dcd.SetPen(wx.Pen(col7, 3))
         dcd.DrawLine(tliml, int(ciryc+6.5*hver), tlimp, int(ciryc+6.5*hver)) 
         dcd.SetTextForeground(col7)
         dcd.DrawText(("%7.4f" %(-tsk2)), cirx-rcmin, int(ciryc+5*hver))
         dcd.DrawText(("%7.4f" %(tsk2)), cirxc+rcminc-wt, int(ciryc+5*hver))
         dcd.SetPen(wx.TRANSPARENT_PEN)
         dcd.SetBrush(wx.Brush(col7))
         dcd.DrawCircle(cx3, int(ciryc+6.5*hver), 5)
         dcd.SetBrush(wx.Brush(col8))
         dcd.SetPen(wx.Pen(col7, 1))
         dcd.DrawRectangle(cirxc+rcminc+30, int(ciryc+7*hver-0.75*rcminc), int(1.8*rcminc), int(0.7*rcminc))
         dcd.SetTextForeground(col2) 
         dcd.DrawText(("%7.4f" %tqz), cirxc+rcminc+40, int(ciryc+7*hver-0.6*rcminc))
         dcd.DrawLine(lnc, int(ciryc+6.1*hver), lnc, int(ciryc+6.9*hver))

         dcd.SetBrush(wx.Brush(col8))
         dcd.SetPen(wx.Pen(col1, 1))
         dcd.DrawLine(cirxc+rcminc, int(ciryc+10*hver), cirx-rcmin, int(ciryc+10*hver)) 
         dcd.SetPen(wx.TRANSPARENT_PEN)
         dcd.SetBrush(wx.Brush(col1))
         dcd.DrawCircle(cx4, int(ciryc+10*hver), 5)
         dcd.SetBrush(wx.Brush(col8))
         dcd.SetPen(wx.Pen(col1, 1))
         dcd.DrawRectangle(cirxc+rcminc+30, int(ciryc+10.5*hver-0.75*rcminc), int(1.8*rcminc), int(0.7*rcminc))
         dcd.SetTextForeground(col2)
         dcd.DrawText(("%7.4f" %tq0), cirxc+rcminc+40, int(ciryc+10.5*hver-0.6*rcminc))
         dcd.DrawLine(cirx-rcmin, int(ciryc+9.6*hver), cirx-rcmin, int(ciryc+10.4*hver)) 
         dcd.DrawLine(lnc, int(ciryc+9.6*hver), lnc, int(ciryc+10.4*hver)) 
         dcd.DrawLine(cirxc+rcminc, int(ciryc+9.6*hver), cirxc+rcminc, int(ciryc+10.4*hver)) 
         dcd.DrawText("-1",cirx-rcmin-5, int(ciryc+10.5*hver)) 
         dcd.DrawText("0",lnc-3, int(ciryc+10.5*hver)) 
         dcd.DrawText("1",cirxc+rcminc-3, int(ciryc+10.5*hver)) 

         OnPaintInCos(self,cx,cy,cz)

         dcd.SetPen(wx.TRANSPARENT_PEN)

         dcd.SetBrush(wx.Brush(wx.Colour(0, 128, 0, 128)))   # 128 == half transparent
         dcd.DrawPolygon(lzn)
         dcd.SetPen(wx.Pen(col5, 1))
         dcd.DrawLines(lzn)

         dcd.SetBrush(wx.Brush(wx.Colour(255, 0, 255, 128)))   # 128 == half transparent
         dcd.DrawPolygon(lzn1)
         dcd.SetPen(wx.Pen(col6, 1))
         dcd.DrawLines(lzn1)

         dcd.SetBrush(wx.Brush(wx.Colour(0, 0, 255, 128)))   # 128 == half transparent
         dcd.DrawPolygon(lzn2)
         dcd.SetPen(wx.Pen(col7, 1))
         dcd.DrawLines(lzn2)

         if tq0 != -1 and tq0 != 1:

          dcd.SetPen(wx.Pen(col3, 2))
          dcd.DrawLine(lxc,lyc,cx0,cy0)  
          dcd.SetPen(wx.Pen(col3, 4))
          dcd.DrawLine(lxc1,lyc1,cx0,cy0)      

      dcd.SetTextForeground(col2) 
      dcd.SetFont(font3)
      dcd.DrawText(ln1, int(0.65*wh), int(2*hver))
      dcd.DrawText(ln2, int(0.65*wh), int(3*hver))
      dcd.DrawText(ln3, int(0.65*wh), int(4*hver))

      dpanel.Bind(wx.EVT_LEFT_DOWN, self.MouseDown)
      dpanel.Bind(wx.EVT_LEFT_UP, self.MouseUp)
      dpanel.Bind(wx.EVT_MOTION, self.MoveObj)

#-------------------------------------
# Mouse down
    def MouseDown(self, evt):
       global imove, xb, yb, ld1, ld2, ld3, ld4, ld5, ld6, ld7, ldx, ldxt, ldyt, bgt

       imove = 1

       xb,yb = evt.GetPosition()

#      one can reduce the box for the rotation cursor if necessary 
#      replacing 0 by some positive value

       if insys < 2:

        rc = math.sqrt((xb-cirx)**2+(yb-ciry)**2)
        rcs = abs(xb-cscx2)
       
        if abs(rc-rcmin) <= 5: ld1 = True
        if abs(rc-2*rcmin) <=5: ld2 = True
        if abs(rc-3*rcmin) <=5: ld3 = True

       if insys == 0 and rcs <= 3: ldx = True

       if insys == 2:

        rc = (xb >= (cirxc-rcminc) and xb <= (cirxc+rcminc)) 

        if rc and abs(yb-ciryc) <= 5: ld4 = True
        if rc and abs(yb-(ciryc+3.5*hver)) <= 5: ld5 = True
        if rc and abs(yb-(ciryc+7*hver)) <= 5: ld6 = True

        rc = math.sqrt((xb-cirxc)**2+(yb-(ciryc+10.5*hver))**2)

        if abs(rc-rcminc) <= 5: ld7 = True

       if insys == 4:

        rc = (xb >= (cirx-rcmin-10) and xb <= (cirxc+rcminc+10)) 

        if rc and abs(yb-(ciryc-0.5*hver)) <= 5: ld4 = True
        if rc and abs(yb-(ciryc+3*hver)) <= 5: ld5 = True
        if rc and abs(yb-(ciryc+6.5*hver)) <= 5: ld6 = True

        if rc and abs(yb-(ciryc+10*hver)) <= 5: ld7 = True

       rcx = abs(xb-cx0)
       rcy = abs(cy0-yb)
       if rcx <= aview: ldxt = True
       if rcy <= aview: ldyt = True

       bgt = time.time()

#-------------------------------------
# Mouse up
    def MouseUp(self, evt):
       global imove, ld1, ld2, ld3, ld3, ld4, ld5, ld6, ld7, ldx, ldxt, ldyt

       imove = 0

       ld1, ld2, ld3, ld4, ld5, ld6, ld7 = False, False, False, False, False, False, False
       ldx, ldxt, ldyt = False, False, False

#-------------------------------------
# Recalculate

    def MoveObj(self, event):
       global cang1, cang2, cang3, cang4, kappa, cx1, cy1, cx2, cy2, cx3, cy3, cscx1, cscx2, scx, bgt
       global qx, qy, qz, q0, qxt, qyt, qzt, q0t, sk2, sk2t, liml, limlt, limp, limpt
       global xb, yb, rotx, roty, rotz, pro
       global ld1, ld2, ld3, ld4, ld5, ld6, ld7, ldx

       act = time.time()

       if  imove  == 1 and abs(act-bgt) >= pert:

        xc,yc = event.GetPosition()
        
        rc = math.sqrt((xc-cirx)**2+(yc-ciry)**2)

        exp1 = (xc > limx1 and xc < limx2) and (yc > limy1 and yc < limy2)

        if insys < 2 and (ld1 == True or ld2 == True or ld3 == True) and  exp1 and rc != 0:

         sman = -(yc-ciry)/rc
         cman = (xc-cirx)/rc

         if ld3 == True:
           cang3 = math.atan2(sman,cman)/grrad
           if cang3 < 0.: cang3 = cang3+360.
           cang3 = int(round(cang3))
           dpanel.Refresh()
           if demowinr: demowinr.Destroy() 
           btnDemor.Disable()

         if ld2 == True: 
           cang2 = math.atan2(sman,cman)/grrad
           if cang2 < 0.: cang2 = cang2+360.
           cang2 = int(round(cang2))
           dpanel.Refresh()  
           if demowinr: demowinr.Destroy() 
           btnDemor.Disable()   

         if ld1 == True:
           cang1 = math.atan2(sman,cman)/grrad
           if cang1 < 0.: 
             if insys == 0: cang1 = cang1+360.
             if insys == 1: cang1 = cang1+180.
           cang1 = int(round(cang1))
           dpanel.Refresh()
           if demowinr: demowinr.Destroy() 
           btnDemor.Disable()

         ex = "%i" %cang1+ ' ' +"%i" %cang2+ ' ' +"%i" %cang3
         inputang.SetValue(ex)

         bgt = act

        ex = (xc >= (cirxc-rcminc) and xc <= (cirxc+rcminc))

        ex4 = (yc >= (ciryc-10) and yc <= (ciryc+10))
        ex5 = (yc >= (ciryc+3.5*hver-10) and yc <= (ciryc+3.5*hver+10))
        ex6 = (yc >= (ciryc+7*hver-10) and yc <= (ciryc+7*hver+10))

        if insys == 2 and ex and ((ld4 == True and ex4) or (ld5 == True and ex5) or (ld6 == True and ex6) or ld7 == True):

         cc1 = float(cang1)
         cc2 = float(cang2)
         cc3 = float(cang3)

         if ld4 == True:
       
           cang1 = float(xc-cirxc)/float(rcminc)
  
           d0 = math.sqrt(1.-cc1*cc1)
           d1 = math.sqrt(1.-cang1*cang1)
           if d0 != 0:
            cang2 = float(cc2*d1)/float(d0)
            cang3 = float(cc3*d1)/float(d0) 

           if (cc1 == 1. or cc1 == -1.) and cc2 == 0. and cc3 == 0. : cang2 = cang3 = d1/math.sqrt(2)

         if ld5 == True:

           cang2 = float(xc-cirxc)/float(rcminc)
         
           d0 = math.sqrt(1-cc2*cc2)
           d1 = math.sqrt(1-cang2*cang2)
           if d0 != 0:
            cang1 = float(cc1*d1)/float(d0)
            cang3 = float(cc3*d1)/float(d0)  
       
           if cc1 == 0. and (cc2 == 1. or cc2 == -1.) and cc3 == 0.: cang1 = cang3 = d1/math.sqrt(2)

         if ld6 == True:
          
           cang3 = float(xc-cirxc)/float(rcminc)

           d0 = math.sqrt(1-cc3*cc3)
           d1 = math.sqrt(1-cang3*cang3)
           if d0 != 0:
            cang1 = float(cc1*d1)/float(d0)
            cang2 = float(cc2*d1)/float(d0) 
       
           if cc1 == 0. and cc2 == 0. and (cc3 == 1. or cc3 == -1.): cang1 = cang2 = d1/math.sqrt(2)

         if cang1 >= 1.-eps2: cang1 = 1.0
         if cang1 <= -1.+eps2: cang1 = -1.0
         if cang2 >= 1.-eps2: cang2 = 1.0
         if cang2 <= -1.+eps2: cang2 = -1.0
         if cang3 >= 1.-eps2: cang3 = 1.0
         if cang3 <= -1.+eps2: cang3 = -1.0

         if ld7 == True:

           rc = math.sqrt((xc-cirxc)**2+(yc-(ciryc+12*hver))**2)

           sman = -(yc-(ciryc+12*hver))/rc
           cman = (xc-cirxc)/rc

           kappa = math.atan2(sman,cman)/grrad

           if kappa < 0.: kappa = kappa+360.
           kappa = int(round(kappa))

         ex = "%9.3f" %cang1 + "%9.3f" %cang2 + "%9.3f" %cang3 +"%9.3f" %kappa
         inputang.SetValue(ex)

         dpanel.Refresh()  
         if demowinr: demowinr.Destroy() 
         btnDemor.Disable()   

         bgt = act

        ex = (xc >= (cirx-rcmin-10) and xc <= (cirxc+rcminc+10))

        ex4 = (yc >= (ciryc-0.5*hver-15) and yc <= (ciryc-0.5*hver+15))
        ex5 = (yc >= (ciryc+3*hver-15) and yc <= (ciryc+3*hver+15))
        ex6 = (yc >= (ciryc+6.5*hver-15) and yc <= (ciryc+6.5*hver+15))
        ex7 = (yc >= (ciryc+10*hver-15) and yc <= (ciryc+10*hver+15))

        if insys == 4 and ex and ((ld4 == True and ex4) or (ld5 == True and ex5) or (ld6 == True and ex6) or (ld7 == True and ex7)):
         qxt = qyt = qzt = q0t = 0.
       
         if cang1 == 0. and cang2 == 0. and cang3 == 0:
           if cang4 >= 1.: cang4 = 1.-eps1
           if cang4 <= -1.: cang4 = -1.+eps1
           sk2 = math.sqrt(1.-cang4*cang4)
           cang1 = cang2 = cang3 = sk2/math.sqrt(3)    

         cc1 = float(cang1)
         cc2 = float(cang2)
         cc3 = float(cang3) 
         cc4 = float(cang4)

         if ld4 == True:
       
           cang1 = 2*sk2*(xc-lnc)/lnl
           if cang1 <= -1.: cang1 = -1.
           if cang1 >= 1.: cang1 = 1.

           e1 = sk2*sk2-cc1*cc1
           e2 = sk2*sk2-cang1*cang1
           if e1 >=0 and e2 >=0:
            d0 = math.sqrt(e1)
            d1 = math.sqrt(e2)
            if d0 != 0:
             cang2 = float(cc2*d1)/float(d0)
             cang3 = float(cc3*d1)/float(d0)
             
           if (cc1 == 1. or cc1 == -1.) and cc2 == 0. and cc3 == 0. : cang2 = cang3 = (sk2*sk2-1)/math.sqrt(2)  

         if ld5 == True:

           cang2 = 2*sk2*(xc-lnc)/lnl
           if cang2 <= -1.: cang2 = -1.
           if cang2 >= 1.: cang2 = 1.

           e1 = sk2*sk2-cc2*cc2
           e2 = sk2*sk2-cang2*cang2
           if e1 >=0 and e2 >=0:
            d0 = math.sqrt(e1)
            d1 = math.sqrt(e2)
            if d0 != 0:
             cang1 = float(cc1*d1)/float(d0)
             cang3 = float(cc3*d1)/float(d0)  
       
           if cc1 == 0. and (cc2 == 1. or cc2 == -1.) and cc3 == 0.: cang1 = cang3 = (sk2*sk2-1)/math.sqrt(2) 

         if ld6 == True:
          
           cang3 = 2*sk2*(xc-lnc)/lnl
           if cang3 <= -1.: cang3 = -1.
           if cang3 >= 1.: cang3 = 1.

           e1 = sk2*sk2-cc3*cc3
           e2 = sk2*sk2-cang3*cang3
           if e1 >=0 and e2 >=0:
            d0 = math.sqrt(e1)
            d1 = math.sqrt(e2)
            if d0 != 0:
             cang1 = float(cc1*d1)/float(d0)
             cang2 = float(cc2*d1)/float(d0) 
       
           if cc1 == 0. and cc2 == 0. and (cc3 == 1. or cc3 == -1.): cang1 = cang2 = (sk2*sk2-1)/math.sqrt(2)

         if ld7 == True:

           cang4 = q0t = 2*(xc-lnc)/lnl
           if cang4 <= -1.: cang4 = q0t = -1.
           if cang4 >= 1.: cang4 = q0t = 1.

           d0 = math.sqrt(1-cc4*cc4)
           d1 = math.sqrt(1-cang4*cang4)

           if d0 != 0:
            cang1 = qxt = float(cc1*d1)/float(d0)
            cang2 = qyt = float(cc2*d1)/float(d0) 
            cang3 = qzt = float(cc3*d1)/float(d0)

            if cang1 >= 1.-eps2: cang1 = 1.0
            if cang1 <= -1.+eps2: cang1 = -1.0
            if cang2 >= 1.-eps2: cang2 = 1.0
            if cang2 <= -1.+eps2: cang2 = -1.0
            if cang3 >= 1.-eps2: cang3 = 1.0
            if cang3 <= -1.+eps2: cang3 = -1.0
            
           if cang4 >= 1. or cang4 <= -1.: 
            qxt = cang1
            qyt = cang2
            qzt = cang3
            q0t = cang4
            cang1 = cc1
            cang2 = cc2
            cang3 = cc3
            cang4 = cc4        

           sk2t = math.sqrt(1.-q0t*q0t)
           limlt = int(lnc-0.5*sk2t*lnl)
           limpt = int(lnc+0.5*sk2t*lnl)

         if ld7 == True:
             det = math.sqrt(qxt*qxt+qyt*qyt+qzt*qzt+q0t*q0t)
             if det == 0.: pass
             if det != 1.0:
               scal =1./det
               qxt =qxt*scal
               qyt =qyt*scal
               qzt =qzt*scal
               q0t =q0t*scal
             ex = "%9.4f" %qxt + "%9.4f" %qyt + "%9.4f" %qzt +"%9.4f" %q0t
         else:
             det = math.sqrt(cang1*cang1+cang2*cang2+cang3*cang3+cang4*cang4)
             if det == 0.: pass
             if det != 1.0:
               scal =1./det
               cang1 =cang1*scal
               cang2 =cang2*scal
               cang3 =cang3*scal
               cang4 =cang4*scal
             ex = "%9.4f" %cang1 + "%9.4f" %cang2 + "%9.4f" %cang3 +"%9.4f" %cang4
         inputang.SetValue(ex)

         dpanel.Refresh()  
         if demowinr: demowinr.Destroy() 
         btnDemor.Disable()  

         bgt = act

        exp2 = (xc >= cscx1 and xc <=cirx+3*rcmin+50) and (yc >= cscy1 and yc <= cscy2)

        if insys == 0 and ldx == True and exp2:
  
         scx = float(2*(xc-cscx1))/float(cirx+3*rcmin+50-cscx1)
         cscx2 = xc

         dpanel.Refresh()

         bgt = act

        exp3 = (abs(xc-cx0) <= aview and abs(cy0-yc) <= aview)

        if ldxt == True and ldyt == True and exp3 and (abs(xb-xc) >= 5 or abs(yb-yc) >= 5):

         ld1, ld2, ld3, ld4, ld5, ld6, ld7, ldx = False, False, False, False, False, False, False, False

         xbm = (cx0-xb)/aview
         zbm = (cy0-yb)/aview

         db = math.sqrt(xbm*xbm+zbm*zbm)

         xcm = (cx0-xc)/aview
         zcm = (cy0-yc)/aview

         dc = math.sqrt(xcm*xcm+zcm*zcm)

         xbs = xbm
         zbs = zbm
         xcs = xcm
         zcs = zcm

         if db > 1:
             xbs = xbm/db
             zbs = zbm/db
             db= 1.

         if dc > 1:
             xcs = xcm/dc
             zcs = zcm/dc
             dc = 1.

         ybs = math.sqrt(1-db*db)
         ycs = math.sqrt(1-dc*dc)

         cosk = xbs*xcs + ybs*ycs + zbs*zcs
         if cosk > 1.0: cosk = 1.0
         if cosk < -1.0: cosk = -1.0
         kview = math.acos(cosk)
         sink = math.sin(kview)

         xl = (ybs*zcs-zbs*ycs)/sink
         yl = (zbs*xcs-xbs*zcs)/sink
         zl = (xbs*ycs-ybs*xcs)/sink

         m2[0] = xl*xl*(1-cosk)+cosk
         m2[1] = xl*yl*(1-cosk)-zl*sink
         m2[2] = xl*zl*(1-cosk)+yl*sink
         m2[3] = xl*yl*(1-cosk)+zl*sink
         m2[4] = yl*yl*(1-cosk)+cosk
         m2[5] = yl*zl*(1-cosk)-xl*sink
         m2[6] = xl*zl*(1-cosk)-yl*sink
         m2[7] = yl*zl*(1-cosk)+xl*sink
         m2[8] = zl*zl*(1-cosk)+cosk

         Mulrot(self,m2,pro)

# assigned below      pro = rtemp

         xb = xc
         yb = yc

         srotx = -rtemp[5]
         crotx = math.sqrt(1-srotx*srotx)
         dxchk = math.sqrt(srotx*srotx+crotx*crotx)
         srotx = srotx/dxchk
         crotx = crotx/dxchk

         if crotx == 0:             
             srotz = -rtemp[1]
             crotz = rtemp[0]
             sroty = 0
             croty = 1

         if crotx > 0:             
             srotz = rtemp[3]/crotx
             crotz = rtemp[4]/crotx
             sroty = rtemp[2]/crotx
             croty = rtemp[8]/crotx   

         dychk = math.sqrt(sroty*sroty+croty*croty)
         sroty = sroty/dychk
         croty = croty/dychk
         dzchk = math.sqrt(srotz*srotz+crotz*crotz)
         srotz = srotz/dzchk
         crotz = crotz/dzchk

         pro[0]= srotz*srotx*sroty+crotz*croty
         pro[1]= crotz*srotx*sroty-srotz*croty
         pro[2]= crotx*sroty
         pro[3]= srotz*crotx
         pro[4]= crotz*crotx
         pro[5]= -srotx
         pro[6]= srotz*srotx*croty-crotz*sroty
         pro[7]= crotz*srotx*croty+srotz*sroty
         pro[8]= crotx*croty   

         dpanel.Refresh()

         bgt = act

#-------------------------------------
#  Change transparency

    def ChangeTrans(self, event):
       global itrans

       id = event.GetId()

       if id == 1: itrans = 0
       if id == 2: itrans = 1

       dpanel.Refresh()
   
#-----------------------------------------------------
# Close input demo window

    def OnCloseDemo(self, evt):

        if demowin : demowin.Destroy()

#-------------------------------------
# Demo output rotation

class Demor_Rot(wx.Frame):
    def __init__(self, parent) :
       global dpanelr, alpout, betout, gamout, kapout, coltr1, coltr2, coltr3
       global qxr, qyr, qzr, q0r
       global lzenr, lzenr1, xmr1, ymr1, zmr1


       OnPaintInit(self)

       lzenr, lzenr1 = [], []

       xmr1 = [0 for x in range(3)]
       ymr1 = [0 for x in range(3)]
       zmr1 = [0 for x in range(3)]

       iwd = int(wd-0.9*wh)
       ihd = int(hd-hh-40)
       iwh = int(0.9*wh)
       
       if outsys == 0: 
         wx.Frame.__init__(self, None, -1, title= 'DEMO OUTPUT: Euler rotation', pos=(iwd, ihd), size=(iwh, hh)) 
       if outsys == 1: 
         wx.Frame.__init__(self, None, -1, title= 'DEMO OUTPUT: polar rotation', pos=(iwd, ihd), size=(iwh, hh)) 
       if outsys == 2: 
         wx.Frame.__init__(self, None, -1, title= 'DEMO OUTPUT: cos rotation', pos=(iwd, ihd), size=(iwh, hh)) 
       if outsys == 4: 
         wx.Frame.__init__(self, None, -1, title= 'DEMO OUTPUT: quaternions rotation', pos=(iwd, ihd), size=(iwh+60, hh)) 

       dpanelr = self.dpanelr = wx.Panel(self, pos=(0, 0), size=(int(0.85*wh), hh))
       dpanelr.SetBackgroundColour(col9)
       dpanelr.SetFont(font5)

       if outsys == 0:   

         rax1 = lax12[outcon][0]
         rax2 = lax12[outcon][1]
         rax3 = lax12[outcon][2]

         if str(rax1) == 'x': coltr1 = col5
         if str(rax1) == 'y': coltr1 = col6
         if str(rax1) == 'z': coltr1 = col7
         if str(rax2) == 'x': coltr2 = col5
         if str(rax2) == 'y': coltr2 = col6 
         if str(rax2) == 'z': coltr2 = col7
         if str(rax3) == 'x': coltr3 = col5
         if str(rax3) == 'y': coltr3 = col6
         if str(rax3) == 'z': coltr3 = col7
         
         tit1 = wx.StaticText(self.dpanelr, -1, typerot[outrot].strip()+", "+typeaxes[outaxes], pos =(int((wh-wfi9)/2), int(0.5*hver)))
         tit1.SetFont(font2) 
         tit2 = wx.StaticText(self.dpanelr, -1, "consecutive rotation axes: "+lax12[outcon], pos =(int((wh-wfi9)/2), int(1.5*hver)))
         tit2.SetFont(font2) 
         tit3 = wx.StaticText(self.dpanelr, -1, "rotation direction: "+lrot8[outdir], pos =(int((wh-wfi9)/2), int(2.5*hver)))
         tit3.SetFont(font2) 
         tit4 = wx.StaticText(self.dpanelr, -1, teuler5, pos =(int(0.45*wh), int(5*hver)))
         tit4.SetFont(font2)

       if len(angoutlist) != 0:

        if outsys < 2:

         alpout = float(angoutlist[0].split()[0])
         if outsys == 0 and alpout > 360: alpout = math.fmod(alpout, 360)
         if outsys == 1 and alpout > 180: alpout = math.fmod(alpout, 180)
         betout = float(angoutlist[0].split()[1])
         if betout > 360: betout = math.fmod(betout, 360)
         gamout = float(angoutlist[0].split()[2])
         if gamout > 360: gamout = math.fmod(gamout, 360)

        if outsys == 2:
         alpout = float(angoutlist[0].split()[0])
         betout = float(angoutlist[0].split()[1])
         gamout = float(angoutlist[0].split()[2])
         kapout = float(angoutlist[0].split()[3])
         if kapout > 360: kapout = math.fmod(kapout, 360)
         kapout = int(round(kapout))

       if outsys == 4:

         qxr = float(angoutlist[0].split()[0])
         qyr = float(angoutlist[0].split()[1])
         qzr = float(angoutlist[0].split()[2])
         q0r = float(angoutlist[0].split()[3])

       if outsys == 0 :

        btnop = self.btnop = wx.Button(dpanelr, 3, "opaque", (int(0.05*wh), int(0.85*hh)), (wh3+5, int(1.5*hver)))
        btnop.SetFont(font5)
        btnop.SetBackgroundColour(col4) 
        btnop.Bind(wx.EVT_BUTTON, self.ChangeTransr, self.btnop)  
 
        btntr = self.btntr = wx.Button(dpanelr, 4, "transparent", (int(0.3*wh), int(0.85*hh)), (wh3+15, int(1.5*hver)))
        btntr.SetFont(font5)
        btntr.SetBackgroundColour(col4) 
        btntr.Bind(wx.EVT_BUTTON, self.ChangeTransr, self.btntr)   

       pgr = 360
       sls = 250

       if outsys == 1: 

          pgr = 180
          sls = 125

          tit1 = wx.StaticText(self.dpanelr, -1, typerot[outrot].strip(), pos =(int((wh-wfi31)/2), int(0.5*hver)))
          tit1.SetFont(font2)
          tit2 = wx.StaticText(self.dpanelr, -1, tpolar1+"  "+laxp6[outpol], pos =(int((wh-wfi31)/2), int(1.5*hver)))
          tit2.SetFont(font2) 
          tit3 = wx.StaticText(self.dpanelr, -1, "rotation direction: "+lrotp4[outdirp], pos =(int((wh-wfi31)/2), int(2.5*hver)))
          tit3.SetFont(font2) 
          tit4 = wx.StaticText(self.dpanelr, -1, tpolar4, pos =(int(0.45*wh), int(5*hver)))
          tit4.SetFont(font2)

       if outsys == 2:

         tit1 = wx.StaticText(self.dpanelr, -1, typerot[outrot].strip(), pos =(int((wh-wfi31)/2), int(0.5*hver)))
         tit1.SetFont(font2)
         tit2 = wx.StaticText(self.dpanelr, -1, "rotation direction: "+lrotc2[outdirc], pos =(int((wh-wfi31)/2), int(1.5*hver)))
         tit2.SetFont(font2) 

         tel= wx.StaticText(self.dpanelr, -1, "cos(ax)     ax ", pos =(cirxc-rcminc, int(6.5*hver)))
         tel.SetFont(font2)
         tel.SetForegroundColour(col2)

         tel1= wx.StaticText(self.dpanelr, -1, "cosine values to x ", pos =(cirx-3*rcmin, int(ciryc-hver)))
         tel1.SetFont(font2)
         tel1.SetForegroundColour(col5)
         tel2= wx.StaticText(self.dpanelr, -1, "cosine values to y ", pos =(cirx-3*rcmin, int(ciryc+2.5*hver)))
         tel2.SetFont(font2)
         tel2.SetForegroundColour(col6)
         tel3= wx.StaticText(self.dpanelr, -1, "cosine values to z ", pos =(cirx-3*rcmin, int(ciryc+6*hver)))
         tel3.SetFont(font2)
         tel3.SetForegroundColour(col7)
         tel4= wx.StaticText(self.dpanelr, -1, "rotation angle ", pos =(cirx-3*rcmin, int(ciryc+9.5*hver)))
         tel4.SetFont(font2)
         tel4.SetForegroundColour(col1)

       if outsys == 4:

         tit1 = wx.StaticText(self.dpanelr, -1, typerot[outrot].strip(), pos =(int((wh-wfi31)/2), int(0.5*hver)))
         tit1.SetFont(font2)
         tit2 = wx.StaticText(self.dpanelr, -1, "rotation direction: "+lrotc2[outdirc], pos =(int((wh-wfi31)/2), int(1.5*hver)))
         tit2.SetFont(font2) 

         tel1= wx.StaticText(self.dpanelr, -1, "qx ", pos =(cirx-3*rcmin, int(ciryc-hver)))
         tel1.SetFont(font2)
         tel1.SetForegroundColour(col5)
         tel2= wx.StaticText(self.dpanelr, -1, "qy ", pos =(cirx-3*rcmin, int(ciryc+2.5*hver)))
         tel2.SetFont(font2)
         tel2.SetForegroundColour(col6)
         tel3= wx.StaticText(self.dpanelr, -1, "qz ", pos =(cirx-3*rcmin, int(ciryc+6*hver)))
         tel3.SetFont(font2)
         tel3.SetForegroundColour(col7)
         tel4= wx.StaticText(self.dpanelr, -1, "q0 ", pos =(cirx-3*rcmin, int(ciryc+9.5*hver)))
         tel4.SetFont(font2)
         tel4.SetForegroundColour(col1)

       closd = self.closd = wx.Button(dpanelr, -1, "close", (int(0.7*wh), int(0.85*hh)), (wh2+15, int(1.5*hver)))
       closd.SetFont(font5)
       closd.SetBackgroundColour(col4) 
       closd.Bind(wx.EVT_BUTTON, self.OnCloseDemor)
       self.Bind(wx.EVT_CLOSE, self.OnCloseDemor) 

       dpanelr.Bind(wx.EVT_PAINT, self.DcDemor)
 
       self.Show()

#-------------------------------------
# Put DC on the window (output)

    def DcDemor(self, evt): 

       pdcr = wx.PaintDC(dpanelr)
       pdcr.Clear()
       try:
            dcdr = wx.GCDC(pdcr)
       except:
            dcdr = pdcr

       dcdr.Clear()
       self.OnPaintDemor(dcdr)

#-----------------------------------------------------

    def OnPaintDemor(self, dcdr): 
      global alpout, betout, gamout, kapout, lxrxr, lxryr, lyrxr, lyryr, lzrxr, lzryr
      global protr3, protr4, protr5, lxpolr, lypolr, lxpolr1, lypolr1, lzenr, lzenr1, sk2r

      lxbxr = int(cx0-lbr*crot1)
      lxbyr = int(cy0+lbr*srot1*srot2)
      lybxr = int(cx0+lbr*srot1)
      lybyr = int(cy0+lbr*crot1*srot2)
      lzbxr = cx0
      lzbyr = int(cy0-lbr*crot2)

      lxaxr = int(cx0-la*crot1)
      lxayr = int(cy0+la*srot1*srot2)
      lyaxr = int(cx0+la*srot1)
      lyayr = int(cy0+la*crot1*srot2)
      lzaxr = cx0
      lzayr = int(cy0-la*crot2)

      if outsys < 2:
       alpout = int(round(alpout))
       betout = int(round(betout))
       gamout = int(round(gamout))

      if outrot == 0:
       
         xm = (rot[0], rot[1], rot[2])
         ym = (rot[3], rot[4], rot[5])
         zm = (rot[6], rot[7], rot[8])  

         for i in range(3):     
           xmr1[i]=xm[i]*crot1-ym[i]*srot1
           ymr1[i]=xm[i]*srot1+ym[i]*crot1
           zmr1[i]=zm[i]*crot2-ymr1[i]*srot2

         lxrxr = int(cx0-lrr*xmr1[0])
         lxryr = int(cy0-lrr*zmr1[0])
         lyrxr = int(cx0-lrr*xmr1[1])
         lyryr = int(cy0-lrr*zmr1[1])
         lzrxr = int(cx0-lrr*xmr1[2])
         lzryr = int(cy0-lrr*zmr1[2])

         lxaxr = int(cx0-la*xmr1[0])
         lxayr = int(cy0-la*zmr1[0])
         lyaxr = int(cx0-la*xmr1[1])
         lyayr = int(cy0-la*zmr1[1])
         lzaxr = int(cx0-la*xmr1[2])
         lzayr = int(cy0-la*zmr1[2])

      if outrot == 1:  

         xm = ([rot[0], rot[3], rot[6]])
         ym = ([rot[1], rot[4], rot[7]])
         zm = ([rot[2], rot[5], rot[8]])  

         for i in range(3):
          xmr1[i]=xm[i]*crot1-ym[i]*srot1
          ymr1[i]=xm[i]*srot1+ym[i]*crot1
          zmr1[i]=zm[i]*crot2-ymr1[i]*srot2
        
         lxbxr = int(cx0-lbr*xmr1[0])
         lxbyr = int(cy0-lbr*zmr1[0])
         lybxr = int(cx0-lbr*xmr1[1])
         lybyr = int(cy0-lbr*zmr1[1])
         lzbxr = int(cx0-lbr*xmr1[2])
         lzbyr = int(cy0-lbr*zmr1[2])

         lxrxr = int(cx0-lrr*crot1)
         lxryr = int(cy0+lrr*srot1*srot2)
         lyrxr = int(cx0+lrr*srot1)
         lyryr = int(cy0+lrr*crot1*srot2)
         lzrxr = cx0
         lzryr = int(cy0-lrr*crot2)
    
      if outsys == 0:

         dcdr.SetPen(wx.Pen(col5, 2))
         dcdr.DrawLines(((lxbxr,lxbyr),(cx0,cy0)))
         dcdr.SetPen(wx.Pen(col6, 2))
         dcdr.DrawLines(((lybxr,lybyr),(cx0,cy0)))
         dcdr.SetPen(wx.Pen(col7, 2))
         dcdr.DrawLines(((lzbxr,lzbyr),(cx0,cy0)))

         dcdr.SetFont(font2)
         dcdr.SetTextForeground(col5) 
         dcdr.DrawText('X',lxbxr-15,lxbyr)
         dcdr.SetTextForeground(col6) 
         dcdr.DrawText('Y',lybxr+8,lybyr)
         dcdr.SetTextForeground(col7) 
         dcdr.DrawText('Z',lzbxr-15,lzbyr-15)

         dcdr.SetTextForeground(col1) 
         dcdr.SetFont(font2)
         dcdr.DrawText('x',lxaxr-12,lxayr-17)
         dcdr.DrawText('y',lyaxr+8,lyayr-17)
         dcdr.DrawText('z',lzaxr-12,lzayr-10)

         xh1 = lxrxr+lzrxr-cx0
         yh1 = lxryr+lzryr-cy0
         xh2 = lyrxr+lzrxr-cx0
         yh2 = lyryr+lzryr-cy0
         xh3 = lxrxr+lyrxr-cx0
         yh3 = lxryr+lyryr-cy0
         xh4 = xh1+xh3-lxrxr
         yh4 = yh1+yh3-lxryr

         dcdr.SetFont(font2)
         dcdr.SetTextForeground(coltr1) 
         dcdr.DrawText('around axis 1 =   '+str(alpout), int(0.5*wh), int(9*hver))
         dcdr.SetTextForeground(coltr2) 
         dcdr.DrawText('around axis 2 =   '+str(betout), int(0.5*wh), int(11*hver))
         dcdr.SetTextForeground(coltr3) 
         dcdr.DrawText('around axis 3 =   '+str(gamout), int(0.5*wh), int(13*hver))

         if outrot == 0:
          Mulrot(self,pro,rot)
          protr3 = rtemp[3]
          protr4 = rtemp[4]
          protr5 = rtemp[5]

         dcdr.SetPen(wx.Pen(col1, 2))

         if protr3 >0 and protr4 >0: dcdr.DrawLine(lzaxr,lzayr,cx0,cy0)
         if protr3 >0 and protr5 >0: dcdr.DrawLine(lyaxr,lyayr,cx0,cy0)
         if protr4 >0 and protr5 >0: dcdr.DrawLine(lxaxr,lxayr,cx0,cy0)

         if itransr == 0: trcol = wx.ALPHA_OPAQUE
         if itransr == 1: trcol = 128   

         dcdr.SetPen(wx.Pen(col2, 1)) 

         if protr3 >0:

           dcdr.SetBrush(wx.Brush(wx.Colour(205, 129, 98, trcol))) 
           dcdr.DrawPolygon([(xh1,yh1),(xh4,yh4),(xh3,yh3),(lxrxr,lxryr)])
         else:
           dcdr.SetBrush(wx.Brush(wx.Colour(122, 103, 238, trcol))) 
           dcdr.DrawPolygon([(lyrxr,lyryr),(xh2,yh2),(lzrxr,lzryr),(cx0,cy0)])

         if protr4 >0:
           dcdr.SetBrush(wx.Brush(wx.Colour(127, 255, 0, trcol)))  
           dcdr.DrawPolygon([(xh4,yh4),(xh3,yh3),(lyrxr,lyryr),(xh2,yh2)])
         else:
           dcdr.SetBrush(wx.Brush(wx.Colour(255, 215, 0, trcol)))
           dcdr.DrawPolygon([(lzrxr,lzryr),(cx0,cy0),(lxrxr,lxryr),(xh1,yh1)])

         if protr5 >0:
           dcdr.SetBrush(wx.Brush(wx.Colour(0, 0, 255, trcol))) 
           dcdr.DrawPolygon([(lzrxr,lzryr),(xh1,yh1),(xh4,yh4),(xh2,yh2)])
         else:
           dcdr.SetBrush(wx.Brush(wx.Colour(0, 197, 205, trcol)))
           dcdr.DrawPolygon([(cx0,cy0),(lxrxr,lxryr),(xh3,yh3),(lyrxr,lyryr)])

         dcdr.SetPen(wx.Pen(col1, 2))

         if protr3 <=0 or protr4 <=0: dcdr.DrawLine(lzaxr,lzayr,cx0,cy0)
         if protr3 <=0 or protr5 <=0: dcdr.DrawLine(lyaxr,lyayr,cx0,cy0)
         if protr4 <=0 or protr5 <=0: dcdr.DrawLine(lxaxr,lxayr,cx0,cy0)

      if outsys == 1:

         if alpout == 0 and betout == 0:

            if outpol == 0 or outpol == 1:  
              xp = 0.
              yp = 0.
              zp = rz
            if outpol == 2 or outpol == 3:  
              xp = rz
              yp = 0.
              zp = 0.
            if outpol == 4 or outpol == 5:  
              xp = 0.
              yp = rz
              zp = 0.  

            xp1 = xp*crot1-yp*srot1
            yp1 = xp*srot1+yp*crot1
            zp1 = zp*crot2-yp1*srot2   

         dcdr.SetPen(wx.Pen(col7, 1))
         dcdr.DrawCircle(cx0,cy0,lb)
         dcdr.DrawEllipse(cx0-lb,lyey,lb*2,(cy0-lyey)*2)

         dcdr.SetPen(wx.Pen(col7, 2))
         dcdr.DrawLines(((lxbxr,lxbyr),(cx0,cy0)))
         dcdr.DrawLines(((lybxr,lybyr),(cx0,cy0)))
         dcdr.DrawLines(((lzbxr,lzbyr),(cx0,cy0)))

         OnPaintOutPol(self,outpol,alpout,betout,gamout)
         lxpolr = lxpr
         lypolr = lypr
         lxpolr1 = lxpr1
         lypolr1 = lypr1
         lzenr = lznr
         lzenr1 = lznr1

         dcdr.SetPen(wx.Pen(col7, 1))
         dcdr.DrawCircle(cx0,cy0,lb)
         dcdr.DrawEllipse(cx0-lb,lyey,lb*2,(cy0-lyey)*2)

         dcdr.SetPen(wx.Pen(col3, 1))
         dcdr.DrawLines(((lxpolr,lypolr),(cx0,cy0)))

         dcdr.SetPen(wx.Pen(col5, 1))
         dcdr.DrawLines(((lxpolr1,lypolr1),(cx0,cy0)))

         dcdr.SetPen(wx.Pen(col7, 2))
         dcdr.DrawLines(((lxbxr,lxbyr),(cx0,cy0)))
         dcdr.DrawLines(((lybxr,lybyr),(cx0,cy0)))
         dcdr.DrawLines(((lzbxr,lzbyr),(cx0,cy0)))

         dcdr.SetFont(font2)
         dcdr.SetTextForeground(col3) 
         dcdr.DrawText('zenith = '+str(alpout), int(0.52*wh), int(9*hver))
         dcdr.SetTextForeground(col5) 
         dcdr.DrawText('azimuth = '+str(betout), int(0.52*wh), int(11*hver))
         dcdr.SetTextForeground(col1) 
         dcdr.DrawText('rotation = '+str(gamout), int(0.52*wh), int(13*hver))

         dcdr.SetPen(wx.Pen(col1, 2))

         dcdr.DrawLine(lxrxr,lxryr,cx0,cy0)
         dcdr.DrawLine(lyrxr,lyryr,cx0,cy0)
         dcdr.DrawLine(lzrxr,lzryr,cx0,cy0)

         dcdr.SetPen(wx.TRANSPARENT_PEN)

         dcdr.SetBrush(wx.Brush(wx.Colour(148, 0, 211, 128)))   # 128 == half transparent
         dcdr.DrawPolygon(lzenr)

         dcdr.SetBrush(wx.Brush(wx.Colour(0, 255, 0, 128)))   # 128 == half transparent
         dcdr.DrawPolygon(lzenr1)

         len1 = len(lzenr)
         dcdr.SetPen(wx.Pen(col3, 4))
         dcdr.DrawLine(lzenr[len1-1][0],lzenr[len1-1][1],cx0,cy0)

         dcdr.SetTextForeground(col1) 
         dcdr.SetFont(font2)
         dcdr.DrawText('x',lxrxr-12,lxryr-17)
         dcdr.DrawText('y',lyrxr+8,lyryr-17)
         dcdr.DrawText('z',lzrxr-12,lzryr-10)

         dcdr.SetTextForeground(col7) 
         dcdr.DrawText('X',lxbxr-15,lxbyr)
         dcdr.DrawText('Y',lybxr+8,lybyr)
         dcdr.DrawText('Z',lzbxr-15,lzbyr-15)

      if outsys == 2:

       cr1 = math.acos(float(alpout))
       cr2 = math.acos(float(betout))
       cr3 = math.acos(float(gamout))  
       cr4 = math.radians(float(kapout))   
  
       cx1,cy1 = int(cirxc+rcminc*alpout), int(ciryc-rcminc*math.sin(cr1))
       cx2,cy2 = int(cirxc+rcminc*betout), int(ciryc+3.5*hver-rcminc*math.sin(cr2))
       cx3,cy3 = int(cirxc+rcminc*gamout), int(ciryc+7*hver-rcminc*math.sin(cr3))
       cx4,cy4 = int(cirxc+rcminc*math.cos(cr4)), int(ciryc+10.5*hver-rcminc*math.sin(cr4))
       if outdirc == 1: cy4 = int(ciryc+12*hver+rcminc*math.sin(cr4))

       cr1 = math.degrees(cr1)
       cr2 = math.degrees(cr2)
       cr3 = math.degrees(cr3)
       cr1 = int(round(cr1))
       cr2 = int(round(cr2))
       cr3 = int(round(cr3))

       dcdr.SetPen(wx.Pen(col5, 2))
       dcdr.DrawLines(((lxbxr,lxbyr),(cx0,cy0)))
       dcdr.SetPen(wx.Pen(col6, 2))
       dcdr.DrawLines(((lybxr,lybyr),(cx0,cy0)))
       dcdr.SetPen(wx.Pen(col7, 2))
       dcdr.DrawLines(((lzbxr,lzbyr),(cx0,cy0)))

       dcdr.SetPen(wx.Pen(col1, 2))
       dcdr.DrawLines(((lxaxr,lxayr),(cx0,cy0)))
       dcdr.SetPen(wx.Pen(col1, 2))
       dcdr.DrawLines(((lyaxr,lyayr),(cx0,cy0)))
       dcdr.SetPen(wx.Pen(col1, 2))
       dcdr.DrawLines(((lzaxr,lzayr),(cx0,cy0)))

       dcdr.SetFont(font2)
       dcdr.SetTextForeground(col5) 
       dcdr.DrawText('X',lxbxr-15,lxbyr)
       dcdr.SetTextForeground(col6) 
       dcdr.DrawText('Y',lybxr+8,lybyr)
       dcdr.SetTextForeground(col7) 
       dcdr.DrawText('Z',lzbxr-15,lzbyr-15)

       dcdr.SetTextForeground(col1) 
       dcdr.SetFont(font2)
       dcdr.DrawText('x',lxaxr-12,lxayr-17)
       dcdr.DrawText('y',lyaxr+8,lyayr-17)
       dcdr.DrawText('z',lzaxr-12,lzayr-10)

       dcdr.SetFont(font3)

       dcdr.SetPen(wx.Pen(col5, 1))
       dcdr.DrawRectangle(cirxc-rcminc, int(ciryc-0.75*rcminc), int(1.5*rcminc), int(0.7*rcminc))
       dcdr.DrawRectangle(int(cirxc+0.5*rcminc), int(ciryc-0.75*rcminc), int(1.8*rcminc), int(0.7*rcminc))
       dcdr.SetTextForeground(col2) 
       dcdr.DrawText(("%5.3f" %alpout), cirxc-rcminc+10, int(ciryc-0.6*rcminc))
       dcdr.DrawText(str(cr1), int(cirxc+0.5*rcminc+15), int(ciryc-0.6*rcminc))

       dcdr.SetPen(wx.Pen(col6, 1))
       dcdr.DrawRectangle(cirxc-rcminc, int(ciryc+3.5*hver-0.75*rcminc), int(1.5*rcminc), int(0.7*rcminc))
       dcdr.DrawRectangle(int(cirxc+0.5*rcminc), int(ciryc+3.5*hver-0.75*rcminc), int(1.8*rcminc), int(0.7*rcminc))
       dcdr.SetTextForeground(col2) 
       dcdr.DrawText(("%5.3f" %betout), cirxc-rcminc+10, int(ciryc+3.5*hver-0.6*rcminc))
       dcdr.DrawText(str(cr2), int(cirxc+0.5*rcminc+15), int(ciryc+3.5*hver-0.6*rcminc))

       dcdr.SetPen(wx.Pen(col7, 1))
       dcdr.DrawRectangle(cirxc-rcminc, int(ciryc+7*hver-0.75*rcminc), int(1.5*rcminc), int(0.7*rcminc))
       dcdr.DrawRectangle(int(cirxc+0.5*rcminc), int(ciryc+7*hver-0.75*rcminc), int(1.8*rcminc), int(0.7*rcminc))
       dcdr.SetTextForeground(col2) 
       dcdr.DrawText("%5.3f" %(gamout), cirxc-rcminc+10, int(ciryc+7*hver-0.6*rcminc))
       dcdr.DrawText(str(cr3),int(cirxc+0.5*rcminc+15), int(ciryc+7*hver-0.6*rcminc))

       dcdr.SetPen(wx.Pen(col1, 1))
       dcdr.DrawRectangle(int(cirxc+0.5*rcminc), int(ciryc+10.5*hver-0.75*rcminc), int(1.8*rcminc), int(0.7*rcminc))
       dcdr.SetTextForeground(col2) 
       dcdr.DrawText(str(kapout), int(cirxc+0.5*rcminc+15), int(ciryc+10.5*hver-0.6*rcminc))

       OnPaintOutCos(self,alpout,betout,gamout)

       dcdr.SetPen(wx.TRANSPARENT_PEN)

       dcdr.SetBrush(wx.Brush(wx.Colour(0, 128, 0, 128)))   # 128 == half transparent
       dcdr.DrawPolygon(lznr)
       dcdr.SetPen(wx.Pen(col5, 1))
       dcdr.DrawLines(lznr)

       dcdr.SetBrush(wx.Brush(wx.Colour(255, 0, 255, 128)))   # 128 == half transparent
       dcdr.DrawPolygon(lznr1)
       dcdr.SetPen(wx.Pen(col6, 1))
       dcdr.DrawLines(lznr1)

       dcdr.SetBrush(wx.Brush(wx.Colour(0, 0, 255, 128)))   # 128 == half transparent
       dcdr.DrawPolygon(lznr2)
       dcdr.SetPen(wx.Pen(col7, 1))
       dcdr.DrawLines(lznr2)

       dcdr.SetPen(wx.Pen(col3, 4))
       dcdr.DrawLine(lxcr,lycr,cx0,cy0)

      if outsys == 4:

         sk2r = math.sqrt(1.-q0r*q0r)

         if sk2r != 0:
           cx = qxr/sk2r
           cy = qyr/sk2r
           cz = qzr/sk2r
         else:         
           cx = cy = cz = 0.

         lnl = int(cirxc+rcminc-cirx+rcmin)
         lnc = int(0.5*(cirx+cirxc+rcminc-rcmin))

         liml = int(lnc-0.5*sk2r*lnl)
         limp = int(lnc+0.5*sk2r*lnl)

         cx1,cy1 = int(lnc+0.5*lnl*qxr), int(ciryc)
         cx2,cy2 = int(lnc+0.5*lnl*qyr), int(ciryc+3.5*hver)
         cx3,cy3 = int(lnc+0.5*lnl*qzr), int(ciryc+7*hver)
         cx4,cy4 = int(lnc+0.5*lnl*q0r), int(ciryc+10.5*hver)

         dcdr.SetPen(wx.Pen(col5, 2))
         dcdr.DrawLines(((lxbxr,lxbyr),(cx0,cy0)))
         dcdr.SetPen(wx.Pen(col6, 2))
         dcdr.DrawLines(((lybxr,lybyr),(cx0,cy0)))
         dcdr.SetPen(wx.Pen(col7, 2))
         dcdr.DrawLines(((lzbxr,lzbyr),(cx0,cy0)))

         dcdr.SetPen(wx.Pen(col1, 2))
         dcdr.DrawLines(((lxaxr,lxayr),(cx0,cy0)))
         dcdr.SetPen(wx.Pen(col1, 2))
         dcdr.DrawLines(((lyaxr,lyayr),(cx0,cy0)))
         dcdr.SetPen(wx.Pen(col1, 2))
         dcdr.DrawLines(((lzaxr,lzayr),(cx0,cy0)))

         dcdr.SetFont(font2)
         dcdr.SetTextForeground(col5) 
         dcdr.DrawText('X',lxbxr-15,lxbyr)
         dcdr.SetTextForeground(col6) 
         dcdr.DrawText('Y',lybxr+8,lybyr)
         dcdr.SetTextForeground(col7) 
         dcdr.DrawText('Z',lzbxr-15,lzbyr-15)

         dcdr.SetTextForeground(col1) 
         dcdr.SetFont(font2)
         dcdr.DrawText('x',lxaxr-12,lxayr-17)
         dcdr.DrawText('y',lyaxr+8,lyayr-17)
         dcdr.DrawText('z',lzaxr-12,lzayr-10)

         dcdr.SetPen(wx.Pen(col5, 1))
         dcdr.DrawLine(cirxc+rcminc, int(ciryc-0.5*hver), cirx-rcmin, int(ciryc-0.5*hver)) 
         dcdr.SetPen(wx.Pen(col5, 3))
         dcdr.DrawLine(liml, int(ciryc-0.5*hver), limp, int(ciryc-0.5*hver)) 
         dcdr.SetTextForeground(col5)
         dcdr.DrawText(("%7.4f" %(-sk2r)), cirx-rcmin, int(ciryc-2*hver))
         dcdr.DrawText(("%7.4f" %(sk2r)), cirxc+rcminc-wt, int(ciryc-2*hver))
         dcdr.SetPen(wx.TRANSPARENT_PEN)
         dcdr.SetBrush(wx.Brush(col5))
         dcdr.SetPen(wx.Pen(col5, 1))
         dcdr.DrawCircle(cx1, int(ciryc-0.5*hver),4)
         dcdr.SetBrush(wx.Brush(col8))
         dcdr.SetPen(wx.Pen(col5, 1))
         dcdr.DrawRectangle(cirxc+rcminc+30, int(ciryc-0.75*rcminc), int(1.8*rcminc), int(0.7*rcminc))
         dcdr.SetTextForeground(col2) 
         dcdr.DrawText(("%7.4f" %qxr), cirxc+rcminc+40, int(ciryc-0.6*rcminc))
         dcdr.DrawLine(lnc, int(ciryc-0.1*hver), lnc, int(ciryc-0.9*hver)) 

         dcdr.SetBrush(wx.Brush(col8))
         dcdr.SetPen(wx.Pen(col6, 1))
         dcdr.DrawLine(cirxc+rcminc, int(ciryc+3*hver), cirx-rcmin, int(ciryc+3*hver)) 
         dcdr.SetPen(wx.Pen(col6, 3))
         dcdr.DrawLine(liml, int(ciryc+3*hver), limp, int(ciryc+3*hver))
         dcdr.SetTextForeground(col6)
         dcdr.DrawText(("%7.4f" %(-sk2r)), cirx-rcmin, int(ciryc+1.5*hver))
         dcdr.DrawText(("%7.4f" %(sk2r)), cirxc+rcminc-wt, int(ciryc+1.5*hver))
         dcdr.SetPen(wx.TRANSPARENT_PEN)
         dcdr.SetBrush(wx.Brush(col6))
         dcdr.DrawCircle(cx2, int(ciryc+3*hver),4)
         dcdr.SetBrush(wx.Brush(col8))
         dcdr.SetPen(wx.Pen(col6, 1))
         dcdr.DrawRectangle(cirxc+rcminc+30, int(ciryc+3.5*hver-0.75*rcminc), int(1.8*rcminc), int(0.7*rcminc))
         dcdr.SetTextForeground(col2) 
         dcdr.DrawText(("%7.4f" %qyr),cirxc+rcminc+40, int(ciryc+3.5*hver-0.6*rcminc))
         dcdr.DrawLine(lnc, int(ciryc+2.6*hver), lnc, int(ciryc+3.4*hver))

         dcdr.SetBrush(wx.Brush(col8))
         dcdr.SetPen(wx.Pen(col7, 1))
         dcdr.DrawLine(cirxc+rcminc, int(ciryc+6.5*hver),cirx-rcmin, int(ciryc+6.5*hver)) 
         dcdr.SetPen(wx.Pen(col7, 3))
         dcdr.DrawLine(liml, int(ciryc+6.5*hver), limp, int(ciryc+6.5*hver)) 
         dcdr.SetTextForeground(col7)
         dcdr.DrawText(("%7.4f" %(-sk2r)), cirx-rcmin, int(ciryc+5*hver))
         dcdr.DrawText(("%7.4f" %(sk2r)), cirxc+rcminc-wt, int(ciryc+5*hver)) 
         dcdr.SetPen(wx.TRANSPARENT_PEN)
         dcdr.SetBrush(wx.Brush(col7))
         dcdr.DrawCircle(cx3, int(ciryc+6.5*hver),4)
         dcdr.SetBrush(wx.Brush(col8))
         dcdr.SetPen(wx.Pen(col7, 1))
         dcdr.DrawRectangle(cirxc+rcminc+30, int(ciryc+7*hver-0.75*rcminc), int(1.8*rcminc), int(0.7*rcminc))
         dcdr.SetTextForeground(col2) 
         dcdr.DrawText(("%7.4f" %qzr), cirxc+rcminc+40, int(ciryc+7*hver-0.6*rcminc))
         dcdr.DrawLine(lnc, int(ciryc+6.1*hver), lnc, int(ciryc+6.9*hver))

         dcdr.SetBrush(wx.Brush(col8))
         dcdr.SetPen(wx.Pen(col1, 1))
         dcdr.DrawLine(cirxc+rcminc, int(ciryc+10*hver), cirx-rcmin, int(ciryc+10*hver)) 
         dcdr.SetPen(wx.TRANSPARENT_PEN)
         dcdr.SetBrush(wx.Brush(col1))
         dcdr.DrawCircle(cx4, int(ciryc+10*hver),4)
         dcdr.SetBrush(wx.Brush(col8))
         dcdr.SetPen(wx.Pen(col1, 1))
         dcdr.DrawRectangle(cirxc+rcminc+30, int(ciryc+10.5*hver-0.75*rcminc), int(1.8*rcminc), int(0.7*rcminc))
         dcdr.SetTextForeground(col2)
         dcdr.DrawText(("%7.4f" %q0r), cirxc+rcminc+40, int(ciryc+10.5*hver-0.6*rcminc)) 
         dcdr.DrawLine(cirx-rcmin, int(ciryc+9.6*hver), cirx-rcmin, int(ciryc+10.4*hver)) 
         dcdr.DrawLine(lnc, int(ciryc+9.6*hver), lnc, int(ciryc+10.4*hver)) 
         dcdr.DrawLine(cirxc+rcminc, int(ciryc+9.6*hver), int(cirxc+rcminc), int(ciryc+10.4*hver)) 
         dcdr.DrawText("-1",cirx-rcmin-5, int(ciryc+10.5*hver)) 
         dcdr.DrawText("0",lnc-3, int(ciryc+10.5*hver)) 
         dcdr.DrawText("1",cirxc+rcminc-3, int(ciryc+10.5*hver)) 

         OnPaintOutCos(self,cx,cy,cz)

         dcdr.SetPen(wx.TRANSPARENT_PEN)

         dcdr.SetBrush(wx.Brush(wx.Colour(0, 128, 0, 128)))   # 128 == half transparent
         dcdr.DrawPolygon(lznr)
         dcdr.SetPen(wx.Pen(col5, 1))
         dcdr.DrawLines(lznr)

         dcdr.SetBrush(wx.Brush(wx.Colour(255, 0, 255, 128)))   # 128 == half transparent
         dcdr.DrawPolygon(lznr1)
         dcdr.SetPen(wx.Pen(col6, 1))
         dcdr.DrawLines(lznr1)

         dcdr.SetBrush(wx.Brush(wx.Colour(0, 0, 255, 128)))   # 128 == half transparent
         dcdr.DrawPolygon(lznr2)
         dcdr.SetPen(wx.Pen(col7, 1))
         dcdr.DrawLines(lznr2)

         dcdr.SetPen(wx.Pen(col3, 2))
         dcdr.DrawLine(lxcr,lycr,cx0,cy0)  
         dcdr.SetPen(wx.Pen(col3, 4))
         dcdr.DrawLine(lxc1,lyc1,cx0,cy0)      

#-----------------------------------------------------
#  Change transparency

    def ChangeTransr(self, event):
       global itransr

       id = event.GetId()

       if id == 3: itransr = 0
       if id == 4: itransr = 1

       dpanelr.Refresh()
   
#-----------------------------------------------------
# Close output demo window

    def OnCloseDemor(self, evt):

        if demowinr : demowinr.Destroy()

#-------------------------------------
# Help: parameters transformation

class Help_Trans(wx.Frame):
    def __init__(self, parent) :

       dc = wx.ScreenDC()
       dc.SetFont(font5)
       wh, hh = dc.GetTextExtent("1.xxxxxxxxChooseXinputxandxoutputxconventionsxbyxpressxcorrespondingxradioxbuttons")
       whc, hhc = dc.GetTextExtent("Close") 

       wx.Frame.__init__(self, None, -1, title= 'HELP: parameters and coordinates transformation', pos=(wpp2, int(100*hpar)), size=(wh, hh*34))

       self.scroll = scroll = wx.ScrolledWindow(self,-1)
       scroll.SetBackgroundColour(col8)

       st=wx.StaticText(scroll, -1, 
           "\n  I. Main protocol: transform rotation parameters from one convention to another\n"
           "       1.     Choose input and output conventions in left and right pages:\n"
           "                - Selecting a particular program fixes the convention automatically\n"
           "                - Selecting N/A in 'programs' allows a manual selection of conventions\n"
           "       2.     Define input rotation parameters:\n"
           "                 - type angles, or cosines or matrix elements respecting their order\n"
           "                   (e.g. 1-2-3 for Euler angles or z-a for polar); copy-paste can be used\n"
           "                 - choose these values from a text file\n"
           "       3.     Press virtual button 'transform parameters'\n"
           "\n  II. Options\n"
           "       1.     Convert a list of parameters:\n"
           "                 - parameters should be given line by line, either entered directly\n"
           "                   or defined in the file; neither other characters nor separators used\n"
           "       2.     Modify the orthogonalisation convention:\n"
           "                 - choose additionally respective conventions\n"
           "       3.     Calculate symmetry related rotation parameters:\n"
           "                 - define input and output orthogonalisation conventions\n"
           "                 - type unit cell parameters and select space group\n"
           "                 - press virtual button 'transform parameters'\n"
           "       4.     Transform coordinates:\n"
           "                 - get output rotation parameters and press 'transform coordinates;'\n"
           "                   resulted rotation matrix will be inserted automatically\n"
           "                 - define the translation vector\n"
           "                 - define input and output files with the model and run the program\n"
           "                 Alternatively, one can press directly 'transform coordinates'\n"
           "                 and fill in all information required\n", pos = (0,0))
 
       st.SetFont(font5)
       self.unit=20
       (width,height) = st.GetSize()
       scroll.SetScrollbars(0, self.unit, 0, int(height/self.unit)) 

       closh = self.closh = wx.Button(self.scroll, -1, "Close", (int((wh-(whc+20))/2), hh*30), (whc+20, int(1.5*hver)))
       closh.SetFont(font5)
       closh.SetBackgroundColour(col4) 
       self.Bind(wx.EVT_BUTTON, self.OnCloseHelpp, closh)
       self.Bind(wx.EVT_CLOSE, self.OnCloseHelpp)  
 
       self.Show()

#-----------------------------------------------------
# Close window

    def OnCloseHelpp(self, evt):

        if helpwin : helpwin.Destroy()
       
#-------------------------------------
def Mrot(self,ang1,ang2,ang3): 
      global rot, kappa

# Euler
      if insys == 0:

        alp=ang1*grrad
        bet=ang2*grrad
        gam=ang3*grrad

        labincon = lax12[incon].strip()
        labindir = lrot8[indir].strip()

        if inrot == 0 and inaxes == 1:
          alp=ang3*grrad
          bet=ang2*grrad
          gam=ang1*grrad

        if inrot == 1 and inaxes == 1:
          alp=-ang1*grrad
          bet=-ang2*grrad
          gam=-ang3*grrad

        if inrot == 1 or inaxes == 0:

         if labindir[0] == 'c': alp = -alp
         if labindir[1] == 'c': bet = -bet
         if labindir[2] == 'c': gam = -gam

        if inrot == 0 and inaxes == 1:

         if labindir[2] == 'c': alp = -alp
         if labindir[1] == 'c': bet = -bet
         if labindir[0] == 'c': gam = -gam

        calp = math.cos(alp)
        salp = math.sin(alp)
        cbet = math.cos(bet)
        sbet = math.sin(bet)
        cgam = math.cos(gam)
        sgam = math.sin(gam)

# XYX
        if labincon == 'xyx': MrotXYX(self,calp,salp,cbet,sbet,cgam,sgam)
# YZY
        if labincon == 'yzy': MrotYZY(self,calp,salp,cbet,sbet,cgam,sgam)
# ZXZ
        if labincon == 'zxz': MrotZXZ(self,calp,salp,cbet,sbet,cgam,sgam)
# XZX
        if labincon == 'xzx': MrotXZX(self,calp,salp,cbet,sbet,cgam,sgam)
# YXY
        if labincon == 'yxy': MrotYXY(self,calp,salp,cbet,sbet,cgam,sgam)
# ZYZ
        if labincon == 'zyz': MrotZYZ(self,calp,salp,cbet,sbet,cgam,sgam)

# XYZ
        if labincon == 'xyz': 
          if inaxes == 0 or inrot == 1: MrotXYZ(self,calp,salp,cbet,sbet,cgam,sgam)
          else: MrotZYX(self,calp,salp,cbet,sbet,cgam,sgam)
# YZX
        if labincon == 'yzx': 
          if inaxes == 0 or inrot == 1: MrotYZX(self,calp,salp,cbet,sbet,cgam,sgam)
          else: MrotXZY(self,calp,salp,cbet,sbet,cgam,sgam)
# ZXY
        if labincon == 'zxy': 
          if inaxes == 0 or inrot == 1: MrotZXY(self,calp,salp,cbet,sbet,cgam,sgam)
          else: MrotYXZ(self,calp,salp,cbet,sbet,cgam,sgam)
# XZY
        if labincon == 'xzy': 
          if inaxes == 0 or inrot == 1: MrotXZY(self,calp,salp,cbet,sbet,cgam,sgam)
          else: MrotYZX(self,calp,salp,cbet,sbet,cgam,sgam)
# YXZ
        if labincon == 'yxz': 
          if inaxes == 0 or inrot == 1: MrotYXZ(self,calp,salp,cbet,sbet,cgam,sgam)
          else: MrotZXY(self,calp,salp,cbet,sbet,cgam,sgam)
# ZYX
        if labincon == 'zyx': 
          if inaxes == 0 or inrot == 1: MrotZYX(self,calp,salp,cbet,sbet,cgam,sgam) 
          else: MrotXYZ(self,calp,salp,cbet,sbet,cgam,sgam)      

# polar

      if insys == 1:

        if inrot == 1: ang3 = -ang3

        labindirp = lrotp4[indirp].strip()

        if labindirp[0] == 'c': ang2 = -ang2
        if labindirp[1] == 'c': ang3 = -ang3

        if inpol == 0 or inpol == 2 or inpol == 4: 
         the=ang1*grrad
         phi=ang2*grrad
         kap=ang3*grrad

        if inpol == 1 or inpol == 3 or inpol == 5:
         the=ang1*grrad
         phi=(ang2+90.)*grrad
         kap=ang3*grrad

        cthe = math.cos(the)
        sthe = math.sin(the)
        cphi = math.cos(phi)
        sphi = math.sin(phi)
        ckap = math.cos(kap)
        skap = math.sin(kap)

# ZX, ZY 
        if inpol == 0 or inpol == 1: MpolZX_ZY(self,cthe,sthe,cphi,sphi,ckap,skap)
# XY, XZ 
        if inpol == 2 or inpol == 3: MpolXY_XZ(self,cthe,sthe,cphi,sphi,ckap,skap)
# YZ, YX 
        if inpol == 4 or inpol == 5: MpolYZ_YX(self,cthe,sthe,cphi,sphi,ckap,skap)

# cos
      if insys == 2:

        cx = ang1
        cy = ang2
        cz = ang3

        if inrot == 1: kappa = -kappa
        if indirc == 1: kappa = -kappa
         
        kr =kappa*grrad
        ck =math.cos(kr)
        sk =math.sin(kr)

        rot[0]= cx*cx*(1-ck)+ck 
        rot[1]= cx*cy*(1-ck)-cz*sk
        rot[2]= cx*cz*(1-ck)+cy*sk
        rot[3]= cx*cy*(1-ck)+cz*sk 
        rot[4]= cy*cy*(1-ck)+ck
        rot[5]= cy*cz*(1-ck)-cx*sk
        rot[6]= cx*cz*(1-ck)-cy*sk
        rot[7]= cy*cz*(1-ck)+cx*sk
        rot[8]= cz*cz*(1-ck)+ck

#-------------------------------------
def MQrot(self,ang1,ang2,ang3,ang4): 
      global rot

# quaternions 

      if insys == 4:

        if inrot == 1: 
          ang1 = -ang1
          ang2 = -ang2
          ang3 = -ang3
        if indirc == 1:
          ang1 = -ang1
          ang2 = -ang2
          ang3 = -ang3

        rot[0]= ang4*ang4+ang1*ang1-ang2*ang2-ang3*ang3
        rot[1]= 2*(ang1*ang2-ang3*ang4)
        rot[2]= 2*(ang1*ang3+ang2*ang4)
        rot[3]= 2*(ang1*ang2+ang3*ang4) 
        rot[4]= ang4*ang4-ang1*ang1+ang2*ang2-ang3*ang3
        rot[5]= 2*(ang2*ang3-ang1*ang4)
        rot[6]= 2*(ang1*ang3-ang2*ang4)
        rot[7]= 2*(ang2*ang3+ang1*ang4)
        rot[8]= ang4*ang4-ang1*ang1-ang2*ang2+ang3*ang3

#-------------------------------------
# multiplication 2 matrices 3*3 : r3=r1*r2

def Mulrot(self, r1, r2): 
       global rtemp
       
       rtemp = [0 for i in range(9)]

       rtemp[0]=r1[0]*r2[0]+r1[1]*r2[3]+r1[2]*r2[6]
       rtemp[1]=r1[0]*r2[1]+r1[1]*r2[4]+r1[2]*r2[7]
       rtemp[2]=r1[0]*r2[2]+r1[1]*r2[5]+r1[2]*r2[8]
       rtemp[3]=r1[3]*r2[0]+r1[4]*r2[3]+r1[5]*r2[6]
       rtemp[4]=r1[3]*r2[1]+r1[4]*r2[4]+r1[5]*r2[7]
       rtemp[5]=r1[3]*r2[2]+r1[4]*r2[5]+r1[5]*r2[8]
       rtemp[6]=r1[6]*r2[0]+r1[7]*r2[3]+r1[8]*r2[6]
       rtemp[7]=r1[6]*r2[1]+r1[7]*r2[4]+r1[8]*r2[7]
       rtemp[8]=r1[6]*r2[2]+r1[7]*r2[5]+r1[8]*r2[8]

#-------------------------------------
def MrotZYZ(self,calp,salp,cbet,sbet,cgam,sgam): 

         rot[0]= calp*cbet*cgam-salp*sgam
         rot[1]=-salp*cbet*cgam-calp*sgam
         rot[2]= sbet*cgam
         rot[3]= calp*cbet*sgam+salp*cgam
         rot[4]=-salp*cbet*sgam+calp*cgam
         rot[5]= sbet*sgam
         rot[6]=-calp*sbet
         rot[7]= salp*sbet
         rot[8]= cbet

         return rot

#-------------------------------------
def MrotZXZ(self,calp,salp,cbet,sbet,cgam,sgam):

         rot[0]= calp*cgam-salp*cbet*sgam
         rot[1]=-salp*cgam-calp*cbet*sgam
         rot[2]= sbet*sgam
         rot[3]= calp*sgam+salp*cbet*cgam
         rot[4]=-salp*sgam+calp*cbet*cgam
         rot[5]=-sbet*cgam
         rot[6]= salp*sbet
         rot[7]= calp*sbet
         rot[8]= cbet

         return rot

#-------------------------------------
def MrotZYX(self,calp,salp,cbet,sbet,cgam,sgam):

         rot[0]= calp*cbet
         rot[1]=-salp*cbet
         rot[2]= sbet
         rot[3]= salp*cgam+calp*sbet*sgam
         rot[4]= calp*cgam-salp*sbet*sgam
         rot[5]=-cbet*sgam
         rot[6]= salp*sgam-calp*sbet*cgam
         rot[7]= calp*sgam+salp*sbet*cgam
         rot[8]= cbet*cgam

         return rot

#-------------------------------------
def MrotZXY(self,calp,salp,cbet,sbet,cgam,sgam):

         rot[0]= calp*cgam+salp*sbet*sgam
         rot[1]=-salp*cgam+calp*sbet*sgam
         rot[2]= cbet*sgam
         rot[3]= salp*cbet
         rot[4]= calp*cbet
         rot[5]=-sbet
         rot[6]=-calp*sgam+salp*sbet*cgam
         rot[7]= salp*sgam+calp*sbet*cgam
         rot[8]= cbet*cgam

         return rot

#-------------------------------------
def MrotXZX(self,calp,salp,cbet,sbet,cgam,sgam):

         rot[0]= cbet
         rot[1]=-calp*sbet
         rot[2]= salp*sbet
         rot[3]= sbet*cgam
         rot[4]= calp*cbet*cgam-salp*sgam
         rot[5]=-salp*cbet*cgam-calp*sgam
         rot[6]= sbet*sgam
         rot[7]= calp*cbet*sgam+salp*cgam
         rot[8]=-salp*cbet*sgam+calp*cgam

         return rot

#-------------------------------------
def MrotXYX(self,calp,salp,cbet,sbet,cgam,sgam):

         rot[0]= cbet
         rot[1]= salp*sbet
         rot[2]= calp*sbet
         rot[3]= sbet*sgam
         rot[4]= calp*cgam-salp*cbet*sgam
         rot[5]=-salp*cgam-calp*cbet*sgam
         rot[6]=-sbet*cgam
         rot[7]= calp*sgam+salp*cbet*cgam
         rot[8]=-salp*sgam+calp*cbet*cgam

         return rot

#-------------------------------------
def MrotXYZ(self,calp,salp,cbet,sbet,cgam,sgam):

         rot[0]= cbet*cgam
         rot[1]= salp*sbet*cgam-calp*sgam
         rot[2]= calp*sbet*cgam+salp*sgam
         rot[3]= cbet*sgam
         rot[4]= salp*sbet*sgam+calp*cgam
         rot[5]= calp*sbet*sgam-salp*cgam
         rot[6]=-sbet
         rot[7]= salp*cbet
         rot[8]= calp*cbet

         return rot

#-------------------------------------
def MrotXZY(self,calp,salp,cbet,sbet,cgam,sgam):

         rot[0]= cbet*cgam
         rot[1]=-calp*sbet*cgam+salp*sgam
         rot[2]= salp*sbet*cgam+calp*sgam
         rot[3]= sbet
         rot[4]= calp*cbet
         rot[5]=-salp*cbet
         rot[6]=-cbet*sgam
         rot[7]= calp*sbet*sgam+salp*cgam
         rot[8]=-salp*sbet*sgam+calp*cgam

         return rot

#-------------------------------------
def MrotYXY(self,calp,salp,cbet,sbet,cgam,sgam):

         rot[0]= calp*cgam-salp*cbet*sgam
         rot[1]= sbet*sgam
         rot[2]= salp*cgam+calp*cbet*sgam
         rot[3]= salp*sbet
         rot[4]= cbet
         rot[5]=-calp*sbet
         rot[6]=-calp*sgam-salp*cbet*cgam
         rot[7]= sbet*cgam
         rot[8]=-salp*sgam+calp*cbet*cgam

         return rot

#-------------------------------------
def MrotYZY(self,calp,salp,cbet,sbet,cgam,sgam):

         rot[0]= calp*cbet*cgam-salp*sgam
         rot[1]=-sbet*cgam
         rot[2]= salp*cbet*cgam+calp*sgam
         rot[3]= calp*sbet
         rot[4]= cbet
         rot[5]= salp*sbet
         rot[6]=-calp*cbet*sgam-salp*cgam
         rot[7]= sbet*sgam
         rot[8]=-salp*cbet*sgam+calp*cgam

         return rot

#-------------------------------------
def MrotYXZ(self,calp,salp,cbet,sbet,cgam,sgam):

         rot[0]= calp*cgam-salp*sbet*sgam
         rot[1]=-cbet*sgam
         rot[2]= salp*cgam+calp*sbet*sgam
         rot[3]= calp*sgam+salp*sbet*cgam
         rot[4]= cbet*cgam
         rot[5]= salp*sgam-calp*sbet*cgam
         rot[6]=-salp*cbet
         rot[7]= sbet
         rot[8]= calp*cbet

         return rot

#-------------------------------------
def MrotYZX(self,calp,salp,cbet,sbet,cgam,sgam):

         rot[0]= calp*cbet
         rot[1]=-sbet
         rot[2]= salp*cbet
         rot[3]= calp*sbet*cgam+salp*sgam
         rot[4]= cbet*cgam
         rot[5]= salp*sbet*cgam-calp*sgam
         rot[6]= calp*sbet*sgam-salp*cgam
         rot[7]= cbet*sgam
         rot[8]= salp*sbet*sgam+calp*cgam

         return rot

#-------------------------------------
def MpolZX_ZY(self,cthe,sthe,cphi,sphi,ckap,skap):

         rot[0]= sthe*sthe*cphi*cphi*(1-ckap)+ckap   
         rot[1]= sthe*sthe*sphi*cphi*(1-ckap)-cthe*skap
         rot[2]= sthe*cthe*cphi*(1-ckap)+sthe*sphi*skap
         rot[3]= sthe*sthe*sphi*cphi*(1-ckap)+cthe*skap
         rot[4]= sthe*sthe*sphi*sphi*(1-ckap)+ckap
         rot[5]= sthe*cthe*sphi*(1-ckap)-sthe*cphi*skap
         rot[6]= sthe*cthe*cphi*(1-ckap)-sthe*sphi*skap
         rot[7]= sthe*cthe*sphi*(1-ckap)+sthe*cphi*skap
         rot[8]= cthe*cthe*(1-ckap)+ckap

         return rot

#-------------------------------------
def MpolXY_XZ(self,cthe,sthe,cphi,sphi,ckap,skap):

         rot[0]= cthe*cthe*(1-ckap)+ckap   
         rot[1]= sthe*cthe*cphi*(1-ckap)-sthe*sphi*skap
         rot[2]= sthe*cthe*sphi*(1-ckap)+sthe*cphi*skap
         rot[3]= sthe*cthe*cphi*(1-ckap)+sthe*sphi*skap
         rot[4]= sthe*sthe*cphi*cphi*(1-ckap)+ckap
         rot[5]= sthe*sthe*sphi*cphi*(1-ckap)-cthe*skap
         rot[6]= sthe*cthe*sphi*(1-ckap)-sthe*cphi*skap
         rot[7]= sthe*sthe*sphi*cphi*(1-ckap)+cthe*skap
         rot[8]= sthe*sthe*sphi*sphi*(1-ckap)+ckap
   
         return rot

#-------------------------------------
def MpolYZ_YX(self,cthe,sthe,cphi,sphi,ckap,skap):

         rot[0]= sthe*sthe*sphi*sphi*(1-ckap)+ckap   
         rot[1]= sthe*cthe*sphi*(1-ckap)-sthe*cphi*skap
         rot[2]= sthe*sthe*sphi*cphi*(1-ckap)+cthe*skap
         rot[3]= sthe*cthe*sphi*(1-ckap)+sthe*cphi*skap
         rot[4]= cthe*cthe*(1-ckap)+ckap
         rot[5]= sthe*cthe*cphi*(1-ckap)-sthe*sphi*skap
         rot[6]= sthe*sthe*sphi*cphi*(1-ckap)-cthe*skap
         rot[7]= sthe*cthe*cphi*(1-ckap)+sthe*sphi*skap
         rot[8]= sthe*sthe*cphi*cphi*(1-ckap)+ckap

         return rot

#-------------------------------------
def OnPaintInit(self):
       global wh, hh, cx0, cy0, cirx, ciry, rcmin, cx1, cy1, cx2, cy2, cx3, cy3, cscx1, cscx2, cscy1, cscy2
       global lr, la, lb, lc, ld, aview, lrr, lbr, pro, srotz, crotz, srotx, crotx, sroty, croty, cr1, cr2, cr3
       global lstet, lctet, lsphi, lcphi, lyey, rz
       global limx1, limx2, limy1, limy2, srot1, crot1, srot2, crot2
       global cirxc, ciryc, rcminc

       wh = int(0.5*wd)
       hh = int(0.6*hd)

       cx0 = int(wh/4.)
       cy0 = int(16*hver)

       la = int(7.5*hver)
       lr = int(4*hver)
       lb = int(9.5*hver)
       lc = int(6*hver)
       ld = int(5*hver)    

       rz = int(5.2*hver)

       aview = lb

       if insys == 1: 
         lr = int(6*hver)
         lb = int(8*hver)
       if lb >= cx0: 
          lb = int(lb-abs(lb-cx0)-20)
          lr = int(0.75*lb)

       lrr = int(4*hver)
       lbr = int(9.5*hver)
       if outsys == 1: 
         lrr = int(6*hver)
         lbr = int(8*hver)
       if lbr >= cx0: 
          lbr = int(lbr-abs(lbr-cx0)-20)
          lbr = int(0.75*lbr)

       cirx = int(0.6*wh)
       ciry = int(13*hver)
       rcmin = int(0.033*wh)

       dc = wx.ScreenDC()
       dc.SetFont(font2)

       wdc, hdc = dc.GetTextExtent('cosine values to x')

       cirxc = int(cirx-rcmin+wdc)
       ciryc = int(10*hver)
       rcminc = int(0.05*wh)

       if cang1 == 0 and cang2 == 0 and cang3 == 0: 

        cx1, cy1 = int(cirx+rcmin), ciry
        cx2, cy2 = int(cirx+2*rcmin), ciry
        cx3, cy3 = int(cirx+3*rcmin), ciry
     
       limx1, limx2 = int(cirx-3*rcmin-40), int(cirx+3*rcmin+40)
       limy1, limy2 = int(ciry-3*rcmin-30), int(ciry+3*rcmin+30)

       cscx1, cscx2 = int(cirx-3*rcmin+50), int(cirx+50)
       cscy1, cscy2 = int(hh-7*hver-10), int(hh-7*hver+10)

       lyey = int(cy0-0.5*lb)

       rot45 = math.radians(45)
       rot30 = math.radians(30)

       srot1 = math.sin(rot45)
       crot1 = math.cos(rot45)
       srot2 = math.sin(rot30)
       crot2 = math.cos(rot30)

       rotd1 = math.radians(rotz)
       rotd2 = math.radians(rotx)
       rotd3 = math.radians(roty)

       srotz = math.sin(rotd1)
       crotz = math.cos(rotd1)
       srotx = math.sin(rotd2)
       crotx = math.cos(rotd2)
       sroty = math.sin(rotd3)
       croty = math.cos(rotd3)

       pro[0]= srotz*srotx*sroty+crotz*croty
       pro[1]= crotz*srotx*sroty-srotz*croty
       pro[2]= crotx*sroty
       pro[3]= srotz*crotx
       pro[4]= crotz*crotx
       pro[5]= -srotx
       pro[6]= srotz*srotx*croty-crotz*sroty
       pro[7]= crotz*srotx*croty+srotz*sroty
       pro[8]= crotx*croty

       lstet, lctet = [], []
       lsphi, lcphi = [], []

       for iang in range(181):

           tet = math.radians(iang)
           stet = math.sin(tet)
           ctet = math.cos(tet)
           lstet.append(stet)
           lctet.append(ctet)

       for iang in range(361):
           phi = math.radians(iang)
           sphi = math.sin(phi)
           cphi = math.cos(phi) 
           lsphi.append(sphi)
           lcphi.append(cphi)

       cr1 = int((rcmin*lcphi[0])**2+(rcmin*lsphi[0])**2)
       cr2 = int((2*rcmin*lcphi[0])**2+(2*rcmin*lsphi[0])**2)
       cr3 = int((3*rcmin*lcphi[0])**2+(3*rcmin*lsphi[0])**2)

#-------------------------------------
def OnPaintInPol(self,npol,an1,an2,an3):
         global lxp, lyp, lxp1, lyp1, lzn, lzn1

         if inrot == 1: an3 = -an3

         labindirp = lrotp4[indirp].strip()

         if labindirp[0] == 'c': an2 = -an2
         if labindirp[1] == 'c': an3 = -an3

         ii = int(an1)
         jj = int(an2)
         if an2 < 0 : jj = int(360+an2)

         ra = rz*lstet[ii]

         lzn, lzn1 = [(cx0, cy0)], [(cx0, cy0)]

         for i in range(ii+1):

             rp1 = rz*lstet[i]*lcphi[jj]
             rp2 = rz*lstet[i]*lsphi[jj]
             rp3 = rz*lctet[i]

             if npol == 0: 
              xp = rp1
              yp = rp2
              zp = rp3
             if npol == 1:  
              xp = -rp2
              yp = rp1
              zp = rp3
             if npol == 2: 
              xp = rp3
              yp = rp1
              zp = rp2
             if npol == 3: 
              xp = rp3
              yp = -rp2
              zp = rp1
             if npol == 4: 
              xp = rp2
              yp = rp3
              zp = rp1
             if npol == 5: 
              xp = rp1
              yp = rp3
              zp = -rp2   

             if inrot == 1:  

              xpt = xp   
              ypt = yp
              zpt = zp

              xp = rots[0]*xpt+rots[3]*ypt+rots[6]*zpt
              yp = rots[1]*xpt+rots[4]*ypt+rots[7]*zpt
              zp = rots[2]*xpt+rots[5]*ypt+rots[8]*zpt

             xp1 = xp*pro[0]+yp*pro[1]+zp*pro[2]
             yp1 = xp*pro[3]+yp*pro[4]+zp*pro[5]
             zp1 = xp*pro[6]+yp*pro[7]+zp*pro[8]  
   
             lxp = int(cx0-xp1)
             lyp = int(cy0-zp1)    

             lzn.append((lxp,lyp))

         for j in range(jj+1):

           ra1 = ra*lcphi[j]
           ra2 = ra*lsphi[j]
           ra3 = 0

           if npol == 0: 
              xp = ra1
              yp = ra2
              zp = ra3
           if npol == 1:  
              xp = -ra2
              yp = ra1
              zp = ra3
           if npol == 2: 
              xp = ra3
              yp = ra1
              zp = ra2
           if npol == 3: 
              xp = ra3
              yp = -ra2
              zp = ra1
           if npol == 4: 
              xp = ra2
              yp = ra3
              zp = ra1
           if npol == 5: 
              xp = ra1
              yp = ra3
              zp = -ra2

           if inrot == 1:     

              xpt = xp   
              ypt = yp
              zpt = zp

              xp = rots[0]*xpt+rots[3]*ypt+rots[6]*zpt
              yp = rots[1]*xpt+rots[4]*ypt+rots[7]*zpt
              zp = rots[2]*xpt+rots[5]*ypt+rots[8]*zpt

           xp1 = xp*pro[0]+yp*pro[1]+zp*pro[2]
           yp1 = xp*pro[3]+yp*pro[4]+zp*pro[5]
           zp1 = xp*pro[6]+yp*pro[7]+zp*pro[8]  

           lxp1 = int(cx0-xp1)
           lyp1 = int(cy0-zp1)  
 
           lzn1.append((lxp1,lyp1))

#-------------------------------------
def OnPaintOutPol(self,npol,an1,an2,an3):
         global lxpr, lypr, lxpr1, lypr1, lznr, lznr1


         if outrot == 1: an3 = -an3

         laboutdirp = lrotp4[outdirp].strip()

         if laboutdirp[0] == 'c': an2 = -an2
         if laboutdirp[1] == 'c': an3 = -an3

         ii = int(an1)
         jj = int(an2)
         if an2 < 0 : jj = int(360+an2)

         ra = rz*lstet[ii]

         lznr, lznr1 = [(cx0, cy0)], [(cx0, cy0)]

         for i in range(ii+1):

             rp1 = rz*lstet[i]*lcphi[jj]
             rp2 = rz*lstet[i]*lsphi[jj]
             rp3 = rz*lctet[i]

             if npol == 0: 
              xp = rp1
              yp = rp2
              zp = rp3
             if npol == 1:  
              xp = -rp2
              yp = rp1
              zp = rp3
             if npol == 2: 
              xp = rp3
              yp = rp1
              zp = rp2
             if npol == 3: 
              xp = rp3
              yp = -rp2
              zp = rp1
             if npol == 4: 
              xp = rp2
              yp = rp3
              zp = rp1
             if npol == 5: 
              xp = rp1
              yp = rp3
              zp = -rp2   

             if outrot == 1:  

              xpt = xp   
              ypt = yp
              zpt = zp

              xp = rots[0]*xpt+rots[3]*ypt+rots[6]*zpt
              yp = rots[1]*xpt+rots[4]*ypt+rots[7]*zpt
              zp = rots[2]*xpt+rots[5]*ypt+rots[8]*zpt

             xp1 = xp*pro[0]+yp*pro[1]+zp*pro[2]
             yp1 = xp*pro[3]+yp*pro[4]+zp*pro[5]
             zp1 = xp*pro[6]+yp*pro[7]+zp*pro[8]  
   
             lxpr = int(cx0-xp1)
             lypr = int(cy0-zp1)    

             lznr.append((lxpr,lypr))

         for j in range(jj+1):

           ra1 = ra*lcphi[j]
           ra2 = ra*lsphi[j]
           ra3 = 0

           if npol == 0: 
              xp = ra1
              yp = ra2
              zp = ra3
           if npol == 1:  
              xp = -ra2
              yp = ra1
              zp = ra3
           if npol == 2: 
              xp = ra3
              yp = ra1
              zp = ra2
           if npol == 3: 
              xp = ra3
              yp = -ra2
              zp = ra1
           if npol == 4: 
              xp = ra2
              yp = ra3
              zp = ra1
           if npol == 5: 
              xp = ra1
              yp = ra3
              zp = -ra2

           if outrot == 1:     

              xpt = xp   
              ypt = yp
              zpt = zp

              xp = rots[0]*xpt+rots[3]*ypt+rots[6]*zpt
              yp = rots[1]*xpt+rots[4]*ypt+rots[7]*zpt
              zp = rots[2]*xpt+rots[5]*ypt+rots[8]*zpt

           xp1 = xp*pro[0]+yp*pro[1]+zp*pro[2]
           yp1 = xp*pro[3]+yp*pro[4]+zp*pro[5]
           zp1 = xp*pro[6]+yp*pro[7]+zp*pro[8]  

           lxpr1 = int(cx0-xp1)
           lypr1 = int(cy0-zp1)  
 
           lznr1.append((lxpr1,lypr1))

#-------------------------------------
def OnPaintInCos(self,an1,an2,an3):
         global lxc, lyc, lxc1, lyc1, lzn, lzn1, lzn2

         if inrot == 1: an3 = -float(an3)

         if an1 > 1.0: an1 = 1.0
         if an1 < -1.0: an1 = -1.0
         if an2 > 1.0: an2 = 1.0
         if an2 < -1.0: an2 = -1.0
         if an3 > 1.0: an3 = 1.0
         if an3 < -1.0: an3 = -1.0
 
         ii = int(math.degrees(math.acos(an1)))
         jj = int(math.degrees(math.acos(an2)))
         kk = int(math.degrees(math.acos(an3)))

         lzn, lzn1, lzn2 = [(cx0,cy0)], [(cx0,cy0)], [(cx0,cy0)]

         if insys == 2:
          xp = lc*an1
          yp = lc*an2
          zp = lc*an3   
 
         if insys == 4:
          xp = lc*tsk2*an1
          yp = lc*tsk2*an2
          zp = lc*tsk2*an3

          xpq = lc*an1
          ypq = lc*an2
          zpq = lc*an3 

         if inrot == 1:  
           xpt = xp   
           ypt = yp
           zpt = zp

           xp = rots[0]*xpt+rots[3]*ypt+rots[6]*zpt
           yp = rots[1]*xpt+rots[4]*ypt+rots[7]*zpt
           zp = rots[2]*xpt+rots[5]*ypt+rots[8]*zpt

           if insys == 4:
            xptq = xpq   
            yptq = ypq
            zptq = zpq

            xpq = rots[0]*xptq+rots[3]*yptq+rots[6]*zptq
            ypq = rots[1]*xptq+rots[4]*yptq+rots[7]*zptq
            zpq = rots[2]*xptq+rots[5]*yptq+rots[8]*zptq

         if insys == 2:

          xp1 = xp*pro[0]+yp*pro[1]+zp*pro[2]
          yp1 = xp*pro[3]+yp*pro[4]+zp*pro[5]
          zp1 = xp*pro[6]+yp*pro[7]+zp*pro[8]  
   
          lxc = int(cx0-xp1)
          lyc = int(cy0-zp1)   

         if insys == 4:

          xp11 = xpq*pro[0]+ypq*pro[1]+zpq*pro[2]
          yp11 = xpq*pro[3]+ypq*pro[4]+zpq*pro[5]
          zp11 = xpq*pro[6]+ypq*pro[7]+zpq*pro[8]  
   
          lxc = int(cx0-xp11)
          lyc = int(cy0-zp11)   

         for i in range(ii):

           cang1 = math.cos(math.radians(i))

           d0 = math.sqrt(1.-an1*an1)
           d1 = math.sqrt(1.-cang1*cang1)
           if d0 != 0:
            cang2 = float(an2*d1)/float(d0)
            cang3 = float(an3*d1)/float(d0)
           else: cang2 = cang3 = d1/math.sqrt(2)
       
           if (an1 == 1. or an1 == -1.) and an2 == 0. and an3 == 0.: cang2 = cang3 = d1/math.sqrt(2)

           xc = ld*cang1
           yc = ld*cang2
           zc = ld*cang3

           if insys == 4:            
            xc = lc*tsk2*cang1
            yc = lc*tsk2*cang2
            zc = lc*tsk2*cang3

           if inrot == 1:     

              xct = xc   
              yct = yc
              zct = zc

              xc = rots[0]*xct+rots[3]*yct+rots[6]*zct
              yc = rots[1]*xct+rots[4]*yct+rots[7]*zct
              zc = rots[2]*xct+rots[5]*yct+rots[8]*zct

           xc1 = xc*pro[0]+yc*pro[1]+zc*pro[2]
           yc1 = xc*pro[3]+yc*pro[4]+zc*pro[5]
           zc1 = xc*pro[6]+yc*pro[7]+zc*pro[8]  

           lxc1 = int(cx0-xc1)
           lyc1 = int(cy0-zc1)  

           lzn.append((lxc1,lyc1))
         lzn.append((cx0, cy0))

         for i in range(jj):

           cang2 = math.cos(math.radians(i))

           d0 = math.sqrt(1.-an2*an2)
           d1 = math.sqrt(1.-cang2*cang2)
           if d0 != 0:
            cang1 = float(an1*d1)/float(d0)
            cang3 = float(an3*d1)/float(d0)
           else: cang1 = cang3 = d1/math.sqrt(2)
       
           if an1 == 0. and (an2 == 1. or an2 == -1.) and an3 == 0.: cang1 = cang3 = d1/math.sqrt(2)
            
           xc = ld*cang1
           yc = ld*cang2
           zc = ld*cang3

           if insys == 4:            
            xc = lc*tsk2*cang1
            yc = lc*tsk2*cang2
            zc = lc*tsk2*cang3

           if inrot == 1:     

              xct = xc   
              yct = yc
              zct = zc

              xc = rots[0]*xct+rots[3]*yct+rots[6]*zct
              yc = rots[1]*xct+rots[4]*yct+rots[7]*zct
              zc = rots[2]*xct+rots[5]*yct+rots[8]*zct

           xc1 = xc*pro[0]+yc*pro[1]+zc*pro[2]
           yc1 = xc*pro[3]+yc*pro[4]+zc*pro[5]
           zc1 = xc*pro[6]+yc*pro[7]+zc*pro[8]  

           lxc1 = int(cx0-xc1)
           lyc1 = int(cy0-zc1)  

           lzn1.append((lxc1,lyc1))
         lzn1.append((cx0, cy0))

         for i in range(kk):

           cang3 = math.cos(math.radians(i))

           d0 = math.sqrt(1.-an3*an3)
           d1 = math.sqrt(1.-cang3*cang3)
           if d0 != 0:
            cang1 = float(an1*d1)/float(d0)
            cang2 = float(an2*d1)/float(d0)
           else: cang1 = cang2 = d1/math.sqrt(2)
       
           if an1 == 0. and an2 == 0. and (an3 == 1. or an3 == -1.): cang1 = cang2 = d1/math.sqrt(2)
            
           xc = ld*cang1
           yc = ld*cang2
           zc = ld*cang3

           if insys == 4:            
            xc = lc*tsk2*cang1
            yc = lc*tsk2*cang2
            zc = lc*tsk2*cang3

           if inrot == 1:     

              xct = xc   
              yct = yc
              zct = zc

              xc = rots[0]*xct+rots[3]*yct+rots[6]*zct
              yc = rots[1]*xct+rots[4]*yct+rots[7]*zct
              zc = rots[2]*xct+rots[5]*yct+rots[8]*zct

           xc1 = xc*pro[0]+yc*pro[1]+zc*pro[2]
           yc1 = xc*pro[3]+yc*pro[4]+zc*pro[5]
           zc1 = xc*pro[6]+yc*pro[7]+zc*pro[8]  

           lxc1 = int(cx0-xc1)
           lyc1 = int(cy0-zc1)  

           lzn2.append((lxc1,lyc1))
         lzn2.append((cx0, cy0))

#-------------------------------------
def OnPaintOutCos(self,an1,an2,an3):
         global lxcr, lycr, lxc1, lyc1, lznr, lznr1, lznr2

         if outrot == 1: an3 = -float(an3)

         if an1 > 1.0: an1 = 1.0
         if an1 < -1.0: an1 = -1.0
         if an2 > 1.0: an2 = 1.0
         if an2 < -1.0: an2 = -1.0
         if an3 > 1.0: an3 = 1.0
         if an3 < -1.0: an3 = -1.0

         ii = int(math.degrees(math.acos(an1)))
         jj = int(math.degrees(math.acos(an2)))
         kk = int(math.degrees(math.acos(an3)))

         lznr, lznr1, lznr2 = [(cx0,cy0)], [(cx0,cy0)], [(cx0,cy0)]

         if outsys == 2:
          xp = lc*an1
          yp = lc*an2
          zp = lc*an3

         if outsys == 4:
          xp = lc*sk2r*an1
          yp = lc*sk2r*an2
          zp = lc*sk2r*an3

          xpq = lc*an1
          ypq = lc*an2
          zpq = lc*an3       

         if outrot == 1:  
           xpt = xp   
           ypt = yp
           zpt = zp

           xp = rots[0]*xpt+rots[3]*ypt+rots[6]*zpt
           yp = rots[1]*xpt+rots[4]*ypt+rots[7]*zpt
           zp = rots[2]*xpt+rots[5]*ypt+rots[8]*zpt

           if outsys == 4:
            xptq = xpq   
            yptq = ypq
            zptq = zpq

            xpq = rots[0]*xptq+rots[3]*yptq+rots[6]*zptq
            ypq = rots[1]*xptq+rots[4]*yptq+rots[7]*zptq
            zpq = rots[2]*xptq+rots[5]*yptq+rots[8]*zptq

         if outsys == 2:

          xp1 = xp*pro[0]+yp*pro[1]+zp*pro[2]
          yp1 = xp*pro[3]+yp*pro[4]+zp*pro[5]
          zp1 = xp*pro[6]+yp*pro[7]+zp*pro[8]  
 
          lxcr = int(cx0-xp1)
          lycr = int(cy0-zp1)   

         if outsys == 4:

          xp11 = xpq*pro[0]+ypq*pro[1]+zpq*pro[2]
          yp11 = xpq*pro[3]+ypq*pro[4]+zpq*pro[5]
          zp11 = xpq*pro[6]+ypq*pro[7]+zpq*pro[8]  
   
          lxcr = int(cx0-xp11)
          lycr = int(cy0-zp11)   

         for i in range(ii):

           ai = math.cos(math.radians(i))

           d0 = math.sqrt(1.-an1*an1)
           d1 = math.sqrt(1.-ai*ai)
           if d0 != 0:
            betout = float(an2*d1)/float(d0)
            gamout = float(an3*d1)/float(d0)  
       
           if (an1 == 1. or an1 == -1.) and an2 == 0. and an3 == 0.: betout = gamout = d1/math.sqrt(2)
            
           xc = ld*ai
           yc = ld*betout
           zc = ld*gamout

           if outsys == 4:            
            xc = lc*sk2r*ai
            yc = lc*sk2r*betout
            zc = lc*sk2r*gamout

           if outrot == 1:     
              xct = xc   
              yct = yc
              zct = zc

              xc = rots[0]*xct+rots[3]*yct+rots[6]*zct
              yc = rots[1]*xct+rots[4]*yct+rots[7]*zct
              zc = rots[2]*xct+rots[5]*yct+rots[8]*zct

           xc1 = xc*pro[0]+yc*pro[1]+zc*pro[2]
           yc1 = xc*pro[3]+yc*pro[4]+zc*pro[5]
           zc1 = xc*pro[6]+yc*pro[7]+zc*pro[8]  

           lxc1 = int(cx0-xc1)
           lyc1 = int(cy0-zc1)  

           lznr.append((lxc1,lyc1))
         lznr.append((cx0, cy0))

         for i in range(jj):

           ai = math.cos(math.radians(i))

           d0 = math.sqrt(1.-an2*an2)
           d1 = math.sqrt(1.-ai*ai)
           if d0 != 0:
            alpout = float(an1*d1)/float(d0)
            gamout = float(an3*d1)/float(d0)  
       
           if an1 == 0. and (an2 == 1. or an2 == -1.) and an3 == 0.: alpout = gamout = d1/math.sqrt(2)
            
           xc = ld*alpout
           yc = ld*ai
           zc = ld*gamout

           if outsys == 4:            
            xc = lc*sk2r*alpout
            yc = lc*sk2r*ai
            zc = lc*sk2r*gamout

           if outrot == 1:     
              xct = xc   
              yct = yc
              zct = zc

              xc = rots[0]*xct+rots[3]*yct+rots[6]*zct
              yc = rots[1]*xct+rots[4]*yct+rots[7]*zct
              zc = rots[2]*xct+rots[5]*yct+rots[8]*zct

           xc1 = xc*pro[0]+yc*pro[1]+zc*pro[2]
           yc1 = xc*pro[3]+yc*pro[4]+zc*pro[5]
           zc1 = xc*pro[6]+yc*pro[7]+zc*pro[8]  

           lxc1 = int(cx0-xc1)
           lyc1 = int(cy0-zc1)  

           lznr1.append((lxc1,lyc1))
         lznr1.append((cx0, cy0))

         for i in range(kk):

           ai = math.cos(math.radians(i))

           d0 = math.sqrt(1.-an3*an3)
           d1 = math.sqrt(1.-ai*ai)
           if d0 != 0:
            alpout = float(an1*d1)/float(d0)
            betout = float(an2*d1)/float(d0)  
       
           if an1 == 0. and an2 == 0. and (an3 == 1. or an3 == -1.): alpout = betout = d1/math.sqrt(2)
            
           xc = ld*alpout
           yc = ld*betout
           zc = ld*ai

           if outsys == 4:            
            xc = lc*sk2r*alpout
            yc = lc*sk2r*betout
            zc = lc*sk2r*ai

           if outrot == 1:     
              xct = xc   
              yct = yc
              zct = zc

              xc = rots[0]*xct+rots[3]*yct+rots[6]*zct
              yc = rots[1]*xct+rots[4]*yct+rots[7]*zct
              zc = rots[2]*xct+rots[5]*yct+rots[8]*zct

           xc1 = xc*pro[0]+yc*pro[1]+zc*pro[2]
           yc1 = xc*pro[3]+yc*pro[4]+zc*pro[5]
           zc1 = xc*pro[6]+yc*pro[7]+zc*pro[8]  

           lxc1 = int(cx0-xc1)
           lyc1 = int(cy0-zc1)  

           lznr2.append((lxc1,lyc1))
         lznr2.append((cx0, cy0))

#-------------------------------------
def RunPdfFile(path):
    global ierr
 
# file exists ?

    if not os.path.exists(path):
        tmes.SetValue('No such file :  %s' % path)
        tmes.SetForegroundColour(col1) 
        ierr = 1
        return
 
# We have read access ?

    if hasattr(os, 'access') and not os.access(path, os.R_OK):
        tmes.SetValue(' Cannot access file :  %s' % path)
        tmes.SetForegroundColour(col1) 
        ierr = 1
        return

# Windows

    if 'wxMSW' in wx.PlatformInfo:
        proc = os.system(path) 

# Linux
 
    elif 'wxGTK' in wx.PlatformInfo:
        proc = subprocess.Popen(['xdg-open', path], 
                               stdout=subprocess.PIPE, stderr=subprocess.PIPE)
# Mac
 
    elif 'wxMac' in wx.PlatformInfo:
        proc = subprocess.Popen(['open', '--', path], 
                                stdout=subprocess.PIPE, stderr=subprocess.PIPE)
 
    else:
        tmes.SetValue(" Your `%s` isn't a supported operating system`." % sys.platform)
        tmes.SetForegroundColour(col1) 
        ierr = 1
        return

#-------------------------------------
class App(wx.App):

    """ Application class """
    
    def OnInit(self):
        """ Function OnInit, initializating application, making main frame"""
        self.appFrame = InsertFrame(parent=1, id=-1)
        self.appFrame.Show()
        return True
        
if __name__ == '__main__':
    app = App(False, "output")
    app.MainLoop()

